Package: @PKGNAME@
Type: Package
Title: @PKGTITLE@
Description: @PKGDESCRIPTION@
Version: @PKGVERSION@
Date: @DATE@
Author: @AUTHOR@
Maintainer: @MAINTAINER@
Depends: @GENOMENAME@
License: @LIC@
LazyLoad: yes
organism: @ORGANISM@
provider: @PROVIDER@
provider_version: @PROVIDERVERSION@
release_date: @RELEASEDATE@
release_name: @RELEASENAME@
source: @SRCDATAFILES@
biocViews: @ORGANISMBIOCVIEW@

Package: QuasR
Type: Package
Title: Quantify and Annotate Short Reads in R
Version: 1.51.0
Date: 2025-06-23
Authors@R: c(person("Anita", "Lerch", role = c("aut")),
             person("Adam Alexander Thil", "SMITH", role = c("aut"), 
                    email = "alex.smith@fmi.ch", 
                    comment = c(ORCID = "0000-0003-4593-3042")),
             person("Charlotte", "Soneson", role = c("aut"), 
                    email = "charlottesoneson@gmail.com", 
                    comment = c(ORCID = "0000-0003-3833-2169")),
             person("Dimos", "Gaidatzis", role = c("aut")),
             person("Michael", "Stadler", role = c("aut", "cre"), 
                    email = "michael.stadler@fmi.ch", 
                    comment = c(ORCID = "0000-0002-2269-4934")))
Depends: R (>= 4.4), parallel, GenomicRanges, Rbowtie
Imports: methods, grDevices, graphics, utils, stats, tools,
        BiocGenerics, S4Vectors, IRanges, Biobase, Biostrings,
        BSgenome, Rsamtools (>= 2.13.1), GenomicFeatures, txdbmaker,
        ShortRead, BiocParallel, Seqinfo, rtracklayer, GenomicFiles,
        AnnotationDbi
Suggests: Gviz, BiocStyle, GenomeInfoDbData, GenomicAlignments,
        Rhisat2, knitr, rmarkdown, covr, testthat
LinkingTo: Rhtslib (>= 1.99.1)
Encoding: UTF-8
SystemRequirements: GNU make
Description: This package provides a framework for the quantification
    and analysis of Short Reads. It covers a complete workflow
    starting from raw sequence reads, over creation of alignments
    and quality control plots, to the quantification of genomic
    regions of interest. Read alignments are either generated through
    Rbowtie (data from DNA/ChIP/ATAC/Bis-seq experiments) or
    Rhisat2 (data from RNA-seq experiments that require spliced alignments),
    or can be provided in the form of bam files.
URL: https://bioconductor.org/packages/QuasR
License: GPL-2
biocViews: Genetics, Preprocessing, Sequencing, ChIPSeq, RNASeq,
        MethylSeq, Coverage, Alignment, QualityControl, ImmunoOncology
Archs: x64
VignetteBuilder: knitr
RoxygenNote: 7.3.2
BugReports: https://github.com/fmicompbio/QuasR/issues
git_url: https://git.bioconductor.org/packages/QuasR
git_branch: devel
git_last_commit: 331f3b2
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-04
NeedsCompilation: yes
Packaged: 2025-11-05 00:25:56 UTC; biocbuild
Author: Anita Lerch [aut],
  Adam Alexander Thil SMITH [aut] (ORCID:
    <https://orcid.org/0000-0003-4593-3042>),
  Charlotte Soneson [aut] (ORCID:
    <https://orcid.org/0000-0003-3833-2169>),
  Dimos Gaidatzis [aut],
  Michael Stadler [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-2269-4934>)
Maintainer: Michael Stadler <michael.stadler@fmi.ch>

<img src="vignettes/QuasR-logo.png" align="left" alt="" />
<br>

# Quantify and annotate short reads in R 

<br>

## Overview

`QuasR` aims to cover the whole analysis workflow of typical ultra-high throughput
sequencing experiments, starting from the raw sequence reads, over pre-processing and
alignment, up to quantification. A single **R** script can contain all steps of a complete
analysis, making it simple to document, reproduce or share the workflow containing all
relevant details.

The `QuasR` package integrates the functionality of several **R** packages
(such as `IRanges` and `Rsamtools`) and external software (e.g. `bowtie`,
through the `Rbowtie` package).

The package was originally created for in house use at the Friedrich Miescher Institute.
Current contributors include:

- [Michael Stadler](https://github.com/mbstadler)
- Dimos Gaidatzis
- [Charlotte Soneson](https://github.com/csoneson)
- Anita Lerch
- Florian Hahne

## Functionality

The current `QuasR` release supports the analysis of single read and
paired-end ChIP-seq (chromatin immuno-precipitation combined with sequencing), RNA-seq
(gene expression profiling by sequencing of RNA) and Bis-seq (measurement of DNA
methylation by sequencing of bisulfite-converted genomic DNA) experiments. Allele
specific alignment and quantification is also supported in all of these experiment
types. `QuasR` has been successfully used with data from Illumina, 454 Life Technologies
and SOLiD sequencers, the latter by using bam files created externally `QuasR`.

## Reference
`QuasR` has been described in:  

"QuasR: Quantify and Annotate Short Reads in R"  
Gaidatzis, D. and Lerch, A. and Hahne, F. and Stadler, M.B.  
*Bioinformatics* **2015**, 31(7):1130-1132.  
[PubMed: 25417205](https://www.ncbi.nlm.nih.gov/pubmed/25417205), [doi: 10.1093/bioinformatics/btu781](https://doi.org/10.1093/bioinformatics/btu781)

## Download from Bioconductor
[QuasR download page](https://bioconductor.org/packages/QuasR/)

## Software status

| Platforms          |  OS              | R CMD check      | Coverage         | 
|:------------------:|:----------------:|:----------------:|:----------------:|
| Github-Actions     | Multiple         |  [![R build status](https://github.com/fmicompbio/QuasR/workflows/R-CMD-check/badge.svg)](https://github.com/fmicompbio/QuasR/actions) | [![Codecov.io coverage status](https://codecov.io/github/fmicompbio/QuasR/coverage.svg?branch=master)](https://codecov.io/github/fmicompbio/QuasR) |
| Bioc ([_devel_](http://bioconductor.org/packages/devel/bioc/html/QuasR.html)) | Multiple | [![Bioconductor-devel Build Status](http://bioconductor.org/shields/build/devel/bioc/QuasR.svg)](http://bioconductor.org/checkResults/devel/bioc-LATEST/QuasR) | [![Codecov.io coverage status](https://codecov.io/github/fmicompbio/QuasR/coverage.svg?branch=master)](https://codecov.io/github/fmicompbio/QuasR) |
| Bioc ([_release_](http://bioconductor.org/packages/release/bioc/html/QuasR.html)) | Multiple | [![Bioconductor-release Build Status](http://bioconductor.org/shields/build/release/bioc/QuasR.svg)](http://bioconductor.org/checkResults/release/bioc-LATEST/QuasR) | [![Codecov.io coverage status](https://codecov.io/github/fmicompbio/QuasR/coverage.svg?branch=master)](https://codecov.io/github/fmicompbio/QuasR) |

#' Quantify and Annotate Short Reads in R
#'
#' This package provides a pipeline for the quantification and analysis of 
#' short reads.
#'
#' See packageDescription('QuasR') for package details.
#' 
#' @author Anita Lerch, Charlotte Soneson, Dimos Gaidatzis and Michael Stadler
#' 
#' @aliases QuasR QuasR-package
#' @name QuasR-package
#' 
#' @keywords package
#' 
#' @seealso \code{\link{qAlign}}, \code{\link{qCount}}, \code{\link{qProfile}}, 
#'   \code{\link{qMeth}}, \code{\link{qQCReport}}
#' 
#' @useDynLib QuasR, .registration=TRUE
#' 
#' @examples 
#' \dontrun{
#' # see qCount, qMeth and qProfile manual pages for examples
#' example(qCount)
#' example(qMeth)
#' example(qProfile)
#' }
#' @keywords internal 
"_PACKAGE"

#' @keywords internal
#' @importFrom parallel makeCluster stopCluster clusterEvalQ parLapply
#' @importFrom tools file_path_sans_ext
createGenomicAlignments <- function(proj, clObj) {

    # check if a cluster object is provided. if not, use only one core.
    if (is.null(clObj)) {
        clObj <- parallel::makeCluster(1)
        on.exit(parallel::stopCluster(clObj))
    }
    # retrieve information about the cluster
    message("Testing the compute nodes...", appendLF = FALSE)
    tryCatch({
        nodeNamesList <- parallel::clusterEvalQ(clObj, Sys.info()["nodename"])
    }, error = function(ex) {
        message("FAILED")
        stop("The cluster object does not work properly on this system. ",
             "Please consult the manual of the package 'parallel'\n",
             call. = FALSE)
    })
    message("OK")

    message("Loading QuasR on the compute nodes...", appendLF = FALSE)
    # load QuasR package on all the nodes
    loadQuasR(clObj)

    nodeNames <- unlist(nodeNamesList)
    coresPerNode <- table(nodeNames)
    message("Available cores:")
    for (i in seq_along(coresPerNode))
        message(names(coresPerNode)[i], ": ", as.character(coresPerNode[i]))

    # log file that is passed to all the nodes. each node can write into
    # that file and serves as a monitor of their progress
    logFile <- tempfile(tmpdir = getwd(), pattern = "QuasR_log_", fileext = ".txt")

    #create the parameters necessary for the individual processes
    # performing the genomic alignments
    paramsListGenomic <- NULL
    for (i in seq_len(nrow(proj@reads))) {
        if (is.na(proj@alignments$FileName)[i]) {
            # create a filename for the current bam file and update the
            # qProject. ensure uniqueness by adding a random suffix
            if (is.na(proj@alignmentsDir)) {
                bamDir <- dirname(proj@reads[i, 1])
            } else {
                bamDir <- proj@alignmentsDir
            }
            samplePrefix <- basename(tools::file_path_sans_ext(proj@reads[i, 1],
                                                               compression = TRUE))
            proj@alignments$FileName[i] <- tempfile(tmpdir = bamDir,
                                                    pattern = paste(samplePrefix,
                                                                    "_", sep = ""),
                                                    fileext = ".bam")

            paramsListGenomic[[length(paramsListGenomic) + 1]] <- list(
                "sampleNr" = i,
                "qProject" = proj,
                "coresPerNode" = coresPerNode,
                "logFile" = logFile
            )
        }
    }

    # perform all necessary genomic alignments
    n_tasks <- length(paramsListGenomic)
    if (n_tasks > 0) {
        message(paste("Performing genomic alignments for", n_tasks,
                      "samples. See progress in the log file:"))
        message(logFile)

        # create a cluster object that has only one entry per machine.
        # multithreading (on a lower level) results
        # in a fully occupied node. This new clObj does not have to be stopped.
        # it closes once the original one closes
        clObjNR <- clObj[!duplicated(nodeNames)]

        parallel::clusterExport(clObjNR, "n_tasks", envir = environment())
        parallel::parLapply(clObjNR, paramsListGenomic,
                            createGenomicAlignmentsController)
        message("Genomic alignments have been created successfully")
        message("")
    }

    return(proj)
}

#' @keywords internal
#' @importFrom parallel makeCluster stopCluster clusterEvalQ parLapply
#' @importFrom tools file_path_sans_ext
createAuxAlignments <- function(proj, clObj) {

    # check if a cluster object is provided. if not, use only one core.
    if (is.null(clObj)) {
        clObj <- parallel::makeCluster(1)
        on.exit(parallel::stopCluster(clObj))
    }
    # retrieve information about the cluster
    message("Testing the compute nodes...", appendLF = FALSE)
    tryCatch({
        nodeNamesList <- parallel::clusterEvalQ(clObj, Sys.info()["nodename"])
    }, error = function(ex) {
        message("FAILED")
        stop("The cluster object does not work properly on this system. ",
             "Please consult the manual of the package 'parallel'\n",
             call. = FALSE)
    })
    message("OK")

    message("Loading QuasR on the compute nodes...", appendLF = FALSE)
    # load QuasR package on all the nodes
    loadQuasR(clObj)

    nodeNames <- unlist(nodeNamesList)
    coresPerNode <- table(nodeNames)
    message("Available cores:")
    print(coresPerNode)

    # log file that is passed to all the nodes. each node can write into
    # that file and serves as a monitor of their progress
    logFile <- tempfile(tmpdir = getwd(), pattern = "QuasR_log_", fileext = ".txt")

    # create the parameters necessary for the individual processes
    # performing the aux alignments
    paramsListAux <- NULL
    for (i in seq_len(ncol(proj@auxAlignments))) {
        if (any(is.na(proj@auxAlignments[, i]))) {
            if (is.na(proj@alignmentsDir)) {
                bamDir <- dirname(proj@reads[i, 1])
            } else {
                bamDir <- proj@alignmentsDir
            }
            samplePrefix <- basename(tools::file_path_sans_ext(proj@reads[i, 1],
                                                               compression = TRUE))
            auxNrs <- NULL # the aux files to map in the children
            for (j in seq_len(nrow(proj@auxAlignments))) {
                if (is.na(proj@auxAlignments[j, i])) {
                    auxNrs <- c(auxNrs, j)
                    proj@auxAlignments[j, i] <- tempfile(
                        tmpdir = bamDir,
                        pattern = paste(samplePrefix, "_", sep = ""),
                        fileext = ".bam"
                    )
                }
            }
            paramsListAux[[length(paramsListAux) + 1]] <- list(
                "sampleNr" = i,
                "auxNrs" = auxNrs,
                "qProject" = proj,
                "coresPerNode" = coresPerNode,
                "logFile" = logFile
            )
        }
    }

    n_tasks <- length(paramsListAux)
    if (n_tasks > 0) {
        message(paste("Performing auxiliary alignments for",
                      n_tasks, "samples. See progress in the log file:"))
        message(logFile)

        # create a cluster object that has only one entry per machine.
        # multithreading (on a lower level) results
        # in a fully occupied node. This new clObj does not have to be stopped.
        # it closes once the original one closes
        clObjNR <- clObj[!duplicated(nodeNames)]

        parallel::clusterExport(clObjNR, "n_tasks", envir = environment())
        parallel::parLapply(clObjNR, paramsListAux, createAuxAlignmentsController)
        message("Auxiliary alignments have been created successfully")
        message("")
    }

    return(proj)
}

#' @keywords internal
#' @importFrom tools file_path_sans_ext
#' @importFrom utils installed.packages write.table
#' @importFrom stats na.omit
#' @importFrom Rsamtools asBam
createGenomicAlignmentsController <- function(params) {
    tryCatch({# try catch block goes through the whole function

        # extract the parameters from params
        sampleNr <- params$sampleNr
        proj <- params$qProject
        coresPerNode <- params$coresPerNode
        logFile <- params$logFile
        rm(params) # clean up
        sink(logFile, append = TRUE) # redirect all the print output to a logfile
        cacheDir <- resolveCacheDir(proj@cacheDir) # tmp dir can change for each machine

        # find out how many threads are available on this node
        # (for running the alignments)
        if (!(Sys.info()["nodename"] %in% names(coresPerNode))) {
            stop("Fatal error 2394793")
        }
        coresThisNode <- coresPerNode[names(coresPerNode) %in% Sys.info()["nodename"]]

        n_tasks <- get0("n_tasks", ifnotfound = 1)
        task_prefix <- paste0("(Task ", sampleNr, "/", n_tasks, "): ")
        worker_message(
          task_prefix, "Number of threads available: ", coresThisNode)

        # try to load all the required libraries on the compute node.
        # these are the aligner package
        # and in the case of a BSgenome, the BSgenome itself needs to be
        # loaded and the associated index
        if (!require(proj@aligner, character.only = TRUE, quietly = TRUE)) {
            stop("Could not load the aligner package ", proj@aligner)
        }

        if (proj@genomeFormat == "file") {
            indexDir <- paste(proj@genome, proj@alnModeID, sep = ".")
        } else if (proj@genomeFormat == "BSgenome") {
            if (!(proj@genome %in% utils::installed.packages()[, "Package"])) {
                stop("The genome package ", proj@genome, " is not installed")
            }
            if (is.na(proj@snpFile)) {
                if (!(paste(proj@genome, proj@alnModeID, sep = ".") %in%
                      utils::installed.packages()[, "Package"])) {
                    stop("The genome index package ", paste(proj@genome,
                                                            proj@alnModeID, sep = "."),
                         " is not installed")
                }
            }

            indexDir <- system.file("alignmentIndex", package = paste(proj@genome,
                                                                      proj@alnModeID,
                                                                      sep = "."))
        } else {
            stop("Fatal error 4778493")
        }

        # create the info file for the bam file
        bamInfo <- qProjectBamInfo(proj, sampleNr)

        # uncompress the files containing the reads (twice for paired end samples)
        if (proj@paired == "no") {
            # SINGLE END SAMPLES
            # decompress the reads if necessary
            reads <- proj@reads$FileName[sampleNr]
            if (compressedFileFormat(reads) != "none") {
                worker_message(task_prefix, "Decompressing SE read file:", reads)
                readsUNC <- tempfile(tmpdir = cacheDir, pattern = basename(reads),
                                     fileext = paste(".", proj@samplesFormat, sep = ""))
                compressFile(reads, readsUNC, remove = FALSE)
                proj@reads$FileName[sampleNr] <- readsUNC
                on.exit(file.remove(readsUNC)) # make sure that the temp file is deleted
            }
        } else {
            # PAIRED END SAMPLES
            # decompress the first read pair if necessary
            reads1 <- proj@reads$FileName1[sampleNr]
            if (compressedFileFormat(reads1) != "none") {
                worker_message(task_prefix, "Decompressing PE R1 file:", reads1)
                readsUNC1 <- tempfile(tmpdir = cacheDir, pattern = basename(reads1),
                                      fileext = paste(".", proj@samplesFormat, sep = ""))
                compressFile(reads1, readsUNC1, remove = FALSE)
                proj@reads$FileName1[sampleNr] <- readsUNC1
                # make sure that the temp file is deleted at the end
                on.exit(file.remove(readsUNC1))
            }
            # decompress the second read pair if necessary
            reads2 <- proj@reads$FileName2[sampleNr]
            if (compressedFileFormat(reads2) != "none") {
                worker_message(task_prefix, "Decompressing PE R2 file:", reads2)
                readsUNC2 <- tempfile(tmpdir = cacheDir, pattern = basename(reads2),
                                      fileext = paste(".", proj@samplesFormat, sep = ""))
                compressFile(reads2, readsUNC2, remove = FALSE)
                proj@reads$FileName2[sampleNr] <- readsUNC2
                # make sure that the temp file is deleted at the end
                on.exit(file.remove(readsUNC2), add = TRUE)
            }
        }

        samFile <- tempfile(tmpdir = cacheDir,
                            pattern = basename(proj@reads[sampleNr, 1]),
                            fileext = ".sam")
        # make sure that the temp file is deleted at the end
        on.exit(file.remove(samFile), add = TRUE)

        # perform the required alignments based on the information in qProject
        if (proj@alnModeID == "Rbowtie") {
            if (!proj@splicedAlignment) {
                if (is.na(proj@snpFile)) {
                    align_Rbowtie(indexDir, proj@reads[sampleNr, ],
                                  proj@samplesFormat, proj@paired,
                                  proj@alignmentParameter, coresThisNode,
                                  samFile, cacheDir)
                } else {
                    # add numeric id to the reads, this is required for the correct
                    # operation of mergeReorderSam in allelic mode
                    proj@reads[sampleNr, ] <- addNumericToID(proj@reads[sampleNr, ],
                                                             proj@paired, cacheDir)
                    # make sure that the temp file(s) are deleted at the end
                    on.exit(file.remove(unlist(
                        proj@reads[sampleNr, stats::na.omit(match(c("FileName",
                                                                    "FileName1",
                                                                    "FileName2"),
                                                                  colnames(proj@reads)))]
                    )), add = TRUE)

                    samFileR <- tempfile(tmpdir = cacheDir,
                                         pattern = basename(proj@reads[sampleNr, 1]),
                                         fileext = ".sam")
                    samFileA <- tempfile(tmpdir = cacheDir,
                                         pattern = basename(proj@reads[sampleNr, 1]),
                                         fileext = ".sam")
                    on.exit(file.remove(samFileR), add = TRUE)
                    on.exit(file.remove(samFileA), add = TRUE)
                    align_Rbowtie(paste(proj@snpFile, basename(proj@genome),
                                        "R", "fa", proj@alnModeID, sep = "."),
                                  proj@reads[sampleNr, ], proj@samplesFormat,
                                  proj@paired, proj@alignmentParameter,
                                  coresThisNode, samFileR, cacheDir)
                    align_Rbowtie(paste(proj@snpFile, basename(proj@genome),
                                        "A", "fa", proj@alnModeID, sep = "."),
                                  proj@reads[sampleNr, ], proj@samplesFormat,
                                  proj@paired, proj@alignmentParameter,
                                  coresThisNode, samFileA, cacheDir)
                    worker_message(task_prefix, "merging 2 sam files")
                    mrQuSize <- .Call(mergeReorderSam, c(samFileR, samFileA),
                                      samFile, as.integer(2), as.integer(proj@maxHits))
                    worker_message(
                      task_prefix, "maximal queue size during merging:", mrQuSize)
                }
            } else {
                if (is.na(proj@snpFile)) {
                    # in the case of BSgenome, flush it because it is needed by SpliceMap
                    if (proj@genomeFormat == "BSgenome") {
                        if (!require(paste(proj@genome, proj@alnModeID, sep = "."),
                                     character.only = TRUE, quietly = TRUE)) {
                            stop("Could not load the genome index package ",
                                 paste(proj@genome, proj@alnModeID, sep = "."))
                        }
                        genomeObj <- get(proj@genome) # access the BSgenome
                        fastaFilepath <- tempfile(tmpdir = cacheDir, fileext = ".fa")
                        worker_message(
                          task_prefix, "Writing BSgenome to disk: ", fastaFilepath)
                        # flush the BSgenome to disk
                        BSgenomeSeqToFasta(genomeObj, fastaFilepath)
                        on.exit(unlink(fastaFilepath), add = TRUE)
                    } else {
                        fastaFilepath <- proj@genome
                    }
                    align_RbowtieSpliced(fastaFilepath, indexDir, proj@reads[sampleNr, ],
                                         proj@samplesFormat, proj@paired,
                                         proj@alignmentParameter, coresThisNode,
                                         samFile, cacheDir)
                } else {
                    # add numeric id to the reads, this is required for the correct
                    # operation of mergeReorderSam in allelic mode
                    proj@reads[sampleNr, ] <- addNumericToID(proj@reads[sampleNr, ],
                                                             proj@paired, cacheDir)
                    # make sure that the temp file(s) are deleted at the end
                    on.exit(file.remove(unlist(
                        proj@reads[sampleNr, stats::na.omit(match(c("FileName",
                                                                    "FileName1",
                                                                    "FileName2"),
                                                                  colnames(proj@reads)))]
                    )), add = TRUE)

                    samFileR <- tempfile(tmpdir = cacheDir,
                                         pattern = basename(proj@reads[sampleNr, 1]),
                                         fileext = ".sam")
                    samFileA <- tempfile(tmpdir = cacheDir,
                                         pattern = basename(proj@reads[sampleNr, 1]),
                                         fileext = ".sam")
                    on.exit(file.remove(samFileR), add = TRUE)
                    on.exit(file.remove(samFileA), add = TRUE)
                    align_RbowtieSpliced(paste(proj@snpFile, basename(proj@genome),
                                               "R", "fa", sep = "."),
                                         paste(proj@snpFile, basename(proj@genome),
                                               "R", "fa", proj@alnModeID,
                                               sep = "."),
                                         proj@reads[sampleNr, ], proj@samplesFormat,
                                         proj@paired, proj@alignmentParameter,
                                         coresThisNode, samFileR, cacheDir)
                    align_RbowtieSpliced(paste(proj@snpFile, basename(proj@genome),
                                               "A", "fa", sep = "."),
                                         paste(proj@snpFile, basename(proj@genome),
                                               "A", "fa", proj@alnModeID, sep = "."),
                                         proj@reads[sampleNr, ], proj@samplesFormat,
                                         proj@paired, proj@alignmentParameter,
                                         coresThisNode, samFileA, cacheDir)
                    worker_message(task_prefix, "merging 2 sam files")
                    mrQuSize <- .Call(mergeReorderSam, c(samFileR, samFileA),
                                      samFile, as.integer(2), as.integer(proj@maxHits))
                    worker_message(
                        task_prefix, "maximal queue size during merging:", mrQuSize)
                }
            }
        } else if (proj@alnModeID == "RbowtieCtoT") {
            if (proj@bisulfite == "dir") {
                if (is.na(proj@snpFile)) {
                    align_RbowtieCtoT_dir(indexDir, proj@reads[sampleNr, ],
                                          proj@samplesFormat, proj@paired,
                                          proj@alignmentParameter, !is.na(proj@snpFile),
                                          proj@maxHits, coresThisNode, samFile, cacheDir)
                } else {
                    samFileR <- tempfile(tmpdir = cacheDir,
                                         pattern = basename(proj@reads[sampleNr, 1]),
                                         fileext = ".sam")
                    samFileA <- tempfile(tmpdir = cacheDir,
                                         pattern = basename(proj@reads[sampleNr, 1]),
                                         fileext = ".sam")
                    on.exit(file.remove(samFileR), add = TRUE)
                    on.exit(file.remove(samFileA), add = TRUE)

                    align_RbowtieCtoT_dir(paste(proj@snpFile, basename(proj@genome),
                                                "R", "fa", proj@alnModeID, sep = "."),
                                          proj@reads[sampleNr, ], proj@samplesFormat,
                                          proj@paired, proj@alignmentParameter,
                                          !is.na(proj@snpFile), proj@maxHits,
                                          coresThisNode, samFileR, cacheDir)
                    align_RbowtieCtoT_dir(paste(proj@snpFile, basename(proj@genome),
                                                "A", "fa", proj@alnModeID, sep = "."),
                                          proj@reads[sampleNr, ], proj@samplesFormat,
                                          proj@paired, proj@alignmentParameter,
                                          !is.na(proj@snpFile), proj@maxHits,
                                          coresThisNode, samFileA, cacheDir)
                    worker_message(task_prefix, "merging 2 sam files")
                    mrQuSize <- .Call(mergeReorderSam, c(samFileR, samFileA),
                                      samFile, as.integer(2), as.integer(proj@maxHits))
                    worker_message(
                        task_prefix, "maximal queue size during merging:", mrQuSize)
                }
            } else {
                if (is.na(proj@snpFile)) {
                    align_RbowtieCtoT_undir(indexDir, proj@reads[sampleNr, ],
                                            proj@samplesFormat, proj@paired,
                                            proj@alignmentParameter,
                                            !is.na(proj@snpFile),
                                            proj@maxHits, coresThisNode, samFile, cacheDir)
                } else {
                    samFileR <- tempfile(tmpdir = cacheDir,
                                         pattern = basename(proj@reads[sampleNr, 1]),
                                         fileext = ".sam")
                    samFileA <- tempfile(tmpdir = cacheDir,
                                         pattern = basename(proj@reads[sampleNr, 1]),
                                         fileext = ".sam")
                    on.exit(file.remove(samFileR), add = TRUE)
                    on.exit(file.remove(samFileA), add = TRUE)

                    align_RbowtieCtoT_undir(paste(proj@snpFile, basename(proj@genome),
                                                  "R", "fa", proj@alnModeID, sep = "."),
                                            proj@reads[sampleNr, ], proj@samplesFormat,
                                            proj@paired, proj@alignmentParameter,
                                            !is.na(proj@snpFile), proj@maxHits,
                                            coresThisNode, samFileR, cacheDir)
                    align_RbowtieCtoT_undir(paste(proj@snpFile, basename(proj@genome),
                                                  "A", "fa", proj@alnModeID, sep = "."),
                                            proj@reads[sampleNr, ], proj@samplesFormat,
                                            proj@paired, proj@alignmentParameter,
                                            !is.na(proj@snpFile), proj@maxHits,
                                            coresThisNode, samFileA, cacheDir)
                    worker_message(task_prefix, "merging 2 sam files")
                    mrQuSize <- .Call(mergeReorderSam, c(samFileR, samFileA),
                                      samFile, as.integer(2), as.integer(proj@maxHits))
                    worker_message(
                        task_prefix, "maximal queue size during merging:", mrQuSize)
                }
            }
        } else if (proj@alnModeID == "Rhisat2") {
            if (is.na(proj@snpFile)) {
                align_Rhisat2(indexDir, proj@reads[sampleNr, ],
                              proj@samplesFormat, proj@paired, proj@alignmentParameter,
                              coresThisNode, samFile, cacheDir,
                              proj@splicedAlignment, proj@maxHits)
            } else {
                # add numeric id to the reads, this is required for the correct
                # operation of mergeReorderSam in allelic mode
                proj@reads[sampleNr, ] <- addNumericToID(proj@reads[sampleNr, ],
                                                         proj@paired, cacheDir)
                # make sure that the temp file(s) are deleted at the end
                on.exit(file.remove(unlist(
                    proj@reads[sampleNr, stats::na.omit(match(c("FileName", "FileName1",
                                                                "FileName2"),
                                                              colnames(proj@reads)))]
                )), add = TRUE)
                samFileR <- tempfile(tmpdir = cacheDir,
                                     pattern = basename(proj@reads[sampleNr, 1]),
                                     fileext = ".sam")
                samFileA <- tempfile(tmpdir = cacheDir,
                                     pattern = basename(proj@reads[sampleNr, 1]),
                                     fileext = ".sam")
                on.exit(file.remove(samFileR), add = TRUE)
                on.exit(file.remove(samFileA), add = TRUE)
                align_Rhisat2(paste(proj@snpFile, basename(proj@genome), "R",
                                    "fa", proj@alnModeID, sep = "."),
                              proj@reads[sampleNr, ], proj@samplesFormat,
                              proj@paired, proj@alignmentParameter,
                              coresThisNode, samFileR, cacheDir,
                              proj@splicedAlignment, proj@maxHits)
                align_Rhisat2(paste(proj@snpFile, basename(proj@genome), "A",
                                    "fa", proj@alnModeID, sep = "."),
                              proj@reads[sampleNr, ], proj@samplesFormat,
                              proj@paired, proj@alignmentParameter,
                              coresThisNode, samFileA, cacheDir,
                              proj@splicedAlignment, proj@maxHits)
                worker_message(task_prefix, "merging 2 sam files")
                mrQuSize <- .Call(mergeReorderSam, c(samFileR, samFileA),
                                  samFile, as.integer(2), as.integer(proj@maxHits))
                worker_message(
                    task_prefix, "maximal queue size during merging:", mrQuSize)
            }
        } else {
            stop("Fatal error 23484303")
        }

        worker_message(
          task_prefix, "Converting sam file to sorted bam file:", samFile)
        if (coresThisNode > 3) {
            # sort sam and convert to bam parallel
            samToSortedBamParallel(
                samFile, tools::file_path_sans_ext(proj@alignments$FileName[sampleNr]),
                coresThisNode, cacheDir
            )
        } else {
            # sort sam and convert to bam
            Rsamtools::asBam(
                samFile,
                tools::file_path_sans_ext(proj@alignments$FileName[sampleNr])
            )
        }

        # save the info file for the bam file
        utils::write.table(bamInfo, paste(proj@alignments$FileName[sampleNr],
                                          "txt", sep = "."),
                           sep = "\t", quote = FALSE, col.names = FALSE)

        worker_message(
          task_prefix, "Genomic alignments have been successfully created.")

        # if one process stops due to an error, catch it, concatenate the
        # message with specific information about
        # the compute node and then print it to the log file. this procedure
        # provides the information about which
        # sample was processed and on which machine when the error occured.
    }, error = function(ex) {
        emsg <- paste(task_prefix, "Error processing sample",
                      proj@reads[sampleNr, 1], ":", ex$message)
        worker_message(emsg)
        stop(emsg)
    }, finally = {
        sink() # close the redirection of the print statements
    })
}

#' @keywords internal
#' @importFrom tools file_path_sans_ext
#' @importFrom Rsamtools sortBam indexBam
#' @importFrom utils write.table
createAuxAlignmentsController <- function(params) {
    tryCatch({ # try catch block goes through the whole function

        # extract the parameters from params
        sampleNr <- params$sampleNr
        auxNrs <- params$auxNrs
        proj <- params$qProject
        coresPerNode <- params$coresPerNode
        logFile <- params$logFile
        rm(params)
        sink(logFile, append = TRUE) # redirect all the print output to a logfile
        cacheDir <- resolveCacheDir(proj@cacheDir) # tmp dir can change for each machine

        # load the aligner package on the compute node
        if (!require(proj@aligner, character.only = TRUE, quietly = TRUE)) {
            stop("Could not load the aligner package ", proj@aligner)
        }

        # find out how many threads are available on this node
        # (for running the alignments)
        thisNodesName <- Sys.info()["nodename"]
        if (!(thisNodesName %in% names(coresPerNode))) {
            stop("Fatal error 23594793")
        }
        coresThisNode <- coresPerNode[names(coresPerNode) %in% thisNodesName]

        n_tasks <- get0("n_tasks", ifnotfound = 1)
        task_prefix <- paste0("(Task ", sampleNr, "/", n_tasks, "): ")
        worker_message(
          task_prefix, "Number of threads available: ", coresThisNode)

        # extract the unmapped reads from bam file. in the case of a bisulfite
        # sample, this requires the conversion from ff (that is present in the bam file)
        # to fr to make the rest of the execution compatible (see last parameter
        # of extractUnmappedReads)
        unmappedReadsInfo <- proj@reads[sampleNr, ]
        if (proj@paired == "no") {
            unmappedReadsFile <- tempfile(
                tmpdir = cacheDir,
                pattern = basename(proj@alignments$FileName[sampleNr]),
                fileext = proj@samplesFormat
            )
            .Call(extractUnmappedReads, proj@alignments$FileName[sampleNr],
                  unmappedReadsFile, proj@samplesFormat == "fastq",
                  proj@bisulfite != "no")
            unmappedReadsInfo$FileName <- unmappedReadsFile
            # make sure that the temp file is deleted
            on.exit(file.remove(unmappedReadsFile))
        } else {
            unmappedReadsFile1 <- tempfile(
                tmpdir = cacheDir,
                pattern = basename(proj@alignments$FileName[sampleNr]),
                fileext = proj@samplesFormat
            )
            unmappedReadsFile2 <- tempfile(
                tmpdir = cacheDir,
                pattern = basename(proj@alignments$FileName[sampleNr]),
                fileext = proj@samplesFormat
            )
            .Call(extractUnmappedReads, proj@alignments$FileName[sampleNr],
                  c(unmappedReadsFile1, unmappedReadsFile2),
                  proj@samplesFormat == "fastq", proj@bisulfite != "no")
            unmappedReadsInfo$FileName1 <- unmappedReadsFile1
            unmappedReadsInfo$FileName2 <- unmappedReadsFile2
            # make sure that the temp files are deleted
            on.exit(file.remove(unmappedReadsFile1))
            on.exit(file.remove(unmappedReadsFile2), add = TRUE)
        }

        # for the current sample, create alignments against all the aux files
        for (j in auxNrs) {
            samFile <- tempfile(tmpdir = cacheDir,
                                pattern = basename(proj@reads[sampleNr, 1]),
                                fileext = ".sam")
            bamFileNoUnmapped <- tempfile(tmpdir = cacheDir,
                                          pattern = basename(proj@reads[sampleNr, 1]),
                                          fileext = ".bam")

            if (proj@alnModeID == "Rbowtie") {
                if (!proj@splicedAlignment) {
                    align_Rbowtie(paste(proj@aux$FileName[j], proj@alnModeID, sep = "."),
                                  unmappedReadsInfo, proj@samplesFormat,
                                  proj@paired, proj@alignmentParameter,
                                  coresThisNode, samFile, cacheDir)
                } else {
                    align_RbowtieSpliced(proj@aux$FileName[j],
                                         paste(proj@aux$FileName[j], proj@alnModeID,
                                               sep = "."),
                                         unmappedReadsInfo, proj@samplesFormat,
                                         proj@paired, proj@alignmentParameter,
                                         coresThisNode, samFile, cacheDir)
                }
            } else if (proj@alnModeID == "RbowtieCtoT") {
                if (proj@bisulfite == "dir") {
                    align_RbowtieCtoT_dir(paste(proj@aux$FileName[j], proj@alnModeID,
                                                sep = "."),
                                          unmappedReadsInfo, proj@samplesFormat,
                                          proj@paired, proj@alignmentParameter,
                                          FALSE, proj@maxHits,
                                          coresThisNode, samFile, cacheDir)
                } else {
                    align_RbowtieCtoT_undir(paste(proj@aux$FileName[j], proj@alnModeID,
                                                  sep = "."),
                                            unmappedReadsInfo, proj@samplesFormat,
                                            proj@paired, proj@alignmentParameter,
                                            FALSE, proj@maxHits,
                                            coresThisNode, samFile, cacheDir)
                }
            } else if (proj@alnModeID == "Rhisat2") {
                align_Rhisat2(paste(proj@aux$FileName[j], proj@alnModeID, sep = "."),
                              unmappedReadsInfo, proj@samplesFormat, proj@paired,
                              proj@alignmentParameter, coresThisNode, samFile,
                              cacheDir, proj@splicedAlignment, proj@maxHits)
            } else {
                stop("Fatal error 23484303")
            }

            # remove the unmapped reads and convert to sorted bam
            worker_message(
              task_prefix, "Converting sam file to sorted bam file: ", samFile)
            .Call(removeUnmappedFromSamAndConvertToBam, samFile, bamFileNoUnmapped)
            file.remove(samFile)
            # sort bam
            Rsamtools::sortBam(bamFileNoUnmapped,
                               tools::file_path_sans_ext(proj@auxAlignments[j, sampleNr]))
            Rsamtools::indexBam(proj@auxAlignments[j, sampleNr])
            file.remove(bamFileNoUnmapped)

            # create the info file for the bam file
            bamInfo <- qProjectBamInfo(proj, sampleNr, j)
            utils::write.table(bamInfo,
                               paste(proj@auxAlignments[j, sampleNr],
                                     "txt", sep = "."),
                               sep = "\t", quote = FALSE, col.names = FALSE)

            worker_message(
              task_prefix, "Auxiliary alignments ", j, " for sample ", sampleNr,
              " (", proj@reads$SampleName[sampleNr],
              ") have been successfully created")

  }

        # if one process stops due to an error, catch it, concatenate the
        # message with specific information about
        # the compute node and then print it to the log file. this procedure
        # provides the information about which
        # sample was processed and on which machine when the error occured.
    }, error = function(ex) {
        emsg <- paste(task_prefix,
                      "Error processing sample",
                      proj@reads[sampleNr, 1], ":", ex$message)
        worker_message(emsg)
        stop(emsg)
    }, finally = {
        sink() # close the redirection of the print statements
    })
}

#' @keywords internal
#' @import Rbowtie
align_Rbowtie <- function(indexDir, reads, samplesFormat, paired,
                          alignmentParameter, threads, outFile, cacheDir) {

    # add some variable parameters based on the input format
    if (samplesFormat == "fasta") {
        alignmentParameterAdded <- "-f"
    } else {
        alignmentParameterAdded <- paste("--phred", reads$phred, "-quals", sep = "")
    }

    worker_message(
      " - Executing bowtie using ", threads, " cores. Parameters:")
    if (paired == "no") {
        args <- paste(shQuote(file.path(indexDir, "bowtieIndex")),
                      shQuote(reads$FileName), alignmentParameter,
                      alignmentParameterAdded, "-S", "-p", threads, shQuote(outFile))
        worker_message("   ", args)
        ret <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                       args, stdout = TRUE, stderr = TRUE)
    } else {
        args <- paste(shQuote(file.path(indexDir, "bowtieIndex")),
                      "-1", shQuote(reads$FileName1),
                      "-2", shQuote(reads$FileName2),
                      paste("--", paired, sep = ""), alignmentParameter,
                      alignmentParameterAdded, "-S", "-p", threads, shQuote(outFile))
        worker_message("   ", args)
        ret <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                       args, stdout = TRUE, stderr = TRUE)
    }
    if (!(grepl(" alignments", ret[length(ret)]))) {
        stop("bowtie failed to perform the alignments")
    }
}

#' @keywords internal
align_Rhisat2 <- function(indexDir, reads, samplesFormat, paired,
                          alignmentParameter, threads, outFile, cacheDir,
                          splicedAlignment, maxHits) {
    # add some variable parameters based on the input format
    if (samplesFormat == "fasta") {
        alignmentParameterAdded <- "-f"
    } else {
        alignmentParameterAdded <- paste("--phred", reads$phred, sep = "")
    }
    worker_message(
      " - Executing hisat2 using ", threads, " cores. Parameters:")
    if (paired == "no") {
        args <- paste(shQuote(file.path(indexDir, "hisat2Index")),
                      shQuote(reads$FileName), alignmentParameter,
                      alignmentParameterAdded, "-p", threads,
                      "-S", shQuote(paste(outFile, "tmp", sep = ".")))
    } else {
        args <- paste(shQuote(file.path(indexDir, "hisat2Index")),
                      "-1", shQuote(reads$FileName1), "-2", shQuote(reads$FileName2),
                      paste0("--", paired), alignmentParameter, alignmentParameterAdded,
                      "-p", threads, "-S", shQuote(paste(outFile, "tmp", sep = ".")))
    }
    if (!splicedAlignment) {
        args <- paste(args, "--no-spliced-alignment")
    }
    worker_message("   ", args)
    ret <- system2(file.path(system.file(package = "Rhisat2"), "hisat2"),
                   args, stdout = TRUE, stderr = TRUE)
    if (!(grepl(" reads", ret[1]))) {
        stop("hisat2 failed to perform the alignments")
    }

    ## Filter alignments (keep only reads with at most maxHits alignments, only 1
    ## hit for multimapping reads)
    fhs <- .Call(filterHisat2, paste(outFile, "tmp", sep = "."),
                 outFile, as.integer(maxHits))
    worker_message("   ", "Number of filtered secondary alignments:", fhs["n_secondary"])
    worker_message("   ", "Number of filtered overmapped alignments:", fhs["n_overmapped"])
}

#' @keywords internal
#' @importFrom Rbowtie SpliceMap
#' @importFrom Rsamtools scanFaIndex
align_RbowtieSpliced <- function(genomeFilepath, indexDir, reads, samplesFormat,
                                 paired, alignmentParameter, threads,
                                 outFile, cacheDir) {
    # determine the number of chromosomes (or sequences in case of aux). this is needed to ensure that no more threads
    # than chromosomes are used in the spliced alignment step of SpliceMap
    nrChr <- length(Rsamtools::scanFaIndex(genomeFilepath))
    nrChrTogether <- min(threads, nrChr)

    # parse alignment parameters
    keyValueMatrix <- matrix(unlist(strsplit(alignmentParameter,
                                             "\\s+", perl = TRUE)),
                             ncol = 2, byrow = TRUE)
    if (!all(substr(keyValueMatrix[, 1], 1, 1) == "-")) {
        stop(paste("The parameters for spliced-aligment are in an incorrect format:",
                   alignmentParameter))
    }

    rownames(keyValueMatrix) <- substring(keyValueMatrix[, 1], 2)
    sm_cfg <- as.list(keyValueMatrix[, 2])

    # convert integer strings to actual integers
    all.numbers <- grep("^[[:digit:]]*$", keyValueMatrix[, 2])
    sm_cfg[all.numbers] <- lapply(sm_cfg[all.numbers], as.integer)

    # convert boolean to actual logicals
    all.logicals <- grep("^(TRUE|FALSE)$", keyValueMatrix[, 2])
    sm_cfg[all.logicals] <- lapply(sm_cfg[all.logicals], as.logical)

    sm_cfg[["genome_dir"]] <- genomeFilepath
    if (paired == "no") {
        sm_cfg[["reads_list1"]] <- reads$FileName
    } else {
        sm_cfg[["reads_list1"]] <- reads$FileName1
        sm_cfg[["reads_list2"]] <- reads$FileName2
    }
    sm_cfg[["read_format"]] <- toupper(samplesFormat)
    if (samplesFormat == "fastq") {
        sm_cfg[["quality_format"]] <- paste("phred", reads$phred, sep = "-")
    }
    sm_cfg[["temp_path"]] <- cacheDir
    sm_cfg[["num_chromosome_together"]] <- nrChrTogether
    sm_cfg[["num_threads"]] <- threads
    sm_cfg[["bowtie_base_dir"]] <- file.path(indexDir, "bowtieIndex")
    sm_cfg[["outfile"]] <- outFile

    sm_cfgParString <- cbind(paste("-", as.character(names(sm_cfg)), sep = ""),
                             as.character(sm_cfg))
    worker_message(" - Executing Splicemap using", threads, "cores. Parameters:")
    worker_message("   ", paste(sm_cfgParString[, 1], sm_cfgParString[, 2]), collapse = " ")

    Rbowtie::SpliceMap(sm_cfg)
}

#' @keywords internal
#' @import Rbowtie
align_RbowtieCtoT_dir <- function(indexDir, reads, samplesFormat, paired,
                                  alignmentParameter, allelic, maxHits,
                                  threads, outFile, cacheDir) {
    # add some variable parameters based on the input format
    if (samplesFormat == "fasta") {
        alignmentParameterAdded <- "-f"
    } else {
        alignmentParameterAdded <- paste("--phred", reads$phred, "-quals", sep = "")
    }

    # set the format of the read identifier. this is necessary for mergeReorderSam outside of this function in allelic mode
    if (!allelic) {
        idMode <- 1
    } else {
        idMode <- 3
    }

    worker_message(" - Executing bowtie (CtoT and GtoA) using", threads, "cores. Parameters:")
    if (paired == "no") {
        # CtoT convert the reads. include the original sequence in the identifier.
        readsCtoT <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName), "readsCtoT_", sep = "_"),
            fileext = paste(".", samplesFormat, sep = "")
        )
        .Call(convertReadsIdBisRc, reads$FileName, readsCtoT, c("C", "T"), FALSE)
        # make sure that the temp file is deleted
        on.exit(file.remove(readsCtoT), add = TRUE)

        # create temp filenames for the aligment results
        readsCtoT_genomeCtoT <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName), "readsCtoT_genomeCtoT_", sep = "_"),
            fileext = ".sam"
        )
        readsCtoT_genomeGtoA <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName), "readsCtoT_genomeGtoA_", sep = "_"),
            fileext = ".sam"
        )
        # make sure that the temp files are deleted
        on.exit(file.remove(readsCtoT_genomeCtoT), add = TRUE)
        on.exit(file.remove(readsCtoT_genomeGtoA), add = TRUE)

        argsCtoT <- paste(shQuote(file.path(indexDir, "bowtieIndexCtoT")),
                          shQuote(readsCtoT), alignmentParameter,
                          alignmentParameterAdded, "-S", "-p", threads,
                          "--norc", shQuote(readsCtoT_genomeCtoT))
        argsGtoA <- paste(shQuote(file.path(indexDir, "bowtieIndexGtoA")),
                          shQuote(readsCtoT), alignmentParameter,
                          alignmentParameterAdded, "-S", "-p", threads,
                          "--nofw", shQuote(readsCtoT_genomeGtoA))
        worker_message("   ", argsCtoT)
        worker_message("   ", argsGtoA)

        # perform two alignments, readsCtoT agains genomeCtoT (plus strand)
        # and readsCtoT agains genomeGtoA (minus strand)
        ret1 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                        argsCtoT, stdout = TRUE, stderr = TRUE)
        ret2 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                        argsGtoA, stdout = TRUE, stderr = TRUE)

        if (!(grepl(" alignments", ret1[length(ret1)]))) {
            stop("bowtie (CtoT) failed to perform the alignments")
        }
        if (!(grepl(" alignments", ret2[length(ret2)]))) {
            stop("bowtie (GtoA) failed to perform the alignments")
        }

        worker_message("   ", "merging 2 sam files")
        mrQuSize <- .Call(mergeReorderSam, c(readsCtoT_genomeCtoT,
                                             readsCtoT_genomeGtoA),
                          outFile, as.integer(idMode), as.integer(maxHits))
        worker_message(
            "   ", "maximal queue size during merging:", mrQuSize)

    } else if (paired == "fr") {
        # CtoT convert the reads. include the original sequence in the identifier.
        readsCtoT_1 <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName1), "readsCtoT_1_", sep = "_"),
            fileext = paste(".", samplesFormat, sep = "")
        )
        readsCtoT_2 <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName1), "readsCtoT_2_", sep = "_"),
            fileext = paste(".", samplesFormat, sep = "")
        )
        .Call(convertReadsIdBisRc, reads$FileName1, readsCtoT_1, c("C", "T"), FALSE)
        .Call(convertReadsIdBisRc, reads$FileName2, readsCtoT_2, c("C", "T"), TRUE) # reverse complement the second read because its fr
        # make sure that the temp files are deleted
        on.exit(file.remove(readsCtoT_1), add = TRUE)
        on.exit(file.remove(readsCtoT_2), add = TRUE)

        # create temp filenames for the aligment results
        readsCtoT_genomeCtoT <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName1),
                            "readsCtoT_genomeCtoT_", sep = "."),
            fileext = ".sam"
        )
        readsCtoT_genomeGtoA <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName1),
                            "readsCtoT_genomeGtoA_", sep = "."),
            fileext = ".sam"
        )
        # make sure that the temp files are deleted
        on.exit(file.remove(readsCtoT_genomeCtoT), add = TRUE)
        on.exit(file.remove(readsCtoT_genomeGtoA), add = TRUE)

        argsCtoT <- paste(shQuote(file.path(indexDir, "bowtieIndexCtoT")),
                          "-1", shQuote(readsCtoT_1),
                          "-2", shQuote(readsCtoT_2),
                          "--ff", alignmentParameter, alignmentParameterAdded,
                          "-S", "-p", threads, "--norc", shQuote(readsCtoT_genomeCtoT))
        argsGtoA <- paste(shQuote(file.path(indexDir, "bowtieIndexGtoA")),
                          "-1", shQuote(readsCtoT_1),
                          "-2", shQuote(readsCtoT_2),
                          "--ff", alignmentParameter, alignmentParameterAdded,
                          "-S", "-p", threads, "--nofw", shQuote(readsCtoT_genomeGtoA))
        worker_message("   ", argsCtoT)
        worker_message("   ", argsGtoA)

        # perform two alignments, readsCtoT against genomeCtoT (plus strand) and
        # readsCtoT against genomeGtoA (minus strand)
        ret1 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                        argsCtoT, stdout = TRUE, stderr = TRUE)
        ret2 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                        argsGtoA, stdout = TRUE, stderr = TRUE)

        if (!(grepl(" alignments", ret1[length(ret1)]))) {
            stop("bowtie (CtoT) failed to perform the alignments")
        }
        if (!(grepl(" alignments", ret2[length(ret2)]))) {
            stop("bowtie (GtoA) failed to perform the alignments")
        }

        worker_message("   ", "merging 2 sam files")
        mrQuSize <- .Call(mergeReorderSam,
                          c(readsCtoT_genomeCtoT, readsCtoT_genomeGtoA),
                          outFile, as.integer(idMode), as.integer(maxHits))
        worker_message(
            "   ", "maximal queue size during merging:", mrQuSize)
    }
}

# For undirected bisulfite, these are the four alignments that are being produced
#
# single end:
#    read        genome
# 0  C->T        C->T Plus
# 1  C->T        G->A Minus
# 2  rc, C->T    C->T Plus
# 3  rc, C->T    G->A Minus
#
# paired end:
#    read1       read2        genome
# 0  C->T        rc, C->T     C->T Plus
# 1  C->T        rc, C->T     G->A Minus
# 2  rc, C->T    C->T *       C->T Plus   -| for 2&3, swap first and second read
# 3  rc, C->T    C->T *       G->A Minus  -|
#
# * reverse complemented twice which cancels out

#' @keywords internal
#' @import Rbowtie
align_RbowtieCtoT_undir <- function(indexDir, reads, samplesFormat, paired,
                                    alignmentParameter, allelic, maxHits,
                                    threads, outFile, cacheDir) {
    # add some variable parameters based on the input format
    if (samplesFormat == "fasta") {
        alignmentParameterAdded <- "-f"
    } else {
        alignmentParameterAdded <- paste("--phred", reads$phred, "-quals", sep = "")
    }

    # set the format of the read identifier. this is necessary for mergeReorderSam outside of this function in allelic mode
    if (!allelic) {
        idMode <- 1
    } else {
        idMode <- 3
    }

    worker_message(" - Executing bowtie (CtoT and GtoA) using", threads, "cores. Parameters:")
    if (paired == "no") {

        # CtoT convert the reads. include the original sequence in the identifier.
        readsCtoT <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName), "readsCtoT_", sep = "_"),
            fileext = paste(".", samplesFormat, sep = "")
        )
        readsRcCtoT <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName), "readsRcCtoT_", sep = "_"),
            fileext = paste(".", samplesFormat, sep = "")
        )
        .Call(convertReadsIdBisRc, reads$FileName, readsCtoT, c("C", "T"), FALSE)
        .Call(convertReadsIdBisRc, reads$FileName, readsRcCtoT, c("C", "T"), TRUE)
        # make sure that the temp files are deleted
        on.exit(file.remove(readsCtoT), add = TRUE)
        on.exit(file.remove(readsRcCtoT), add = TRUE)

        # create temp filenames for the aligment results
        readsCtoT_genomeCtoT <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName),
                            "readsCtoT_genomeCtoT_", sep = "_"),
            fileext = ".sam"
        )
        readsCtoT_genomeGtoA <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName),
                            "readsCtoT_genomeGtoA_", sep = "_"),
            fileext = ".sam"
        )
        readsRcCtoT_genomeCtoT <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName),
                            "readsRcCtoT_genomeCtoT_", sep = "_"),
            fileext = ".sam"
        )
        readsRcCtoT_genomeGtoA <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName),
                            "readsRcCtoT_genomeGtoA_", sep = "_"),
            fileext = ".sam"
        )

        # make sure that the temp files are deleted
        on.exit(file.remove(readsCtoT_genomeCtoT), add = TRUE)
        on.exit(file.remove(readsCtoT_genomeGtoA), add = TRUE)
        on.exit(file.remove(readsRcCtoT_genomeCtoT), add = TRUE)
        on.exit(file.remove(readsRcCtoT_genomeGtoA), add = TRUE)

        # compile bowtie parameters for the four alignments
        args0 <- paste(shQuote(file.path(indexDir, "bowtieIndexCtoT")),
                       shQuote(readsCtoT), alignmentParameter,
                       alignmentParameterAdded, "-S", "-p", threads,
                       "--norc", shQuote(readsCtoT_genomeCtoT))
        args1 <- paste(shQuote(file.path(indexDir, "bowtieIndexGtoA")),
                       shQuote(readsCtoT), alignmentParameter,
                       alignmentParameterAdded, "-S", "-p", threads,
                       "--nofw", shQuote(readsCtoT_genomeGtoA))
        args2 <- paste(shQuote(file.path(indexDir, "bowtieIndexCtoT")),
                       shQuote(readsRcCtoT), alignmentParameter,
                       alignmentParameterAdded, "-S", "-p", threads,
                       "--norc", shQuote(readsRcCtoT_genomeCtoT))
        args3 <- paste(shQuote(file.path(indexDir, "bowtieIndexGtoA")),
                       shQuote(readsRcCtoT), alignmentParameter,
                       alignmentParameterAdded, "-S", "-p", threads,
                       "--nofw", shQuote(readsRcCtoT_genomeGtoA))

        worker_message("   ", args0)
        worker_message("   ", args1)
        worker_message("   ", args2)
        worker_message("   ", args3)

        # perform four alignments, readsCtoT agains genomeCtoT (plus strand) and
        # readsCtoT agains genomeGtoA (minus strand)
        ret1 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                        args0, stdout = TRUE, stderr = TRUE)
        ret2 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                        args1, stdout = TRUE, stderr = TRUE)
        ret3 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                        args2, stdout = TRUE, stderr = TRUE)
        ret4 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                        args3, stdout = TRUE, stderr = TRUE)

        if (!(grepl(" alignments", ret1[length(ret1)]))) {
            stop("bowtie (CtoT) failed to perform the alignments")
        }
        if (!(grepl(" alignments", ret2[length(ret2)]))) {
            stop("bowtie (GtoA) failed to perform the alignments")
        }
        if (!(grepl(" alignments", ret1[length(ret1)]))) {
            stop("bowtie (RC, CtoT) failed to perform the alignments")
        }
        if (!(grepl(" alignments", ret2[length(ret2)]))) {
            stop("bowtie (RC, GtoA) failed to perform the alignments")
        }

        worker_message("   ", "merging 4 sam files")
        mrQuSize <- .Call(mergeReorderSam,
                          c(readsCtoT_genomeCtoT, readsCtoT_genomeGtoA,
                            readsRcCtoT_genomeCtoT, readsRcCtoT_genomeGtoA),
                          outFile, as.integer(idMode), as.integer(maxHits))
        worker_message(
            "   ", "maximal queue size during merging:", mrQuSize)

    } else if (paired == "fr") {

        # CtoT convert the reads. include the original sequence in the identifier.
        readsCtoT_1 <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName1), "readsCtoT_1_", sep = "_"),
            fileext = paste(".", samplesFormat, sep = "")
        )
        readsCtoT_2 <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName1), "readsCtoT_2_", sep = "_"),
            fileext = paste(".", samplesFormat, sep = "")
        )
        readsRcCtoT_1 <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName1), "readsRcCtoT_1_", sep = "_"),
            fileext = paste(".", samplesFormat, sep = "")
        )
        readsRcCtoT_2 <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName1), "readsRcCtoT_2_", sep = "_"),
            fileext = paste(".", samplesFormat, sep = "")
        )

        .Call(convertReadsIdBisRc, reads$FileName1, readsCtoT_1, c("C", "T"), FALSE)
        .Call(convertReadsIdBisRc, reads$FileName2, readsCtoT_2, c("C", "T"), TRUE) # reverse complement the second read because its fr
        .Call(convertReadsIdBisRc, reads$FileName1, readsRcCtoT_1, c("C", "T"), TRUE)
        .Call(convertReadsIdBisRc, reads$FileName2, readsRcCtoT_2, c("C", "T"), FALSE) # don't reverse complement the second read because its like reverse complementing twice

        # make sure that the temp files are deleted
        on.exit(file.remove(readsCtoT_1), add = TRUE)
        on.exit(file.remove(readsCtoT_2), add = TRUE)
        on.exit(file.remove(readsRcCtoT_1), add = TRUE)
        on.exit(file.remove(readsRcCtoT_2), add = TRUE)

        # create temp filenames for the aligment results
        readsCtoT_genomeCtoT <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName1),
                            "readsCtoT_genomeCtoT_", sep = "."),
            fileext = ".sam"
        )
        readsCtoT_genomeGtoA <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName1),
                            "readsCtoT_genomeGtoA_", sep = "."),
            fileext = ".sam"
        )
        readsRcCtoT_genomeCtoT <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName1),
                            "readsRcCtoT_genomeCtoT_", sep = "."),
            fileext = ".sam"
        )
        readsRcCtoT_genomeGtoA <- tempfile(
            tmpdir = cacheDir,
            pattern = paste(basename(reads$FileName1),
                            "readsRcCtoT_genomeGtoA_", sep = "."),
            fileext = ".sam"
        )

        # make sure that the temp files are deleted
        on.exit(file.remove(readsCtoT_genomeCtoT), add = TRUE)
        on.exit(file.remove(readsCtoT_genomeGtoA), add = TRUE)
        on.exit(file.remove(readsRcCtoT_genomeCtoT), add = TRUE)
        on.exit(file.remove(readsRcCtoT_genomeGtoA), add = TRUE)

        args0 <- paste(shQuote(file.path(indexDir, "bowtieIndexCtoT")),
                       "-1", shQuote(readsCtoT_1),
                       "-2", shQuote(readsCtoT_2),
                       "--ff", alignmentParameter, alignmentParameterAdded,
                       "-S", "-p", threads, "--norc", shQuote(readsCtoT_genomeCtoT))
        args1 <- paste(shQuote(file.path(indexDir, "bowtieIndexGtoA")),
                       "-1", shQuote(readsCtoT_1),
                       "-2", shQuote(readsCtoT_2),
                       "--ff", alignmentParameter, alignmentParameterAdded,
                       "-S", "-p", threads, "--nofw", shQuote(readsCtoT_genomeGtoA))
        args2 <- paste(shQuote(file.path(indexDir, "bowtieIndexCtoT")),
                       "-2", shQuote(readsRcCtoT_1),
                       "-1", shQuote(readsRcCtoT_2),
                       "--ff", alignmentParameter, alignmentParameterAdded,
                       "-S", "-p", threads, "--norc", shQuote(readsRcCtoT_genomeCtoT))
        args3 <- paste(shQuote(file.path(indexDir, "bowtieIndexGtoA")),
                       "-2", shQuote(readsRcCtoT_1),
                       "-1", shQuote(readsRcCtoT_2),
                       "--ff", alignmentParameter, alignmentParameterAdded,
                       "-S", "-p", threads, "--nofw", shQuote(readsRcCtoT_genomeGtoA))

        worker_message("   ", args0)
        worker_message("   ", args1)
        worker_message("   ", args2)
        worker_message("   ", args3)

        # perform four alignments, readsCtoT agains genomeCtoT (plus strand) and
        # readsCtoT agains genomeGtoA (minus strand)
        ret1 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                        args0, stdout = TRUE, stderr = TRUE)
        ret2 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                        args1, stdout = TRUE, stderr = TRUE)
        ret3 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                        args2, stdout = TRUE, stderr = TRUE)
        ret4 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie"),
                        args3, stdout = TRUE, stderr = TRUE)

        if (!(grepl(" alignments", ret1[length(ret1)]))) {
            stop("bowtie (CtoT) failed to perform the alignments")
        }
        if (!(grepl(" alignments", ret2[length(ret2)]))) {
            stop("bowtie (GtoA) failed to perform the alignments")
        }
        if (!(grepl(" alignments", ret1[length(ret1)]))) {
            stop("bowtie (RC, CtoT) failed to perform the alignments")
        }
        if (!(grepl(" alignments", ret2[length(ret2)]))) {
            stop("bowtie (RC, GtoA) failed to perform the alignments")
        }

        worker_message("   ", "merging 4 sam files")
        mrQuSize <- .Call(mergeReorderSam,
                          c(readsCtoT_genomeCtoT, readsCtoT_genomeGtoA,
                            readsRcCtoT_genomeCtoT, readsRcCtoT_genomeGtoA),
                          outFile, as.integer(idMode), as.integer(maxHits))
        worker_message(
            "   ", "maximal queue size during merging:", mrQuSize)
    }
}


# For a given sample, add an integer to the id. This is necessary for allelic analysis
# when calling mergeReorderSam
#' @keywords internal
#' @importFrom tools file_ext
addNumericToID <- function(reads, paired, cacheDir) {

    if (paired == "no") {
        readsFileNameTmp <- tempfile(
            tmpdir = cacheDir,
            pattern = basename(reads$FileName),
            paste(".", fileext = tools::file_ext(reads$FileName), sep = "")
        )
        .Call(convertReadsIdBisRc, reads$FileName, readsFileNameTmp, NULL, FALSE)
        reads$FileName <- readsFileNameTmp
    } else {
        readsFileNameTmp1 <- tempfile(
            tmpdir = cacheDir,
            pattern = basename(reads$FileName1),
            paste(".", fileext = tools::file_ext(reads$FileName1), sep = "")
        )
        readsFileNameTmp2 <- tempfile(
            tmpdir = cacheDir,
            pattern = basename(reads$FileName2),
            paste(".", fileext = tools::file_ext(reads$FileName2), sep = "")
        )
        .Call(convertReadsIdBisRc, reads$FileName1, readsFileNameTmp1, NULL, FALSE)
        .Call(convertReadsIdBisRc, reads$FileName2, readsFileNameTmp2, NULL, FALSE)
        reads$FileName1 <- readsFileNameTmp1
        reads$FileName2 <- readsFileNameTmp2
    }
    return(reads)
}


# helper function executed in parallel by samToSortedBamParallel
#' @keywords internal
#' @importFrom Rsamtools asBam sortBam
samToSortedBamCore <- function(ind, paramsL) {
    set.seed(0)
    params <- paramsL[[ind]]

    # don't sort in the case of splitChrSam_unaligned
    if (basename(params[2]) != "splitChrSam_unaligned") {
        bamtempFile <- tempfile()
        Rsamtools::asBam(params[1], bamtempFile, indexDestination = FALSE)
        on.exit(file.remove(bamtempFile))
        Rsamtools::sortBam(paste(bamtempFile, "bam", sep = "."), params[2])
    } else {
        Rsamtools::asBam(params[1], params[2], indexDestination = FALSE)
    }
}

# convert a sam file to a sorted bam file in parallel fashion using p threads.
# it splits the sam file into individual chromosomes, creates a cluster object with
# p nodes and sort and converts to bam in parallel fashion. After this step, the bam
# files are concatentated (in the order of the header of the original sam file and
# an index in built for the final bam file
#' @keywords internal
#' @importFrom parallel makeCluster stopCluster clusterEvalQ clusterApplyLB
#' @importFrom Rsamtools indexBam
samToSortedBamParallel <- function(file, destination, p, cacheDir = NULL) {
    # test if the input file exists
    if (!file.exists(file)) {
        stop("Cannot read ", file, call. = FALSE)
    }

    if (is.null(cacheDir))
        cacheDir <- tempdir()

    # split the input sam file into seperate files, one per chromosome in
    # a temporary directory
    splitDir <- tempfile(tmpdir = cacheDir, pattern = "samToBam_")
    if (!dir.create(path = splitDir, showWarnings = FALSE)) {
        stop("No permissions to create a directory in the cacheDir", call. = FALSE)
    }
    # make sure that the temp dir is deleted
    on.exit(unlink(splitDir, recursive = TRUE))

    # perform the split
    chrNames <- .Call(splitSamChr, file, splitDir)

    # collect the sam files that are not empty. The empty ones would cause a
    # problem during sam to bam conversion
    splitSamAndBamNames <- NULL
    for (i in seq_len(length(chrNames))) {
        samName <- file.path(splitDir, paste(chrNames[i], "sam", sep = "."))
        bamName <- file.path(splitDir, chrNames[i])
        con <- file(samName, "r")
        fileHead <- scan(con, as.list(rep("character", 20)),
                         sep = "\t", comment.char = "@", fill = TRUE,
                         nmax = 30, quiet = TRUE)
        if (length(fileHead[[1]]) > 0) {
            splitSamAndBamNames[[length(splitSamAndBamNames) + 1]] <-
                c(samName, bamName)
        }
        close(con)
    }

    # sort the jobs based on the file sizes
    sortedOrder <- order(file.info(do.call(rbind, splitSamAndBamNames)[, 1])$size,
                         decreasing = TRUE)

    clObjS <- parallel::makeCluster(p)
    on.exit(parallel::stopCluster(clObjS), add = TRUE)

    # load QuasR package on all the nodes
    loadQuasR(clObjS)

    parallel::clusterApplyLB(clObjS, seq_len(length(splitSamAndBamNames)),
                             samToSortedBamCore,
                             splitSamAndBamNames[sortedOrder])

    # concatenate all the sorted bam files in the order of the original sam file header
    .Call(catBam, paste0(do.call(rbind, splitSamAndBamNames)[, 2], ".bam"),
          paste0(destination, ".bam"))

    # create index for the final bam file
    Rsamtools::indexBam(paste0(destination, ".bam"))

    invisible(paste0(destination, ".bam"))
}

context("createAlignments-functions")

samf  <- system.file("unitTests", "cases", "ex1.sam.gz", package = "Rsamtools")
bout1 <- tempfile(tmpdir = "extdata")
bamf  <- Rsamtools::asBam(file = samf, destination = bout1)
bout2 <- tempfile(tmpdir = "extdata")

test_that("samToSortedBamParallel correctly digests its arguments", {
    expect_error(QuasR:::samToSortedBamParallel(file = "nonexistent.sam", destination = bout2, p = 2L, cacheDir = NULL))
    expect_error(QuasR:::samToSortedBamParallel(file = samf,              destination = bout2, p = 2L, cacheDir = "error"))
})

test_that("samToSortedBamParallel works as expected", {
    bamout <- QuasR:::samToSortedBamParallel(file = samf, destination = bout2, p = 2L, cacheDir = NULL)
    expect_identical(bamout, paste0(bout2, ".bam"))
    expect_identical(unname(alignmentStats(bamout)),
                     unname(alignmentStats(bamf)))
})

# proj       : qProject object
# query      : NULL (whole genome)
#              GRanges object (only quantify C's in these regions)
# reportLevel: "C" or "alignment"
# mode       : "allC"            : all C's (+/- strands separate)
#              "CpG"             : only C's in CpG context (+/- strands separate)
#              "CpGcomb"(default): only C's in CpG context (+/- strands collapsed)
#              "var"             : variant detection (all C's, +/- strands separate)
# collapseBySample : combine (sum) counts from bamfiles with the same sample name
# collapseByQueryRegion : combine (sum) counts for C's per query region
# asGRanges  : return value as GRanges object or data.frame
# mask       : mask genomic regions (e.g. unmappable regions)
# reference  : source of bam files ("genome" or AuxName)
# keepZero   : return C's with total==0 in results
# mapqMin    : minimal mapping quality
# mapqMax    : maximal mapping quality
# clObj      : cluster object for parallelization
#
# value      : if asGRanges==TRUE, GRanges object with one region per quantified C and two metadata columns per sample (_T, _M)
#              else, data.frame with one row per quantified C and in the columns the coordinates of the C, as well as two count (_T, _M) per sample

# TODO:
# - support for gapped aligments (parsing of cigar strings at C level)
# - ignore presumable PCR duplicates (multiple alignment pairs with same external coordinates)
# - ignore overlapping read pairs (insert size smaller than twice the read length)

#' Quantify DNA methylation
#'
#' Quantify methylation of cytosines from bisulfite sequencing data.
#'
#' \code{qMeth} can be used on a \code{qProject} object from a bisulfite
#' sequencing experiment (sequencing of bisulfite-converted DNA), such as
#' the one returned by \code{\link[QuasR]{qAlign}} when its parameter
#' \code{bisulfite} is set to a different value than \dQuote{no}.
#'
#' \code{qMeth} quantifies DNA methylation by counting total and
#' methylated events for individual cytosines, using the alignments that
#' have been generated in converted (three-letter) sequence space for
#' example by \code{\link[QuasR]{qAlign}}. A methylated event corresponds
#' to a C/C match in the alignment, an unmethylated event to a T/C mismatch
#' (or G/G matches and A/G mismatches on the opposite strand). For paired-end
#' samples, the part of the left fragment alignment that overlaps
#' with the right fragment alignment is ignored, preventing the
#' use of redundant information coming from the same molecule.
#'
#' Both directed (\code{bisulfite}=\dQuote{dir}) and undirected
#' (\code{bisulfite}=\dQuote{undir}) experimental protocols are supported
#' by \code{\link[QuasR]{qAlign}} and \code{qMeth}.
#'
#' By default, results are returned per C nucleotide. If
#' \code{reportLevel}=\dQuote{alignment}, results are reported separately
#' for individual alignments. In that case, \code{query} has to be a
#' \code{GRanges} object with exactly one region, \code{mode} has to be
#' either \dQuote{CpG} or \dQuote{allC}, the arguments
#' \code{collapseByQueryRegion}, \code{asGRanges}, \code{mask} and
#' \code{keepZero} have no effect and allele-specific projects are
#' treated in the same way as normal (non-allele specific) projects.
#'
#' Using the parameter \code{mode}, quantification can be limited to
#' cytosines in CpG context, and counts obtained for the two cytosines on
#' opposite strands within a single CpG can be combined (summed).
#'
#' The quantification of methylation for all cytosines in the query region(s)
#' (\code{mode}=\dQuote{allC}) should be done with care, especially for
#' large query regions, as the return value may require a large amount of
#' memory.
#'
#' If \code{mode} is set to \dQuote{var}, \code{qMeth} only counts reads
#' from the strand opposite of the cytosine and reports total and
#' matching alignments. For a position identical to the reference
#' sequence, only matches (and very few sequencing errors) are
#' expected, independent on the methylation state of the cytosine. A
#' reduced fraction of alignments matching the reference are indicative
#' of sequence variations in the sequenced sample.
#'
#' \code{mapqMin} and \code{mapqMax} allow to select alignments
#' based on their mapping qualities. \code{mapqMin} and \code{mapqMax} can
#' take integer values between 0 and 255 and equal to
#' \eqn{-10 log_{10} Pr(\textnormal{mapping position is wrong})}{-10
#' log10 Pr(mapping position is wrong)}, rounded to the nearest
#' integer. A value 255 indicates that the mapping quality is not available.
#'
#' If an object that inherits from class \code{cluster} is provided to
#' the \code{clObj} argument, for example an object returned by
#' \code{\link[parallel]{makeCluster}} from package \pkg{parallel},
#' the quantification task is split into multiple chunks and processed in
#' parallel using \code{\link[parallel:clusterApply]{clusterApplyLB}} from package
#' \pkg{parallel}. Not all tasks will be efficiently parallelized: For
#' example, a single query region and a single (group of) bam files will
#' not be split into multiple chunks.
#'
#' @param proj A \code{qProject} object from a bisulfite sequencing experiment
#' @param query A \code{GRanges} object with the regions to be
#'   quantified. If \code{NULL}, all available target sequences (e.g. the
#'   whole genome) will be analyzed. Available target sequences are
#'   extracted from the header of the first bam file.
#' @param reportLevel Report results combined for C's
#'   (\code{reportLevel}=\dQuote{C}), the default) or individually for single
#'   alignments (\code{reportLevel}=\dQuote{alignment}). The latter imposes
#'   further restrictions on some arguments (see \sQuote{Details}).
#' @param mode Cytosine quantification mode, one of:
#'   \describe{
#'     \item{\code{CpGcomb}}{: only C's in CpG context (strands combined)}
#'     \item{\code{CpG}}{: only C's in CpG context (strands separate)}
#'     \item{\code{allC}}{: all C's (strands separate)}
#'     \item{\code{var}}{: variant detection (all C's, strands separate)}
#'   }
#'   \code{CpGcomb} is the default.
#' @param collapseBySample If \code{TRUE}, combine (sum) counts from
#'   bamfiles with the same sample name.
#' @param collapseByQueryRegion If \code{TRUE}, combine (sum) counts for
#'   all cytosines contained in the same query region.
#' @param asGRanges If \code{TRUE}, return results as a \code{GRanges} object;
#'   if \code{FALSE}, the results are returned as a \code{data.frame}.
#' @param mask An optional \code{GRanges} object with genomic regions to
#'   be masked, i.e. excluded from the analysis (e.g. unmappable regions).
#' @param reference Source of bam files; can be either \dQuote{genome}
#'   (then the alignments against the genome are used) or the name of an
#'   auxiliary target sequence (then alignments against this target
#'   sequence will be used). The auxiliary name must correspond to the
#'   name contained in the auxiliary file refered by the
#'   \code{auxiliaryFile} argument of \code{\link[QuasR]{qAlign}}.
#' @param keepZero If \code{FALSE}, only cytosines covered by at least
#'   one alignment will be returned; \code{keepZero} must be \code{TRUE}
#'   if multiple samples have the same sample name and
#'   \code{collapseBySample} is \code{TRUE}.
#' @param mapqMin Minimal mapping quality of alignments to be included when
#'   counting (mapping quality must be greater than or equal to
#'   \code{mapqMin}). Valid values are between 0 and 255. The default (0)
#'   will include all alignments.
#' @param mapqMax Maximal mapping quality of alignments to be included when
#'   counting (mapping quality must be less than or equal to \code{mapqMax}).
#'   Valid values are between 0 and 255. The default (255) will include
#'   all alignments.
#' @param clObj A cluster object to be used for parallel processing of
#'   multiple files (see \sQuote{Details}).
#'
#' @export
#'
#' @return
#' For \code{reportLevel}=\dQuote{C}, a \code{GRanges} object if
#' \code{asGRanges}=\code{TRUE}, otherwise a \code{data.frame}.
#'
#' Each row contains the coordinates of individual cytosines for
#' \code{collapseByQueryRegion}=\code{FALSE} or query regions
#' for \code{collapseByQueryRegion}=\code{TRUE}.
#'
#' In addition to the coordinates columns (or \code{seqnames},
#' \code{ranges} and \code{strand} slots for \code{GRanges} objects),
#' each row contains per bam file:
#'
#' Two values (total and methylated events, with suffixes _T and _M), or
#' if the \code{qProject} object was created including a SNP table,
#' six values (total and methylated events for Reference, Unknown and
#' Alternative genotypes, with suffixed _TR, _TU, _TA, _MR, _MU and _MA).
#' In the latter case, C's or CpG's that overlap with SNPs in the table
#' are removed.
#'
#' If \code{collapseBySample}=\code{TRUE}, groups of bam files with
#' identical sample name are combined (summed) and will be represented by
#' a single set of total and methylated count columns.
#'
#' If \code{mode}=\dQuote{var}, the _T and _M columns correspond to total
#' and matching alignments overlapping the guanine paired to the cytosine.
#'
#' For \code{reportLevel}=\dQuote{alignment}, a \code{list} with one
#' element per bam file or sample (depending on \code{collapseBySample}).
#' Each list element is another list with the elements:
#' \describe{
#'   \item{\code{aid}}{: character vector with unique alignment identifiers}
#'   \item{\code{Cid}}{: integer vector with genomic coordinate of C base}
#'   \item{\code{strand}}{: character vector with the strand of the C base}
#'   \item{\code{meth}}{: integer vector with methylation state for
#'   alignment and C defined by \code{aid} and \code{Cid}. The values are
#'   1 for methylated or 0 for unmethylated states.}
#' }
#'
#' @author Anita Lerch, Dimos Gaidatzis and Michael Stadler
#' @keywords utilities misc
#'
#' @seealso
#' \code{\link[QuasR]{qAlign}},
#' \code{\link[parallel]{makeCluster}} from package \pkg{parallel}
#'
#' @name qMeth
#' @aliases qMeth
#'
#' @examples
#' # copy example data to current working directory
#' file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)
#'
#' # create alignments
#' sampleFile <- "extdata/samples_bis_single.txt"
#' genomeFile <- "extdata/hg19sub.fa"
#' proj <- qAlign(sampleFile, genomeFile, bisulfite="dir")
#' proj
#'
#' # calculate methylation states
#' meth <- qMeth(proj, mode="CpGcomb")
#' meth
#'
#' @importFrom Rsamtools scanBamHeader scanFaIndex
#' @importFrom parallel clusterEvalQ clusterApplyLB
#' @importFrom Seqinfo seqlevels seqinfo seqnames
#' @importFrom IRanges IRanges
#' @importFrom GenomicRanges GRanges
qMeth <- function(proj,
                  query = NULL,
                  reportLevel = c("C", "alignment"),
                  mode = c("CpGcomb", "CpG", "allC", "var"),
                  collapseBySample = TRUE,
                  collapseByQueryRegion = FALSE,
                  asGRanges = TRUE,
                  mask = NULL,
                  reference = "genome",
                  keepZero = TRUE,
                  mapqMin = 0L,
                  mapqMax = 255L,
                  clObj = NULL) {
    ## setup variables from 'proj' ---------------------------------------------
    # 'proj' is correct type?
    if (!inherits(proj, "qProject", which = FALSE))
        stop("'proj' must be an object of type 'qProject' (returned by 'qAlign')")
    if (proj@bisulfite == "no")
        stop("'proj' is not a bisulfite-seq project")
    if (proj@splicedAlignment)
        stop("'splicedAlignment==TRUE' is not supported by qMeth")
    if (!is.na(proj@aligner) && proj@aligner == "Rhisat2")
        stop("Rhisat2 is not supported by qMeth")

    samples <- proj@alignments$SampleName
    nsamples <- length(samples)
    if (reference == "genome") {
        bamfiles <- proj@alignments$FileName
        referenceFormat <- proj@genomeFormat
        referenceSource <- proj@genome
    } else if (!is.na(i <- match(reference, rownames(proj@auxAlignments)))) {
        bamfiles <- unlist(proj@auxAlignments[i, ], use.names = FALSE)
        referenceFormat <- "file"
        referenceSource <- proj@aux[i, 'FileName']
    } else {
        stop("unknown 'reference', should be one of: ",
             paste(sprintf("'%s'", c("genome", rownames(proj@auxAlignments))), collapse = ", "))
    }
    reportLevel <- match.arg(reportLevel)
    mode <- match.arg(mode)


    ## validate parameters -----------------------------------------------------
    # 'query' is correct type?
    if (is.null(query)) {
        if (reportLevel == "alignment")
            stop("'query' must be an object of type 'GRanges' with length 1 for reportLevel='alignment'")
        tr <- Rsamtools::scanBamHeader(bamfiles[1])[[1]]$targets
        query <- GenomicRanges::GRanges(names(tr),
                                        IRanges::IRanges(start = 1, end = tr))
    } else if(!inherits(query, "GRanges")) {
        stop("'query' must be either NULL or an object of type 'GRanges'")
    }

    if (!is.logical(keepZero) || length(keepZero) != 1)
        stop("'keepZero' must be either TRUE or FALSE")
    if (!is.logical(asGRanges) || length(asGRanges) != 1)
        stop("'asGRanges' must be either TRUE or FALSE")

    if (!keepZero && ((collapseBySample && length(unique(samples)) > 1) ||
                      (!collapseBySample && length(samples) > 1)))
        stop("'keepZero' must be TRUE if there are multiple non-collapsible samples")

    if (mode == "var" && collapseByQueryRegion)
        stop("'collapseByQueryRegion' must be FALSE for variant detection mode")
    if (mode == "var" && !is.na(proj@snpFile))
        stop("allele-specific mode cannot be combined with variant detection mode")

    if (reportLevel == "alignment") {
        if (!(mode %in% c("CpG", "allC")))
            stop("'mode' must be 'CpG' or 'allC' for reportLevel='alignment'")
        if (length(query) != 1)
            stop("'query' must be an object of type 'GRanges' with length 1 for reportLevel='alignment'")
    }

    # all query chromosomes present in all bamfiles?
    trTab <- table(unlist(lapply(Rsamtools::scanBamHeader(bamfiles),
                                 function(bh) names(bh$targets))))
    trCommon <- names(trTab)[trTab == length(bamfiles)]
    if (any(f <- !(Seqinfo::seqlevels(query) %in% trCommon)))
        stop(sprintf("sequence levels in 'query' not found in alignment files: %s",
                     paste(Seqinfo::seqlevels(query)[f], collapse = ", ")))


    ## apply 'mask' to query ---------------------------------------------------
    if (!is.null(mask)) {
        if (reportLevel == "alignment")
            warning("ignoring 'mask' for reportLevel='alignment'")
        stop("'mask' (masking of query regions, e.g. unmappable genomic ",
             "regions) is not implemented yet")
    }

    ## setup tasks for parallelization -----------------------------------------
    ## TODO: create several chunks per chromosome?
    taskIByQuery <- split(seq.int(length(query)),
                          as.factor(Seqinfo::seqnames(query)))
    taskIByQuery <- taskIByQuery[lengths(taskIByQuery) > 0]
    nChunkQuery <- length(taskIByQuery)

    if (collapseBySample) {
        taskBamfiles <- split(bamfiles, samples)
        sampleNames <- names(taskBamfiles)
    } else {
        taskBamfiles <- as.list(bamfiles)
        sampleNames <- displayNames(proj)
    }
    nChunkBamfile <- length(taskBamfiles)

    nChunk <- nChunkQuery * nChunkBamfile
    taskIByQuery <- rep(taskIByQuery, nChunkBamfile)
    taskBamfiles <- rep(taskBamfiles, each = nChunkQuery)

    if (!is.null(clObj) & inherits(clObj, "cluster", which = FALSE)) {
        loadQuasR(clObj)
        myapply <- function(...) parallel::clusterApplyLB(clObj, ...)
    } else {
        myapply <- function(...) lapply(...)
    }

    ## quantify methylation  ---------------------------------------------------
    if (reportLevel == "alignment") {
        # ...per alignment reporting mode: list(nSamples) of list(3) with
        # "aid","Cid","meth" elements
        resL <- myapply(
            seq_len(nChunk), #nChunk is always equal to nChunkBamfile (length(taskBamfiles))
            function(i) quantifyMethylationBamfilesRegionsSingleChromosomeSingleAlignments(
                taskBamfiles[[i]],
                query[taskIByQuery[[i]]],
                collapseByQueryRegion,
                mode,
                referenceFormat,
                referenceSource,
                as.integer(mapqMin)[1],
                as.integer(mapqMax)[1])
        )
        names(resL) <- sampleNames
        res <- resL

    } else if (!is.na(proj@snpFile)) {
        # allele-bis-mode: 6 columns per sample in output (TR, MR, TU, MU, TA, MA) -------------
        resL <- myapply(
            seq_len(nChunk),
            function(i) quantifyMethylationBamfilesRegionsSingleChromosomeAllele(
                taskBamfiles[[i]],
                query[taskIByQuery[[i]]],
                collapseByQueryRegion,
                mode,
                referenceFormat,
                referenceSource,
                proj@snpFile,
                keepZero,
                as.integer(mapqMin)[1],
                as.integer(mapqMax)[1])
        )
        # combine and reorder chunks
        # ...rbind chunks for the same sample
        resL <- lapply(split(seq_len(nChunk), rep(seq_len(nChunkBamfile), each = nChunkQuery)),
                       function(i) do.call(rbind, resL[i]))
        names(resL) <- sampleNames

        if (any(unlist(lapply(resL, nrow), use.names = FALSE) != nrow(resL[[1]])))
            stop("error while combining partial results (chunks are incompatable)")

        # ...cbind TR/MR/TU/MU/TA/MA columns for different samples
        res <- cbind(resL[[1]][, c("chr", "start", "end", "strand")],
                     do.call(cbind, lapply(resL, "[", c("TR", "MR", "TU", "MU", "TA", "MA"))),
                     stringsAsFactors = FALSE)
        colnames(res)[5:ncol(res)] <- sprintf("%s_%s", rep(sampleNames, each = 6),
                                              c("TR", "MR", "TU", "MU", "TA", "MA"))
    } else if (mode == "var") {
        # variant detection mode: 2 columns per sample in output (total and match) -------------
        resL <- myapply(
            seq_len(nChunk),
            function(i) detectVariantsBamfilesRegionsSingleChromosome(
                taskBamfiles[[i]],
                query[taskIByQuery[[i]]],
                referenceFormat,
                referenceSource,
                keepZero,
                as.integer(mapqMin)[1],
                as.integer(mapqMax)[1])
        )
        # combine and reorder chunks
        # ...rbind chunks for the same sample
        resL <- lapply(split(seq_len(nChunk), rep(seq_len(nChunkBamfile), each = nChunkQuery)),
                       function(i) do.call(rbind, resL[i]))
        names(resL) <- sampleNames

        if (any(unlist(lapply(resL, nrow), use.names = FALSE) != nrow(resL[[1]])))
            stop("error while combining partial results (chunks are incompatable)")

        # ...cbind T/M columns for different samples
        res <- cbind(resL[[1]][, c("chr", "start", "end", "strand")],
                     do.call(cbind, lapply(resL, "[", c("T", "M"))),
                     stringsAsFactors = FALSE)
        colnames(res)[5:ncol(res)] <- sprintf("%s_%s", rep(sampleNames, each = 2), c("T", "M"))
    } else {
        # normal mode: 2 columns per sample in output (T and M) -------------
        resL <- myapply(
            seq_len(nChunk),
            function(i) quantifyMethylationBamfilesRegionsSingleChromosome(
                taskBamfiles[[i]],
                query[taskIByQuery[[i]]],
                collapseByQueryRegion,
                mode,
                referenceFormat,
                referenceSource,
                keepZero,
                as.integer(mapqMin)[1],
                as.integer(mapqMax)[1])
        )
        # combine and reorder chunks
        # ...rbind chunks for the same sample
        resL <- lapply(split(seq_len(nChunk), rep(seq_len(nChunkBamfile), each = nChunkQuery)),
                       function(i) do.call(rbind, resL[i]))
        names(resL) <- sampleNames

        if (any(unlist(lapply(resL, nrow), use.names = FALSE) != nrow(resL[[1]])))
            stop("error while combining partial results (chunks are incompatible)")

        # ...cbind T/M columns for different samples
        res <- cbind(resL[[1]][, c("chr", "start", "end", "strand")],
                     do.call(cbind, lapply(resL, "[", c("T", "M"))),
                     stringsAsFactors = FALSE)
        colnames(res)[5:ncol(res)] <- sprintf("%s_%s", rep(sampleNames, each = 2), c("T", "M"))
    }

    if (asGRanges && reportLevel != "alignment") {
        if (referenceFormat == "file") {
            si <- Seqinfo::seqinfo(Rsamtools::scanFaIndex(referenceSource))
        } else {
            library(referenceSource, character.only = TRUE)
            gnmObj <- get(referenceSource)
            si <- Seqinfo::seqinfo(gnmObj)
        }
        res <- GenomicRanges::GRanges(seqnames = res$chr,
                                      IRanges::IRanges(start = res$start,
                                                       end = res$end),
                       strand = res$strand, seqinfo = si, res[, 5:ncol(res)])
    }

    ## return results
    return(res)
}


# detect variants for:
#  - multiple bamfiles (will allways be collapsed)
#  - multiple regions (all on single chromosome, never collapsed)
#  - referenceFormat and reference (access to sequence at 'regions')
# return a data.frame or GRanges object with 4+2*nSamples vectors: chr, start, end, strand of C, counts of T (total) and M (match) reads
#' @keywords internal
#' @importFrom GenomicRanges GRanges findOverlaps
#' @importFrom IRanges IRanges
#' @importFrom Seqinfo seqlengths seqnames
#' @importFrom Rsamtools scanFaIndex scanFa
#' @importFrom BSgenome getSeq
#' @importFrom S4Vectors queryHits
#' @importFrom BiocGenerics start end
#'
detectVariantsBamfilesRegionsSingleChromosome <- function(bamfiles, regions,
                                                          referenceFormat,
                                                          reference, keepZero,
                                                          mapqmin, mapqmax) {
    ## verify parameters
    if (length(chr <- as.character(unique(Seqinfo::seqnames(regions)))) != 1)
        stop("all regions need to be on the same chromosome for 'quantifyMethylationBamfilesRegionsSingleChromosome'")

    ## collapse regions
    regionsStart <- as.integer(min(BiocGenerics::start(regions)))
    regionsEnd   <- as.integer(max(BiocGenerics::end(regions)))
    regionsGr    <- GenomicRanges::GRanges(
        chr, IRanges::IRanges(start = regionsStart, end = regionsEnd)
    )

    ## get sequence string from...
    #message("loading reference sequence (", chr, ")...", appendLF=FALSE)
    if (referenceFormat == "file") { # genome file
        chrLen <- as.integer(Seqinfo::seqlengths(Rsamtools::scanFaIndex(reference))[chr])
        seqstr <- as.character(Rsamtools::scanFa(reference, regionsGr)[[1]])
    } else {                        # BSgenome object
        library(reference, character.only = TRUE)
        referenceObj <- get(reference) # access the BSgenome
        chrLen <- as.integer(length(referenceObj[[chr]]))
        seqstr <- BSgenome::getSeq(referenceObj, regionsGr, as.character = TRUE)
    }
    #message("done")

    ## call CPP function (multiple bam files, single region)
    #message("detecting single nucleotide variations...", appendLF=FALSE)
    resL <- .Call(detectSNVs, bamfiles, chr, chrLen, regionsStart, seqstr,
                  keepZero, mapqmin, mapqmax)
    #message("done")

    ## filter out C's that do not fall into 'regions'
    #message("processing results...", appendLF=FALSE)
    ov <- GenomicRanges::findOverlaps(
        query = GenomicRanges::GRanges(
            chr, IRanges::IRanges(start = resL$position, width = 1
            )
        ),
        subject = regions)
    resL <- lapply(resL, "[", unique(S4Vectors::queryHits(ov)))

    res <- data.frame(chr = resL$chr,
                      start = resL$position,
                      end = resL$position,
                      strand = rep("*", length(resL$chr)),
                      T = resL$nTotal,
                      M = resL$nMatch,
                      stringsAsFactors = FALSE)
    #message("done")

    res
}

# quantify methylation for (report for INDIVIDUAL ALIGMENTS):
#  - multiple bamfiles (will allways be collapsed)
#  - a single region
#  - mode (defines which and how C's are quantified)
#  - referenceFormat and reference (access to sequence at 'regions')
# return a list(4) with elements "aid","Cid","strand","meth"
#' @keywords internal
#' @importFrom GenomicRanges GRanges
#' @importFrom IRanges IRanges
#' @importFrom Seqinfo seqlengths seqnames
#' @importFrom Rsamtools scanFaIndex scanFa
#' @importFrom BSgenome getSeq
#' @importFrom BiocGenerics start end
#'
quantifyMethylationBamfilesRegionsSingleChromosomeSingleAlignments <-
    function(bamfiles, regions, collapseByQueryRegion, mode = c("CpG","allC"),
             referenceFormat, reference, mapqmin, mapqmax) {
        ## verify parameters
        if (length(regions) != 1)
            stop("'regions' must be of length 1 for 'quantifyMethylationBamfilesRegionsSingleChromosomeSingleAlignments'")
        mode <- c("CpG" = 1L, "allC" = 2L)[match.arg(mode)]
        chr <- as.character(unique(Seqinfo::seqnames(regions)))
        regionsStart <- as.integer(BiocGenerics::start(regions))
        regionsEnd   <- as.integer(BiocGenerics::end(regions))
        regionsGr    <- GenomicRanges::GRanges(
            chr, IRanges::IRanges(start = regionsStart, end = regionsEnd)
        )

        ## get sequence string from...
        if (referenceFormat == "file") { # genome file
            chrLen <- as.integer(Seqinfo::seqlengths(
                Rsamtools::scanFaIndex(reference))[chr]
            )
            seqstr <- as.character(Rsamtools::scanFa(reference, regionsGr)[[1]])
        } else {                         # BSgenome object
            library(reference, character.only = TRUE)
            referenceObj <- get(reference) # access the BSgenome
            chrLen <- as.integer(length(referenceObj[[chr]]))
            seqstr <- BSgenome::getSeq(referenceObj, regionsGr, as.character = TRUE)
        }

        ## call CPP function (multiple bam files, single region)
        resL <- .Call(quantifyMethylationSingleAlignments, bamfiles, chr, chrLen,
                      regionsStart, seqstr, mode, mapqmin, mapqmax)

        return(resL)
    }

# quantify methylation for:
#  - multiple bamfiles (will allways be collapsed)
#  - multiple regions (all on single chromosome, may be collapsed if collapseByRegion==TRUE)
#  - mode (defines which and how C's are quantified)
#  - referenceFormat and reference (access to sequence at 'regions')
# return a data.frame or GRanges object with 4+2*nSamples vectors: chr, start, end, strand of C, counts of T (total) and M (methylated) reads
#' @keywords internal
#' @importFrom GenomicRanges GRanges findOverlaps
#' @importFrom IRanges IRanges
#' @importFrom Seqinfo seqlengths seqnames
#' @importFrom Rsamtools scanFaIndex scanFa
#' @importFrom BSgenome getSeq
#' @importFrom S4Vectors queryHits subjectHits
#' @importFrom BiocGenerics start end
quantifyMethylationBamfilesRegionsSingleChromosome <- function(bamfiles, regions,
                                                               collapseByRegion,
                                                               mode = c("CpGcomb", "CpG", "allC"),
                                                               referenceFormat, reference,
                                                               keepZero, mapqmin, mapqmax) {
    ## verify parameters
    if (length(chr <- as.character(unique(Seqinfo::seqnames(regions)))) != 1)
        stop("all regions need to be on the same chromosome for 'quantifyMethylationBamfilesRegionsSingleChromosome'")
    mode <- c("CpGcomb" = 0L, "CpG" = 1L, "allC" = 2L)[match.arg(mode)]
    Cwidth <- ifelse(mode == 0, 2L, 1L)

    ## collapse regions
    regionsStart <- as.integer(min(BiocGenerics::start(regions)))
    regionsEnd   <- as.integer(max(BiocGenerics::end(regions)))
    regionsGr    <- GenomicRanges::GRanges(
        chr, IRanges::IRanges(start = regionsStart, end = regionsEnd)
    )

    ## get sequence string from...
    #message("loading reference sequence (", chr, ")...", appendLF=FALSE)
    if (referenceFormat == "file") { # genome file
        chrLen <- as.integer(Seqinfo::seqlengths(
            Rsamtools::scanFaIndex(reference))[chr]
        )
        seqstr <- as.character(Rsamtools::scanFa(reference, regionsGr)[[1]])
    } else {                         # BSgenome object
        library(reference, character.only = TRUE)
        referenceObj <- get(reference) # access the BSgenome
        chrLen <- as.integer(length(referenceObj[[chr]]))
        seqstr <- BSgenome::getSeq(referenceObj, regionsGr, as.character = TRUE)
    }
    #message("done")

    ## call CPP function (multiple bam files, single region)
    #message("quantifying methylation...", appendLF=FALSE)
    resL <- .Call(quantifyMethylation, bamfiles, chr, chrLen, regionsStart,
                  seqstr, mode, keepZero, mapqmin, mapqmax)
    #message("done")

    ## collapse by region
    #message("processing results...", appendLF=FALSE)
    ov <- GenomicRanges::findOverlaps(
        query = GenomicRanges::GRanges(chr, IRanges::IRanges(start = resL$position,
                                                             width = Cwidth)),
        subject = regions)

    if (collapseByRegion) {
        tmpT <- tmpM <- numeric(length(regions))
        tmp <- tapply(resL$T[S4Vectors::queryHits(ov)], S4Vectors::subjectHits(ov), sum)
        tmpT[as.integer(names(tmp))] <- tmp
        tmp <- tapply(resL$M[S4Vectors::queryHits(ov)], S4Vectors::subjectHits(ov), sum)
        tmpM[as.integer(names(tmp))] <- tmp
        res <- data.frame(chr = rep(chr, length(regions)),
                          start = BiocGenerics::start(regions),
                          end = BiocGenerics::end(regions),
                          strand = as.character(BiocGenerics::strand(regions)),
                          T = tmpT,
                          M = tmpM,
                          stringsAsFactors = FALSE)
    } else {
        ## filter out C's that do not fall into 'regions'
        resL <- lapply(resL, "[", unique(S4Vectors::queryHits(ov)))

        res <- data.frame(chr = resL$chr,
                          start = resL$position,
                          end = resL$position+Cwidth-1L,
                          strand = resL$strand,
                          T = resL$T,
                          M = resL$M,
                          stringsAsFactors = FALSE)
    }
    #message("done")

    res
}


# quantify ALLELE-SPECIFIC methylation for:
#  - multiple bamfiles (will allways be collapsed)
#  - multiple regions (all on single chromosome, may be collapsed if collapseByRegion==TRUE)
#  - mode (defines which and how C's are quantified)
#  - referenceFormat and reference (access to sequence at 'regions')
# return a data.frame or GRanges object with 4+6*nSamples vectors: chr, start, end, strand of C, counts of TR, TU, TA (total) and MR, MU, MA (methylated) reads
#' @keywords internal
#' @importFrom GenomicRanges GRanges findOverlaps
#' @importFrom IRanges IRanges overlapsAny
#' @importFrom Seqinfo seqlengths seqnames
#' @importFrom Rsamtools scanFaIndex scanFa
#' @importFrom BSgenome getSeq
#' @importFrom S4Vectors queryHits
#' @importFrom BiocGenerics start end strand
quantifyMethylationBamfilesRegionsSingleChromosomeAllele <-
    function(bamfiles, regions, collapseByRegion, mode = c("CpGcomb", "CpG", "allC"),
             referenceFormat, reference, snpFile, keepZero, mapqmin, mapqmax) {
        ## verify parameters
        if (length(chr <- as.character(unique(Seqinfo::seqnames(regions)))) != 1)
            stop("all regions need to be on the same chromosome for 'quantifyMethylationBamfilesRegionsSingleChromosome'")
        mode <- c("CpGcomb" = 0L, "CpG" = 1L, "allC" = 2L)[match.arg(mode)]
        Cwidth <- ifelse(mode == 0, 2L, 1L)

        ## collapse regions
        regionsStart <- as.integer(min(BiocGenerics::start(regions)))
        regionsEnd   <- as.integer(max(BiocGenerics::end(regions)))
        regionsGr    <- GenomicRanges::GRanges(
            chr, IRanges::IRanges(start = regionsStart, end = regionsEnd)
        )

        ## get sequence string from...
        #message("loading reference sequence (", chr, ")...", appendLF=FALSE)
        if (referenceFormat == "file") { # genome file
            chrLen <- as.integer(Seqinfo::seqlengths(
                Rsamtools::scanFaIndex(reference))[chr]
            )
            seqstr <- as.character(Rsamtools::scanFa(reference, regionsGr)[[1]])
        } else {                         # BSgenome object
            library(reference, character.only = TRUE)
            referenceObj <- get(reference) # access the BSgenome
            chrLen <- as.integer(length(referenceObj[[chr]]))
            seqstr <- BSgenome::getSeq(referenceObj, regionsGr, as.character = TRUE)
        }
        #message("done")

        ## call CPP function (multiple bam files, single region)
        #message("quantifying methylation...", appendLF=FALSE)
        resL <- .Call(quantifyMethylationAllele, bamfiles, chr, chrLen, regionsStart,
                      seqstr, mode, keepZero, mapqmin, mapqmax)
        #message("done")

        ## filter out CpGs that overlap SNPs (may not be possible to discriminate allele from methylation status)
        #message("removing C's overlapping SNPs...", appendLF=FALSE)
        snpL <- scan(snpFile, what = list(chr = "", pos = 1L, R = "", A = ""), quiet = TRUE)
        snp <- GenomicRanges::GRanges(
            snpL$chr, IRanges::IRanges(start = snpL$pos, width = nchar(snpL$R))
        )
        ikeep <- !IRanges::overlapsAny(
            GenomicRanges::GRanges(
                chr, IRanges::IRanges(start = resL$position, width = Cwidth)
            ), snp
        )
        resL <- lapply(resL, "[", ikeep)
        #message(sprintf("removed %d C's, done",sum(!ikeep)))

        ## collapse by region
        #message("processing results...", appendLF=FALSE)
        ov <- GenomicRanges::findOverlaps(
            query = GenomicRanges::GRanges(chr, IRanges::IRanges(start = resL$position,
                                                                 width = Cwidth)),
            subject = regions
        )

        if (collapseByRegion) {
            tmpTR <- tmpTU <- tmpTA <- tmpMR <- tmpMU <- tmpMA <- numeric(length(regions))
            tmp <- tapply(resL$TR[S4Vectors::queryHits(ov)],
                          S4Vectors::subjectHits(ov), sum)
            tmpTR[as.integer(names(tmp))] <- tmp
            tmp <- tapply(resL$TU[S4Vectors::queryHits(ov)],
                          S4Vectors::subjectHits(ov), sum)
            tmpTU[as.integer(names(tmp))] <- tmp
            tmp <- tapply(resL$TA[S4Vectors::queryHits(ov)],
                          S4Vectors::subjectHits(ov), sum)
            tmpTA[as.integer(names(tmp))] <- tmp
            tmp <- tapply(resL$MR[S4Vectors::queryHits(ov)],
                          S4Vectors::subjectHits(ov), sum)
            tmpMR[as.integer(names(tmp))] <- tmp
            tmp <- tapply(resL$MU[S4Vectors::queryHits(ov)],
                          S4Vectors::subjectHits(ov), sum)
            tmpMU[as.integer(names(tmp))] <- tmp
            tmp <- tapply(resL$MA[S4Vectors::queryHits(ov)],
                          S4Vectors::subjectHits(ov), sum)
            tmpMA[as.integer(names(tmp))] <- tmp
            res <- data.frame(chr = rep(chr,length(regions)),
                              start = BiocGenerics::start(regions),
                              end = BiocGenerics::end(regions),
                              strand = as.character(BiocGenerics::strand(regions)),
                              TR = tmpTR,
                              MR = tmpMR,
                              TU = tmpTU,
                              MU = tmpMU,
                              TA = tmpTA,
                              MA = tmpMA,
                              stringsAsFactors = FALSE)
        } else {
            ## filter out C's that do not fall into 'regions'
            resL <- lapply(resL, "[", unique(S4Vectors::queryHits(ov)))

            res <- data.frame(chr = resL$chr,
                              start = resL$position,
                              end = resL$position + Cwidth - 1L,
                              strand = resL$strand,
                              TR = resL$TR,
                              MR = resL$MR,
                              TU = resL$TU,
                              MU = resL$MU,
                              TA = resL$TA,
                              MA = resL$MA,
                              stringsAsFactors = FALSE)
        }
        #message("done")

        res
    }

context("qMeth")

test_that("qMeth correctly digests its arguments", {
  expect_error(qMeth("error"))
  expect_error(qMeth(pChipSingle))
  expect_error(qMeth(pBis, NULL, reportLevel = "alignment"))
  expect_error(qMeth(pBis, "error"))
  expect_error(qMeth(pBis, keepZero = "error"))
  expect_error(qMeth(pBis, asGRanges = "error"))
  expect_error(qMeth(pBis[c(1,1)], keepZero = FALSE, collapseBySample = FALSE))
  expect_error(qMeth(pBis, mode = "var", collapseByQueryRegion = TRUE))
  expect_error(qMeth(pBis, reportLevel = "alignment", mode = "var"))
  expect_error(qMeth(pBis, gtfGr, reportLevel = "alignment"))
  expect_error(qMeth(pBis, mask = gtfGr))
})

test_that("qMeth works as expected in (un-)directional mode", {
  requireNamespace("GenomicRanges")
  meth <- qMeth(pBisUndir, clObj = clObj)
  expect_identical(colSums(as(GenomicRanges::mcols(meth), "matrix")),
                   c("Sample1_T" = 37467, "Sample1_M" = 31907))
  expect_equal(GenomicRanges::mcols(meth)[201:210, 2],
               c(0, 3, 5, 7, 8, 6, 5, 0, 0, 2))

  meth <- qMeth(pBis)
  expect_identical(colSums(as(GenomicRanges::mcols(meth), "matrix")),
                   c("Sample1_T" = 37467, "Sample1_M" = 31907))
  expect_equal(GenomicRanges::mcols(meth)[201:210, 2],
               c(0, 3, 5, 7, 8, 6, 5, 0, 0, 2))
  
  meth <- qMeth(pBisSnps)
  expect_length(meth, 3013L)
  expect_identical(ncol(GenomicRanges::mcols(meth)), 6L)
})

test_that("qMeth correctly works with different 'mode' and 'reportLevel' arguments", {
  requireNamespace("GenomicRanges")
  
  meth <- qMeth(pBis, mode = "allC")
  expect_length(meth, 50969L)

  meth <- qMeth(pBis, mode = "CpG", collapseBySample = FALSE)
  expect_length(meth, 6220L)

  meth <- qMeth(pBis, mode = "CpGcomb")
  expect_length(meth, 3110L)

  meth <- qMeth(pBis, GenomicRanges::GRanges("chr1", IRanges(start = c(100, 300), width = 50)), collapseByQueryRegion = TRUE)
  expect_length(meth, 2L)
  
  meth <- qMeth(pBis, mode = "var")
  expect_length(meth, 6220L)
  
  gr <- GenomicRanges::GRanges("chr1", IRanges(start = 100, width = 50))
  meth <- qMeth(pBis, gr, mode = "CpG", reportLevel = "alignment")
  expect_is(meth, "list")
  expect_length(meth[[1]], 4L)
  expect_equal(meth[[1]]$meth, c(1,1,1,0,1,1,0,1,1,0))

  meth2 <- qMeth(pBis, gr, mode = "CpG", reportLevel = "alignment", collapseByQueryRegion = TRUE)
  expect_identical(meth, meth2)
})

#' Preprocess Short Reads
#'
#' Truncate sequences, remove parts matching to adapters and filter out low
#' quality or low complexity sequences from (compressed) 'fasta' or 'fastq' files.
#'
#' Sequence files can be in fasta or fastq format, and can be compressed by
#' either gzip, bzip2 or xz (extensions .gz, .bz2 or .xz). Multiple files
#' can be processed by a single call to \code{preprocessReads}; in that
#' case all sequence file vectors must have identical lengths.
#'
#' \code{nrec} can be used to limit the memory usage when processing
#' large input files. \code{preprocessReads} iteratively loads chunks of
#' \code{nrec} sequences from the input until all data been processed.
#'
#' Sequence pairs from paired-end experiments can be processed by
#' specifying pairs of input and output files (\code{filenameMate} and
#' \code{outputFilenameMate} arguments). In that case, it is assumed that
#' pairs appear in the same order in the two input files, and only pairs
#' in which both reads pass all filtering criteria are written to the
#' output files, maintaining the consistent ordering.
#'
#' If output files are compressed, the processed sequences are first
#' written to temporary files (created in the same directory as the final
#' output file), and the output files are generated at the end by compressing
#' the temporary files.
#'
#' For the trimming of left and/or right flanking sequences (adapters) from
#' sequence reads, the \code{\link[Biostrings]{trimLRPatterns}} function
#' from package \pkg{Biostrings} is used, and the arguments \code{Lpattern},
#' \code{Rpattern}, \code{max.Lmismatch}, \code{max.Rmismatch},
#' \code{with.Lindels} and \code{with.Rindels} are used in the call to
#' \code{trimLRPatterns}. \code{Lfixed} and \code{Rfixed} arguments
#' of \code{trimLRPatterns} are set to \code{TRUE}, thus only fixed
#' patterns (without IUPAC codes for ambigous bases) can be
#' used. Currently, trimming of adapters is only supported for single read
#' experiments.
#'
#' Sequence complexity (\eqn{H}) is calculated based on the dinucleotide
#' composition using the formula (Shannon entropy): \deqn{H = -\sum_i {f_i \log_2 f_i},}
#' where \eqn{f_i} is the fraction of dinucleotide \eqn{i} from all
#' dinucleotides in the sequence. Sequence reads that fulfill the condition
#' \eqn{H/H_r \ge c} are retained (not filtered out), where \eqn{H_r =
#' 3.908} is the reference complexity in bits obtained from the human
#' genome, and \eqn{c} is the value given to the argument \code{complexity}.
#'
#' If an object that inherits from class \code{cluster} is provided to
#' the \code{clObj} argument, for example an object returned by
#' \code{\link[parallel]{makeCluster}} from package \pkg{parallel},
#' multiple files will be processed in parallel using
#' \code{\link[parallel:clusterApply]{clusterMap}} from package \pkg{parallel}.
#'
#' @param filename the name(s) of the input sequence file(s).
#' @param outputFilename the name(s) of the output sequence file(s).
#' @param filenameMate for paired-end experiments, the name(s) of the
#'   input sequence file(s) containing the second read (mate) of each pair.
#' @param outputFilenameMate for paired-end experiments, the name(s) of the
#'   output sequence file(s) containing the second read (mate) of each pair.
#' @param truncateStartBases integer(1): the number of bases to be truncated
#'   (removed) from the beginning of each sequence.
#' @param truncateEndBases integer(1): the number of bases to be truncated
#'   (removed) from the end of each sequence.
#' @param Lpattern character(1): the left (5'-end) adapter sequence.
#' @param Rpattern character(1): the right (3'-end) adapter sequence.
#' @param max.Lmismatch mismatch tolerance when searching for matches of
#'   \code{Lpattern} (see \sQuote{Details}).
#' @param max.Rmismatch mismatch tolerance when searching for matches of
#'   \code{Rpattern} (see \sQuote{Details}).
#' @param with.Lindels if \code{TRUE}, indels are allowed in the alignments of
#'   the suffixes of \code{Lpattern} with the subject, at its beginning
#'   (see \sQuote{Details}).
#' @param with.Rindels same as \code{with.Lindels} but for alignments of the
#'   prefixes of \code{Rpattern} with the subject, at its end (see
#'   \sQuote{Details}).
#' @param minLength integer(1): the minimal allowed sequence length.
#' @param nBases integer(1): the maximal number of Ns allowed per sequence.
#' @param complexity \code{NULL} (default) or numeric(1): If not \code{NULL},
#'   the minimal sequence complexity, as a fraction of the average complexity
#'   in the human genome (~3.9bits). For example, \code{complexity = 0.5} will
#'   filter out sequences that do not have at least half the complexity of the
#'   human genome. See \sQuote{Details} on how the complexity is calculated.
#' @param nrec integer(1): the number of sequence records to read at a time.
#' @param clObj a cluster object to be used for parallel processing of multiple
#' files (see \sQuote{Details}).
#'
#' @name preprocessReads
#' @aliases preprocessReads
#'
#' @returns
#' A matrix with summary statistics on the processed sequences, containing:
#' \itemize{
#'   \item One column per input file (or pair of input files for paired-end
#'                                    experiments).
#'   \item The number of sequences or sequence pairs in rows:
#'   \describe{
#'     \item{\code{totalSequences}}{ - the total number in the input}
#'     \item{\code{matchTo5pAdaptor}}{ - matching to \code{Lpattern}}
#'     \item{\code{matchTo3pAdaptor}}{ - matching to \code{Rpattern}}
#'     \item{\code{tooShort}}{ - shorter than \code{minLength}}
#'     \item{\code{tooManyN}}{ - more than \code{nBases} Ns}
#'     \item{\code{lowComplexity}}{ - relative complexity below \code{complexity}}
#'     \item{\code{totalPassed}}{ - the number of sequences/sequence pairs
#'       that pass all filtering criteria and were written to the output file(s).}
#'   }
#' }
#'
#' @author Anita Lerch, Dimos Gaidatzis and Michael Stadler
#'
#' @keywords utilities misc
#'
#' @export
#'
#' @seealso \code{\link[Biostrings]{trimLRPatterns}} from package \pkg{Biostrings},
#' \code{\link[parallel]{makeCluster}} from package \pkg{parallel}
#'
#' @importFrom parallel clusterEvalQ clusterMap
#' @importFrom ShortRead nFilter SRFilterResult
#' @importFrom tools file_path_sans_ext file_ext
#' @importFrom S4Vectors active
#'
#' @examples
#' # sample files
#' infiles <- system.file(package="QuasR", "extdata",
#'                        c("rna_1_1.fq.bz2","rna_1_2.fq.bz2"))
#' outfiles <- paste(tempfile(pattern=c("output_1_","output_2_")),".fastq",sep="")
#' # single read example
#' preprocessReads(infiles, outfiles, nBases=0, complexity=0.6)
#' unlink(outfiles)
#' # paired-end example
#' preprocessReads(filename=infiles[1],
#'                 outputFilename=outfiles[1],
#'                 filenameMate=infiles[2],
#'                 outputFilenameMate=outfiles[2],
#'                 nBases=0, complexity=0.6)
#' unlink(outfiles)
#'
preprocessReads <- function(filename, outputFilename = NULL,
                            filenameMate = NULL, outputFilenameMate = NULL,
                            truncateStartBases = NULL, truncateEndBases = NULL,
                            Lpattern = "", Rpattern = "",
                            max.Lmismatch = rep(0:2, c(6, 3, 100)),
                            max.Rmismatch = rep(0:2, c(6, 3, 100)),
                            with.Lindels = FALSE, with.Rindels = FALSE,
                            minLength = 14L, nBases = 2L, complexity = NULL,
                            nrec = 1000000L, clObj = NULL) {

    ## check parameters
    if (!is.character(filename))
        stop("'filename' must be of type character.")
    if (is.null(outputFilename)) {
        outputFilename <- paste(tools::file_path_sans_ext(filename), "_prep.",
                                tools::file_ext(filename), sep = "")
        message(paste(c("using default 'outputFilename':",
                        truncPath(outputFilename)), collapse = "\n "), "\n")
    }
    if (!is.character(outputFilename))
        stop("'outputFilename' must be of type character.")
    if (length(filename) != length(outputFilename))
        stop("'filename' and 'outputFilename' must have equal length.")
    if (any(f <- !file.exists(filename)))
        stop("non-existing input file(s): ",
             paste(filename[f], collapse = ", "))
    if (any(f <- file.exists(outputFilename)))
        stop("existing output file(s): ",
             paste(outputFilename[f], collapse = ", "))
    fileformat <- consolidateFileExtensions(filename, compressed = TRUE)
    if (any(f <- !(fileformat %in% c("fasta","fastq"))))
        stop("unsupported file format (must be one of 'fasta' or 'fastq'): ",
             paste(filename[f], collapse = ", "))
    if (any(fileformat != consolidateFileExtensions(outputFilename, compressed = TRUE)))
        stop("format of 'filename' and 'outputFilename' must be identical")
    filecompr <- compressedFileFormat(outputFilename)
    if (any(fileformat == "fasta") && any(compressedFileFormat(filename) != "none"))
        stop("compressed 'fasta' input is not yet supported")

    paired <- !is.null(filenameMate)
    if (paired) {
        paired <- TRUE
        if (Lpattern != "" || Rpattern != "")
            stop("Removing adapters from paired-end samples is not yet ",
                 "supported ('Lpattern' and 'Rpattern' must be set to \"\").")
        if (!is.character(filenameMate))
            stop("'filenameMate' must be of type character.")
        if (is.null(outputFilenameMate)) {
            outputFilenameMate <- paste(tools::file_path_sans_ext(filenameMate),
                                        "_prep.", tools::file_ext(filenameMate), sep = "")
            message(paste(c("using default 'outputFilenameMate':",
                            truncPath(outputFilenameMate)), collapse = "\n "), "\n")
        }
        if (!is.character(outputFilenameMate))
            stop("'outputFilenameMate' must be of type character.")
        if (length(filenameMate) != length(outputFilenameMate))
            stop("'filenameMate' and 'outputFilenameMate' must have equal length.")
        if (length(filename) != length(filenameMate))
            stop("'filename' and 'filenameMate' must have equal length.")
        if (any(f <- file.exists(outputFilenameMate)))
            stop("existing output files: ", paste(outputFilenameMate[f], collapse = ", "))
        if (any(fileformat != consolidateFileExtensions(filenameMate, compressed = TRUE)))
            stop("format of 'filename' and 'filenameMate' must be identical")
        if (any(fileformat != consolidateFileExtensions(outputFilenameMate, compressed = TRUE)))
            stop("format of 'filenameMate' and 'outputFilenameMate' must be identical")
        if (any(filecompr != compressedFileFormat(outputFilenameMate)))
            stop("compression format of 'outputFilename' and 'outputFilenameMate' must be identical")
    }

    ## set 'from' and 'to' for truncation (from=1 is the first base, to=-1 is the last one)
    truncateFromBase <- ifelse(is.null(truncateStartBases), 1, truncateStartBases + 1)
    truncateToBase <- ifelse(is.null(truncateEndBases), -1, -(truncateEndBases + 1))

    ## initialize filters
    activeFilters <- c(!is.null(nBases),
                       !is.null(complexity),
                       !is.null(minLength))
    nFilt <- ShortRead::nFilter(threshold = ifelse(activeFilters[1], nBases[1], 0L))
    cFilt <- filterLowComplexity(threshold = ifelse(activeFilters[2], complexity[1], 0.5))
    lFilt <- filterLength(threshold = ifelse(activeFilters[3], minLength, 0L))
    filters <- c(nFilt, cFilt, lFilt)
    S4Vectors::active(filters) <- activeFilters

    ## parallel execution?
    if (!is.null(clObj) & inherits(clObj, "cluster", which = FALSE)) {
        message("preparing to run on ", length(clObj), " nodes...", appendLF = FALSE)
        myapply <- function(...) do.call(cbind, parallel::clusterMap(clObj, ...))
        # load libraries on nodes
        loadQuasR(clObj)
        # avoid nested parallelization
        nthreads <- parallel::clusterEvalQ(clObj, .Call(ShortRead:::.set_omp_threads, 1L))
        on.exit(parallel::clusterMap(clObj, function(n) .Call(ShortRead:::.set_omp_threads, n), nthreads))
    } else {
        myapply <- mapply
    }

    ## do the filtering
    if (paired) {
        #message("start filtering (paired-end mode)")
        filterReport <- myapply(preprocessPairedReads,
                                filename = filename, filenameMate = filenameMate,
                                outputFilename = outputFilename,
                                outputFilenameMate = outputFilenameMate,
                                fileformat = fileformat, filecompr = filecompr,
                                MoreArgs = list(
                                    truncateFromBase = truncateFromBase,
                                    truncateToBase = truncateToBase,
                                    filters = filters,
                                    nrec = nrec))
        colnames(filterReport) <- paste(basename(filename),
                                        basename(filenameMate), sep = ":")
    } else {
        #message("start filtering (single read mode)")
        filterReport <- myapply(preprocessSingleReads,
                                filename = filename,
                                outputFilename = outputFilename,
                                fileformat = fileformat, filecompr = filecompr,
                                MoreArgs = list(
                                    truncateFromBase = truncateFromBase,
                                    truncateToBase = truncateToBase,
                                    Lpattern = Lpattern, Rpattern = Rpattern,
                                    max.Lmismatch = max.Lmismatch,
                                    max.Rmismatch = max.Rmismatch,
                                    with.Lindels = with.Lindels,
                                    with.Rindels = with.Rindels,
                                    filters = filters,
                                    nrec = nrec))
        colnames(filterReport) <- basename(filename)
    }
    #message("finished filtering")
    return(filterReport)
}

#' @keywords internal
#' @importFrom ShortRead readFasta writeFastq FastqStreamer yield narrow
#'   SRFilterResult
#' @importFrom Biostrings trimLRPatterns
#' @importFrom S4Vectors evalSeparately
#' @importFrom BiocGenerics width start end
preprocessSingleReads <- function(filename, outputFilename, fileformat, filecompr,
                                  truncateFromBase, truncateToBase,
                                  Lpattern, Rpattern,
                                  max.Lmismatch, max.Rmismatch,
                                  with.Lindels, with.Rindels,
                                  filters,
                                  nrec) {

    message("  filtering ", truncPath(filename, getOption('width') - 13))

    ## create (temporary) output file name, will be compressed if filecompr!="none"
    tmpOutputFilename <- if (filecompr != "none") tempfile(pattern = "preprocessReadsTemp")
    else outputFilename

    ## extend R/Lpattern by Ns
    numNs <- 90
    if (nchar(Lpattern) > 0) {
        max.Lmismatch <- max.Lmismatch[seq_len(nchar(Lpattern))]
        max.Lmismatch <- c(max.Lmismatch, seq_len(numNs) + max(max.Lmismatch))
        Lpattern <- paste(c(rep("N", numNs), Lpattern), collapse = "")
    }
    if (nchar(Rpattern) > 0) {
        max.Rmismatch <- max.Rmismatch[seq_len(nchar(Rpattern))]
        max.Rmismatch <- c(max.Rmismatch, seq_len(numNs) + max(max.Rmismatch))
        Rpattern <- paste(c(Rpattern, rep("N", numNs)), collapse = "")
    }

    ## filter chunks
    filterReport <- c(totalSequences = 0, matchTo5pAdapter = 0,
                      matchTo3pAdapter = 0, tooShort = 0, tooManyN = 0,
                      lowComplexity = 0, totalPassed = 0)

    if (fileformat == "fasta") {
        mode <- 'w'
        cycle <- 1L
        while (length(chunks <- ShortRead::readFasta(filename, nrec = nrec,
                                                     skip = (cycle - 1) * nrec)) != 0L) {
            filterReport['totalSequences'] <- filterReport['totalSequences'] +
                length(chunks)

            ## truncate start or end bases
            chunks <- ShortRead::narrow(x = chunks, start = truncateFromBase,
                                        end = truncateToBase)

            ## trim adaptor
            ranges <- Biostrings::trimLRPatterns(
                subject = chunks, Lpattern = Lpattern, Rpattern = Rpattern,
                max.Lmismatch = max.Lmismatch, max.Rmismatch = max.Rmismatch,
                with.Lindels = with.Lindels, with.Rindels = with.Rindels,
                ranges = TRUE
            )
            filterReport['matchTo5pAdapter'] <- filterReport['matchTo5pAdapter'] +
                sum(BiocGenerics::start(ranges) != 1)
            filterReport['matchTo3pAdapter'] <- filterReport['matchTo3pAdapter'] +
                sum(BiocGenerics::end(ranges) != BiocGenerics::width(chunks))
            chunks <- ShortRead::narrow(x = chunks,
                                        start = BiocGenerics::start(ranges),
                                        end = BiocGenerics::end(ranges))

            ## filter and write short reads
            filterResults <- S4Vectors::evalSeparately(filters, chunks)
            if (is.list(filterResults)) # return value of evalSeparately?
                filterResults <- do.call(cbind, filterResults)
            #filterReport['tooManyN'] <- filterReport['tooManyN'] + sum(!filterResults[, 'CleanNFilter'])
            # workaround for filter being renamed to 'CleanNFilter.other' if nrec=1:
            filterReport['tooManyN'] <- filterReport['tooManyN'] +
                sum(!filterResults[, grep('CleanNFilter',colnames(filterResults))[1]])
            filterReport['tooShort'] <- filterReport['tooShort'] + sum(!filterResults[, 'LengthFilter'])
            filterReport['lowComplexity'] <- filterReport['lowComplexity'] +
                sum(!filterResults[, 'LowComplexityFilter'])
            filter <- apply(filterResults, 1, all)
            filterReport['totalPassed'] <- filterReport['totalPassed'] + sum(filter)
            if (sum(filter))
                ShortRead::writeFasta(chunks[filter], tmpOutputFilename,
                                      mode = mode, compress = FALSE)
            mode <- 'a'
            cycle <- cycle + 1
        }

    } else if (fileformat == "fastq") {
        fs1 <- ShortRead::FastqStreamer(filename, n = nrec)
        on.exit(close(fs1))
        on.exit(rm(fs1), add = TRUE)
        mode <- 'w'
        while (length(chunks <- ShortRead::yield(fs1)) != 0L) {
            filterReport['totalSequences'] <- filterReport['totalSequences'] + length(chunks)

            ## truncate start or end bases
            chunks <- ShortRead::narrow(x = chunks, start = truncateFromBase,
                                        end = truncateToBase)

            ## trim adaptor
            ranges <- Biostrings::trimLRPatterns(
                subject = chunks, Lpattern = Lpattern, Rpattern = Rpattern,
                max.Lmismatch = max.Lmismatch, max.Rmismatch = max.Rmismatch,
                with.Lindels = with.Lindels, with.Rindels = with.Rindels,
                ranges = TRUE
            )
            filterReport['matchTo5pAdapter'] <- filterReport['matchTo5pAdapter'] +
                sum(BiocGenerics::start(ranges) != 1)
            filterReport['matchTo3pAdapter'] <- filterReport['matchTo3pAdapter'] +
                sum(BiocGenerics::end(ranges) != BiocGenerics::width(chunks))
            chunks <- ShortRead::narrow(x = chunks,
                                        start = BiocGenerics::start(ranges),
                                        end = BiocGenerics::end(ranges))

            ## filter and write short reads
            filterResults <- S4Vectors::evalSeparately(filters, chunks)
            #filterReport['tooManyN'] <- filterReport['tooManyN'] + sum(!filterResults[, 'CleanNFilter'])
            # workaround for filter being renamed to 'CleanNFilter.other' if nrec=1:
            filterReport['tooManyN'] <- filterReport['tooManyN'] +
                sum(!filterResults[, grep('CleanNFilter',colnames(filterResults))[1]])
            filterReport['tooShort'] <- filterReport['tooShort'] + sum(!filterResults[, 'LengthFilter'])
            filterReport['lowComplexity'] <- filterReport['lowComplexity'] +
                sum(!filterResults[, 'LowComplexityFilter'])
            filter <- apply(filterResults, 1, all)
            filterReport['totalPassed'] <- filterReport['totalPassed'] + sum(filter)
            if (sum(filter))
                ShortRead::writeFastq(chunks[filter], tmpOutputFilename,
                                      mode = mode, qualityType = "Auto", compress = FALSE)
            mode <- 'a'
        }

    } else {
        stop("unknown file format: ", fileformat)
    }

    if(filecompr != "none")
        compressFile(tmpOutputFilename, destname = outputFilename, remove = TRUE)

    return(filterReport)
}

#' @keywords internal
#' @importFrom ShortRead readFasta writeFastq FastqStreamer yield narrow
#' @importFrom Biostrings trimLRPatterns
#' @importFrom S4Vectors evalSeparately
preprocessPairedReads <- function(filename, filenameMate, outputFilename,
                                  outputFilenameMate, fileformat, filecompr,
                                  truncateFromBase, truncateToBase,
                                  filters,
                                  nrec) {

    message("  filtering ", truncPath(filename, getOption('width') - 17), " and\n    ",
            truncPath(filenameMate, getOption('width') - 16))

    ## create (temporary) output file names, will be compressed if filecompr!="none"
    if (filecompr != "none") {
        tmpOutputFilename <- tempfile(pattern = "preprocessReadsTemp")
        tmpOutputFilenameMate <- tempfile(pattern = "preprocessReadsTemp")
    } else {
        tmpOutputFilename <- outputFilename
        tmpOutputFilenameMate <- outputFilenameMate
    }

    ## filter chunks
    nrec <- round(nrec/2) # only load half the number of pairs
    filterReport <- c(totalSequences = 0, matchTo5pAdapter = NA,
                      matchTo3pAdapter = NA, tooShort = 0, tooManyN = 0,
                      lowComplexity = 0, totalPassed = 0)

    if (fileformat == "fasta") {
        mode <- 'w'
        cycle <- 1L
        while(length(chunks <- ShortRead::readFasta(filename, nrec = nrec,
                                                    skip = (cycle - 1)*nrec)) != 0L) {
            chunksMate <- ShortRead::readFasta(filenameMate, nrec = nrec,
                                               skip = (cycle - 1)*nrec)
            filterReport['totalSequences'] <- filterReport['totalSequences'] + length(chunks)

            chunks <- ShortRead::narrow(x = chunks, start = truncateFromBase,
                                        end = truncateToBase)
            chunksMate <- ShortRead::narrow(x = chunksMate,
                                            start = truncateFromBase,
                                            end = truncateToBase)

            ## filter and write short reads
            filterResults <- S4Vectors::evalSeparately(filters, chunks)
            if (is.list(filterResults)) # return value of evalSeparately?
                filterResults <- do.call(cbind, filterResults)
            filterResultsMate <- S4Vectors::evalSeparately(filters, chunksMate)
            if (is.list(filterResultsMate)) # return value of evalSeparately?
                filterResults <- do.call(cbind, filterResultsMate)
            #filterReport['tooManyN'] <- filterReport['tooManyN'] + sum(!(filterResults[, 'CleanNFilter'] & filterResultsMate[, 'CleanNFilter']))
            # workaround for filter being renamed to 'CleanNFilter.other' if nrec=1:
            filterReport['tooManyN'] <- filterReport['tooManyN'] +
                sum(!(filterResults[, grep('CleanNFilter',colnames(filterResults))[1]] &
                          filterResultsMate[, grep('CleanNFilter', colnames(filterResultsMate))[1]]))
            filterReport['tooShort'] <- filterReport['tooShort'] +
                sum(!(filterResults[, 'LengthFilter'] &
                          filterResultsMate[, 'LengthFilter']))
            filterReport['lowComplexity'] <- filterReport['lowComplexity'] +
                sum(!(filterResults[, 'LowComplexityFilter'] &
                          filterResultsMate[, 'LowComplexityFilter']))
            filter <- apply(cbind(filterResults, filterResultsMate), 1, all)
            filterReport['totalPassed'] <- filterReport['totalPassed'] + sum(filter)
            if (sum(filter)) {
                ShortRead::writeFasta(chunks[filter], tmpOutputFilename,
                                      mode = mode, compress = FALSE)
                ShortRead::writeFasta(chunksMate[filter], tmpOutputFilenameMate,
                                      mode = mode, compress = FALSE)
                }

            mode <- 'a'
            cycle <- cycle + 1
        }

    } else if (fileformat == "fastq") {
        fs1 <- ShortRead::FastqStreamer(filename, n = nrec)
        fs2 <- ShortRead::FastqStreamer(filenameMate, n = nrec)
        on.exit(close(fs1))
        on.exit(close(fs2), add = TRUE)
        on.exit(rm(fs1, fs2), add = TRUE)
        mode <- 'w'
        while (length(chunks <- ShortRead::yield(fs1)) != 0L) {
            chunksMate <- ShortRead::yield(fs2)
            filterReport['totalSequences'] <- filterReport['totalSequences'] + length(chunks)

            chunks <- ShortRead::narrow(x = chunks, start = truncateFromBase,
                                        end = truncateToBase)
            chunksMate <- ShortRead::narrow(x = chunksMate,
                                            start = truncateFromBase,
                                            end = truncateToBase)

            ## filter and write short reads
            filterResults <- S4Vectors::evalSeparately(filters, chunks)
            filterResultsMate <- S4Vectors::evalSeparately(filters, chunksMate)
            #filterReport['tooManyN'] <- filterReport['tooManyN'] + sum(!(filterResults[, 'CleanNFilter'] & filterResultsMate[, 'CleanNFilter']))
            # workaround for filter being renamed to 'CleanNFilter.other' if nrec=1:
            filterReport['tooManyN'] <- filterReport['tooManyN'] +
                sum(!(filterResults[, grep('CleanNFilter',colnames(filterResults))[1]] &
                          filterResultsMate[, grep('CleanNFilter',colnames(filterResultsMate))[1]]))
            filterReport['tooShort'] <- filterReport['tooShort'] +
                sum(!(filterResults[, 'LengthFilter'] &
                          filterResultsMate[, 'LengthFilter']))
            filterReport['lowComplexity'] <- filterReport['lowComplexity'] +
                sum(!(filterResults[, 'LowComplexityFilter'] &
                          filterResultsMate[, 'LowComplexityFilter']))
            filter <- apply(cbind(filterResults, filterResultsMate), 1, all)
            filterReport['totalPassed'] <- filterReport['totalPassed'] + sum(filter)
            if (sum(filter)) {
                ShortRead::writeFastq(chunks[filter], tmpOutputFilename,
                                      mode = mode, qualityType = "Auto", compress = FALSE)
                ShortRead::writeFastq(chunksMate[filter], tmpOutputFilenameMate,
                                      mode = mode, qualityType = "Auto", compress = FALSE)
            }

            mode <- 'a'
        }

    } else {
        stop("unknown file format: ", fileformat)
    }

    if (filecompr != "none") {
        compressFile(tmpOutputFilename, destname = outputFilename, remove = TRUE)
        compressFile(tmpOutputFilenameMate, destname = outputFilenameMate, remove = TRUE)
    }

    return(filterReport)
}

#' @keywords internal
#' @importFrom ShortRead srFilter
#' @importFrom BiocGenerics width
filterLength <- function(threshold = 0L, .name = "LengthFilter") {
    #.check_type_and_length(threshold, "numeric", 1)
    ShortRead::srFilter(function(x) {
        BiocGenerics::width(x) >= threshold
    }, name = .name)
}

#' @keywords internal
#' @importFrom ShortRead srFilter sread
#' @importFrom Biostrings dinucleotideFrequency
filterLowComplexity <- function(threshold = 0.5, referenceEntropy = 3.908135,
                                .name = "LowComplexityFilter") {
    ShortRead::srFilter(function(x) {
        # less than half the average entropy per dinucleotide of non-random
        # chromosomes in hg18 (3.908135 bits):
        #   entropy(x)/3.908135 >= threshold
        diNucFreq <- Biostrings::dinucleotideFrequency(ShortRead::sread(x))
        if (is.null(dim(diNucFreq))) {
            diNucFreq <- diNucFreq/sum(diNucFreq)
            H <- -sum(diNucFreq * log2(diNucFreq), na.rm = TRUE)
        } else {
            diNucFreq <- diNucFreq/rowSums(diNucFreq)
            H <- -rowSums(diNucFreq * log2(diNucFreq), na.rm = TRUE)
        }
        H/referenceEntropy >= threshold
    }, name = .name)
}

context("preprocessReads")

# prepare sample data
#   Fragment design:
#     Left Adapter  ATACTG
#     Insert        TGTGACAGACCTCGGGGCCACATGCACTGACTCCTCAGCTGCCAGATGTGCAGTCCAAGCTGGGCCGAGGTC
#     Right Adapter ATCTCGTATGCCGTCTTCTGCTTG
# ... create two temporary fasta files and return file names
faFiles <- tempfile(fileext = rep(".fa", 2), tmpdir = "extdata")
writeLines(c(">seq1", "CCTCAGCTGCCAGATGTGCAGTCCAAGCTGGGCCGA", # onlyInsert
             ">seq2", "AAAAANNAAAAAAAAAAAAAAAAAAAAAAAAAAAAA", # low complexity, 2N
             ">seq3", "AAAATACTGTGTGACAGACCTCGGGGCCACATGCAC", # A.., LAdapter
             ">seq4", "ATACTGTGTGACAGACCTCGGGGCCACATGCACTGA", # LAdapter
             ">seq5", "TGTGACAGACCTCGGGGCCACATGCACTGACTCCTC", # Insert
             ">seq6", "ATACTGATCTCGTATGCCGTCTTCTGCTTGAAAAAA", # LAdapter, noInsert, RAdapter, A..
             ">seq7", "ATACTGATCTCGTATGCCGTCTTCTGCTTGAAAANN", # LAdapter, noInsert, RAdapter, A.., 2N
             ">seq8", "ATACTGGAGGTCATCTCGTATGCCGTCTTCTGCTTG", # LAdapter, shortInsert, RAdapter
             ">seq9", "TGACAGACCTCGGGGCCAC"),                 # shortLength
             faFiles[1])
writeLines(c(">seq1", "AAAAAAAAAAAAAAAAAAA",                  # low complexity
             ">seq2", "TCAGCTGCCAGATGTGCAGTCCAAGCTGGGCCGAGG", # low complexity, shortLength
             ">seq3", "CTCCTCAGCTGCCAGATGTGCAGTCCAAGCTGGGCC", # onlyInsert
             ">seq4", "GAGGTCATCTCGTATGCCGTCTTCTGCTTGAAAAAA", # RAdapter
             ">seq5", "AGCTGCCAGATGTGCAGTCCAAGCTGGGCCGAGGTC", # Insert
             ">seq6", "ATACTGATCTCGTATGCCGTCTTCTGCTTGAAAAAA", # LAdapter, noInsert, RAdapter, A..
             ">seq7", "ATACTGATCTCGTATGCCGTCTTCTGCTTGAAAANN", # LAdapter, noInsert, RAdapter, A.., 2N
             ">seq8", "AAAAATACTGGAGGTCATCTCGTATGCCGTCTTCTG", # A.., LAdapter, shortInsert, RAdapter
             ">seq9", "CAGCTGCCAGATGTGCAGTCCAAGCTGGGCCGAGGT"),# Insert
             faFiles[2])
# ... create two temporary fastq files and return file names
fqFiles <- tempfile(fileext = rep(".fq", 2), tmpdir = "extdata")
writeLines(c("@seq1", "CCTCAGCTGCCAGATGTGCAGTCCAAGCTGGGCCGA", "+", "5..49<494*<49493####################",
             "@seq2", "AAAAANNAAAAAAAAAAAAAAAAAAAAAAAAAAAAA", "+", "+4544944444444######################",
             "@seq3", "AAAATACTGTGTGACAGACCTCGGGGCCACATGCAC", "+", "BCCBCCBBB60>CA;5;@BB@A6+;8@BC?0:B@/=",
             "@seq4", "ATACTGTGTGACAGACCTCGGGGCCACATGCACTGA", "+", "BCBBB>ACBCCCBCC@BCC@*7@82=BBBB1>CABC",
             "@seq5", "TGTGACAGACCTCGGGGCCACATGCACTGACTCCTC", "+", "BA?AB??60>A6?0BBBB95>057;@*.<(434;+4",
             "@seq6", "ATACTGATCTCGTATGCCGTCTTCTGCTTGAAAAAA", "+", "+BCCCCBCCCBACB:?BBCCCCCCBCBC>;(>BBB@",
             "@seq7", "ATACTGATCTCGTATGCCGTCTTCTGCTTGAAAANN", "+", "####################################",
             "@seq8", "ATACTGGAGGTCATCTCGTATGCCGTCTTCTGCTTG", "+", "(33(;?B@AB43*,/;9(6</7>5;<##########",
             "@seq9", "TGACAGACCTCGGGGCCAC",                  "+", "###################"),
             fqFiles[1])
writeLines(c("@seq1", "AAAAAAAAAAAAAAAAAAA",                  "+", "3@?3/>9A8@A1-*/4@BB",
             "@seq2", "TCAGCTGCCAGATGTGCAGTCCAAGCTGGGCCGAGG", "+", "4-093<##############################",
             "@seq3", "CTCCTCAGCTGCCAGATGTGCAGTCCAAGCTGGGCC", "+", "CB?(8=(<A/<=-(07+7&883@#############",
             "@seq4", "GAGGTCATCTCGTATGCCGTCTTCTGCTTGAAAAAA", "+", "5..49<494*<4949#####################",
             "@seq5", "AGCTGCCAGATGTGCAGTCCAAGCTGGGCCGAGGTC", "+", "+45449444444########################",
             "@seq6", "ATACTGATCTCGTATGCCGTCTTCTGCTTGAAAAAA", "+", "BCCBCCBBB60>CA;5;@BB@A6+;8@BC?0:B@A<",
             "@seq7", "ATACTGATCTCGTATGCCGTCTTCTGCTTGAAAANN", "+", "BCBBB>ACBCCCBCC@BCC@*7@82=BBBB1>CABB",
             "@seq8", "AAAAATACTGGAGGTCATCTCGTATGCCGTCTTCTG", "+", "BA?AB??60>A6?0BBBB95>057;@*.<(434;@B",
             "@seq9", "CAGCTGCCAGATGTGCAGTCCAAGCTGGGCCGAGGT", "+", "+BCCCCBCCCBACB:?BBCCCCCCBCBC>;(>B@4;"),
             fqFiles[2])

test_that("arguments in preprocessReads are digested correctly", {
  tmptxt <- tempfile(fileext = ".txt", tmpdir = "extdata")
  writeLines("AAA", tmptxt)
  tmpfagz <- tempfile(fileext = ".fa.gz", tmpdir = "extdata")
  Biostrings::writeXStringSet(DNAStringSet(x = "AAA"), 
                              filepath = tmpfagz, compress = TRUE)
  expect_error(preprocessReads(1L),
               ".filename. must be of type character")
  expect_error(preprocessReads(c("a","b"), "c"),
               ".filename. and .outputFilename. must have equal length")
  expect_error(preprocessReads("in1.fa", "out1.fa"),
               "non-existing input file.s.: in1.fa")
  expect_error(preprocessReads("a", 1L),
               ".outputFilename. must be of type character")
  expect_error(preprocessReads(tmptxt, NULL),
               "unsupported file format")
  expect_error(preprocessReads(faFiles[1], "b.fastq"),
               "format of .filename. and .outputFilename. must be identical")
  expect_error(preprocessReads(tmpfagz, "b.fa.gz"),
               "compressed .fasta. input is not yet supported")
  expect_error(preprocessReads(faFiles[1], "out1.fa", faFiles[2], "out2.fa", Lpattern = "AAA"),
               "Removing adapters from paired-end samples is not yet supported")
  expect_error(preprocessReads(faFiles[1], "out1.fa", 1L, "out2.fa"),
               ".filenameMate. must be of type character")
  expect_error(preprocessReads(faFiles[1], "out1.fa", faFiles[2], 1L),
               ".outputFilenameMate. must be of type character")
  expect_error(preprocessReads(faFiles[1], "out1.fa", faFiles[2], c("o2a.fa","o2b.fa")),
               ".filenameMate. and .outputFilenameMate. must have equal length")
  expect_error(preprocessReads(faFiles[1], "out1.fa", faFiles[2], "out2.fq"),
               "format of .filenameMate. and .outputFilenameMate. must be identical")
  expect_error(preprocessReads(faFiles[1], "out1.fa.gz", faFiles[2], "out2.fa.bz2"),
               "compression format of .outputFilename. and .outputFilenameMate. must be identical")
})

test_that("preprocessReads correctly processes single-read files", {
  # results for default parameters
  outFilesFasta <- tempfile(fileext = rep(".fa", 2), tmpdir = "extdata")
  resSoll <- cbind(c(9,0,0,0,0,0,9), c(9,0,0,0,0,0,9))
  rownames(resSoll) <- c("totalSequences","matchTo5pAdapter","matchTo3pAdapter",
                         "tooShort","tooManyN","lowComplexity","totalPassed")
  colnames(resSoll) <- basename(faFiles)
  outFilesFastq <- tempfile(fileext = rep(".fq", 2), tmpdir = "extdata")

  # default
  res <- preprocessReads(faFiles, outFilesFasta, clObj = clObj)
  expect_equal(resSoll, res)
  
  # existing output file
  expect_error(preprocessReads(faFiles, outFilesFasta))
  unlink(outFilesFasta)
  
  # complexity
  res <- preprocessReads(fqFiles, outFilesFastq, complexity = 0.5)
  expect_equal(c(1, 1), unname(res["lowComplexity",]))
  unlink(outFilesFastq)
  
  # minLength
  res <- preprocessReads(faFiles, outFilesFasta, minLength = 30)
  expect_equal(c(1, 1), unname(res["tooShort",]))
  unlink(outFilesFasta)
  
  # nBases
  res <- preprocessReads(fqFiles, outFilesFastq, nBases = 1)
  expect_equal(c(2, 1), unname(res["tooManyN",]))
  unlink(outFilesFastq)
  
  # truncateStartBases
  res <- preprocessReads(faFiles, outFilesFasta, truncateStartBases = 2)
  expect_equal(nchar(readLines(faFiles[1]))[seq(2, 18, by = 2)] - 2L,
               nchar(readLines(outFilesFasta[1])[seq(2, 18, by = 2)]))
  unlink(outFilesFasta)
  
  # truncateEndBases
  res <- preprocessReads(fqFiles, outFilesFastq, truncateEndBases = 3)
  expect_equal(nchar(readLines(fqFiles[2]))[seq(2, 36, by = 4)] - 3L,
               nchar(readLines(outFilesFastq[2])[seq(2, 36, by = 4)]))
  unlink(outFilesFastq)
  
  # Lpattern
  res <- preprocessReads(faFiles, outFilesFasta, Lpattern = "ATACTG")
  expect_equal(c(7, 4), unname(res["matchTo5pAdapter",]))
  unlink(outFilesFasta)
  
  # Rpattern
  res <- preprocessReads(fqFiles, outFilesFastq, Rpattern = "ATCTCGTATGCCGTCTTCTGCTTG")
  expect_equal(c(6, 5), unname(res["matchTo3pAdapter",]))
  unlink(outFilesFastq)
})

test_that("preprocessReads correctly processes paired-end files", {
  # results for default parameters
  outFilesFasta <- tempfile(fileext = rep(".fa", 2), tmpdir = "extdata")
  resSoll <- matrix(c(9,NA,NA,0,0,0,9), nrow = 7, ncol = 1,
                    dimnames = list(c("totalSequences","matchTo5pAdapter","matchTo3pAdapter",
                                      "tooShort","tooManyN","lowComplexity","totalPassed"),
                                    paste(basename(faFiles), collapse = ":")))
  outFilesFastq <- tempfile(fileext = rep(".fq", 2), tmpdir = "extdata")
  
  # default
  res <- preprocessReads(faFiles[1], outFilesFasta[1], faFiles[2], outFilesFasta[2])
  expect_equal(resSoll, res)
  unlink(outFilesFasta)
  
  # complexity
  res <- preprocessReads(fqFiles[1], outFilesFastq[1], fqFiles[2], outFilesFastq[2],
                         complexity = 0.5)
  expect_equal(2, res["lowComplexity",])
  unlink(outFilesFastq)
  
  # minLength
  res <- preprocessReads(faFiles[1], outFilesFasta[1], faFiles[2], outFilesFasta[2],
                         minLength = 30)
  expect_equal(2, res["tooShort",])
  unlink(outFilesFasta)
  
  # nBases
  res <- preprocessReads(fqFiles[1], outFilesFastq[1], fqFiles[2], outFilesFastq[2],
                         nBases = 1)
  expect_equal(2, res["tooManyN",])
  unlink(outFilesFastq)
  
  # truncateStartBases
  res <- preprocessReads(faFiles[1], outFilesFasta[1], faFiles[2], outFilesFasta[2],
                         truncateStartBases = 2)
  expect_equal(nchar(readLines(faFiles[1]))[seq(2, 18, by = 2)] - 2L,
               nchar(readLines(outFilesFasta[1])[seq(2, 18, by = 2)]))
  expect_equal(nchar(readLines(faFiles[2]))[seq(2, 18, by = 2)] - 2L,
               nchar(readLines(outFilesFasta[2])[seq(2, 18, by = 2)]))
  unlink(outFilesFasta)
  
  # truncateEndBases and compressed output
  res <- preprocessReads(fqFiles[1], outFilesFastq[1], fqFiles[2], outFilesFastq[2],
                         truncateEndBases = 3)
  res <- preprocessReads(fqFiles[1], paste0(outFilesFastq[1], ".gz"),
                         fqFiles[2], paste0(outFilesFastq[2], ".gz"),
                         truncateEndBases = 3)
  expect_equal(nchar(readLines(fqFiles[1]))[seq(2, 36, by = 4)] - 3L,
               nchar(readLines(paste0(outFilesFastq[1],".gz"))[seq(2, 36, by = 4)]))
  expect_equal(nchar(readLines(fqFiles[2]))[seq(2, 36, by = 4)] - 3L,
               nchar(readLines(paste0(outFilesFastq[2],".gz"))[seq(2, 36, by = 4)]))
  unlink(paste0(outFilesFastq,".gz"))
})

test_that("preprocessReads correctly (de-)compresses files", {
  # results for default parameters
  resSoll <- matrix(c(9,0,0,0,0,0,9), ncol = 1,
                    dimnames = list(c("totalSequences","matchTo5pAdapter","matchTo3pAdapter",
                                      "tooShort","tooManyN","lowComplexity","totalPassed"),
                                    basename(faFiles[1])))
  
  outFile <- tempfile(fileext = ".fa.gz", tmpdir = "extdata")
  res <- preprocessReads(faFiles[1], outFile)
  expect_equal(resSoll, res)
  unlink(outFile)
  
  outFile <- tempfile(fileext = ".fa.bz2", tmpdir = "extdata")
  res <- preprocessReads(faFiles[1], outFile)
  expect_equal(resSoll, res)
  unlink(outFile)
  
  outFile <- tempfile(fileext = ".fa.xz", tmpdir = "extdata")
  res <- preprocessReads(faFiles[1], outFile)
  expect_equal(resSoll, res)
  unlink(outFile)
})

# remove sample data
unlink("extdata", recursive = TRUE)

# remove QuasR log files
unlink(list.files(path = ".", pattern = "^QuasR_log_.+\\.txt$"))

# stop cluster object
parallel::stopCluster(clObj)

# restore original values of R_LIBS
Sys.setenv(R_LIBS = oldRlibs)

## query : GRanges : value has one row per unique name in GRanges
## query : GRangesList : value has one row per name of GRangesList
## query : TxDb : value has has one row per 'reportLevel'
## query : NULL & reportLevel=="junction": value has has one row per 'junction'

#' Quantify alignments
#'
#' Quantify alignments from sequencing data.
#'
#' \code{qCount} is used to count alignments in each sample from a
#' \code{qProject} object. The features to be quantified, together with
#' the mode of quantification, are specified by the \code{query}
#' argument, which is one of:
#' \describe{
#'   \item{\code{\link[GenomicRanges:GRanges-class]{GRanges}}}{: Overlapping alignments
#'   are counted separately for each coordinate region. If multiple
#'   regions have identical names, their counts will be summed, counting
#'   each alignment only once even if it overlaps more than one of these
#'   regions. Alignments may be counted more than once if they overlap
#'   multiple regions that have different names.
#'   This mode is for example used to quantify ChIP-seq alignments in
#'   promoter regions, or gene expression levels in an RNA-seq experiment
#'   (using a \code{query} with exon regions named by gene).}
#'   \item{\code{\link[GenomicRanges:GRangesList-class]{GRangesList}}}{: Alignments are
#'   counted and summed for each list element in \code{query} if they
#'   overlap with any of the regions contained in the list element. The
#'   order of the list elements defines a hierarchy for quantification:
#'   Alignment will only be counted for the first element (the one with
#'   the lowest index in \code{query}) that they overlap, but not for any
#'   potential further list elements containing overlapping regions.
#'   This mode can be used to hierarchically and uniquely count (assign)
#'   each alignment to a one of several groups of regions (the elements
#'   in \code{query}), for example to estimate the fractions of different
#'   classes of RNA in an RNA-seq experiment (rRNA, tRNA, snRNA, snoRNA,
#'   mRNA, etc.)}
#'   \item{\code{\link[GenomicFeatures:TxDb-class]{TxDb}}}{: Used to extract
#'   regions from annotation and report alignment counts depending on the
#'   value of \code{reportLevel}. If \code{reportLevel="exon"},
#'   alignments overlapping each exon in \code{query} are counted.
#'   If \code{reportLevel="gene"}, alignment counts for all exons of a
#'   gene will be summed, counting each alignment only once even if it
#'   overlaps multiple annotated exons of a gene. These are useful to
#'   calculate exon or gene expression levels in RNA-seq experiments
#'   based on the annotation in a \code{TxDb} object. If
#'   \code{reportLevel="promoter"}, the \code{promoters} function from package
#'   \pkg{GenomicFeatures} is used with default arguments to extract
#'   promoter regions around transcript start sites, e.g. to quantify
#'   alignments inf a ChIP-seq experiment.}
#'   \item{any of the above or \code{NULL} for
#'   \code{reportLevel="junction"}}{: The \code{query} argument is ignored
#'   if \code{reportLevel} is set to \code{"junction"}, and \code{qCount}
#'   will count the number of alignments supporting each exon-exon
#'   junction detected in any of the samples in \code{proj}. The
#'   arguments \code{selectReadPosition}, \code{shift},
#'   \code{orientation}, \code{useRead} and \code{mask} will have no
#'   effect in this quantification mode.}
#' }
#'
#' The additional arguments allow to fine-tune the quantification:
#'
#' \code{selectReadPosition} defines the part of the alignment that has
#' to be contained within a query region for an overlap. The values
#' \code{start} (default) and \code{end} refer to the biological start
#' (5'-end) and end (3'-end) of the alignment. For example, the
#' \code{start} of an alignment on the plus strand is its leftmost
#' (lowest) base, and the \code{end} of an alignment on the minus strand
#' is also the leftmost base.
#'
#' \code{shift} allows on-the-fly shifting of alignments towards their
#' 3'-end prior to overlap determination and counting. This can be
#' helpful to increase resolution of ChIP-seq experiments by moving
#' alignments by half the immuno-precipitated fragment size towards the
#' middle of fragments. \code{shift} is either an \dQuote{integer} vector
#' with one value per alignment file in \code{proj}, or a single
#' \dQuote{integer} value, in which case all alignment files will be
#' shifted by the same value. For paired-end experiments, it can be
#' alternatively set to "halfInsert", which will estimate the true
#' fragment size from the distance between aligned read pairs and shift
#' the alignments accordingly.
#'
#' \code{orientation} controls the interpretation of alignment strand
#' when counting, relative to the strand of the query region. \code{any}
#' will count all overlapping alignments, irrespective of the alignment
#' strand (e.g. used in an unstranded RNA-seq experiment). \code{same}
#' will only count the alignments on the same strand as the query region
#' (e.g. in a stranded RNA-seq experiment that generates reads from the
#' sense strand), and \code{opposite} will only
#' count the alignments on the opposite strand from the query region
#' (e.g. to quantify anti-sense transcription in a stranded RNA-seq
#' experiment).
#'
#' \code{includeSpliced} and \code{includeSecondary} can be used to
#' include or exclude spliced or secondary alignments,
#' respectively. \code{mapqMin} and \code{mapqMax} allow to select alignments
#' based on their mapping qualities. \code{mapqMin} and \code{mapqMax} can
#' take integer values between 0 and 255 and equal to
#' \eqn{-10 log_{10} Pr(\textnormal{mapping position is wrong})}{-10
#' log10 Pr(mapping position is wrong)}, rounded to the nearest
#' integer. A value 255 indicates that the mapping quality is not available.
#'
#' In paired-end experiments, \code{useRead} allows to quantify either
#' all alignments (\code{useRead="any"}), or only the first
#' (\code{useRead="first"}) or last (\code{useRead="last"}) read from a
#' read pair or read group. Note that for \code{useRead="any"} (the
#' default), an alignment pair that is fully contained within a query
#' region will contribute two counts to the value of that
#' region. \code{absIsizeMin} and \code{absIsizeMax} can be used to
#' select alignments based on their insert size (TLEN field in SAM Spec
#' v1.4).
#'
#' \code{auxiliaryName} selects the reference sequence for which
#' alignments should be quantified. \code{NULL} (the default) will
#' select alignments against the genome. If set to a character string
#' that matches one of the auxiliary target names (as specified in
#' the \code{auxiliaryFile} argument of \code{\link[QuasR]{qAlign}}), the
#' corresponding alignments will be counted.
#'
#' \code{mask} can be used to specify a
#' \code{\link[GenomicRanges:GRanges-class]{GRanges}} object with regions in the
#' reference sequence to be excluded from quantification. The regions
#' will be considered unstranded (\code{strand="*"}). Alignments that
#' overlap with a region in \code{mask} will not be counted. Masking may
#' reduce the effective width of query regions reported by \code{qCount},
#' even down to zero for regions that are fully contained in \code{mask}.
#'
#' If \code{clObj} is set to an object that inherits from class
#' \code{cluster}, for example an object returned by
#' \code{\link[parallel]{makeCluster}} from package \pkg{parallel}, the
#' quantification task is split into multiple chunks and processed in
#' parallel using \code{\link[parallel:clusterApply]{clusterMap}}. Currently, not all
#' tasks will be efficiently parallelized: For example, a single query
#' region and a single (group of) bam files will not be split into
#' multiple chunks.
#'
#' @param proj A \code{\linkS4class{qProject}} object representing a
#'   sequencing experiment as returned by \code{\link[QuasR]{qAlign}}
#' @param query An object of type \code{\link[GenomicRanges:GRanges-class]{GRanges}},
#'   \code{\link[GenomicRanges:GRangesList-class]{GRangesList}} or
#'   \code{\link[GenomicFeatures:TxDb-class]{TxDb}} with the regions to be
#'   quantified. The type of \code{query} will determine the mode of
#'   quantification (see \sQuote{Details}). For
#'   \code{reportLevel="junction"}, \code{query} is ignored and can also
#'   be \code{NULL}.
#' @param reportLevel Level of quantification (\code{query} of type
#'   \code{TxDb} or \code{NULL}), one of
#'   \describe{
#'     \item{\code{gene} (default)}{: one value per gene}
#'     \item{\code{exon}}{: one value per exon}
#'     \item{\code{promoter}}{: one value per promoter}
#'     \item{\code{junction}}{: one count per detected exon-exon junction
#'         (\code{query} will be ignored in this case) }
#'   }
#' @param selectReadPosition defines the part of the alignment that has
#'   to be contained within a query region to produce an overlap (see
#'   \sQuote{Details}). Possible values are:
#'   \describe{
#'     \item{\code{start} (default)}{: start of the alignment}
#'     \item{\code{end}}{: end of the alignment}
#'   }
#' @param shift controls the shifting alignments towards their 3'-end before
#'   quantification. \code{shift} can be one of:
#'   \itemize{
#'     \item an \dQuote{integer} vector of the same length as the
#'     number of alignment files
#'     \item a single \dQuote{integer} value
#'     \item the character string \code{"halfInsert"} (only available for
#'     paired-end experiments)
#'   }
#'   The default of \code{0} will not shift any alignments.
#' @param orientation sets the required orientation of the alignments relative
#'   to the query region in order to be counted, one of:
#'   \describe{
#'     \item{\code{any} (default)}{: count alignment on the same and opposite strand}
#'     \item{\code{same}}{: count only alignment on the same strand}
#'     \item{\code{opposite}}{: count only alignment on the opposite strand}
#'   }
#' @param useRead For paired-end experiments, selects the read mate whose
#'   alignments should be counted, one of:
#'   \describe{
#'     \item{\code{any} (default)}{: count all alignments}
#'     \item{\code{first}}{: count only alignments from the first read}
#'     \item{\code{last}}{: count only alignments from the last read}
#'   }
#' @param auxiliaryName Which bam files to use in an experiments with
#'   auxiliary alignments (see \sQuote{Details}).
#' @param mask If not \code{NULL}, a \code{\link[GenomicRanges:GRanges-class]{GRanges}}
#'   object with reference regions to be masked, i.e. excluded from the
#'   quantification, such as unmappable or highly repetitive regions (see
#'   \sQuote{Details}).
#' @param collapseBySample If \code{TRUE} (the default), sum alignment
#'   counts from bam files with the same sample name.
#' @param includeSpliced If \code{TRUE} (the default), include spliced
#'   alignments when counting. A spliced alignment is defined as an
#'   alignment with a gap in the read of at least 60 bases.
#' @param includeSecondary If \code{TRUE} (the default), include alignments
#'   with the secondary bit (0x0100) set in the \code{FLAG} when counting.
#' @param mapqMin Minimal mapping quality of alignments to be included when
#'   counting (mapping quality must be greater than or equal to
#'   \code{mapqMin}). Valid values are between 0 and 255. The default (0)
#'   will include all alignments.
#' @param mapqMax Maximal mapping quality of alignments to be included when
#'   counting (mapping quality must be less than or equal to \code{mapqMax}).
#'   Valid values are between 0 and 255. The default (255) will include
#'   all alignments.
#' @param absIsizeMin For paired-end experiments, minimal absolute insert
#'   size (TLEN field in SAM Spec v1.4) of alignments to be included when
#'   counting. Valid values are greater than 0 or \code{NULL} (default),
#'   which will not apply any minimum insert size filtering.
#' @param absIsizeMax For paired-end experiments, maximal absolute insert
#'   size (TLEN field in SAM Spec v1.4) of alignments to be included when
#'   counting. Valid values are greater than 0 or \code{NULL} (default),
#'   which will not apply any maximum insert size filtering.
#' @param maxInsertSize Maximal fragment size of the paired-end experiment.
#'   This parameter is used if \code{shift="halfInsert"} and will
#'   ensure that query regions are made wide enough to emcompass all
#'   alignment pairs whose mid falls into the query region. The default
#'   value is \code{500} bases.
#' @param clObj A cluster object to be used for parallel processing (see
#'   \sQuote{Details}).
#'
#' @name qCount
#' @aliases qCount
#'
#' @return
#' A \code{matrix} with effective query regions width in the first
#' column, and alignment counts in subsequent columns, or a
#' \code{GRanges} object if \code{reportLevel="junction"}.
#'
#' The effective query region width returned as first column in the
#' matrix is calculated by the number of unique, non-masked bases in the
#' reference sequence that contributed to the count of this query
#' name (irrespective if the bases were covered by alignments or not).
#' An effective width of zero indicates that the region was fully
#' masked and will have zero counts in all samples.
#'
#' The alignment counts in the matrix are contained from column two
#' onwards. For projects with allele-specific quantification, i.e. if a
#' file with single nucleotide polymorphisms was supplied to the
#' \code{snpFile} argument of \code{\link[QuasR]{qAlign}}, there will be
#' three columns per bam file (number of alignments for Reference,
#' Unknown and Alternative genotypes, with suffixed _R, _U and
#' _A). Otherwise there is a single columns per bam file.
#'
#' If \code{collapseBySample}=\code{TRUE}, groups of bam files with identical
#' sample name are combined by summing their alignment counts.
#'
#' For \code{reportLevel="junction"}, the return value is a
#' \code{GRanges} object. The start and end coordinates correspond to the
#' first and last base in each detected intron. Plus- and minus-strand
#' alignments are quantified separately, so that in an unstranded RNA-seq
#' experiment, the same intron may be represented twice; once for each
#' strand. The counts for each sample are contained in the \code{mcols}
#' of the \code{GRanges} object.
#'
#' @author Anita Lerch, Dimos Gaidatzis and Michael Stadler
#' @keywords utilities misc
#'
#' @export
#'
#' @seealso
#' \code{\link[QuasR]{qAlign}},
#' \code{\linkS4class{qProject}},
#' \code{\link[parallel]{makeCluster}} from package \pkg{parallel}
#'
#' @examples
#' library(GenomicRanges)
#' library(Biostrings)
#' library(Rsamtools)
#'
#' # copy example data to current working directory
#' file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)
#'
#' # load genome sequence
#' genomeFile <- "extdata/hg19sub.fa"
#' gseq <- readDNAStringSet(genomeFile)
#' chrRegions <- GRanges(names(gseq), IRanges(start=1,width=width(gseq),names=names(gseq)))
#'
#' # create alignments (paired-end experiment)
#' sampleFile <- "extdata/samples_rna_paired.txt"
#' proj <- qAlign(sampleFile, genomeFile, splicedAlignment=TRUE)
#'
#' # count reads using a "GRanges" query
#' qCount(proj, query=chrRegions)
#' qCount(proj, query=chrRegions, useRead="first")
#'
#' # hierarchical counting using a "GRangesList" query
#' library(rtracklayer)
#' annotationFile <- "extdata/hg19sub_annotation.gtf"
#' gtfRegions <- import.gff(annotationFile, format="gtf", feature.type="exon")
#' names(gtfRegions) <- mcols(gtfRegions)$source
#' gtfRegionList <- split(gtfRegions, names(gtfRegions))
#' names(gtfRegionList)
#'
#' res3 <- qCount(proj, gtfRegionList)
#' res3
#'
#' # gene expression levels using a "TxDb" query
#' library("txdbmaker")
#' genomeRegion <- scanFaIndex(genomeFile)
#' chrominfo <- data.frame(chrom=as.character(seqnames(genomeRegion)),
#'                         length=end(genomeRegion),
#'                         is_circular=rep(FALSE, length(genomeRegion)))
#' txdb <- makeTxDbFromGFF(annotationFile,
#'                         format="gtf",
#'                         chrominfo=chrominfo,
#'                         dataSource="Ensembl modified",
#'                         organism="Homo sapiens")
#'
#' res4 <- qCount(proj, txdb, reportLevel="gene")
#' res4
#'
#' # exon-exon junctions
#' res5 <- qCount(proj, NULL, reportLevel="junction")
#' res5
#'
#' @importFrom Rsamtools scanBamHeader
#' @importFrom Seqinfo seqlevels seqlevelsInUse seqlengths
#' @importFrom parallel clusterMap clusterEvalQ splitIndices
#' @importFrom GenomicRanges GRanges reduce findOverlaps seqnames
#' @importFrom IRanges IRanges ranges
#' @importFrom S4Vectors mcols elementNROWS endoapply Rle subjectHits queryHits
#'   split
#' @importFrom BiocGenerics width strand end start setdiff unlist
#' @importFrom GenomicFeatures exons promoters exonsBy
qCount <- function(proj,
                   query,
                   reportLevel = c(NULL, "gene", "exon", "promoter", "junction"),
                   selectReadPosition = c("start", "end"),
                   shift = 0L,
                   orientation = c("any", "same", "opposite"),
                   useRead = c("any", "first", "last"),
                   auxiliaryName = NULL,
                   mask = NULL,
                   collapseBySample = TRUE,
                   includeSpliced = TRUE,
                   includeSecondary = TRUE,
                   mapqMin = 0L,
                   mapqMax = 255L,
                   absIsizeMin = NULL,
                   absIsizeMax = NULL,
                   maxInsertSize = 500L,
                   clObj = NULL) {
    ## setup variables from 'proj' ---------------------------------------------
    ## 'proj' is correct type?
    if (!inherits(proj, "qProject", which = FALSE))
        stop("'proj' must be an object of type 'qProject' (returned by 'qAlign')")

    samples <- proj@alignments$SampleName
    nsamples <- length(samples)
    bamfiles <-
        if (is.null(auxiliaryName))
            proj@alignments$FileName
    else if(!is.na(i <- match(auxiliaryName, proj@aux$AuxName)))
        unlist(proj@auxAlignments[i, ], use.names = FALSE)
    else
        stop("unknown 'auxiliaryName', should be one of: NULL, ",
             paste(sprintf("'%s'", proj@aux$AuxName), collapse = ", "))


    ## validate parameters -----------------------------------------------------
    reportLevel <- match.arg(reportLevel)
    selectReadPosition <- match.arg(selectReadPosition)
    orientation <- match.arg(orientation)
    useRead <- match.arg(useRead)
    if ((!is.null(absIsizeMin) || !is.null(absIsizeMax)) && proj@paired == "no")
        stop("'absIsizeMin' and 'absIsizeMax' can only be used for paired-end experiments")
    if (is.null(absIsizeMin)) # -1L -> do not apply TLEN filtering
        absIsizeMin <- -1L
    if (is.null(absIsizeMax))
        absIsizeMax <- -1L

    ## check shift
    if (length(shift) == 1 && shift == "halfInsert") {
        if (proj@paired == "no") {
            stop("'shift=\"halfInsert\"' can only be used for paired-end experiments")
        } else {
            shifts <- rep(-1000000L, nsamples)
            broaden <- as.integer(ceiling(maxInsertSize/2))
        }
    } else {
        if (!is.numeric(shift) || (length(shift) > 1 && length(shift) != nsamples))
            stop(sprintf("'shift' must be 'halfInsert', a single integer or an integer vector with %d values", nsamples))
        else if(length(shift) == 1)
            shifts <- rep(as.integer(shift), nsamples)
        else
            shifts <- as.integer(shift)
        broaden <- 0L
    }

    ## all query chromosomes present in all bamfiles?
    trTab <- table(unlist(lapply(Rsamtools::scanBamHeader(bamfiles),
                                 function(bh) names(bh$targets))))
    trCommon <- names(trTab)[trTab == length(bamfiles)]
    queryseqs <- NULL
    if (inherits(query, c("GRanges","GRangesList"))) {
        queryseqs <- Seqinfo::seqlevelsInUse(query)
    } else if (inherits(query,"TxDb")) { # only use active sequences
        queryseqs <- Seqinfo::seqlevels(query) # isActiveSeq is deprecated; no seqlevelsInUse for TxDb yet
    }
    if (!is.null(query) && any(f <- !(queryseqs %in% trCommon)))
        stop(sprintf("sequence levels in 'query' not found in alignment files: %s",
                     paste(Seqinfo::seqlevels(query)[f], collapse = ", ")))

    ## 'query' is correct type?
    if (reportLevel == "junction") {
        if (proj@splicedAlignment != TRUE && proj@samplesFormat != "bam")
            stop("reportLevel=\"junction\" cannot be used for non-spliced alignments")
        if (absIsizeMin != -1L || absIsizeMax != -1L) {
            warning("ignoring 'absIsizeMin' and 'absIsizeMax' for reportLevel=\"junction\"")
            absIsizeMin <- absIsizeMax <- -1L
        }
        if (!is.null(query))
            warning("ignoring 'query' for reportLevel=\"junction\"")

        ### reportLevel == "junction" ------------------------------------------
        ## setup tasks for parallelization -------------------------------------
        if (!is.null(clObj) & inherits(clObj, "cluster", which = FALSE)) {
            loadQuasR(clObj)
            taskTargets <- rep(trCommon, nsamples)
            bamfiles <- rep(bamfiles, each = length(trCommon))
            iByBamfile <- split(seq_along(bamfiles), bamfiles)[unique(bamfiles)]
            myapply <- function(...) {
                ret <- parallel::clusterMap(clObj, ..., SIMPLIFY = FALSE,
                                            .scheduling = "dynamic")
                # fuse
                if (!is.na(proj@snpFile)) {
                    # ret is a list of list(id,R,U,A)
                    ret <- lapply(iByBamfile, function(i)
                        list(id = do.call(c, lapply(ret[i], "[[", "id")),
                             R = do.call(c, lapply(ret[i], "[[", "R")),
                             U = do.call(c, lapply(ret[i], "[[", "U")),
                             A = do.call(c, lapply(ret[i], "[[", "A"))))
                } else {
                    # ret is a list of named vectors
                    ret <- lapply(iByBamfile, function(i) do.call(c, unname(ret[i])))
                }
                ret
            }
        } else {
            taskTargets <- rep(list(NULL), length(bamfiles))
            myapply <- function(...) {
                ret <- mapply(..., SIMPLIFY = FALSE)
                ret
            }
        }

        ## count junctions -----------------------------------------------------
        message("counting junctions...", appendLF = FALSE)
        resL <- myapply(countJunctionsOneBamfile,
                        bamfile = bamfiles,
                        targets = taskTargets,
                        MoreArgs = list(allelic = !is.na(proj@snpFile),
                                        includeSecondary = includeSecondary,
                                        mapqmin = as.integer(mapqMin)[1],
                                        mapqmax = as.integer(mapqMax)[1]))
        message("done")

        ## make result rectangular and collapse (sum) counts by sample if necessary
        if (!is.na(proj@snpFile)) {
            # ret is a list of list(id,R,U,A)
            allJunctions <- unique(Reduce(c, lapply(resL, "[[", "id")))
            res <- matrix(0, nrow = length(allJunctions),
                          ncol = 3 * length(resL), dimnames = list(allJunctions, NULL))
            for (i in seq_len(length(resL))) # make res a matrix with 3 columns per sample
                res[resL[[i]]$id, ((i - 1) * 3 + 1):((i - 1) * 3 + 3)] <-
                do.call(cbind, resL[[i]][c("R", "U", "A")])
            if (nsamples > length(unique(samples))) {
                if (collapseBySample) {
                    message("collapsing counts by sample...", appendLF = FALSE)
                    iBySample <- split(seq_len(nsamples), samples)[unique(samples)]
                    res <- do.call(cbind, lapply(iBySample, function(i)
                        cbind(R = rowSums(res[, (i - 1) * 3 + 1, drop = FALSE]),
                              U = rowSums(res[, (i - 1) * 3 + 2, drop = FALSE]),
                              A = rowSums(res[, (i - 1) * 3 + 3, drop = FALSE]))))
                    colnames(res) <- paste(rep(names(iBySample), each = 3),
                                           c("R", "U", "A"), sep = "_")
                    message("done")
                } else {
                    # unify non-collapsed identical sample names
                    colnames(res) <- paste(rep(displayNames(proj), each = 3),
                                           c("R", "U", "A"), sep = "_")
                }
            } else {
                colnames(res) <- paste(rep(samples, each = 3), c("R", "U", "A"),
                                       sep = "_")
            }
        } else {
            # ret is a list of named vectors
            allJunctions <- unique(Reduce(c, lapply(resL, names)))
            res <- matrix(0, nrow = length(allJunctions), ncol = length(resL),
                          dimnames = list(allJunctions, NULL))
            for (i in seq_len(length(resL)))
                res[names(resL[[i]]),i] <- resL[[i]]
            if (nsamples > length(unique(samples))) {
                if (collapseBySample) {
                    message("collapsing counts by sample...", appendLF = FALSE)
                    iBySample <- split(seq_len(nsamples), samples)[unique(samples)]
                    res <- do.call(cbind, lapply(iBySample, function(i)
                        rowSums(res[, i, drop = FALSE])))
                    message("done")
                } else {
                    # unify non-collapsed identical sample names
                    colnames(res) <- displayNames(proj)
                }
            } else {
                colnames(res) <- samples
            }
        }

        ## make GRanges object
        res2 <- GenomicRanges::GRanges(
            seqnames = sub("^(.+):[0-9]+:[0-9]+:.$", "\\1", allJunctions),
            ranges = IRanges::IRanges(
                start = as.integer(sub("^.+:([0-9]+):[0-9]+:.$",
                                       "\\1", allJunctions)),
                end = as.integer(sub("^.+:[0-9]+:([0-9]+):.$",
                                     "\\1", allJunctions))),
            strand = sub("^.+:[0-9]+:[0-9]+:(.)$", "\\1", allJunctions))
        S4Vectors::mcols(res2) <- res

        ## return results
        return(res2)
    } else {
        ### reportLevel != "junction" ------------------------------------------
        if (!inherits(query, c("GRanges", "GRangesList", "TxDb")))
            stop("'query' must be either an object of type 'GRanges', 'GRangesList' or 'TxDb', or NULL for reportLevel=\"junction\"")

        ## 'useRead' set but not a paired-end experiment?
        if (useRead != "any" && proj@paired == "no")
            warning("ignoring 'useRead' for single read experiments")


        ## preprocess query ----------------------------------------------------
        ##    --> create 'flatquery', 'querynames', 'querylengths' and 'zeroquerynames'
        ##    GRanges query ----------------------------------------------------
        if (inherits(query, "GRanges")) {
            if (!is.null(names(query)) && length(query) > length(unique(names(query)))) {
                # remove redundancy from 'query' by names
                tmpquery <- GenomicRanges::reduce(S4Vectors::split(query, names(query))[unique(names(query))])
                flatquery <- BiocGenerics::unlist(tmpquery, use.names = FALSE)
                querynames <- rep(names(tmpquery), S4Vectors::elementNROWS(tmpquery))
                rm(tmpquery)
            } else {
                flatquery <- query
                querynames <- if (is.null(names(query)))
                    as.character(seq_len(length(query))) else names(query)
            }
            querylengths <- BiocGenerics::width(flatquery)
            zeroquerynames <- character(0)

            ##    GRangesList query --------------------------------------------
        } else if (inherits(query, "GRangesList")) {
            if (any(i <- S4Vectors::elementNROWS(query) == 0)) {
                warning(sprintf("removing %d elements from 'query' with zero regions: %s",
                                sum(i), paste(names(query)[i], collapse = ", ")))
                query <- query[-i]
            }
            # hierarchically remove redundancy from 'query'
            message("hierarchically removing redundancy from 'query'...",
                    appendLF = FALSE)
            if (orientation == "any")
                BiocGenerics::strand(query) <-
                S4Vectors::endoapply(BiocGenerics::strand(query), function(x)
                    S4Vectors::Rle(factor("*", levels = c("+", "-", "*")),
                                   lengths = length(x)))
            query <- GenomicRanges::reduce(query)
            if (length(query) > 1) {
                cumquery <- query[[1]]
                for (i in 2:length(query)) {
                    query[[i]] <- BiocGenerics::setdiff(query[[i]], cumquery)
                    cumquery <- c(query[[i]], cumquery)
                }
            }
            message("done")
            flatquery <- BiocGenerics::unlist(query, use.names = FALSE)
            querynames <- rep(if(is.null(names(query))) as.character(seq_len(length(query))) else names(query),
                              S4Vectors::elementNROWS(query))
            querylengths <- unlist(BiocGenerics::width(query), use.names = FALSE)
            zeroquerynames <- (if(is.null(names(query))) as.character(seq_len(length(query))) else names(query))[S4Vectors::elementNROWS(query) == 0]

            ##    TxDb query -----------------------------------------------
        } else if (inherits(query, "TxDb")) {
            if (is.null(reportLevel))
                stop("'reportLevel' must be set to a non-NULL value for 'query' of type 'TxDb'")
            message(sprintf("extracting %s regions from TxDb...", reportLevel),
                    appendLF = FALSE)
            if (reportLevel == "gene") {
                tmpquery <- GenomicRanges::reduce(
                    GenomicFeatures::exonsBy(query, by = "gene")
                )
                flatquery <- BiocGenerics::unlist(tmpquery, use.names = FALSE)
                querynames <- rep(names(tmpquery), S4Vectors::elementNROWS(tmpquery))
                querylengths <- unlist(BiocGenerics::width(tmpquery), use.names = FALSE)
                rm(tmpquery)

            } else if (reportLevel == "exon") {
                flatquery <- GenomicFeatures::exons(query, columns = "exon_id")
                querynames <- as.character(S4Vectors::mcols(flatquery)$exon_id)
                querylengths <- BiocGenerics::width(flatquery)

            } else if (reportLevel == "promoter") {
                flatquery <- GenomicFeatures::promoters(query,
                                                        columns = c("tx_id", "tx_name"))
                querynames <- paste(as.character(S4Vectors::mcols(flatquery)$tx_id),
                                    as.character(S4Vectors::mcols(flatquery)$tx_name), sep = ";")
                querylengths <- BiocGenerics::width(flatquery)
            }
            zeroquerynames <- character(0)
            message("done")
        }
        if (length(flatquery) == 0)
            stop("'query' is empty - nothing to do")
        ## from now on, only use 'flatquery' (GRanges object) with names in 'querynames' and lengthes in 'querylengths'


        ## apply 'mask' to flatquery -------------------------------------------
        if (!is.null(mask)) {
            if (!inherits(mask, "GRanges"))
                stop("'mask' must be an object of type 'GRanges'")
            message("removing 'mask' ranges from 'query'...", appendLF = FALSE)
            BiocGenerics::strand(mask) <- "*"
            mask <- GenomicRanges::reduce(mask)
            ov <- GenomicRanges::findOverlaps(flatquery, mask)
            qOM <- unique(S4Vectors::queryHits(ov))
            gr1 <- GenomicRanges::GRanges(
                seqnames = S4Vectors::Rle(qOM),
                ranges = IRanges::IRanges(start = BiocGenerics::start(flatquery)[qOM],
                                          end = BiocGenerics::end(flatquery)[qOM])
            )
            gr2 <- GenomicRanges::GRanges(
                seqnames = S4Vectors::Rle(S4Vectors::queryHits(ov)),
                ranges = IRanges::IRanges(
                    start = BiocGenerics::start(mask)[S4Vectors::subjectHits(ov)],
                    end = BiocGenerics::end(mask)[S4Vectors::subjectHits(ov)]
                )
            )
            SD <- BiocGenerics::setdiff(gr1, gr2)
            notOverlappingMaskInd <- which(!((seq_len(length(flatquery))) %in% qOM))
            completelyMaskedInd <-
                qOM[!(qOM %in% as.numeric(as.character(unique(GenomicRanges::seqnames(SD)))))]

            # 'zeroquery' contains regions that are completely masked (will get zero count and length)
            #zeroquery <- flatquery[completelyMaskedInd]
            tmpnames <- querynames[completelyMaskedInd]
            zeroquerynames <- c(zeroquerynames, tmpnames[!(tmpnames %in% querynames[-completelyMaskedInd])])
            #zeroquerylengths <- rep(0L, length(completelyMaskedInd))

            # masked 'flatquery' maybe split into several non-masked pieces
            flatquery <- c(flatquery[notOverlappingMaskInd],
                           GenomicRanges::GRanges(
                               seqnames = GenomicRanges::seqnames(flatquery)[as.numeric(as.character(GenomicRanges::seqnames(SD)))],
                               ranges = IRanges::ranges(SD),
                               strand = GenomicRanges::strand(flatquery)[as.numeric(as.character(GenomicRanges::seqnames(SD)))],
                               seqlengths = Seqinfo::seqlengths(flatquery)),
                           ignore.mcols = TRUE)
            querynames <- querynames[c(notOverlappingMaskInd, as.numeric(as.character(GenomicRanges::seqnames(SD))))]
            querylengths <- BiocGenerics::width(flatquery)
            message("done")
        }

        ## setup tasks for parallelization -------------------------------------
        ## TODO: if sum(width(flatquery)) close to sum(seqlengths(genome)) -> select variant counting algorithm (sequential walk through bamfiles)
        if (!is.null(clObj) & inherits(clObj, "cluster", which = FALSE)) {
            loadQuasR(clObj)
            taskIByFlatQuery <- parallel::splitIndices(
                nx = length(flatquery),
                ncl = ceiling(length(clObj)/nsamples*2)
            )
            if (inherits(taskIByFlatQuery, "integer", which = FALSE))
                taskIByFlatQuery <- list(taskIByFlatQuery) # make sure taskIByFlatQuery is a list, even if ceiling(length(clObj) /nsamples *2)==1
            taskSamples <- rep(samples, each = length(taskIByFlatQuery))
            taskBamfiles <- rep(bamfiles, each = length(taskIByFlatQuery))
            flatquery <- lapply(taskIByFlatQuery, function(i) flatquery[i])
            shifts <- rep(shifts, each = length(taskIByFlatQuery))
            myapply <- function(...) {
                ret <- parallel::clusterMap(clObj, ..., SIMPLIFY = FALSE,
                                            .scheduling = "dynamic")
                ## fuse
                iBySample <- split(seq_along(ret),names(ret))[unique(names(ret))]
                names(ret) <- NULL
                if (!is.na(proj@snpFile)) {
                    ret <- do.call(cbind, lapply(iBySample, function(i)
                        do.call(rbind, ret[i])))
                    postfix <- substring(colnames(ret), nchar(colnames(ret)))
                    ## rename
                    dimnames(ret) <- list(querynames,
                                          paste(rep(samples, each = 3),
                                                postfix, sep = "_"))
                } else {
                    ret <- do.call(cbind, lapply(iBySample, function(i)
                        do.call(c, ret[i])))
                    ## rename
                    dimnames(ret) <- list(querynames, samples)
                }
                ret
            }
        } else {
            taskSamples <- samples
            taskBamfiles <- bamfiles
            flatquery <- list(flatquery)
            myapply <- function(...) {
                ret <- do.call(cbind, mapply(..., SIMPLIFY = FALSE))
                ## rename
                if (!is.na(proj@snpFile))
                    dimnames(ret) <- list(querynames,
                                          paste(rep(samples, each = 3),
                                                substring(colnames(ret),
                                                          nchar(colnames(ret))),
                                                sep = "_"))
                else
                    dimnames(ret) <- list(querynames, samples)
                ret
            }
        }

        ## count alignments ----------------------------------------------------
        message("counting alignments...", appendLF = FALSE)
        res <- myapply(countAlignments,
                       bamfile = taskBamfiles,
                       regions = flatquery,
                       shift = shifts,
                       MoreArgs = list(
                           selectReadPosition = selectReadPosition,
                           orientation = orientation,
                           useRead = useRead,
                           broaden = broaden,
                           allelic = !is.na(proj@snpFile),
                           includeSpliced = includeSpliced,
                           includeSecondary = includeSecondary,
                           mapqmin = as.integer(mapqMin)[1],
                           mapqmax = as.integer(mapqMax)[1],
                           absisizemin = as.integer(absIsizeMin)[1],
                           absisizemax = as.integer(absIsizeMax)[1]))
        message("done")


        ## collapse (sum) counts by sample if necessary
        if (nsamples > length(unique(samples))) {
            if (collapseBySample) {
                message("collapsing counts by sample...", appendLF = FALSE)
                if (is.na(proj@snpFile))
                    iBySample <- split(seq_len(nsamples), samples)[unique(samples)]
                else
                    iBySample <- split(seq_len(ncol(res)),
                                       colnames(res))[unique(colnames(res))]
                res <- do.call(cbind, lapply(iBySample, function(i)
                    rowSums(res[, i, drop = FALSE])))
                message("done")

            } else {
                # unify non-collapsed identical sample names
                if (is.na(proj@snpFile))
                    colnames(res) <- displayNames(proj)
                else
                    colnames(res) <- paste(rep(displayNames(proj), each = 3),
                                           substring(colnames(res),
                                                     nchar(colnames(res))), sep = "_")
            }
        }

        ## add the region width as first column
        res <- cbind(width = querylengths, res)
        rm(querylengths)

        ## collapse (sum) counts by 'querynames'
        if (length(querynames) > length(unique(querynames))) {
            message("collapsing counts by query name...", appendLF = FALSE)
            iByQuery <- split(seq_len(nrow(res)), querynames)[unique(querynames)]
            res <- do.call(rbind, lapply(iByQuery, function(i)
                colSums(res[i, seq_len(ncol(res)), drop = FALSE])))
            rownames(res) <- querynames <- names(iByQuery)
            message("done")
        }
        if (length(zeroquerynames) > length(unique(zeroquerynames)))
            zeroquerynames <- unique(zeroquerynames)

        ## combine with zeroquery and reorder according to 'query'
        res2 <- matrix(0, nrow = length(querynames) + length(zeroquerynames),
                       ncol = ncol(res),
                       dimnames = list(if(inherits(query, "TxDb"))
                           sort(c(querynames, zeroquerynames))
                           else if(is.null(names(query)))
                               as.character(seq_len(length(query)))
                           else unique(names(query)),
                           colnames(res)))
        res2[rownames(res), ] <- res

        ## return results
        return(res2)
    }
}


## count junctions (with the C-function) for single bamfile and optionally selected target sequences
## return a named vector with junction elements (names of the form "chromosome:first_intronic_base:last_intronic_base:strand")
#' @keywords internal
#' @importFrom Rsamtools scanBamHeader
countJunctionsOneBamfile <- function(bamfile, targets, allelic,
                                     includeSecondary, mapqmin, mapqmax) {
    tryCatch({ # try catch block goes through the whole function
        # prepare region vectors
        bh <- Rsamtools::scanBamHeader(bamfile)[[1]]$targets
        tid <- seq_along(bh) - 1L
        if (!is.null(targets)) {
            if (any(is.na(i <- match(targets, names(bh)))))
                stop(sprintf("some targets not found in bamfile '%s': %s",
                             bamfile, targets[which(is.na(i))]))
            bh <- bh[i]
            tid <- tid[i]
        }
        start <- rep(0L, length(tid)) # samtools library has 0-based inclusive start
        end <- unname(bh) ## samtool library has 0-based exclusiv end
        # count junctions
        count <- .Call(countJunctions, bamfile, tid, start, end, allelic,
                       includeSecondary, mapqmin, mapqmax)
        return(count)

    }, error = function(ex) {
        emsg <- paste("Internal error on", Sys.info()['nodename'],
                      "query bamfile", bamfile,
                      "\n Error message is:", ex$message)
        stop(emsg)
    })
}


## count alignments (with the C-function) for single bamfile, single shift, and single set of regions
## return a numeric vector with length(regions) elements (same order as regions)
#' @keywords internal
#' @importFrom Rsamtools scanBamHeader
#' @importFrom GenomicRanges seqnames
#' @importFrom BiocGenerics strand start end match as.vector
countAlignments <- function(bamfile, regions, shift, selectReadPosition, orientation,
                            useRead, broaden, allelic, includeSpliced, includeSecondary,
                            mapqmin, mapqmax, absisizemin, absisizemax) {
    tryCatch({ # try catch block goes through the whole function

        ## translate seqnames to tid and create region data.frame
        seqnamesBamHeader <- names(Rsamtools::scanBamHeader(bamfile)[[1]]$targets)

        ## prepare region vectors
        #tid <- IRanges::as.vector(IRanges::match(seqnames(regions), seqnamesBamHeader)) - 1L
        tid <- BiocGenerics::as.vector(BiocGenerics::match(GenomicRanges::seqnames(regions),
                                                           seqnamesBamHeader) - 1L)
        start <- BiocGenerics::start(regions) - 1L ## samtool library has 0-based inclusiv start
        end <- BiocGenerics::end(regions) ## samtools library has 0-based exclusive end

        ## swap strand for 'orientation="opposite"'
        if (orientation == "any")
            strand <- rep("*", length(regions))
        else if (orientation == "opposite")
            strand <- c("+"="-", "-"="+", "*"="*")[as.character(BiocGenerics::strand(regions))]
        else # orientation == "same"
            strand <- as.character(BiocGenerics::strand(regions))

        ## translate useRead parameter
        BAM_FREAD1 <- 64L
        BAM_FREAD2 <- 128L
        if (useRead == "any")
            readBitMask <- BAM_FREAD1 + BAM_FREAD2
        else if (useRead == "first")
            readBitMask <- BAM_FREAD1
        else if (useRead == "last")
            readBitMask <- BAM_FREAD2

        ## translate includeSecondary parameter
        BAM_FSECONDARY <- 256L
        if (includeSecondary)
            readBitMask <- readBitMask + BAM_FSECONDARY

        ## get counts
        if (!allelic) {
            count <- .Call(countAlignmentsNonAllelic, bamfile, tid, start, end, strand,
                           selectReadPosition, readBitMask, shift, broaden, includeSpliced,
                           mapqmin, mapqmax, absisizemin, absisizemax)
        } else {
            count <- as.matrix(as.data.frame(
                .Call(countAlignmentsAllelic, bamfile, tid, start, end, strand,
                      selectReadPosition, readBitMask, shift, broaden, includeSpliced,
                      mapqmin, mapqmax, absisizemin, absisizemax)
            ))
        }

        return(count)
    }, error = function(ex) {
        reg <- regions[c(1, length(regions))]
        emsg <- paste("Internal error on", Sys.info()['nodename'],
                      "query bamfile", bamfile,"with regions\n",
                      paste(GenomicRanges::seqnames(reg), BiocGenerics::start(reg),
                            "-" , BiocGenerics::end(reg),
                            BiocGenerics::strand(reg), collapse = "\n\t...\n"),
                      "\n Error message is:", ex$message)
        stop(emsg)
    })
}



# ## Counts alignments in a given set of regions which are located in a subspace of the genome
# ## using a per-base-coverage vector approach
# ##     shift the read, broaden fetch region,
# ## return a numeric vector with length(regions) elements (same order as regions)
# countAlignmentsSubregionsC <- function(bamfile, regions, selectReadPosition, shift=0L, broaden=0L, includeSpliced=TRUE)
# {
#     ## check if region are located on one chromosme
#     seqName <- unique(seqnames(regions))
#     if(length(seqName) > 1L)
#         stop("regions should only be located on one chromosome")
#
#     ## check broaden and shift parameter
#     if(broaden < 0)
#         stop("'broaden' should not be negative")
#     #    if(shift > 0 && selectReadPosition="midwithin")
#     #        stop("'shift' parameter must be zero if 'selectReadPosition' is set to midwithin")
#     #    if(broaden > 0 && (selectReadPosition="startwithin" || selectReadPosition="endwithin"))
#     #        stop("'broaden' parameter must be zero if 'selectReadPosition' is set to startwithin or endwithin")
#
#     ## translate seqName to tid
#     seqnamesList <- names(scanBamHeader(bamfile)[[1]]$targets)
#     tidList <- as.integer(seq_along(seqnamesList)-1)
#     tid <- tidList[ match(seqName, seqnamesList) ]
#
#     ## convert grange to data.frame
#     ## with 0-based start inclusive
#     ## with 0-based end exclusive
#     regionsTable <- data.frame(start=as.integer(start(regions)-1), ## samtool library has 0-based start
#                                end=as.integer(end(regions)),
#                                strand=as.character(strand(regions)),
#                                stringsAsFactors=FALSE
#     )
#
#     ## call c-function
#     cnt <- .Call(countAlignmentsSubregions, bamfile, bamfile, tid, min(regionsTable$start), max(regionsTable$end),
#                  regionsTable, as.integer(shift), as.integer(broaden), selectReadPosition, includeSpliced)
#
#     return(cnt)
# }

context("qExportWig")

test_that("qExportWig correctly digests its arguments", {
  expect_error(qExportWig("error"))
  expect_error(qExportWig(pChipSingle, collapseBySample = FALSE, strand = c("+", "-")))
  expect_error(qExportWig(pChipSingle, file = "test.wig"))
  expect_error(qExportWig(pChipSingle, createBigWig = TRUE, file = c("w1.wig","w2.wig")))
  expect_error(qExportWig(pChipSingle, file = c("w1.wig.bz2","w2.wig.bz2")))
  expect_error(qExportWig(pChipSingle, binsize = c(100, 200)))
  expect_error(qExportWig(pChipSingle, binsize = -100))
  expect_error(qExportWig(pChipSingle, shift = NA))
  expect_error(qExportWig(pChipSingle, shift = c(10, 20, 30)))
  expect_error(suppressWarnings(qExportWig(pChipSingle, scaling = c(1,2,3))))
  expect_error(qExportWig(pChipSingle, scaling = TRUE, log2p1 = "yes"))
  expect_error(qExportWig(pChipSingle, scaling = FALSE, colors = "gray", includeSecondary = "yes"))
  expect_error(qExportWig(pChipSingle, absIsizeMin = 100))
  expect_error(qExportWig(pChipSingle, scaling = FALSE, mapqMin = "0"))
  expect_error(qExportWig(pChipSingle, scaling = FALSE, mapqMax = "0"))
  expect_warning(qExportWig(pSingle, "extdata/sample.wig", scaling = FALSE, useRead = "first"))
  expect_warning(qExportWig(pSingle, "extdata/sample.wig", scaling = FALSE, pairedAsSingle = TRUE))
})


test_that("qExportWig works as expected", {
  requireNamespace("rtracklayer")
  
  # paired and halfInsert shift
  wigfiles <- tempfile(fileext = rep(".wig",2), tmpdir = "extdata")
  expect_warning(res <- qExportWig(pRnaPaired, wigfiles, scaling = FALSE, shift = 1L))
  wig <- lapply(wigfiles, function(wf) suppressWarnings(rtracklayer::import.wig(wf)))
  res <- qCount(pRnaPaired, wig[[1]], shift = "halfInsert", collapseBySample = FALSE)
  expect_equal(mcols(wig[[1]])$score, unname(res[,2]/2))
  
  # check that we get the same files with parallelization
  wigfilespar <- tempfile(fileext = rep(".wig",2), tmpdir = "extdata")
  expect_warning(respar <- qExportWig(pRnaPaired, wigfilespar, scaling = FALSE, shift = 1L, clObj = clObj))
  expect_equal(unname(md5sum(wigfiles)), unname(md5sum(wigfilespar)))

  # includeSecondary, strand, scaling
  auxGrPlus <- auxGr; strand(auxGrPlus) <- "+"
  res1 <- qExportWig(pPhiX, wigfiles[1], scaling = FALSE, strand = "+", includeSecondary = TRUE)
  wigcnt1 <- sum(as.numeric(readLines(res1)[-c(1, 2)]))
  res2 <- qExportWig(pPhiX, wigfiles[1], scaling = 1e6, includeSecondary = FALSE)
  wigcnt2 <- sum(as.numeric(readLines(res2)[-c(1, 2)]))
  cnt1 <- qCount(pPhiX, auxGrPlus, useRead = "first", orientation = "same", includeSecondary = TRUE)[1,2]
  cnt2 <- qCount(pPhiX, auxGr, useRead = "first", includeSecondary = FALSE)[1,2]
  expect_identical(wigcnt1, cnt1)
  expect_equal(wigcnt2, cnt2 / 696 * 1e6, tolerance = 0.001)
  
  # bigwig
  bwfiles <- tempfile(fileext = rep(".bw", 2), tmpdir = "extdata")
  expect_identical(qExportWig(pPhiX, bwfiles[1], scaling = FALSE, useRead = "first", createBigWig = TRUE),
                   bwfiles[1])
  expect_identical(qExportWig(pPhiX, bwfiles[2], scaling = FALSE, useRead = "last",  createBigWig = TRUE),
                   bwfiles[2])
  
  # check that we get the same files with parallelization
  bwfilespar <- tempfile(fileext = rep(".bw",1), tmpdir = "extdata")
  resparbw <- qExportWig(pPhiX, bwfilespar, scaling = FALSE, useRead = "first", 
                         createBigWig = TRUE, clObj = clObj)
  expect_equal(unname(md5sum(bwfiles[1])), unname(md5sum(bwfilespar)))
})

context("qProfile")

test_that("qProfile correctly digests its arguments", {
  expect_error(qProfile("error", gtfGr))
  expect_error(qProfile(pSingle, "error"))
  expect_error(qProfile(pSingle, qGenome, mask = "error"))
  expect_error(qProfile(pSingle, qGenome, mask = qGenome))
  expect_error(qProfile(pChipSingle, gtfGr, upstream = "error"))
  expect_error(qProfile(pChipSingle, gtfGr, downstream = "error"))
  expect_error(qProfile(pChipSingle, gtfGr, shift = "halfInsert"))
  expect_error(qProfile(pChipSingle, gtfGr, shift = "error"))
  expect_error(qProfile(pChipSingle, gtfGr, collapseBySample = "error"))
  expect_error(qProfile(pChipSingle, gtfGr, includeSpliced = "error"))
  expect_error(qProfile(pChipSingle, gtfGr, includeSecondary = "error"))
  expect_error(qProfile(pSingle, gtfGr))
  expect_warning(qProfile(pSingle, qTiles, useRead = "first"))
  expect_error(qProfile(pSingle, qGenome, upstream = c(100, 100)))
  expect_error(qProfile(pSingle, qGenome, downstream = c(100, 100)))
  expect_error(qProfile(pSingle, qGenome, binSize = "error"))
  expect_error(qProfile(pSingle, qGenome, binSize = 10))
  expect_warning(qProfile(pSingle, qGenome, upstream = 100001))
})

test_that("qProfile works as expected", {
  requireNamespace("GenomicRanges")
  qreg <- GenomicRanges::resize(gtfGr, fix = "start", width = 200)
  qreg <- qreg[!duplicated(qreg)]
  names(qreg) <- NULL
  
  # no shift
  pr  <- qProfile(pChipSingle, qreg, upstream = 0, downstream = 199, shift = c(0, 0), clObj = clObj)
  cnt <- qCount(pChipSingle, qreg)
  expect_equal(sum(cnt[,2]), unname(sum(pr[[2]])))
  expect_equal(sum(cnt[,3]), unname(rowSums(pr[[3]])))

  # shift
  pr  <- qProfile(pChipSingle, qreg, upstream = 0, downstream = 199, shift = 50)
  cnt <- qCount(pChipSingle, qreg, shift = 50)
  expect_equal(sum(cnt[,2]), unname(rowSums(pr[[2]])))
  expect_equal(sum(cnt[,3]), unname(rowSums(pr[[3]])))
  
  # smart shift, useRead
  pr  <- qProfile(pRnaPaired, qreg, upstream = 0, downstream = 199, shift = "halfInsert", useRead = "first")
  cnt <- qCount(pRnaPaired, qreg, shift = "halfInsert", useRead = "first")
  expect_equal(sum(cnt[,2]), unname(rowSums(pr[[2]])))
  expect_equal(sum(cnt[,3]), unname(rowSums(pr[[3]])))

  # includeSecondary
  cnt1 <- qCount(pPhiX, auxGr, includeSecondary = TRUE)[1,2]
  cnt2 <- qCount(pPhiX, auxGr, includeSecondary = FALSE)[1,2]
  pr1  <- qProfile(pPhiX, auxGr, upstream = 0, downstream = 5386, includeSecondary = TRUE)
  pr2  <- qProfile(pPhiX, auxGr, upstream = 0, downstream = 5386, includeSecondary = FALSE)
  expect_equal(cnt1, sum(pr1[[2]]))
  expect_equal(cnt2, sum(pr2[[2]]))
  
  # allelic
  pr1 <- qProfile(pChipSingleSnps, qreg, collapseBySample = TRUE)
  pr2 <- qProfile(pChipSingleSnps, qreg, collapseBySample = FALSE)
  expect_identical(unname(pr1), unname(pr2))
  expect_length(pr1, 7L)
  
  # binSize
  qreg2 <- reduce(qreg + 200) - 200
  names(qreg2) <- seq_along(qreg2)
  pr1 <- qProfile(pChipSingle, qreg2, upstream = 104, downstream = 104)
  pr2 <- qProfile(pChipSingle, qreg2, upstream = 100, downstream = 100, binSize = 11)
  expect_identical(colnames(pr2[[1]]), as.character(seq(-99, 99, by = 11)))
  expect_identical(sapply(pr1[-1], rowSums), sapply(pr2[-1], rowSums))
  cnt <- qCount(pChipSingle, promoters(qreg2, upstream = 104, downstream = 105))
  expect_identical(cnt[, -1], do.call(cbind, lapply(pr1[-1], rowSums)))
  expect_identical(cnt[, -1], do.call(cbind, lapply(pr2[-1], rowSums)))
})

context("qCount")

test_that("qCount correctly digests its arguments", {
  expect_error(qCount(pSingle, query, mapqMin = -1))
  expect_error(qCount(pSingle, query, mapqMax = 256))
})

test_that("qCount correctly uses MAPQ", {
  aln <- Rsamtools::scanBam(pSingle@alignments$FileName[1], what = "mapq")
  binbreaks <- c(seq(0, 240, by = 40), 256)
  resSoll <- table(findInterval(aln[[1]]$mapq, vec = binbreaks,
                                all.inside = TRUE, rightmost.closed = TRUE))
  res <- unlist(lapply(seq_along(binbreaks[-1]),
                       function(i) qCount(pSingle[1], qGenome,
                                          mapqMin = binbreaks[i], mapqMax = binbreaks[i + 1] - 1)[1,2]))
  expect_equal(as.vector(resSoll), res)
})

test_that("qCount correctly uses shift and selectReadPosition", {
  # smart shift
  #fr R1->left R2->right
  res <- qCount(pPaired, q01.20, selectReadPosition = "start", shift = "halfInsert", orientation = "any")[,-1]
  expect_equal(rep(c(0, 4 ,0), c(9, 1, 10)), unname(res))
  res <- qCount(pPaired, q01.20, selectReadPosition = "end",   shift = "halfInsert", orientation = "any")[,-1]
  expect_equal(rep(c(0, 2, 0, 2, 0), c(5, 1, 7, 1, 6)), unname(res))
  #fr R2->left R1->right
  res <- qCount(pPaired, q21.40, selectReadPosition = "start", shift = "halfInsert", orientation = "any")[,-1]
  expect_equal(rep(c(0, 4 ,0), c(9, 1, 10)), unname(res))
  res <- qCount(pPaired, q21.40, selectReadPosition = "end",  shift = "halfInsert", orientation = "any")[,-1]
  expect_equal(rep(c(0, 2, 0, 2, 0), c(5, 1, 7, 1, 6)), unname(res))
  #ff R1->left R2->right
  res <- qCount(pPaired, q41.60, selectReadPosition = "start", shift = "halfInsert", orientation = "any")[,-1]
  expect_equal(rep(c(0, 2, 0, 2, 0), c(5, 1, 3, 1, 10)), unname(res))
  res <- qCount(pPaired, q41.60, selectReadPosition = "end",   shift = "halfInsert", orientation = "any")[,-1]
  expect_equal(rep(c(0, 2, 0, 2, 0), c(9, 1, 3, 1, 6)), unname(res))
  #rr R2->left R1->right
  res <- qCount(pPaired, q61.80, selectReadPosition = "start", shift = "halfInsert", orientation = "any")[,-1]
  expect_equal(rep(c(0, 2, 0, 2, 0), c(9, 1, 3, 1, 6)), unname(res))
  res <- qCount(pPaired, q61.80, selectReadPosition = "end",   shift = "halfInsert", orientation = "any")[,-1]
  expect_equal(rep(c(0, 2, 0, 2, 0), c(5, 1, 3, 1, 10)), unname(res))
  #rf R1->left R2->right
  res <- qCount(pPaired, q81.99, selectReadPosition = "start", shift = "halfInsert", orientation = "any")[,-1]
  expect_equal(rep(c(0, 2, 0, 2, 0), c(5, 1, 7, 1, 5)), unname(res))
  res <- qCount(pPaired, q81.99, selectReadPosition = "end",   shift = "halfInsert", orientation = "any")[,-1]
  expect_equal(rep(c(0, 4 ,0), c(9, 1, 9)), unname(res))
  
  # qCount with interger as shift
  aln <- GenomicAlignments::readGAlignments(pPaired@alignments$FileName)
  resSoll <- rep(0, 99)
  pos <- Rle(ifelse(strand(aln) == "+", start(aln), end(aln)))
  resSoll[runValue(pos)] <- runLength(pos)
  res <- qCount(pPaired, q01.99, selectReadPosition = "start", shift = 0, orientation = "any")[,-1]
  expect_equal(resSoll, unname(res))
  
  resSoll <- rep(0, 99)
  pos <- Rle(ifelse(strand(aln) == "+", end(aln) + 1, start(aln) - 1))
  resSoll[runValue(pos)] <- runLength(pos)
  res <- qCount(pPaired, q01.99, selectReadPosition = "end", shift = 1, orientation = "any")[,-1]
  expect_equal(resSoll, unname(res))
  
  resSoll <- rep(0, 99)
  pos <- Rle(ifelse(strand(aln) == "+", start(aln) - 1, end(aln) + 1))
  resSoll[runValue(pos)] <- runLength(pos)
  res <- qCount(pPaired, q01.99, selectReadPosition = "start", shift = -1, orientation = "any")[,-1]
  expect_equal(resSoll, unname(res))
})

test_that("qCount correctly processes alignment orientation", {
  cnt1 <- qCount(pSingle, qGenome, orientation = "any",      collapseBySample = FALSE)
  cnt2 <- qCount(pSingle, qGenome, orientation = "same",     collapseBySample = FALSE)
  cnt3 <- qCount(pSingle, qGenome, orientation = "opposite", collapseBySample = FALSE)
  expect_equal(unname(cnt1[1,]), c(800, 512, 512))
  expect_equal(unname(cnt2[1,]), c(800, 512,   0))
  expect_equal(unname(cnt3[1,]), c(800,   0, 512))
})

test_that("qCount correctly uses useRead", {
  aln <- GenomicAlignments::readGAlignmentPairs(pPaired@alignments$FileName)
  aln1 <- GenomicAlignments::first(aln)
  aln2 <- GenomicAlignments::last(aln)

  resSoll <- rep(0, 99)
  pos <- Rle(ifelse(strand(aln1) == "+", start(aln1), end(aln1)))
  resSoll[runValue(pos)] <- runLength(pos)
  res <- qCount(pPaired, q01.99, selectReadPosition = "start", shift = 0, orientation = "any", useRead = "first")[,-1]
  expect_equal(resSoll, unname(res))
  
  resSoll <- rep(0, 99)
  pos <- Rle(ifelse(strand(aln1) == "+", end(aln1), start(aln1)))
  resSoll[runValue(pos)] <- runLength(pos)
  res <- qCount(pPaired, q01.99, selectReadPosition = "end", shift = 0, orientation = "any", useRead = "first")[,-1]
  expect_equal(resSoll, unname(res))
  
  resSoll <- rep(0,99)
  pos <- Rle(ifelse(strand(aln2) == "+", start(aln2), end(aln2)))
  resSoll[runValue(pos)] <- runLength(pos)
  res <- qCount(pPaired, q01.99, selectReadPosition = "start", shift = 0, orientation = "any", useRead = "last")[,-1]
  expect_equal(resSoll, unname(res))
  
  resSoll <- rep(0,99)
  pos <- Rle(ifelse(strand(aln2) == "+", end(aln2), start(aln2)))
  resSoll[runValue(pos)] <- runLength(pos)
  res <- qCount(pPaired, q01.99, selectReadPosition = "end", shift = 0, orientation = "any", useRead = "last")[,-1]
  expect_equal(resSoll, unname(res))
})

test_that("qCount corretly uses maxInsertSize", {
  resSoll <- rep(0,20)
  res <- qCount(pPaired, q01.20, selectReadPosition = "start", shift = "halfInsert", maxInsertSize = 0)[,-1]
  expect_equal(resSoll, unname(res))
  
  resSoll[10] <- 4
  res <- qCount(pPaired, q01.20, selectReadPosition = "start", shift = "halfInsert", maxInsertSize = 14)[,-1]
  expect_equal(resSoll, unname(res))
})

test_that("qCount correctly uses mask", {
  mask <- qTiles[names(qTiles) == "H4"]
  region <- qTiles
  strand(region) <- "+"    
  resSoll <- matrix(0, nrow = 4, ncol = 3) 
  resSoll[, 1] <- c(200, 300, 150, 0)
  resSoll[, 2] <- resSoll[, 3] <- c(150, 200, 100, 0)
  res <- qCount(pSingle, region, mask = mask, collapseBySample = FALSE, orientation = "any")
  expect_equal(resSoll, unname(res))
})

test_that("qCount correctly works with a GRangesList query", {
  regionList <- split(qTiles, names(qTiles))
  resSoll <- cbind(c(300, 150, 150, 0), c(212, 100, 100, 0), c(231, 100, 100, 0))
  res <- qCount(pSingle, regionList, collapseBySample = FALSE, orientation = "same")
  expect_equal(resSoll, unname(res))

  strand(regionList) <- "+"
  resSoll[, 3] <- 0
  res <- qCount(pSingle, regionList, collapseBySample = FALSE, orientation = "same")
  expect_equal(resSoll, unname(res))
  
  strand(regionList) <- "-"
  resSoll <- cbind(c(300, 150, 150, 0), c(0, 0, 0, 0), c(231, 100, 100, 0))
  res <- qCount(pSingle, regionList, collapseBySample = FALSE, orientation = "same")
  expect_equal(resSoll, unname(res))
})

test_that("qCount correctly works with a TxDb query", {
  requireNamespace("GenomicFeatures")
  requireNamespace("GenomicRanges")
  
  # gene
  res1 <- qCount(pRnaSingleSpliced, gtfGr, collapseBySample = FALSE, reportLevel = NULL)
  res2 <- qCount(pRnaSingleSpliced, txdb,  collapseBySample = FALSE, reportLevel = "gene")
  expect_identical(res1, res2)

  # exon
  exs <- GenomicFeatures::exons(txdb)
  res1 <- qCount(pRnaSingleSpliced, exs,  collapseBySample = FALSE)
  res2 <- qCount(pRnaSingleSpliced, txdb, collapseBySample = FALSE, reportLevel = "exon")
  expect_identical(res1, res2[rownames(res1),])

  # promoter
  proms <- GenomicFeatures::promoters(txdb)
  res1 <- qCount(pRnaSingleSpliced, proms, collapseBySample = FALSE, reportLevel = "promoter", clObj = clObj)
  res2 <- qCount(pRnaSingleSpliced, txdb,  collapseBySample = FALSE, reportLevel = "promoter")
  rownames(res2) <- sub("^[0-9]+;", "", rownames(res2))
  expect_identical(res1, res2[rownames(res1),])

  # junction, includeSpliced
  exGr <- GenomicRanges::GRanges("chr1", IRanges(start = c(11720, 12322, 14043, 14363),
                                                 end   = c(12212, 12518, 14165, 14512)))
  inGr <- GenomicRanges::GRanges("chr1", IRanges(start = c(12213, 14166),
                                                 end   = c(12321, 14362)), strand = "+")
  res1 <- qCount(pRnaSingleSpliced, exGr, collapseBySample = FALSE)
  res2 <- qCount(pRnaSingleSpliced, exGr, collapseBySample = FALSE, includeSpliced = FALSE)
  res3 <- qCount(pRnaSingleSpliced, NULL, reportLevel = "junction", collapseBySample = FALSE, clObj = clObj)
  expect_equal(unname((res1 - res2)[c(1, 3), -1]),
               unname(as.matrix(mcols(res3)[match(inGr, res3),])))
})

test_that("qCount correctly works in allelic mode", {
  region <- qTiles
  strand(region) <- "-"
  resSoll <- matrix(c(300, 300, 300, 250, rep(rep(0, 4), 3),
                      rep(c(231, 200, 200, 181), 3)), nrow = 4)
  res <- qCount(pSingleAllelic, region, collapseBySample = FALSE, orientation = "same")
  expect_identical(resSoll, unname(res))
})

test_that("qCount correctly works with auxiliary alignments", {
  res <- qCount(pChipSingleAux, auxGr, collapseBySample = FALSE, auxiliaryName = "phiX174")
  expect_equal(c(5386, 251, 493), unname(res[1,]))

  # include secondary alignments
  expect_identical(qCount(pPhiX, auxGr, useRead = "any"  )[1,"test"], 696)
  expect_identical(qCount(pPhiX, auxGr, useRead = "first")[1,"test"], 348)
  expect_identical(qCount(pPhiX, auxGr, useRead = "last" )[1,"test"], 348)
  # exclude secondary alignments
  expect_identical(qCount(pPhiX, auxGr, useRead = "any"  , includeSecondary = FALSE)[1,'test'], 384)
  expect_identical(qCount(pPhiX, auxGr, useRead = "first", includeSecondary = FALSE)[1,'test'], 192)
  expect_identical(qCount(pPhiX, auxGr, useRead = "last" , includeSecondary = FALSE)[1,'test'], 192)
})

# setting R_TESTS to empty string because of
# https://github.com/hadley/testthat/issues/144
# revert this when that issue in R is fixed.
Sys.setenv("R_TESTS" = "")

library(testthat)
library(QuasR)

test_check("QuasR")

## ----options, results='hide', echo=FALSE--------------------------------------
#options(width=65)
options('useFancyQuotes' = FALSE, continue = " ", digits = 3)

## ----cite, eval=TRUE----------------------------------------------------------
citation("QuasR")

## ----install, eval=FALSE------------------------------------------------------
# if (!require("BiocManager"))
#     install.packages("BiocManager")
# BiocManager::install("QuasR")

## ----loadLibraries, eval=TRUE-------------------------------------------------
suppressPackageStartupMessages({
    library(QuasR)
    library(BSgenome)
    library(Rsamtools)
    library(rtracklayer)
    library(GenomicFeatures)
    library(txdbmaker)
    library(Gviz)
})

## ----help1, eval=FALSE--------------------------------------------------------
# help.start()

## ----loadQuasRLibrary, eval=FALSE---------------------------------------------
# library(QuasR)

## ----help2, eval=FALSE--------------------------------------------------------
# ?preprocessReads

## ----help3, eval=FALSE--------------------------------------------------------
# help("preprocessReads")

## ----assign, eval=FALSE-------------------------------------------------------
# x <- 2

## ----ls, eval=FALSE-----------------------------------------------------------
# ls()

## ----printObject, eval=FALSE--------------------------------------------------
# x

## ----SampleSession1, eval=TRUE------------------------------------------------
file.copy(system.file(package = "QuasR", "extdata"), ".", recursive = TRUE)

## ----SampleSession2, eval=TRUE------------------------------------------------
sampleFile <- "extdata/samples_chip_single.txt"
genomeFile <- "extdata/hg19sub.fa"

proj <- qAlign(sampleFile, genomeFile)
proj

## ----SampleSession3, eval=TRUE------------------------------------------------
qQCReport(proj, "extdata/qc_report.pdf")

## ----SampleSession4, eval=TRUE------------------------------------------------
library(rtracklayer)
library(GenomicFeatures)
annotFile <- "extdata/hg19sub_annotation.gtf"
txStart <- import.gff(annotFile, format = "gtf", feature.type = "start_codon")
promReg <- promoters(txStart, upstream = 500, downstream = 500)
names(promReg) <- mcols(promReg)$transcript_name

promCounts <- qCount(proj, query = promReg)
promCounts

## ----sampleFileSingle, echo=FALSE, results="asis"-----------------------------
cat(paste(readLines(system.file(package = "QuasR",
                                "extdata", "samples_chip_single.txt")),
          collapse = "\n"))

## ----sampleFilePaired, echo=FALSE, results="asis"-----------------------------
cat(paste(readLines(system.file(package = "QuasR",
                                "extdata", "samples_rna_paired.txt")),
      collapse = "\n"))

## ----sampleFile, eval=FALSE---------------------------------------------------
# sampleFile1 <- system.file(package="QuasR", "extdata",
#                            "samples_chip_single.txt")
# sampleFile2 <- system.file(package="QuasR", "extdata",
#                            "samples_rna_paired.txt")

## ----<sampleFileSeqToBam, eval=FALSE------------------------------------------
# sampleFile1 <- "samples_fastq.txt"
# sampleFile2 <- "samples_bam.txt"
# 
# proj1 <- qAlign(sampleFile1, genomeFile)
# 
# write.table(alignments(proj1)$genome, sampleFile2, sep="\t", row.names=FALSE)
# 
# proj2 <- qAlign(sampleFile2, genomeFile)

## ----auxFile, echo=FALSE, results="asis"--------------------------------------
cat(paste(readLines(system.file(package = "QuasR",
                                "extdata", "auxiliaries.txt")),
          collapse = "\n"))

## ----auxiliaryFile, eval=TRUE-------------------------------------------------
auxFile <- system.file(package = "QuasR", "extdata", "auxiliaries.txt")

## ----selectGenomeBSgenome, eval=TRUE------------------------------------------
available.genomes()
genomeName <- "BSgenome.Hsapiens.UCSC.hg19"

## ----selectGenomeFile, eval=FALSE---------------------------------------------
# genomeFile <- system.file(package="QuasR", "extdata", "hg19sub.fa")

## ----preprocessReadsSingle,eval=TRUE------------------------------------------
td <- tempdir()
infiles <- system.file(package = "QuasR", "extdata",
                       c("rna_1_1.fq.bz2","rna_2_1.fq.bz2"))
outfiles <- file.path(td, basename(infiles))
res <- preprocessReads(filename = infiles,
                       outputFilename = outfiles,
                       truncateEndBases = 3,
                       Lpattern = "AAAAAAAAAA",
                       minLength = 14, 
                       nBases = 2)
res
unlink(outfiles)

## ----preprocessReadsPaired,eval=TRUE------------------------------------------
td <- tempdir()
infiles1 <- system.file(package = "QuasR", "extdata", "rna_1_1.fq.bz2")
infiles2 <- system.file(package = "QuasR", "extdata", "rna_1_2.fq.bz2")
outfiles1 <- file.path(td, basename(infiles1))
outfiles2 <- file.path(td, basename(infiles2))
res <- preprocessReads(filename = infiles1,
                       filenameMate = infiles2,
                       outputFilename = outfiles1,
                       outputFilenameMate = outfiles2,
                       nBases = 0)
res

## ----ChIP_copyExtdata, eval=TRUE----------------------------------------------
file.copy(system.file(package = "QuasR", "extdata"), ".", recursive = TRUE)

## ----ChIP_qAlign, eval=TRUE---------------------------------------------------
sampleFile <- "extdata/samples_chip_single.txt"
auxFile <- "extdata/auxiliaries.txt"
genomeFile <- "extdata/hg19sub.fa"

proj1 <- qAlign(sampleFile, genome = genomeFile, auxiliaryFile = auxFile)
proj1

## ----ChIP_bamfiles1, eval=TRUE------------------------------------------------
list.files("extdata", pattern = ".bam$")

## ----ChIP_bamfiles2, eval=TRUE------------------------------------------------
list.files("extdata", pattern = "^chip_1_1_")[1:3]

## ----ChIP_qcplot1, eval=TRUE, echo=FALSE--------------------------------------
qcdat1 <- qQCReport(proj1, pdfFilename = "extdata/qc_report.pdf")

## ----ChIP_qcplots2, eval=TRUE-------------------------------------------------
qQCReport(proj1, pdfFilename = "extdata/qc_report.pdf")

## ----ChIP_alignmentStats, eval=TRUE-------------------------------------------
alignmentStats(proj1)

## ----ChIP_qExportWig, eval=TRUE-----------------------------------------------
qExportWig(proj1, binsize = 100L, scaling = TRUE, collapseBySample = TRUE)

## ----ChIP_GenomicFeatures, eval=TRUE------------------------------------------
library(txdbmaker)
annotFile <- "extdata/hg19sub_annotation.gtf"
chrLen <- scanFaIndex(genomeFile)
chrominfo <- data.frame(chrom = as.character(seqnames(chrLen)),
                        length = width(chrLen),
                        is_circular = rep(FALSE, length(chrLen)))
txdb <- makeTxDbFromGFF(file = annotFile, format = "gtf",
                        chrominfo = chrominfo,
                        dataSource = "Ensembl",
                        organism = "Homo sapiens")
promReg <- promoters(txdb, upstream = 1000, downstream = 500,
                     columns = c("gene_id","tx_id"))
gnId <- vapply(mcols(promReg)$gene_id,
               FUN = paste, FUN.VALUE = "",
               collapse = ",")
promRegSel <- promReg[ match(unique(gnId), gnId) ]
names(promRegSel) <- unique(gnId)
promRegSel

## ----ChIP_qCount, eval=TRUE---------------------------------------------------
cnt <- qCount(proj1, promRegSel)
cnt

## ----ChIP_visualize, eval=TRUE, fig.width=8, fig.height=4.5-------------------
gr1 <- import("Sample1.wig.gz")
gr2 <- import("Sample2.wig.gz")

library(Gviz)
axisTrack <- GenomeAxisTrack()
dTrack1 <- DataTrack(range = gr1, name = "Sample 1", type = "h")
dTrack2 <- DataTrack(range = gr2, name = "Sample 2", type = "h")
txTrack <- GeneRegionTrack(txdb, name = "Transcripts", showId = TRUE)
plotTracks(list(axisTrack, dTrack1, dTrack2, txTrack),
           chromosome = "chr3", extend.left = 1000)

## ----ChIP_rtracklayer, eval=TRUE----------------------------------------------
library(rtracklayer)
annotationFile <- "extdata/hg19sub_annotation.gtf"
tssRegions <- import.gff(annotationFile, format = "gtf",
                         feature.type = "start_codon",
                         colnames = "gene_name")
tssRegions <- tssRegions[!duplicated(tssRegions)]
names(tssRegions) <- rep("TSS", length(tssRegions))
head(tssRegions)

## ----ChIP_qProfile, eval=TRUE-------------------------------------------------
prS <- qProfile(proj1, tssRegions, upstream = 3000, downstream = 3000, 
                orientation = "same")
prO <- qProfile(proj1, tssRegions, upstream = 3000, downstream = 3000, 
                orientation = "opposite")
lapply(prS, "[", , 1:10)

## ----ChIP_visualizeProfile, eval=TRUE, fig.width=8, fig.height=4.5------------
prCombS <- do.call("+", prS[-1]) / prS[[1]]
prCombO <- do.call("+", prO[-1]) / prO[[1]]

plot(as.numeric(colnames(prCombS)), filter(prCombS[1,], rep(1/100,100)), 
     type = 'l', xlab = "Position relative to TSS",
     ylab = "Mean no. of alignments")
lines(as.numeric(colnames(prCombO)), filter(prCombO[1,], rep(1/100,100)), 
      type = 'l', col = "red")
legend(title = "strand", legend = c("same as query","opposite of query"), 
       x = "topleft", col = c("black","red"),
       lwd = 1.5, bty = "n", title.adj = 0.1)

## ----ChIP_BSgenomeProject, eval=FALSE-----------------------------------------
# file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)
# 
# sampleFile <- "extdata/samples_chip_single.txt"
# auxFile <- "extdata/auxiliaries.txt"
# 
# available.genomes() # list available genomes
# genomeName <- "BSgenome.Hsapiens.UCSC.hg19"
# 
# proj1 <- qAlign(sampleFile, genome=genomeName, auxiliaryFile=auxFile)
# proj1

## ----RNA_qAlign, eval=TRUE----------------------------------------------------
file.copy(system.file(package = "QuasR", "extdata"), ".", recursive = TRUE)

sampleFile <- "extdata/samples_rna_paired.txt"
genomeFile <- "extdata/hg19sub.fa"

proj2 <- qAlign(sampleFile, genome = genomeFile,
                splicedAlignment = TRUE, aligner = "Rhisat2")
proj2

## ----RNA_alignmentStats, eval=TRUE--------------------------------------------
proj2unspl <- qAlign(sampleFile, genome = genomeFile,
                     splicedAlignment = FALSE)

alignmentStats(proj2)
alignmentStats(proj2unspl)

## ----RNA_qCount, eval=TRUE----------------------------------------------------
geneLevels <- qCount(proj2, txdb, reportLevel = "gene")
exonLevels <- qCount(proj2, txdb, reportLevel = "exon")

head(geneLevels)
head(exonLevels)

## ----RNA_RPMK, eval=TRUE------------------------------------------------------
geneRPKM <- t(t(geneLevels[,-1] / geneLevels[,1] * 1000)
              / colSums(geneLevels[,-1]) * 1e6)
geneRPKM

## ----RNA_junction, eval=TRUE--------------------------------------------------
exonJunctions <- qCount(proj2, NULL, reportLevel = "junction")
exonJunctions

## ----RNA_junction2, eval=TRUE-------------------------------------------------
knownIntrons <- unlist(intronsByTranscript(txdb))
isKnown <- overlapsAny(exonJunctions, knownIntrons, type = "equal")
table(isKnown)

tapply(rowSums(as.matrix(mcols(exonJunctions))),
       isKnown, summary)

## ----RNA_includeSpliced, eval=TRUE--------------------------------------------
exonBodyLevels <- qCount(proj2, txdb, reportLevel = "exon",
                         includeSpliced = FALSE)
summary(exonLevels - exonBodyLevels)

## ----RNA_qcplot1, eval=TRUE, echo=FALSE---------------------------------------
qcdat2 <- qQCReport(proj2unspl, pdfFilename = "qc_report.pdf")

## ----miRNA_extdata, eval=TRUE-------------------------------------------------
file.copy(system.file(package = "QuasR", "extdata"), ".", recursive = TRUE)

## ----miRNA_preprocessReads, eval=TRUE-----------------------------------------
# prepare sample file with processed reads filenames
sampleFile <- file.path("extdata", "samples_mirna.txt")
sampleFile
sampleFile2 <- sub(".txt", "_processed.txt", sampleFile)
sampleFile2

tab <- read.delim(sampleFile, header = TRUE, as.is = TRUE)
tab

tab2 <- tab
tab2$FileName <- sub(".fa", "_processed.fa", tab$FileName)
write.table(tab2, sampleFile2, sep = "\t", quote = FALSE, row.names = FALSE)
tab2

# remove adapters
oldwd <- setwd(dirname(sampleFile))
res <- preprocessReads(tab$FileName,
                       tab2$FileName,
                       Rpattern = "TGGAATTCTCGGGTGCCAAGG")
res
setwd(oldwd)

## ----miRNA_lengthes, eval=TRUE, fig.width=6, fig.height=4.5-------------------
# get read lengths
library(Biostrings)
oldwd <- setwd(dirname(sampleFile))
lens <- fasta.seqlengths(tab$FileName, nrec = 1e5)
lens2 <- fasta.seqlengths(tab2$FileName, nrec = 1e5)
setwd(oldwd)
# plot length distribution
lensTab <- rbind(raw = tabulate(lens, 50),
                 processed = tabulate(lens2, 50))
colnames(lensTab) <- 1:50
barplot(lensTab/rowSums(lensTab)*100,
        xlab = "Read length (nt)", ylab = "Percent of reads")
legend(x = "topleft", bty = "n", fill = gray.colors(2),
       legend = rownames(lensTab))

## ----miRNA_qAlign, eval=TRUE--------------------------------------------------
proj3 <- qAlign(sampleFile2, genomeFile, maxHits = 50)
alignmentStats(proj3)

## ----miRNA_prepareQuery, eval=TRUE--------------------------------------------
mirs <- import("extdata/mirbaseXX_qsr.gff3")
names(mirs) <- mirs$Name
preMirs <- mirs[ mirs$type == "miRNA_primary_transcript" ]
matureMirs <- mirs[ mirs$type == "miRNA" ]

## ----miRNA_coverage, eval=TRUE, fig.width=6, fig.height=4.5-------------------
library(Rsamtools)
alns <- scanBam(alignments(proj3)$genome$FileName,
                param = ScanBamParam(what = scanBamWhat(),
                                     which = preMirs[1]))[[1]]
alnsIR <- IRanges(start = alns$pos - start(preMirs), width = alns$qwidth)
mp <- barplot(as.vector(coverage(alnsIR)), names.arg = seq_len(max(end(alnsIR))),
              xlab = "Relative position in pre-miRNA",
              ylab = "Alignment coverage")
rect(xleft = mp[start(matureMirs) - start(preMirs) + 1,1],
     ybottom = -par('cxy')[2],
     xright = mp[end(matureMirs) - start(preMirs) + 1,1],
     ytop = 0, col = "#CCAA0088", border = NA, xpd = NA)

## ----miRNA_extendQuery, eval=TRUE---------------------------------------------
matureMirsExtended <- resize(matureMirs, width = 1L, fix = "start") + 3L

## ----miRNA_quantify, eval=TRUE------------------------------------------------
# quantify mature miRNAs
cnt <- qCount(proj3, matureMirsExtended, orientation = "same")
cnt

# quantify pre-miRNAs
cnt <- qCount(proj3, preMirs, orientation = "same")
cnt

## ----Bis_qAlign, eval=TRUE----------------------------------------------------
file.copy(system.file(package = "QuasR", "extdata"), ".", recursive = TRUE)

sampleFile <- "extdata/samples_bis_single.txt"
genomeFile <- "extdata/hg19sub.fa"

proj4 <- qAlign(sampleFile, genomeFile, bisulfite = "dir")
proj4

## ----Bis_qMeth1, eval=TRUE----------------------------------------------------
meth <- qMeth(proj4, mode = "CpGcomb", collapseBySample = TRUE)
meth

## ----Bis_qMeth2, eval=TRUE----------------------------------------------------
chrs <- readDNAStringSet(genomeFile)
sum(vcountPattern("CG",chrs))
length(qMeth(proj4))
length(qMeth(proj4, keepZero = FALSE))

## ----Bis_visualize, eval=TRUE, fig.height=4.5, fig.width=8--------------------
percMeth <- mcols(meth)[,2] * 100 / mcols(meth)[,1]
summary(percMeth)

axisTrack <- GenomeAxisTrack()
dTrack1 <- DataTrack(range = gr1, name = "H3K4me3", type = "h")
dTrack2 <- DataTrack(range = meth, data = percMeth,
                     name = "Methylation", type = "p")
txTrack <- GeneRegionTrack(txdb, name = "Transcripts", showId = TRUE)
plotTracks(list(axisTrack, dTrack1, dTrack2, txTrack),
           chromosome = "chr3", extend.left = 1000)

## ----Bis_query, eval=TRUE-----------------------------------------------------
qMeth(proj4, query = GRanges("chr1",IRanges(start = 31633, width = 2)),
      collapseBySample = TRUE)
qMeth(proj4, query = promRegSel, collapseByQueryRegion = TRUE,
      collapseBySample = TRUE)

## ----snpFile, echo=FALSE, results="asis"--------------------------------------
cat(paste(c(readLines(system.file(package = "QuasR",
                                  "extdata", "hg19sub_snp.txt"))[1:4], "..."),
          collapse = "\n"))

## ----Alelle_Extdata, eval=TRUE------------------------------------------------
file.copy(system.file(package = "QuasR", "extdata"), ".", recursive = TRUE)

## ----Allele_qAlign, eval=TRUE-------------------------------------------------
sampleFile <- "extdata/samples_chip_single.txt"
genomeFile <- "extdata/hg19sub.fa"
snpFile <- "extdata/hg19sub_snp.txt"
proj1SNP <- qAlign(sampleFile, genome = genomeFile, snpFile = snpFile)
proj1SNP

## ----Allele_qCount, eval=TRUE-------------------------------------------------
head(qCount(proj1, promRegSel))
head(qCount(proj1SNP, promRegSel))

## ----Allele_Bis, eval=TRUE----------------------------------------------------
sampleFile <- "extdata/samples_bis_single.txt"
genomeFile <- "extdata/hg19sub.fa"
proj4SNP <- qAlign(sampleFile, genomeFile,
                   snpFile = snpFile, bisulfite = "dir")
head(qMeth(proj4SNP, mode = "CpGcomb", collapseBySample = TRUE))

## ----qcplotsFig1, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8------------
QuasR:::plotQualByCycle(qcdat1$raw$qa, lmat = rbind(1:2))

## ----qcplotsFig2, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8------------
QuasR:::plotNuclByCycle(qcdat1$raw$qa, lmat = rbind(1:2))

## ----qcplotsFig3, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8------------
QuasR:::plotDuplicated(qcdat1$raw$qa, lmat = rbind(1:2))

## ----qcplotsFig4, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8------------
QuasR:::plotMappings(qcdat1$raw$mapdata, a4layout = FALSE)

## ----qcplotsFig5, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8------------
QuasR:::plotUniqueness(qcdat1$raw$unique, a4layout = FALSE)

## ----qcplotsFig6, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8------------
QuasR:::plotErrorsByCycle(qcdat1$raw$mm, lmat = rbind(1:2))

## ----qcplotsFig7, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8------------
QuasR:::plotMismatchTypes(qcdat1$raw$mm, lmat = rbind(1:2))

## ----qcplotsFig8, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8------------
QuasR:::plotFragmentDistribution(qcdat2$raw$frag, lmat = rbind(1:2))

## ----alignmentStats, eval=TRUE------------------------------------------------
# using bam files
alignmentStats(alignments(proj1)$genome$FileName)
alignmentStats(unlist(alignments(proj1)$aux))

# using a qProject object
alignmentStats(proj1)

## ----sessionInfo, echo=FALSE--------------------------------------------------
sessionInfo()

## ----cleanUp, eval=TRUE, echo=FALSE-------------------------------------------
unlink("extdata", recursive = TRUE, force = TRUE)

createProjectSingle <- function(allelic=FALSE) {
  requireNamespace("Rsamtools", quietly = TRUE)
  
  # create bam files
  samfile_plus <- tempfile(fileext = ".sam", tmpdir = "extdata")
  samfile_minus <- tempfile(fileext = ".sam", tmpdir = "extdata")
  cat("@HD\tVN:1.0\tSO:unsorted\n@SQ\tSN:chrV\tLN:800\n", file = samfile_plus)
  cat("@HD\tVN:1.0\tSO:unsorted\n@SQ\tSN:chrV\tLN:800\n", file = samfile_minus)
  pos <- seq.int(512)
  cat(paste(paste0(pos, "_", "seq", pos),
            "0\tchrV", pos, pos %% 256, "5M10N5M\t*\t0\t0\t*",
            if (allelic) rep(c("*\tXV:A:R","*\tXV:A:A","*\tXV:A:U"), each = length(pos)) else "*", 
            sep = "\t", collapse = "\n"), file = samfile_plus, append = TRUE)
  cat(paste(paste0(pos + length(pos), "_", "seq", pos + length(pos)),
            "16\tchrV", pos, pos %% 256, "5M10N5M\t*\t0\t0\t*",
            if (allelic) rep(c("*\tXV:A:R","*\tXV:A:A","*\tXV:A:U"), each = length(pos)) else "*",
            sep = "\t", collapse = "\n"), file = samfile_minus, append = TRUE)
  bamfile_plus <- Rsamtools::asBam(samfile_plus, indexDestination = TRUE)
  bamfile_minus <- Rsamtools::asBam(samfile_minus, indexDestination = TRUE)
  
  # create genome
  genome <- tempfile(fileext = ".fa", tmpdir = "extdata")
  cat(">chrV\n", paste(rep("G", 600), collapse = ""), "\n", file = genome)

  # create SNP file
  if (allelic) {
    snp <- tempfile(fileext = ".txt", tmpdir = "extdata")
    cat(">chrV\t10\tC\tG\n", file = snp)
  }
  
  # create sample file
  samplefile <- tempfile(fileext = ".txt", tmpdir = "extdata")
  write.table(data.frame(FileName = basename(c(bamfile_plus, bamfile_minus)),
                         SampleName = c("Sample", "Sample"), stringsAsFactors = FALSE),
              sep = "\t", quote = FALSE, row.names = FALSE, file = samplefile)
  
  # qAlign
  td <- tempdir()
  if (!allelic) {
    proj <- qAlign(samplefile, genome, paired = "no", alignmentsDir = td)
  } else {
    proj <- qAlign(samplefile, genome, snpFile = snp, paired = "no", alignmentsDir = td)        
  }
  return(proj)
}

createProjectPaired <- function() {
  requireNamespace("Rsamtools", quietly = TRUE)
  
  # create samfile
  sfile <- tempfile(fileext = ".sam", tmpdir = "extdata")
  cat("@HD\tVN:1.0\tSO:unsorted\n", file = sfile, append = FALSE)
  cat("@SQ\tSN:chrV\tLN:99\n", file = sfile, append = TRUE)
  # fr R1->left R2->right
  cat("1_seq1\t99\tchrV\t4\t255\t5M\tchrV\t12\t13\t*\t*\n",      file = sfile, append = TRUE)
  cat("1_seq1\t147\tchrV\t12\t255\t5M\tchrV\t4\t-13\t*\t*\n",    file = sfile, append = TRUE)
  cat("2_seq2\t99\tchrV\t4\t255\t5M\tchrV\t13\t14\t*\t*\n",      file = sfile, append = TRUE)
  cat("2_seq2\t147\tchrV\t13\t255\t5M\tchrV\t4\t-14\t*\t*\n",    file = sfile, append = TRUE)
  # fr R2->left R1->right
  cat("3_seq3\t163\tchrV\t24\t255\t5M\tchrV\t32\t13\t*\t*\n",    file = sfile, append = TRUE)
  cat("3_seq3\t83\tchrV\t32\t255\t5M\tchrV\t24\t-13\t*\t*\n",    file = sfile, append = TRUE)
  cat("4_seq4\t163\tchrV\t24\t255\t5M\tchrV\t33\t14\t*\t*\n",    file = sfile, append = TRUE)
  cat("4_seq4\t83\tchrV\t33\t255\t5M\tchrV\t24\t-14\t*\t*\n",    file = sfile, append = TRUE)
  # ff R1->left R2->right
  cat("5_seq5\t67\tchrV\t44\t255\t5M\tchrV\t52\t13\t*\t*\n",     file = sfile, append = TRUE)
  cat("5_seq5\t131\tchrV\t52\t255\t5M\tchrV\t44\t-13\t*\t*\n",   file = sfile, append = TRUE)
  cat("6_seq6\t67\tchrV\t44\t255\t5M\tchrV\t53\t14\t*\t*\n",     file = sfile, append = TRUE)
  cat("6_seq6\t131\tchrV\t53\t255\t5M\tchrV\t44\t-14\t*\t*\n",   file = sfile, append = TRUE)
  # rr R2->left R1->right
  cat("7_seq7\t115\tchrV\t64\t255\t5M\tchrV\t72\t13\t*\t*\n",    file = sfile, append = TRUE)
  cat("7_seq7\t179\tchrV\t72\t255\t5M\tchrV\t64\t-13\t*\t*\n",   file = sfile, append = TRUE)
  cat("8_seq8\t115\tchrV\t64\t255\t5M\tchrV\t73\t14\t*\t*\n",    file = sfile, append = TRUE)
  cat("8_seq8\t179\tchrV\t73\t255\t5M\tchrV\t64\t-14\t*\t*\n",   file = sfile, append = TRUE)
  # rf R1->left R2->right
  cat("9_seq9\t83\tchrV\t84\t255\t5M\tchrV\t92\t13\t*\t*\n",     file = sfile, append = TRUE)
  cat("9_seq9\t163\tchrV\t92\t255\t5M\tchrV\t84\t-13\t*\t*\n",   file = sfile, append = TRUE)
  cat("10_seq10\t83\tchrV\t84\t255\t5M\tchrV\t93\t14\t*\t*\n",   file = sfile, append = TRUE)
  cat("10_seq10\t163\tchrV\t93\t255\t5M\tchrV\t84\t-14\t*\t*\n", file = sfile, append = TRUE)
  # unmapped
  cat("11_seq11\t77\t*\t0\t255\t*\t*\t0\t0\t*\t*\n",   file = sfile, append = TRUE)
  cat("11_seq11\t141\t*\t0\t255\t*\t*\t0\t0\t*\t*\n", file = sfile, append = TRUE)
  
  # create bamfile
  bfile <- Rsamtools::asBam(sfile)
  
  # create sample file
  samplefile <- tempfile(fileext = ".txt", tmpdir = "extdata")
  write.table(data.frame(FileName = basename(bfile),
                         SampleName = "Normal", stringsAsFactors = FALSE),
              sep = "\t", quote = FALSE, row.names = FALSE, file = samplefile)
  
  # create genome
  genome <- tempfile(fileext = ".fa", tmpdir = "extdata")
  cat(">chrV\n", file = genome, append = FALSE)
  cat(paste(rep("G",99), collapse = ""), file = genome, append = TRUE)
  
  # qAlign
  td <- tempdir()
  project <- qAlign(samplefile, genome, paired = "fr", alignmentsDir = td)
  
  return(project)
}

createTiles <- function() {
  #        101  151  201  251  301  351  401  451  501  551  601  651  701     X = 10x 3reads(=R,U,A) 
  #   H1 :   XXXXXXXXXX          XXXXXXXXXX          XXXXXXXXXX            --> 30X => 900
  #   H2 :        XXXXXXXXXX          XXXXXXXXX           XXXXXXXXXX       --> 30X => 900
  #   H3 :             XXXXXXXXXX          XXXXXXXXXX          XXXXXXXXXX  --> 30X => 900
  #   H4 :                  XXXXXXXXXX          XXXXXXXXXX          XXXXX  --> 24X => 750
  
  requireNamespace("GenomicRanges", quietly = TRUE)
  
  width = 100L
  gap = 100L
  times = 600L / (width + gap)
  h1 <- GenomicRanges::GRanges("chrV", IRanges::successiveIRanges(rep(width,times),gap, from = 101))
  names(h1) <- rep("H1", length(h1))
  h2 <- GenomicRanges::GRanges("chrV", IRanges::successiveIRanges(rep(width,times),gap, from = 151))
  names(h2) <- rep("H2", length(h2))
  h3 <- GenomicRanges::GRanges("chrV", IRanges::successiveIRanges(rep(width,times),gap, from = 201))
  names(h3) <- rep("H3", length(h3))
  h4 <- GenomicRanges::GRanges("chrV", IRanges::successiveIRanges(rep(width,times),gap, from = 251))
  names(h4) <- rep("H4", length(h4))
  end(h4[3]) <- 700
  tiles <- sort(c(h1, h2, h3, h4))    
  return(tiles)
}

createGtfGr <- function() {
  requireNamespace("rtracklayer")
  requireNamespace("GenomicRanges")
  gtfFile <- system.file("extdata", "hg19sub_annotation.gtf", package = "QuasR")
  gr <- rtracklayer::import(gtfFile, format = "gtf", feature.type = "exon")
  names(gr) <- mcols(gr)$gene_id
  gr <- gr[order(names(gr))]
  return(gr)
}

createTxDb <- function() {
  requireNamespace("txdbmaker")
  gtfGr <- createGtfGr()
  txdb <- txdbmaker::makeTxDbFromGRanges(gtfGr)
  return(txdb)
}

# createBSgenome <- function() {
#   requireNamespace("BSgenome")
#   
#   # prepare sequences and seed files
#   seqdir      <- tempfile(pattern = "BSgenome.seqs",    tmpdir = "extdata")
#   bsgenomedir <- tempfile(pattern = "BSgenome.hg19sub", tmpdir = "extdata")
#   rlibdir     <- tempfile(pattern = "Rlib",             tmpdir = "extdata")
# 
#   pkgseed <- new(Class = "BSgenomeDataPkgSeed",
#                  Package = "BSgenome.HSapiens.QuasR.hg19sub",
#                  Title = "Nucleotide sequences of subregions from hg19",
#                  Description = "Nucleotide sequences of three short chromosomal subregions from hg19",
#                  Version = "0.1.0",
#                  Author = "Michael Stadler",
#                  Maintainer = "Michael Stadler <michael.stadler@fmi.ch>",
#                  License = "GPL-2",
#                  organism = "Homo Sapiens",
#                  common_name = "Human",
#                  provider = "QuasR",
#                  provider_version = "hg19sub",
#                  release_date = "Feb. 2009",
#                  release_name = "Genome Reference Consortium GRCh37",
#                  organism_biocview = "Homo Sapiens",
#                  BSgenomeObjname = "hg19sub",
#                  seqnames = "paste0('chr',1:3)")
#   
#   chrs <- Biostrings::readDNAStringSet(file.path("extdata", "hg19sub.fa"))
#   dir.create(seqdir)
#   for (i in seq_along(chrs))
#     Biostrings::writeXStringSet(chrs[i], format = "fasta",
#                                 filepath = file.path(seqdir, paste0(names(chrs[i]), ".fa")))
#   
#   # build and install the package
#   dir.create(bsgenomedir)
#   uniqueLetters <- Biostrings::uniqueLetters # without this, BSgenome::forgeBSgenomeDataPkg fails
#   BSgenome::forgeBSgenomeDataPkg(x = pkgseed, seqs_srcdir = seqdir, destdir = bsgenomedir)
#   dir.create(rlibdir)
#   utils::install.packages(pkgs = file.path(bsgenomedir, "BSgenome.hg19sub"),
#                           lib = rlibdir, repos = NULL, type = "source")
#   
#   return(rlibdir)
# }

#' @keywords internal
displayNames <- function(proj) { # create unique names for each sequence file
    if (!inherits(proj, "qProject", which = FALSE))
        stop("'proj' must be an object of type 'qProject' (returned by 'qAlign')")
    samples <- proj@alignments$SampleName
    ndigits <- nchar(as.character(length(samples)))
    sprintf(paste("s%0", ndigits, "i_%s", sep = ""), seq_along(samples), samples)
}

#' Internal function to get seqlengths, mapped and unmapped counts for a bam file
#'
#' @param bf Character scalar with the path and filename to a bam file (index
#'     is assumed to be already existing)
#'
#' @return a named numeric vector with elements 'seqlength', 'mapped' and 'unmapped'
#'
#' @keywords internal
.get_alnstats_for_bam <- function(bf) {
    tmp <- .Call(idxstatsBam, bf)
    im <- tmp$seqname != "*"
    c(seqlength = sum(as.numeric(tmp$seqlength[im])),
      # remark: also count reads with flag 'unmapped' but available alignment
      #         coordinates as mapped (hisat2 in paired-end mode may generate
      #         such alignments), in order to make qCount, qQCReport and
      #         alignmentStats consisten with each other
      mapped = sum(as.numeric(tmp$mapped[im]),
                   as.numeric(tmp$unmapped[im])),
      unmapped = tmp$unmapped[!im])
}

#' Get statistics on alignments
#'
#' Get statistics on alignments from bam file or \code{qProject} object.
#'
#' Internally, \code{alignmentStats} queries the bam index files similar
#' to 'idxstats' from samtools. Please note that this does not discriminate
#' for example between primary and secondary alignments. If you need more
#' statistics, see for example \code{\link[Rsamtools]{quickBamFlagSummary}}
#' from package \pkg{Rsamtools}.
#'
#' If \code{x} is a \code{qProject} object, the auxiliary bam files will not
#' contain any unmapped reads, and the corresponding unmapped counts are
#' calculated by subtracting auxiliary mapped counts from the total reads.
#' The latter correspond to the unmapped counts from the corresponding genome
#' bam files.
#'
#' @param x the source of alignment bam files, one of:
#' \itemize{
#'   \item a \code{character} vector with bam files
#'   \item a \code{qProject} object
#' }
#' @param collapseBySample If \code{TRUE} and \code{x} is a \code{qProject}
#'   object, sum counts for bam files with identical sample names.
#'
#' @return A \code{matrix} with one row per bam file and three columns
#' ("seqlength", "mapped" and "unmapped").
#'
#' @author Anita Lerch, Dimos Gaidatzis and Michael Stadler
#'
#' @export
#'
#' @seealso
#' \code{\link[=qProject-class]{qProject}},
#' \code{\link[Rsamtools]{quickBamFlagSummary}} from package \pkg{Rsamtools}
#'
#' @name alignmentStats
#' @aliases alignmentStats
#' @keywords utilities misc
#'
#' @examples
#' \dontrun{
#' # see qProject manual page for an example
#' example(qProject)
#' }
#'
#' @importFrom stats aggregate
#'
alignmentStats <- function(x, collapseBySample = TRUE) {
    # check argument and extract named vector of 'bamfiles'
    if (is.character(x)) {
        bamfiles <- x
        names(bamfiles) <- basename(x)
    } else if (inherits(x, "qProject", which = FALSE)) {
        aln <- alignments(x)
        bamfiles <- c(aln$genome$FileName, unlist(aln$aux, use.names = FALSE))
        iGenome <- seq_along(aln$genome$SampleName)
        names(bamfiles) <- if (collapseBySample)
            c(sprintf("%s:genome", aln$genome$SampleName),
              sprintf("%s:%s", rep(colnames(aln$aux), each = nrow(aln$aux)),
                      rownames(aln$aux)))
        else
            c(sprintf("%s:genome", displayNames(x)),
              sprintf("%s:%s", rep(displayNames(x), each = nrow(aln$aux)),
                      rownames(aln$aux)))
    } else {
        stop("'x' must be of type 'character' or 'qProject'")
    }
    # files exist?
    if (any(i <- ! file.exists(bamfiles)))
        stop(sprintf("cannot access bam files: %s", paste(bamfiles[i], collapse = ", ")))
    # call idxstats_bam and collapse counts (seqlength, mapped and unmapped)
    res <- do.call(rbind, lapply(bamfiles, .get_alnstats_for_bam))
    # fix unmapped counts for auxiliaries
    if (inherits(x, "qProject", which = FALSE))
        res[-iGenome, "unmapped"] <- rep(res[iGenome, "unmapped"],
                                         each = nrow(aln$aux)) -
        res[-iGenome, "mapped"]
    # collapse by sample
    if (collapseBySample) {
        res_old <- res
        tmp <- stats::aggregate(res, list(factor(rownames(res),
                                                 levels = unique(rownames(res)))), sum)
        res <- as.matrix(tmp[, -1])
        rownames(res) <- as.character(tmp[, 1])
        res[, "seqlength"] <- res_old[rownames(res), "seqlength"]
    }
    return(res)
}

#' @keywords internal
#' @importFrom parallel clusterCall
loadQuasR <- function(clObj, pkgNm = "QuasR") {
    # load package on cluster nodes
    message("preparing to run on ", length(clObj), " nodes...", appendLF = FALSE)
    err <- try(ret <- parallel::clusterCall(clObj, library, package = pkgNm,
                                            character.only = TRUE),
               silent = FALSE)

    # check if it was loaded on all nodes
    if (is(err, "try-error") ||
        !all(vapply(ret, function(x) pkgNm %in% x, TRUE))) {
        stop("'", pkgNm, "' package could not be loaded on all ",
             "nodes in 'clObj'", call. = FALSE)
    } else {
        message("done")
        return(invisible(TRUE))
    }
}

#' @keywords internal
#' @importFrom tools file_path_as_absolute
freeDiskSpace <- function(path) {
    # return the number of free bytes at 'path' as reported by operating system utilities
    path <- sub("(\\\\|/)$", "", path)
    res <- NA
    if (file.exists(path)) {
        path <- tools::file_path_as_absolute(path)
        tryCatch({ # fail silently, just return NA
            if (.Platform$OS.type == "unix") {
                ret <- system2("df", shQuote(path), stdout = TRUE, stderr = TRUE)
                if (grepl("^.*[0-9]+ +[0-9]+ +[0-9]+.*$", perl = TRUE, ret[length(ret)]))
                    res <- as.numeric(sub("^.*[0-9]+ +[0-9]+ +([0-9]+) .*$", "\\1",
                                          perl = TRUE, ret[length(ret)])) * 1024
            } else if (.Platform$OS.type == "windows") {
                ret <- shell(paste("dir", shQuote(path)), intern = TRUE,
                             translate = TRUE, mustWork = NA)
                ret <- ret[nchar(ret) > 0]
                if (grepl("^.* [0-9,]+ bytes free.*$", ret[length(ret)]))
                    res <- as.numeric(gsub(",", "", sub("^.* ([0-9,]+) bytes free.*$",
                                                        "\\1", ret[length(ret)])))
            }}, error = function(ex) NULL, warning = function(ex) NULL)
    } else {
        warning("'", path, "' does not exist")
    }
    return(res)
}

#' @keywords internal
truncPath <- function(path, w = getOption("width")) {
    # always print full basename, but shorten path if longer than w
    truncpath <- lapply(path, function(p) {
        if (nchar(p[1]) > w)
            file.path(paste(substr(p, 1, w - nchar(basename(p)) - 4),
                            "...", sep = ""), basename(p))
        else
            p
    })
    return(unlist(truncpath, use.names = FALSE))
}

#' @keywords internal
truncString <- function(s, w = getOption("width")) {
    # truncate 's' in the middle
    truncs <- lapply(s, function(ss) {
        if (!is.na(ss[1]) && (l <- nchar(ss[1])) > w)
            paste(substr(ss, 1, floor(w / 2) - 2),
                  substr(ss, floor(l - w / 2) + 2, l),
                  sep = "...")
        else
            ss
    })
    return(unlist(truncs, use.names = FALSE))
}

#' @keywords internal
consolidateFileExtensions <- function(filename, compressed = FALSE) {
    # convert various sequence file extension to one representative
    if (compressed) {
        fileExtension <- tolower(tools::file_ext(sub("[.](gz|bz2|xz)$", "", filename)))
    } else {
        fileExtension <- tolower(tools::file_ext(filename))
    }
    fileExtension[fileExtension %in% c("fa", "fna", "fasta")] <- "fasta"
    fileExtension[fileExtension %in% c("fq", "fastq")] <- "fastq"
    return(fileExtension)
}

#' @keywords internal
#' @importFrom tools file_ext
compressedFileFormat <- function(filename) {
    ifelse(grepl("[.](gz|bz2|xz)$", filename),
           c("gz" = "gzip", "bz2" = "bzip2", "xz" = "xz")[tools::file_ext(filename)],
           "none")
}

#' @keywords internal
compressFile <- function(filename, destname, level = 6,
                         overwrite = FALSE, remove = TRUE, BFR.SIZE = 1e+07) {
    # gzip/gunzip a file - based on R.utils::gzip.default and R.utils::tar
    if (filename == destname)
        stop(sprintf("'filename' and 'destname' are identical: %s", filename))
    if (!overwrite && file.exists(destname))
        stop(sprintf("'destname' already exists: %s", destname))
    #inn <- file(filename, "rb")
    inn <- switch(compressedFileFormat(filename),
                  "none" =    file(filename, "rb"),
                  "gzip" =  gzfile(filename, "rb"),
                  "bzip2" = bzfile(filename, "rb"),
                  "xz" =    xzfile(filename, "rb"))
    on.exit(if (!is.null(inn)) close(inn))
    outComplete <- FALSE
    out <- switch(compressedFileFormat(destname),
                  "none" =    file(destname, "wb"),
                  "gzip" =  gzfile(destname, "wb", compression = level),
                  "bzip2" = bzfile(destname, "wb", compression = level),
                  "xz" =    xzfile(destname, "wb", compression = level))
    on.exit({
        close(out)
        if (!outComplete) {
            file.remove(destname)
        }
    }, add = TRUE)
    nbytes <- 0
    repeat {
        bfr <- readBin(inn, what = raw(0), size = 1, n = BFR.SIZE)
        n <- length(bfr)
        if (n == 0)
            break
        nbytes <- nbytes + n
        writeBin(bfr, con = out, size = 1)
    }
    outComplete <- TRUE
    if (remove) {
        close(inn)
        inn <- NULL
        file.remove(filename)
    }
    invisible(nbytes)
}

# grangesFromGff <-
#     function(con, version="2", split=NULL) {
#         # create a GRangesList object from regions defined in a GFF/GTA file, split by 'type'
#         if (requireNamespace("rtracklayer", quietly=TRUE)) {
#             gr <- rtracklayer::import.gff(con, version=version,
#                                           colnames=c("strand", "type", "source", "gene_id", "transcript_id", "exon_number"))
#
#             if(is.null(split) || !(split %in% colnames(mcols(gr))))
#                 return(gr)
#             else
#                 #return(lapply(split(seq.int(length(gr)), mcols(gr)[[split]]), function(i) gr[i])) # creates a list() of GRanges
#                 return(split(gr, mcols(gr)[[split]])) # creates a GRangesList (compound elements, e.g. in findOverlaps)
#         } else {
#             stop("rtracklayer package not found - aborting grangesFromGff")
#         }
#     }

# concatenateFiles <-
#     function(filenames, destname, BFR.SIZE=1e+07) {
#         # concatenate 'filenames' to 'destname'
#         if(any(f <- !(file.exists(filenames))))
#             stop("'filenames' don't exist: ", paste(filenames[f], collapse=", "))
#         if(!is.character(destname) || length(destname)!=1)
#             stop("'destname' needs to be a single output file name")
#         if(file.exists(destname))
#             stop(sprintf("'destname' already exists: %s", destname))
#         outComplete <- FALSE
#         out <- file(destname, "wb")
#         on.exit({
#             close(out)
#             if (!outComplete) {
#                 file.remove(destname)
#             }
#         })
#         nbytes <- 0
#         for(filename in filenames) {
#             inn <- file(filename, "rb")
#             repeat {
#                 bfr <- readBin(inn, what = raw(0), size = 1, n = BFR.SIZE)
#                 n <- length(bfr)
#                 if (n == 0)
#                     break
#                 nbytes <- nbytes + n
#                 writeBin(bfr, con = out, size = 1)
#             }
#             close(inn)
#         }
#         outComplete <- TRUE
#         invisible(nbytes)
#     }

#' @keywords internal
#' @importFrom tools md5sum
md5subsum <- function(filenames) {
    # use RNG kind for sample() from R version 3.5 and earlier
    # (non-uniform, see https://bugs.r-project.org/bugzilla3/show_bug.cgi?id=17494,
    #  but QuasR on R-3.6 would otherwise re-create all bam files created by QuasR on R-3.5 or earlier)
    suppressWarnings(rng.orig <- RNGkind(kind = "Mersenne-Twister",
                                         normal.kind = "Inversion",
                                         sample.kind = "Rounding"))
    on.exit(suppressWarnings(RNGkind(kind = rng.orig[1],
                                     normal.kind = rng.orig[2],
                                     sample.kind = rng.orig[3])))

    # calculate md5sum() on a reproducible random subset of the file's content
    unlist(lapply(filenames, function(fname) {
        funit <- 1e6
        fs <- floor(file.info(fname)$size / funit)
        if (!is.na(fs) && fs == 0) {
            funit <- 1
            fs <- floor(file.info(fname)$size)
        }
        if (!is.na(fs)) {
            inn <- file(fname, "rb")
            outname <- tempfile()
            out <- file(outname, "wb")
            set.seed(1)
            for (pos in c(0, funit * sort(sample.int(n = fs, size = 20, replace = TRUE)))) {
                seek(inn, where = pos)
                bfr <- readBin(inn, what = raw(0), size = 1, n = 10000)
                if (length(bfr) == 0)
                    break
                writeBin(bfr, con = out, size = 1)
            }
            close(inn)
            close(out)
            res <- tools::md5sum(outname)
            unlink(outname)
            return(res)

        } else {
            warning(sprintf("could not stat file '%s'; returning 'NA' as md5subsum", fname))
            return(NA)
        }
    }), use.names = FALSE)
}

# return a list(2) of BiocParallel::BiocParallelParam for nested parallelization
#  [[1]] is used to parallelize across files
#  [[2]] is used to parallelize across threads (accessing a single file) -> has to be a MulticoreParam or SerialParam object
# for downwards compatibility, a parallel::cluster object can be passed that will be used to create the BiocParallel parameter objects
#' @keywords internal
#' @importFrom BiocParallel SerialParam MulticoreParam
#' @importFrom parallel clusterEvalQ
#' @importFrom methods as
getListOfBiocParallelParam <- function(clObj = NULL) {
    if (is.null(clObj)) { # no 'clObj' argument
        bppl <- list(BiocParallel::SerialParam(), BiocParallel::SerialParam())
    } else {             # have 'clObj' argument
        if (inherits(clObj, "SOCKcluster")) {
            if (identical(.Platform$OS.type, "windows")) {
                # MulticoreParam is not supported on windows -> keep the current clObj
                bppl <- list(methods::as(clObj, "SnowParam"),
                             BiocParallel::SerialParam())
            } else {
                # non-windows platforms:
                # get node names
                tryCatch({
                    nodeNames <- unlist(parallel::clusterEvalQ(clObj, Sys.info()["nodename"]))
                }, error = function(ex) {
                    message("FAILED")
                    stop("The cluster object does not work properly on this system. Please consult the manual of the package 'parallel'\n", call. = FALSE)
                })
                coresPerNode <- table(nodeNames)
                # subset cluster object (represent each node just a single time)
                clObjSub <- clObj[!duplicated(nodeNames)]
                bppl <- if (min(coresPerNode) == 1)
                    list(methods::as(clObj, "SnowParam"), BiocParallel::SerialParam())
                else
                    list(methods::as(clObjSub, "SnowParam"),
                         BiocParallel::MulticoreParam(workers = min(coresPerNode)))
            }
        } else if (is.list(clObj) &&
                   all(vapply(clObj, FUN = inherits,
                              FUN.VALUE = TRUE, "BiocParallelParam"))) {
            bppl <- clObj
        }
    }
    if (length(bppl) == 1)
        bppl[[2]] <- BiocParallel::SerialParam()
    if (!inherits(bppl[[2]], c("MulticoreParam", "SerialParam")))
        stop('Error configuring the parallel backend. The second registered backend (registered()[[2]] or clObj[[2]]) has to be of class "MulticoreParam" or "SerialParam"')
    return(bppl[seq_len(2)])
}

#' Build a formatted message for outputting to log files
#' @keywords internal
worker_message <- function(..., sep = "", appendLF = TRUE) {

    # all used functions are from base R
    if (identical(sep, "")) {
        spacer <- " "
    } else {
        spacer <- ""
    }
    cat(paste0("[", format(Sys.time(), format = "%Y-%m-%d %H:%M:%S",
                           tz = "UTC", usetz = TRUE), "] ",
               "(", Sys.info()["user"], "@pid", Sys.getpid(), "/",
               Sys.info()["nodename"], ")", spacer),
        ..., sep = sep)

    if (appendLF) {
        cat("\n")
    }
}

context("utilites")

test_that("md5subsum works as expected", {
  expect_identical_md5subsum <- function(fname, expval) {
    fname <- system.file("extdata", fname, package = "QuasR")
    expect_identical(QuasR:::md5subsum(fname), expval)
  }

    expect_warning(QuasR:::md5subsum("nonexistent"))
  expect_identical_md5subsum("hg19sub.fa",      "cf9c426a33b0e99261f310c67f0df0b6")
  expect_identical_md5subsum("bis_1_1.fa.bz2",  "fb9bd7b28edc59b41757833c68ae94ff")
  set.seed(95874)
  expect_identical_md5subsum("bis_1_1.fa.bz2",  "fb9bd7b28edc59b41757833c68ae94ff")
  set.seed(948620)
  expect_identical_md5subsum("chip_1_1.fq.bz2", "653105d10a200f5663ceb174027e4eb9")
  set.seed(95)
  expect_identical_md5subsum("rna_1_1.fq.bz2",  "89282741f79188e8b8bfb517f606c035")
  expect_identical_md5subsum("NC_001422.1.fa",  "9d91fb2b59c4134ab1dc3249ed81fbce")
})

test_that("displayNames correctly digests its arguments", {
  expect_error(displayNames("error"))
})

test_that("loadQuasR works as expected", {
  cl <- parallel::makeCluster(2L)
  expect_error(loadQuasR(cl, "does_not_exist"), "could not be loaded")
  expect_true(expect_message(loadQuasR(cl, "stats"), "preparing to run"))
})

test_that("freeDiskSpace runs", {
  expect_warning(QuasR:::freeDiskSpace("nonexistent"))
  expect_is(QuasR:::freeDiskSpace("."), "numeric")
})

test_that("truncString works as expected", {
  expect_identical(QuasR:::truncString("AAAAAA", w = 5), "...AA")
})

test_that("getListOfBiocParallelParam works as expected", {
  requireNamespace("BiocParallel")
  bpp <- QuasR:::getListOfBiocParallelParam(list(BiocParallel::SerialParam()))
  expect_is(bpp, "list")
  expect_length(bpp, 2L)
  expect_is(bpp[[1]], "BiocParallelParam")

  bpp2 <- QuasR:::getListOfBiocParallelParam(clObj)
  expect_error(QuasR:::getListOfBiocParallelParam(bpp2[2:1]))
})

test_that("worker_message works as expected", {
    inf <- Sys.info()
    pid <- Sys.getpid()

    expect_output(worker_message(),
                  regexp = paste0(inf[['user']],'@pid',pid,'/',inf[['nodename']]))
    expect_output(worker_message("test1", "test2"),
                  regexp = "test1test2$")
    expect_output(worker_message("hello world", sep = ":"),
                  regexp = ":hello world$")
    expect_output({
        worker_message("test1", appendLF = FALSE)
        worker_message("test2")
    }, regexp = 'test1[^\n].+test2$')
    expect_output({
        worker_message("test1", appendLF = TRUE)
        worker_message("test2")
    }, regexp = 'test1\n.+test2$')
})

# cover parts that are not already covered indirectly by other tests

context("compiled code")

test_that("extractUnmappedReads works as expected", {
  fun    <- function(...) .Call(QuasR:::extractUnmappedReads, ...)
  bamf1  <- pChipSingle@alignments$FileName[1]
  bamf2  <- pRnaPaired@alignments$FileName[1]
  fafile <- tempfile(fileext = rep(".fa",2), tmpdir = "extdata")
  fqfile <- tempfile(fileext = rep(".fq",2), tmpdir = "extdata")
  
  # arguments
  expect_error(fun(1L,         fafile[1],             FALSE, FALSE))
  expect_error(fun(bamf1,             1L,             FALSE, FALSE))
  expect_error(fun(bamf1,      fafile[1],                1L, FALSE))
  expect_error(fun(bamf1,      fafile[1],             FALSE,    1L))
  expect_error(fun("no-file",  fafile[1],             FALSE, FALSE))
  expect_error(fun(genomeFile, fafile[1],             FALSE, FALSE))
  expect_error(fun(bamf1,      "not-there/fafile", FALSE, FALSE))
  
  # results
  f <- fun(bamf1, fafile[1], FALSE, FALSE); expect_length(readLines(f), 516L)
  f <- fun(bamf1, fafile[1], FALSE, TRUE);  expect_length(readLines(f), 516L)
  f <- fun(bamf1, fqfile[1], TRUE,  FALSE); expect_length(readLines(f), 1032L)
  f <- fun(bamf1, fqfile[1], TRUE,  TRUE);  expect_length(readLines(f), 1032L)
  f <- fun(bamf2, fafile,    FALSE, FALSE); expect_length(readLines(f[1]), 3746L)
  f <- fun(bamf2, fafile,    FALSE, TRUE);  expect_length(readLines(f[2]), 3746L)
  f <- fun(bamf2, fqfile,    TRUE,  FALSE); expect_length(readLines(f[1]), 7492L)
  f <- fun(bamf2, fqfile,    TRUE,  TRUE);  expect_length(readLines(f[2]), 7492L)
})

test_that("catBam works as expected", {
  requireNamespace("Rsamtools")
  
  fun    <- function(...) .Call(QuasR:::catBam, ...)
  bamf1  <- pSingle@alignments$FileName[1]
  bfile  <- tempfile(fileext = ".bam", tmpdir = "extdata")
  
  # arguments
  expect_error(fun(   1L, bfile))
  expect_error(fun(bamf1,    1L))
  expect_error(fun(bamf1, "not-there/bfile"))

  # results
  expect_identical(fun(bamf1, bfile), 0L)
  Rsamtools::indexBam(bfile)
  expect_identical(alignmentStats(bamf1)[1,],
                   alignmentStats(bfile)[1,])
})

test_that("splitSamChr works as expected", {
  fun    <- function(...) .Call(QuasR:::splitSamChr, ...)
  bamf1  <- pSingle@alignments$FileName[1]
  samf1  <- sub(".bam$", ".sam", bamf1)
  outdir <- tempfile(pattern = "sam", tmpdir = "extdata")
  dir.create(outdir)
  
  # arguments
  expect_error(fun(   1L, outdir))
  expect_error(fun(samf1,     1L))

  # results
  chrs <- fun(samf1, outdir)
  expect_identical(chrs, c("chrV", "splitChrSam_unaligned"))
  expect_identical(list.files(outdir), paste0(chrs, ".sam"))
  expect_length(readLines(file.path(outdir, "chrV.sam")), 514L)
  expect_length(readLines(file.path(outdir, "splitChrSam_unaligned.sam")), 2L)
  
  unlink(outdir, recursive = TRUE, force = TRUE)
})

test_that("countJunctions works as expected", {
  fun    <- function(...) .Call(QuasR:::countJunctions, ...)
  bamf1  <- pSingleAllelic@alignments$FileName[1]
  samf1  <- sub(".bam$", ".sam", bamf1)
  
  # arguments
  expect_error(fun(   1L, 0L, 0L, 1000L, FALSE, FALSE, 0L, 255L))
  expect_error(fun(bamf1, "", 0L, 1000L, FALSE, FALSE, 0L, 255L))
  expect_error(fun(bamf1, 0L, "", 1000L, FALSE, FALSE, 0L, 255L))
  expect_error(fun(bamf1, 0L, 0L,    "", FALSE, FALSE, 0L, 255L))
  expect_error(fun(bamf1, 0L, 0L, 1000L,    "", FALSE, 0L, 255L))
  expect_error(fun(bamf1, 0L, 0L, 1000L, FALSE,    "", 0L, 255L))
  expect_error(fun(bamf1, 0L, 0L, 1000L, FALSE, FALSE, -1, 255L))
  expect_error(fun(bamf1, 0L, 0L, 1000L, FALSE, FALSE, 0L,   -1))
  expect_error(fun(bamf1, 0L, 0L, 1000L, FALSE, FALSE, 2L,   1L))
  expect_error(fun("err", 0L, 0L, 1000L, FALSE, FALSE, 0L, 255L))
  expect_error(fun(samf1, 0L, 0L, 1000L, FALSE, FALSE, 0L, 255L))
  
  # results
  r1 <- fun(bamf1, 0L, 0L, 1000L, FALSE, FALSE, 0L, 255L)
  r2 <- fun(bamf1, 0L, 0L, 1000L, TRUE,  FALSE, 0L, 255L)
  expect_is(r1, "integer")
  expect_length(r1, 512L)
  expect_is(r2, "list")
  expect_length(r2, 4L)
  expect_true(all(lengths(r2) == 512L))
})

test_that("bamfileToWig works as expected", {
  fun    <- function(...) .Call(QuasR:::bamfileToWig, ...)
  bamf1  <- pSingle@alignments$FileName[1]
  wig1   <- tempfile(fileext = ".wig",    tmpdir = "extdata")
  wig2   <- tempfile(fileext = ".wig.gz", tmpdir = "extdata")
  wig3   <- tempfile(fileext = ".wig",    tmpdir = "extdata")
  wig4   <- tempfile(fileext = ".wig.gz", tmpdir = "extdata")
  
  # arguments
  expect_error(fun(   1L, wig1, FALSE, 10L, 0L, "*", 1.0, "trackname", FALSE,
                   "255,212,0", FALSE, FALSE, 0L, 255L, 0L, 1000L, 16L))
  expect_error(fun(bamf1,   1L, FALSE, 10L, 0L, "*", 1.0, "trackname", FALSE,
                   "255,212,0", FALSE, FALSE, 0L, 255L, 0L, 1000L, 16L))
  expect_error(fun(bamf1, wig1,    "", 10L, 0L, "*", 1.0, "trackname", FALSE,
                   "255,212,0", FALSE, FALSE, 0L, 255L, 0L, 1000L, 16L))
  expect_error(fun(bamf1, wig1, FALSE,  "", 0L, "*", 1.0, "trackname", FALSE,
                   "255,212,0", FALSE, FALSE, 0L, 255L, 0L, 1000L, 16L))
  expect_error(fun(bamf1, wig1, FALSE, 10L, "", "*", 1.0, "trackname", FALSE,
                   "255,212,0", FALSE, FALSE, 0L, 255L, 0L, 1000L, 16L))
  expect_error(fun(bamf1, wig1, FALSE, 10L, 0L,  1L, 1.0, "trackname", FALSE,
                   "255,212,0", FALSE, FALSE, 0L, 255L, 0L, 1000L, 16L))
  expect_error(fun(bamf1, wig1, FALSE, 10L, 0L, "*",  "", "trackname", FALSE,
                   "255,212,0", FALSE, FALSE, 0L, 255L, 0L, 1000L, 16L))
  expect_error(fun(bamf1, wig1, FALSE, 10L, 0L, "*", 1.0,          1L, FALSE,
                   "255,212,0", FALSE, FALSE, 0L, 255L, 0L, 1000L, 16L))
  expect_error(fun(bamf1, wig1, FALSE, 10L, 0L, "*", 1.0, "trackname",    1L,
                   "255,212,0", FALSE, FALSE, 0L, 255L, 0L, 1000L, 16L))
  expect_error(fun(bamf1, wig1, FALSE, 10L, 0L, "*", 1.0, "trackname", FALSE,
                   1L,          FALSE, FALSE, 0L, 255L, 0L, 1000L, 16L))
  expect_error(fun(bamf1, wig1, FALSE, 10L, 0L, "*", 1.0, "trackname", FALSE,
                   "255,212,0",    1L, FALSE, 0L, 255L, 0L, 1000L, 16L))
  expect_error(fun(bamf1, wig1, FALSE, 10L, 0L, "*", 1.0, "trackname", FALSE,
                   "255,212,0", FALSE,    1L, 0L, 255L, 0L, 1000L, 16L))
  expect_error(fun(bamf1, wig1, FALSE, 10L, 0L, "*", 1.0, "trackname", FALSE,
                   "255,212,0", FALSE, FALSE, "", 255L, 0L, 1000L, 16L))
  expect_error(fun(bamf1, wig1, FALSE, 10L, 0L, "*", 1.0, "trackname", FALSE,
                   "255,212,0", FALSE, FALSE, 0L,   "", 0L, 1000L, 16L))
  expect_error(fun(bamf1, wig1, FALSE, 10L, 0L, "*", 1.0, "trackname", FALSE,
                   "255,212,0", FALSE, FALSE, 0L, 255L, "", 1000L, 16L))
  expect_error(fun(bamf1, wig1, FALSE, 10L, 0L, "*", 1.0, "trackname", FALSE,
                   "255,212,0", FALSE, FALSE, 0L, 255L, 0L,    "", 16L))
  expect_error(fun(bamf1, wig1, FALSE, 10L, 0L, "*", 1.0, "trackname", FALSE,
                   "255,212,0", FALSE, FALSE, 0L, 255L, 0L, 1000L,  ""))
  expect_error(fun("err", wig1, FALSE, 10L, 0L, "*", 1.0, "trackname", FALSE,
                   "255,212,0", FALSE, FALSE, 0L, 255L, 0L, 1000L, 16L))

  
  # results
  r1 <- fun(bamf1, wig1, FALSE, 10L, 0L, "*", 1.0, "trackname", FALSE,
            "255,212,0", FALSE, FALSE, 0L, 255L, 0L, 800L, 16L)
  r2 <- fun(bamf1, wig3, FALSE, 20L, 0L, "*", 1.0, "trackname", TRUE,
            "255,212,0", FALSE, FALSE, 0L, 255L, 0L, 800L, 16L)
  r3 <- fun(bamf1, wig2, FALSE, 15L, 0L, "*", 1.0, "trackname", FALSE,
            "255,212,0", TRUE,  FALSE, 0L, 255L, 0L, 800L, 16L)
  r4 <- fun(bamf1, wig4, FALSE, 30L, 0L, "*", 1.0, "trackname", TRUE,
            "255,212,0", TRUE,  FALSE, 0L, 255L, 0L, 800L, 16L)
  l1 <- readLines(wig1)
  l2 <- readLines(wig2)
  l3 <- readLines(wig3)
  l4 <- readLines(wig4)
  expect_length(l1, 82L)
  expect_length(l2, 55L)
  expect_length(l3, 42L)
  expect_length(l4, 28L)
  expect_identical(sum(as.numeric(l1[-c(1, 2)])), sum(as.numeric(l2[-c(1, 2)])))
  expect_equal(sum(as.numeric(l3[-c(1, 2)])), 113.45)
  expect_equal(sum(as.numeric(l4[-c(1, 2)])), 85.73)
})

test_that("mergeReorderSam works as expected", {
  fun    <- function(...) .Call(QuasR:::mergeReorderSam, ...)
  bamf1  <- pPaired@alignments$FileName[1]
  samf1  <- sub(".bam$", ".sam", bamf1)
  samf2  <- tempfile(fileext = ".sam", tmpdir = "extdata")
  
  # arguments
  expect_error(fun(   1L, samf2,     0L, 1L))
  expect_error(fun(samf1,    1L,     0L, 1L))
  expect_error(fun(samf1, samf2,     "", 1L))
  expect_error(fun(samf1, samf2,     0L, ""))
  expect_error(fun(samf1, samf2,     4L, 1L))
  expect_error(fun(samf1, samf2,     1L, 1L))
  expect_error(fun(samf1, samf2,     2L, 1L))
  expect_error(fun(samf1, "err/err", 0L, 1L))

  # results
  expect_identical(fun(rep(samf1, 2), samf2, 0L, 1L), 1L)
  expect_length(readLines(samf2), 44L)
  expect_identical(fun(rep(samf1, 2), samf2, 2L, 1L), 1L)
  expect_length(readLines(samf2), 24L)
})

test_that("removeUnmappedFromSamAndConvertToBam works as expected", {
  fun    <- function(...) .Call(QuasR:::removeUnmappedFromSamAndConvertToBam, ...)
  bamf1  <- pPaired@alignments$FileName[1]
  samf1  <- sub(".bam$", ".sam", bamf1)
  bamf2  <- tempfile(fileext = ".bam", tmpdir = "extdata")
  
  # arguments
  expect_error(fun(   1L, bamf2))
  expect_error(fun(samf1,    1L))
  expect_error(fun("err", bamf2))
  expect_error(fun(samf1, "err/err"))

  # results
  expect_identical(fun(samf1, bamf2), bamf2)
})


test_that("filterHisat2 works as expected", {
  # create example sam file
  fun    <- function(...) .Call(QuasR:::filterHisat2, ...)
  samf1 <- tempfile(fileext = ".sam", tmpdir = "extdata")
  samf2 <- tempfile(fileext = ".sam", tmpdir = "extdata")
  writeLines(text = c("@HD\tVN:1.4",
                      "@SQ\tSN:chr1\tLN:40000",
                      "@SQ\tSN:chr2\tLN:10000",
                      "@SQ\tSN:chr3\tLN:45000",
                      "seq1\t163\tchr3\t12355\t255\t38M560N12M\t=\t13074\t769\tCAGCCCTTGAACGGAGAATAGAGTACATTGAAGCTCGGGTGACAAAAGGT\tggggggggggggggggggggggggggggghggggfggegccceacLSSTS\tNH:i:1",
                      "seq1\t83\tchr3\t13074\t255\t50M\t=\t12355\t-769\tAGAGCAACAGGGCTTATTCTTGTTTTTCTTTTTTCAAAAGTGTGGCCTTT\tgggggggggggggggggggggggfffffffffgggggggggggggggggg\tNH:i:1",
                      "seq2\t163\tchr2\t2927\t255\t14M241N36M\t=\t3424\t547\tCGGCGCTCGGCAAGTTCTCCCAGGAGAAAGCCATGTTCAGTTCGAGCGCC\tgggggggggghgggfggggggdggggggggggggggggggefeggdgggg\tNH:i:2",
                      "seq2\t83\tchr2\t3424\t255\t50M\t=\t2927\t-547\tGATGAACTCGGACCTCAAGGCTCAGCTCAGGGAGCTGAATATTACGGCAG\tgggggggggggggfggggggggggggfgggfggggggggggggggggghg\tNH:i:2",
                      "seq3\t163\tchr2\t5346\t255\t19M2335N31M\t=\t7796\t2500\tAGCAAAAGCGTCCCAGGAGCCGTACTCTGACAGCTGTGCACGATGCCATC\tgggggggggggggggggfggggggggggggggggdggggggggggegggg\tNH:i:3",
                      "seq3\t83\tchr2\t7796\t255\t50M\t=\t5346\t-2500\tCCGGCTCATAAAGGTTCATTTGGACAAAGCACAGCAGAACAATGTGGAAC\tgggggggggggggggggggggggggggggggggggggggggggggggggg\tNH:i:3",
                      "seq4\t99\tchr3\t2413\t255\t50M\t=\t12343\t9980\tCGGGAGATTCACCAGGACTGGGCTGACCAGGAGTACATTGAGATAATCAC\teggegddceedggggeZcec^]`^`ffffcTTSUTTSSTTfffaf]``]^\tNH:i:4",
                      "seq4\t147\tchr3\t12343\t255\t50M\t=\t2413\t-9980\tACGAGAAATTGACAGCCCTTGAACGGAGAATAGAGTACATTGAAGCTCGG\tacaaccaeccTTTSS_]_]`__P__SSTTTgdgggghgbgTTTTSggggg\tNH:i:4",
                      "seq5\t419\tchr1\t23628\t255\t50M\t=\t24226\t648\tCTCGTCCACTTTGAGTTCCTCGTTGAGCCTGATGGCGTCGGCAACCTCCT\tggfegfeeffTSSTSd`bbcc^c```^cc[aeefa_TT[ZTTTTTZ_[ZZ\tNH:i:1",
                      "seq5\t339\tchr1\t24226\t255\t50M\t=\t23628\t-648\tTCCACGGCGCGGAAGTGTGTCTTGCTCTCCTCCATGGCCTCCTGGAAGTG\tgggggggfgfW`]``ggggggfdgd^^c``[d_cbgdggggdgeggggb^\tNH:i:1",
                      "seq6\t77\t*\t0\t0\t*\t*\t0\t0\tGCCGCCCTCGCAGTGCTGCCAGAGAAGGGAGGGCATCCCCTGAGCCGCCG\tggggggggggggggggggggggggggggggggfffggggggggggdgggg",
                      "seq6\t141\t*\t0\t0\t*\t*\t0\t0\tGGCCCCAAGGCCCCCGTCCCGCAGCCACGCTTGTGGTCGCTGCGTCCCGG\tgggggggggggggggggggggggggggdgcgggedbe`^bEbV__ed^bc"),
             con = samf1)

  # arguments
  expect_error(fun(   1L, samf2,     1L))
  expect_error(fun(samf1,    1L,     1L))
  expect_error(fun(samf1, samf2,    "1L"))
  expect_error(fun("err", samf2,     1L))

  # results
  r0 <- fun(samf1, samf2, 0L); n0 <- length(readLines(samf2))
  r1 <- fun(samf1, samf2, 1L); n1 <- length(readLines(samf2))
  r2 <- fun(samf1, samf2, 2L); n2 <- length(readLines(samf2))
  r3 <- fun(samf1, samf2, 3L); n3 <- length(readLines(samf2))
  r4 <- fun(samf1, samf2, 4L); n4 <- length(readLines(samf2))

  expect_identical(n0, 14L)
  expect_identical(n1, 14L)
  expect_identical(n2, 14L)
  expect_identical(n3, 14L)
  expect_identical(n4, 14L)
  
  expect_identical(r0, c(n_secondary=2L, n_overmapped=8L))
  expect_identical(r1, c(n_secondary=2L, n_overmapped=6L))
  expect_identical(r2, c(n_secondary=2L, n_overmapped=4L))
  expect_identical(r3, c(n_secondary=2L, n_overmapped=2L))
  expect_identical(r4, c(n_secondary=2L, n_overmapped=0L)) 
})

# export alignment to wig file
# - each read (pair) "lives" on a single base:
#     pairs on the middle of the fragment
#     singles on the 5'-end base shifted by "shift" towards their 3'-end
# - multiple samples can be automatically normalized to one another
# - multiple bam files with identical sample name can be combined into the same file (track)
# - wig files can be compressed
#
# proj        : qProject object
# file        : wig file name(s) (will be compressed if file QuasR:::compressedFileFormat(file) != "none"
# collapseBySample : create one track per unique sample name
# binsize     : stepInterval and windowSize for the fixedStep wig file
# shift       : only for single read projects; shift read
# strand      : only include alignments on '+', '-' or '*' (any) strand
# scaling     : scale multiple tracks to one another?
# tracknames  : names for display in track header
# log2p1      : transform alignment count by log2(x+1)
# colors      : colors for tracks
# mapqMin     : minimum mapping quality (MAPQ >= mapqMin)
# mapqMax     : maximum mapping quality (MAPQ <= mapqMax)
# absIsizeMin : minimum absolute insert size (TLEN >= absIsizeMin)
# absIsizeMax : maximum absolute insert size (TLEN <= absIsizeMax)
# useRead     : for paired-end data, what read to use
# pairedAsSingle : for paired-end data, treat as single read data (do not calculate fragment mid-points)
#' QuasR wig file export
#'
#' Create a fixed-step wig file from the alignments in the genomic bam files
#' of the \sQuote{QuasR} project.
#'
#' \code{qExportWig()} uses the genome bam files in \code{proj} as input
#' to create wig or bigWig files with the number of alignments (pairs)
#' per window of \code{binsize} nucleotides. By default
#' (\code{collapseBySample=TRUE}), one file per unique sample will be
#' created. If \code{collapseBySample=FALSE}, one file per genomic bam
#' file will be created. See \url{http://genome.ucsc.edu/goldenPath/help/wiggle.html}
#' for the definition of the wig format, and
#' \url{http://genome.ucsc.edu/goldenPath/help/bigWig.html} for the definition
#' of the bigWig format.
#'
#' The genome is tiled with sequential windows of length \code{binsize},
#' and alignments in the bam file are assigned to these windows: Single
#' read alignments are assigned according to their 5'-end coordinate
#' shifted by \code{shift} towards the 3'-end (assuming that the 5'-end
#' is the leftmost coordinate for plus-strand alignments, and the rightmost
#' coordinate for minus-strand alignments). Paired-end alignments are
#' assigned according to the base in the middle between the leftmost and
#' rightmost coordinates of the aligned pair of reads, unless
#' \code{pairedAsSingle = TRUE} is used. Each pair of reads
#' is only counted once, and not properly paired alignments are
#' ignored. If \code{useRead} is set to select only the first or last
#' read in a paired-end experiment, the selected read will be treated as
#' reads from a single read experiment. Secondary alignments can be
#' excluded by setting \code{includeSecondary=FALSE}. In paired-end
#' experiments, \code{absIsizeMin} and \code{absIsizeMax} can be used to select
#' alignments based on their insert size (TLEN field in SAM Spec v1.4).
#'
#' For \code{scaling=TRUE}, the number of alignments per bin \eqn{n}
#' for the sample \eqn{i} are linearly scaled to the mean total
#' number of alignments over all samples in \code{proj} according to:
#' \eqn{n_s = n /N[i] *mean(N)} where \eqn{n_s} is the scaled number
#' of alignments in the bin and \eqn{N} is a vector with the total
#' number of alignments for each sample. Alternatively, if scaling is set
#' to a positive numerical value \eqn{s}, this value is used instead of
#' \eqn{\textnormal{mean}(N)}{mean(N)}, and values are scaled according
#' to: \eqn{n_s = n /N[i] *s}.
#'
#' \code{mapqMin} and \code{mapqMax} allow to select alignments
#' based on their mapping qualities. \code{mapqMin} and \code{mapqMax} can
#' take integer values between 0 and 255 and equal to
#' \eqn{-10 log_{10} Pr(\textnormal{mapping position is wrong})}{-10
#' log10 Pr(mapping position is wrong)}, rounded to the nearest
#' integer. A value 255 indicates that the mapping quality is not available.
#'
#' If \code{createBigWig=FALSE} and \code{file} ends with \sQuote{.gz},
#' the resulting wig file will be compressed using gzip and is suitable
#' for uploading as a custom track to your favorite genome browser
#' (e.g. UCSC or Ensembl).
#'
#' @param proj A \code{qProject} object as returned by \code{qAlign}.
#' @param file A character vector with the name(s) for the wig or bigWig
#'   file(s) to be generated. Either \code{NULL} or a vector of the same
#'   length as the number of bam files (for \code{collapseBySample=FALSE})
#'   or the number of unique sample names (for \code{collapseBySample=TRUE})
#'   in \code{proj}. If \code{NULL}, the wig or bigWig file names are generated
#'   from the names of the genomic bam files or unique sample names with an
#'   added \dQuote{.wig.gz} or \dQuote{.bw} extension.
#' @param collapseBySample If \code{TRUE}, genomic bam files with identical
#'   sample name will be combined (summed) into a single track.
#' @param binsize A numerical value defining the bin and step size for the
#'   wig or bigWig file(s). \code{binsize} will be coerced to \code{integer()}.
#' @param shift Either a vector or a scalar value defining the read shift (e.g.
#'   half of fragment length, see \sQuote{Details}). If \code{length(shift)>1},
#'   the length must match the number of bam files in \sQuote{proj}, and
#'   the i-th sample will be converted to wig or bigWig using the value in
#'   \code{shift[i]}. \code{shift} will be coerced to \code{integer()}. For
#'   paired-end alignments, \code{shift} will be ignored, and a warning
#'   will be issued if it is set to a non-zero value (see \sQuote{Details}).
#' @param strand Only count alignments of \code{strand}. The default
#'   (\dQuote{*}) will count all alignments.
#' @param scaling If TRUE or a numerical value, the output values in the wig
#'   or bigWig file(s) will be linearly scaled by the total number of aligned
#'   reads per sample to improve comparability (see \sQuote{Details}).
#' @param tracknames A character vector with the names of the tracks to appear
#'   in the track header. If \code{NULL}, the sample names in \code{proj}
#'   will be used.
#' @param log2p1 If \code{TRUE}, the number of alignments \code{x} per bin will
#'   be transformed using the formula \code{log2(x+1)}.
#' @param colors A character vector with R color names to be used for the tracks.
#' @param includeSecondary If \code{TRUE} (the default), include alignments
#'   with the secondary bit (0x0100) set in the \code{FLAG}.
#' @param mapqMin Minimal mapping quality of alignments to be included
#'   (mapping quality must be greater than or equal to \code{mapqMin}).
#'   Valid values are between 0 and 255. The default (0) will include all
#'   alignments.
#' @param mapqMax Maximal mapping quality of alignments to be included
#'   (mapping quality must be less than or equal to \code{mapqMax}).
#'   Valid values are between 0 and 255. The default (255) will include all
#'   alignments.
#' @param absIsizeMin For paired-end experiments, minimal absolute insert
#'   size (TLEN field in SAM Spec v1.4) of alignments to be included. Valid
#'   values are greater than 0 or \code{NULL} (default), which will not
#'   apply any minimum insert size filtering.
#' @param absIsizeMax For paired-end experiments, maximal absolute insert
#'   size (TLEN field in SAM Spec v1.4) of alignments to be included. Valid
#'   values are greater than 0 or \code{NULL} (default), which will not apply
#'   any maximum insert size filtering.
#' @param createBigWig If \code{TRUE}, first a temporary wig file will be
#'   created and then converted to BigWig format (file extension \dQuote{.bw})
#'   using the \code{\link[rtracklayer]{wigToBigWig}} function from
#'   package \pkg{rtracklayer}.
#' @param useRead For paired-end experiments, selects the read mate whose
#'   alignments should be counted, one of:
#'   \describe{
#'     \item{\code{any} (default)}{: count all alignments}
#'     \item{\code{first}}{: count only alignments from the first read}
#'     \item{\code{last}}{: count only alignments from the last read}
#'   }
#'   For single-read alignments, this argument will be ignored. For
#'   paired-end alignments, setting this argument to a value different
#'   from the default (\code{any}) will cause \code{qExportWig} not to
#'   automatically use the mid of fragments, but to treat the selected
#'   read as if it would come from a single-read experiment (see
#'   \sQuote{Details}).
#' @param pairedAsSingle If \code{TRUE}, treat paired-end data single read
#'   data, which means that instead of calculating fragment mid-points for
#'   each read pair, the 5-prime ends of the reads is used. This is for example
#'   useful when analyzing paired-end DNAse-seq or ATAC-seq data, in which
#'   the read starts are informative for chromatin accessibility.
#' @param clObj A cluster object to be used for parallel processing of multiple
#'   samples.
#'
#' @return (invisible) The file name of the generated wig or bigWig file(s).
#'
#' @export
#'
#' @author Anita Lerch, Dimos Gaidatzis and Michael Stadler
#'
#' @seealso
#' \code{\linkS4class{qProject}}, \code{\link{qAlign}},
#' \code{\link[rtracklayer]{wigToBigWig}}
#'
#' @keywords utilities
#'
#' @name qExportWig
#' @aliases qExportWig
#'
#' @importFrom Rsamtools scanBamHeader
#' @importFrom Seqinfo Seqinfo
#' @importFrom grDevices col2rgb colorRampPalette
#' @importFrom rtracklayer wigToBigWig
#' @importFrom methods is
#' @importFrom BiocParallel bpworkers bplapply
#'
#' @examples
#' # copy example data to current working directory
#' file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)
#'
#' # create alignments
#' sampleFile <- "extdata/samples_chip_single.txt"
#' genomeFile <- "extdata/hg19sub.fa"
#' proj <- qAlign(sampleFile, genomeFile)
#'
#' # export wiggle file
#' qExportWig(proj, binsize=100L, shift=0L, scaling=TRUE)
#'
qExportWig <- function(proj,
                       file = NULL,
                       collapseBySample = TRUE,
                       binsize = 100L,
                       shift = 0L,
                       strand = c("*", "+", "-"),
                       scaling = TRUE,
                       tracknames = NULL,
                       log2p1 = FALSE,
                       colors = c("#1B9E77", "#D95F02", "#7570B3", "#E7298A",
                                  "#66A61E", "#E6AB02", "#A6761D", "#666666"),
                       includeSecondary = TRUE,
                       mapqMin = 0L,
                       mapqMax = 255L,
                       absIsizeMin = NULL,
                       absIsizeMax = NULL,
                       createBigWig = FALSE,
                       useRead = c("any", "first", "last"),
                       pairedAsSingle = FALSE,
                       clObj = NULL) {
    # validate parameters
    # ...proj
    if (!methods::is(proj, "qProject"))
        stop("'proj' must be a 'qProject' object")

    if (collapseBySample) {
        bamfiles <- split(
            proj@alignments$FileName,
            as.factor(proj@alignments$SampleName))[unique(proj@alignments$SampleName)]
        samplenames <- names(bamfiles)
    } else {
        bamfiles <- as.list(proj@alignments$FileName)
        samplenames <- proj@alignments$SampleName
    }
    n <- length(bamfiles)
    paired <- proj@paired != "no"

    # ...strand
    strand <- match.arg(strand) # checks if strand has length 1

    # ...tracknames
    if (is.null(tracknames)) {
        tracknames <- if (collapseBySample) samplenames else displayNames(proj)
        if (strand[1] != "*")
            tracknames <- sprintf("%s (%s)", tracknames, strand)
    }

    # ...file
    if (is.null(file)) {
        fileExt <- if (createBigWig) ".bw" else ".wig.gz"
        if (collapseBySample)
            file <- paste0(samplenames, fileExt)
        else
            file <- paste0(displayNames(proj), fileExt)
    } else if (length(file) != n) {
        stop(sprintf("the length of 'file' (%d) does not match the number of wig files to be generated (%d)", length(file), n))
    }
    if (createBigWig && any(!grepl(".bw$", file)))
        stop("file names have to end with '.bw' for createBigWig=TRUE")
    compressFormat <- compressedFileFormat(file)
    if (!all(compressFormat %in% c("none", "gzip")))
        stop("only gzip compressed wig files (extension '.gz') are supported")
    compress <- compressFormat == "gzip"
    if (length(compress) == 1)
        compress <- rep(compress, n)

    # ...binsize
    if (length(binsize) != 1)
        stop("'binsize' must be a single integer value")
    binsize <- as.integer(binsize)
    if (is.na(binsize) || binsize < 1)
        stop("'binsize' must be a positive integer value")

    # ...shift
    shift <- as.integer(shift)
    if (any(is.na(shift)))
        stop("'shift' has to be a vector of integer values")
    if (length(shift) != 1 && length(shift) != n)
        stop(sprintf("'shift' has to contain either a single value or one value per output wig file (%d)", n))
    if (paired && shift != 0L) {
        warning("ignoring 'shift' value for paired-end alignments (will calculate alignment-specific values)")
        shift <- 0L
    }
    if (length(shift) == 1)
        shift <- rep(shift, n)

    # ...scaling
    if (!(length(scaling) == 1L && (is.logical(scaling) || is.numeric(scaling))))
        stop("'scaling' needs to be a logical(1) or a numeric(1)")
    fact <- rep(1, n)
    if (is.numeric(scaling) || (is.logical(scaling) && scaling)) {
        message("collecting mapping statistics for scaling...", appendLF = FALSE)
        tmp <- alignmentStats(proj, collapseBySample = collapseBySample)
        N <- tmp[grepl(":genome$", rownames(tmp)), 'mapped']
        names(N) <- sub(":genome$", "", names(N))
        if (is.logical(scaling)) {
            #fact <- min(N) / N
            fact <- mean(N) / N
        } else if(is.numeric(scaling) && length(scaling) == 1L && scaling > 0) {
            fact <- scaling / N
        } else {
            stop("'scaling' must be greater than zero")
        }
        message("done")
    }

    # ...log2p1
    if (length(log2p1) != 1 || !is.logical(log2p1))
        stop("'log2p1' has to be either 'TRUE' or 'FALSE'")
    log2p1 <- rep(log2p1,n)

    # ...colors
    if (length(colors) < n)
        colors <- grDevices::colorRampPalette(colors)(n)
    colors <- apply(grDevices::col2rgb(colors), 2, paste, collapse = ",")

    # ...includeSecondary
    if (length(includeSecondary) != 1 || !is.logical(includeSecondary))
        stop("'includeSecondary' must be of type logical(1)")

    # ...mapping qualities
    if (length(mapqMin) != 1 || !is.integer(mapqMin) ||
        any(is.na(mapqMin)) || min(mapqMin) < 0L || max(mapqMin) > 255L)
        stop("'mapqMin' must be of type integer(1) and have a values between 0 and 255")
    mapqMin <- rep(mapqMin, n)
    if (length(mapqMax) != 1 || !is.integer(mapqMax) ||
        any(is.na(mapqMax)) || min(mapqMax) < 0L || max(mapqMax) > 255L)
        stop("'mapqMax' must be of type integer(1) and have a values between 0 and 255")
    mapqMax <- rep(mapqMax, n)

    # ...absolute insert size
    if ((!is.null(absIsizeMin) || !is.null(absIsizeMax)) && !paired)
        stop("'absIsizeMin' and 'absIsizeMax' can only be used for paired-end experiments")
    if (is.null(absIsizeMin)) # -1L -> do not apply TLEN filtering
        absIsizeMin <- -1L
    if (is.null(absIsizeMax))
        absIsizeMax <- -1L

    # ...useRead
    useRead <- match.arg(useRead)
    if (useRead != "any" && !paired) {
        warning("ignoring 'useRead' for single read experiments")
        useRead <- "any"
    } else if (paired && useRead != "any") {
        message("'useRead' is set - will treat alignments as single reads (no calculation of fragment midpoints)")
        paired <- FALSE
    } else if (pairedAsSingle) {
        if (paired) {
            message("'pairedAsSingle' is set - will treat alignments as single reads (no calculation of fragment midpoints)")
            paired <- FALSE
        } else {
            warning("ignoring 'pairedAsSingle' for single read experiments")
        }
    }

    # translate useRead parameter
    BAM_FREAD1 <- 64L
    BAM_FREAD2 <- 128L
    if (useRead == "any") {
        readBitMask <- BAM_FREAD1 + BAM_FREAD2
    } else if (useRead == "first") {
        readBitMask <- BAM_FREAD1
    } else if (useRead == "last") {
        readBitMask <- BAM_FREAD2
    }

    # generate the wig file(s)
    message("start creating ", if (createBigWig) "bigWig" else "wig"," file",
            if (n > 1) "s" else "", "...")
    tempwigfile <- if (createBigWig) vapply(seq_len(n),
                                            function(i) tempfile(fileext = ".wig"),
                                            "") else file
    if (createBigWig) {
        tmp <- Rsamtools::scanBamHeader(bamfiles[[1]][1])[[1]]$targets
        si <- Seqinfo::Seqinfo(names(tmp), tmp)
    }

    # digest clObj
    clparam <- getListOfBiocParallelParam(clObj)
    nworkers <- unlist(lapply(clparam, BiocParallel::bpworkers))
    # will use only one layer of parallelization, select best
    clsel <- which.max(nworkers)
    if (!inherits(clparam[[clsel]], c("BatchJobsParam", "SerialParam"))) {
        # don't test loading of QuasR on current or BatchJobs cluster nodes
        message("preparing to run on ", min(n, nworkers[clsel]),
                " ", class(clparam[[clsel]]), " nodes...", appendLF = FALSE)
        ret <- BiocParallel::bplapply(seq.int(nworkers[clsel]),
                                      function(i) library(QuasR),
                                      BPPARAM = clparam[[clsel]])
        if (!all(vapply(ret, function(x) "QuasR" %in% x, TRUE)))
            stop("'QuasR' package could not be loaded on all nodes")
        message("done")
    }

    # avoid nested parallelization
    if (!inherits(clparam[[clsel]], "SerialParam"))
        nthreads <- .Call(ShortRead:::.set_omp_threads, 1L)

    BiocParallel::bplapply(seq_len(n), function(i) {
        message("  ",file[i]," (",tracknames[i],")")
        .Call(bamfileToWig, as.character(bamfiles[[i]]),
              as.character(tempwigfile[i]), as.logical(paired[1]),
              as.integer(binsize[1]), as.integer(shift[i]),
              as.character(strand[1]), as.numeric(fact[i]),
              as.character(tracknames[i]), as.logical(log2p1[i]),
              as.character(colors[i]), as.logical(compress[i]),
              as.logical(includeSecondary[1]),
              mapqMin[i], mapqMax[i], as.integer(absIsizeMin),
              as.integer(absIsizeMax), readBitMask)
        if (createBigWig) {
            rtracklayer::wigToBigWig(tempwigfile[i], si, file[i])
            unlink(tempwigfile[i])
        }
    }, BPPARAM = clparam[[clsel]])

    # reset to nthreads
    if (!inherits(clparam[[clsel]], "SerialParam"))
        .Call(ShortRead:::.set_omp_threads, nthreads)

    message("done")

    return(invisible(file))
}

# proj        : qProject object, fasta file, fastq file or bam file
# pdfFilename : Name of the output file. If NULL then the graph are displayed
# chunkSize   : chunk/yield size of the sample
# clObj       : cluster object for parallelization

#' @keywords internal
#' @importFrom ShortRead FastqSampler yield width readFasta ShortReadQ
#' @importFrom Rsamtools BamFile scanBam ScanBamParam
#' @importFrom Biostrings reverseComplement
#' @importFrom IRanges reverse
#' @importFrom GenomicFiles REDUCEsampler reduceByYield
calcQaInformation <- function(filename, label, filetype, chunkSize) {
    if (any(filetype == "fasta") &&
        any(compressedFileFormat(filename) != "none")) {
        warning("compressed 'fasta' input is not yet supported")
        return(NULL)
    } else {
        reads <- switch(as.character(filetype),
                        fastq = {
                            f <- ShortRead::FastqSampler(filename, n = chunkSize)
                            reads <- ShortRead::yield(f)
                            close(f)
                            reads[ShortRead::width(reads) > 0]
                        },
                        fasta = {
                            reads <- ShortRead::readFasta(as.character(filename),
                                                          nrec = chunkSize)
                            reads[ShortRead::width(reads) > 0]
                        },
                        bam = {
                            bf <- Rsamtools::BamFile(filename, yieldSize = 1e6)
                            myyield <- function(x) {
                                tmp <- Rsamtools::scanBam(
                                    x, param = Rsamtools::ScanBamParam(what = c("seq", "qual", "strand"))
                                )[[1]]
                                minusStrand <- !is.na(tmp$strand) & tmp$strand == "-"
                                ShortRead::ShortReadQ(
                                    sread = c(tmp$seq[!minusStrand],
                                              Biostrings::reverseComplement(tmp$seq[minusStrand])),
                                    quality = c(tmp$qual[!minusStrand],
                                                IRanges::reverse(tmp$qual[minusStrand]))
                                )
                            }
                            reads <- GenomicFiles::reduceByYield(
                                X = bf, YIELD = myyield, MAP = identity,
                                REDUCE = GenomicFiles::REDUCEsampler(sampleSize = chunkSize, verbose = FALSE),
                                parallel = FALSE
                            )
                            reads[ShortRead::width(reads) > 0]
                        })
    }
    return(qa(reads, label))
}

#' @keywords internal
#' @importFrom Rsamtools FaFile scanFaIndex getSeq
#' @importFrom IRanges IRanges breakInChunks
#' @importFrom GenomicRanges GRanges GRangesList seqnames
#' @importFrom Seqinfo seqlengths
#' @importFrom BSgenome getSeq
#' @importFrom BiocGenerics unlist match start
#' @importFrom methods is
calcMmInformation <- function(filename, genome, chunkSize) {

    # get bamfile index statistics
    stats <- as.data.frame(.Call(idxstatsBam, filename))
    # get chromosome with mapped reads
    trg <- stats$mapped
    names(trg) <- stats$seqname
    selChr <- names(trg)[trg != 0]

    # get sequence length
    if (methods::is(genome, "BSgenome")) {
        # BSgenome
        ref <- genome
        seqlen <- Seqinfo::seqlengths(ref)[selChr]
    } else {
        # Fasta File
        ref <- Rsamtools::FaFile(genome)
        seqInfo <- Rsamtools::scanFaIndex(ref)
        seqlen <- Seqinfo::seqlengths(seqInfo)[selChr]
    }

    # if no mapped alignments then return array of NAs
    if (length(seqlen) == 0) {
        mmDist <- list(
            array(NA,
                  dim = c(5, 5, 30),
                  dimnames = list(ref = c("A", "C", "G", "T", "N"),
                                  read = c("A", "C", "G", "T", "N"))),
            array(NA,
                  dim = c(5, 5, 30),
                  dimnames = list(ref = c("A", "C", "G", "T", "N"),
                                  read = c("A", "C", "G", "T", "N"))),
            rep(NA, 100),
            rep(NA, 2)
        )
        return(mmDist)
    }

    # create query regions
    if (sum(trg[selChr]) <= chunkSize) {
        # number of mapped reads is smaller or equal than chunkSize
        # query all chromosome with mapped reads
        gr <- GenomicRanges::GRanges(seqnames = names(seqlen),
                                     ranges = IRanges::IRanges(1, seqlen))
    } else {
        # number of mapped reads is bigger than chunkSize
        #  total number of alignments: sum(trg[selChr])
        #  fraction of alignments to be sampled: chunkSize / sum(trg[selChr])
        #  assuming uniform coverage, fraction of chromosome to retrieve: fraction of alignments to be samples * chromosome length
        reflen <- ceiling(chunkSize / sum(trg[selChr]) * seqlen[selChr])
        # use only chromosoms with the most mapped reads
        #seq <- names(sort(trg[selChr], decreasing=T)[seq_len(ceiling(length(trg[selChr]) * chunkSize / sum(trg[selChr])))])
        seq <- selChr
        gr <- BiocGenerics::unlist(GenomicRanges::GRangesList(lapply(seq, function(s) {
            GenomicRanges::GRanges(
                seqnames = s,
                ranges = IRanges::breakInChunks(seqlen[s],
                                                chunksize = reflen[s])
            )
        })))
        rm(seq, reflen)
    }

    # get nucleotide alignment frequencies
    cntFor <- 0
    maxLen <- 0
    # allocate result vector for "nucleotideAlignmentFrequencies" function
    mmDist <- list(integer(25*1000), # mismatch distribution read1
                   integer(25*1000), # mismatch distribution read2
                   integer(10000), # fragment length distribution
                   integer(2)) # uniqueness (unique/total)
    set.seed(0)
    for (s in sample(length(gr))) {
        refseq <- as.character(getSeq(ref, gr[s], as.character = FALSE))
        reftid <- as.integer(BiocGenerics::match(GenomicRanges::seqnames(gr[s]),
                                                 names(trg)) - 1)
        refstart <- BiocGenerics::start(gr[s])
        len <- .Call(nucleotideAlignmentFrequencies, filename, refseq, reftid,
                     refstart, mmDist, as.integer(chunkSize))
        if (len > maxLen)
            maxLen <- len
        if (sum(mmDist[[1]][seq_len(25)]) >= chunkSize ||
            sum(mmDist[[2]][seq_len(25)]) >= chunkSize)
            break
        cntFor <- cntFor + 1
    }

    mmDist[[1]] <- array(mmDist[[1]],
                         dim = c(5, 5, maxLen),
                         dimnames = list(ref = c("A", "C", "G", "T", "N"),
                                         read = c("A", "C", "G", "T", "N"),
                                         pos = seq_len(maxLen)))
    mmDist[[2]] <- array(mmDist[[2]],
                         dim = c(5, 5, maxLen),
                         dimnames = list(ref = c("A", "C", "G", "T", "N"),
                                         read = c("A", "C", "G", "T", "N"),
                                         pos = seq_len(maxLen)))
    names(mmDist[[3]]) <- c(seq_len(length(mmDist[[3]]) - 1),
                            paste(">", length(mmDist[[3]]) - 1, sep = ""))
    names(mmDist) <- c("NucleotidMismatchRead1", "NucleotidMismatchRead2",
                       "FragmentLength", "Uniqueness")
    return(mmDist)
}

#' QuasR Quality Control Report
#'
#' Generate quality control plots for a \code{qProject} object or a vector of
#' fasta/fastq/bam files. The available plots vary depending on the types of
#' available input (fasta, fastq, bam files or \code{qProject} object;
#' paired-end or single-end).
#'
#' This function generates quality control plots for all input files or the
#' sequence and alignment files contained in a \code{qProject} object,
#' allowing assessment of the quality of a sequencing experiment.
#' \code{qQCReport} uses functionality from the \pkg{ShortRead} package to
#' collect quality data, and visualizes the results similarly as the
#' \sQuote{FastQC} quality control tool from Simon Andrews (see
#' \sQuote{References} below). It is recommended to create PDF reports
#' (\code{pdfFilename} argument), for which the plot layouts have been optimised.
#'
#' Some plots will only be generated if the necessary information is available
#' (e.g. base qualities in fastq sequence files).
#'
#' The currently available plot types are:
#' \describe{
#'   \item{\emph{Quality score boxplot}}{shows the distribution of
#'         base quality values as a box plot for each position in the input
#'         sequence. The background color (green, orange or red)
#'         indicates ranges of high, intermediate and low qualities.}
#'   \item{\emph{Nucleotide frequency}}{plot shows the frequency of A, C,
#'         G, T and N bases by position in the read.}
#'   \item{\emph{Duplication level}}{plot shows for each sample the
#'         fraction of reads observed at different duplication levels
#'         (e.g. once, two-times, three-times, etc.). In addition, the most
#'         frequent sequences are listed.}
#'   \item{\emph{Mapping statistics}}{shows fractions of reads that were
#'         (un)mappable to the reference genome.}
#'   \item{\emph{Library complexity}}{shows fractions of unique
#'         read(-pair) alignment positions, as a measure of the complexity in
#'         the sequencing library. Please note that this measure is not
#'         independent from the total number of reads in a library, and is best
#'         compared between libraries of similar sizes.}
#'   \item{\emph{Mismatch frequency}}{shows the frequency and position
#'         (relative to the read sequence) of mismatches in the alignments
#'         against the reference genome.}
#'   \item{\emph{Mismatch types}}{shows the frequency of
#'         read bases that caused mismatches in the alignments to the
#'         reference genome, separately for each genome base.}
#'   \item{\emph{Fragment size}}{shows the distribution of fragment sizes
#'         inferred from aligned read pairs.}
#' }
#'
#' One approach to assess the quality of a sample is to compare its
#' control plots to the ones from other samples and search for relative
#' differences. Special quality measures are expected for certain types
#' of experiments: A genomic re-sequencing sample with an
#' overrepresentation of T bases may be suspicious, while such a
#' nucleotide bias is normal for a directed bisulfite-sequencing sample.
#'
#' Additional arguments can be passed to the internal functions that
#' generate the individual quality control plots using \code{\dots{}}:
#' \describe{
#'   \item{\code{lmat}:}{a matrix (e.g. \code{matrix(1:12, ncol=2)}) used
#'         by an internal call to the \code{layout} function to specify the
#'         positioning of multiple plot panels on a device page. Individual panels
#'         correspond to different samples.}
#'   \item{\code{breaks}:}{a numerical vector
#'         (e.g. \code{c(1:10)}) defining the bins used by
#'         the \sQuote{Duplication level} plot.}
#' }
#'
#' @returns
#' The function is called for its side effect of generating quality
#' control plots. It invisibly returns a list with components that contain the
#' data used to generate each of the QC plots. Available components are
#' (depending on input data, see \sQuote{Details}):
#' \describe{
#'   \item{\emph{qualByCycle}}{: quality score boxplot}
#'   \item{\emph{nuclByCycle}}{: nucleotide frequency plot}
#'   \item{\emph{duplicated}}{: duplication level plot}
#'   \item{\emph{mappings}}{: mapping statistics barplot}
#'   \item{\emph{uniqueness}}{: library complexity barplot}
#'   \item{\emph{errorsByCycle}}{: mismatch frequency plot}
#'   \item{\emph{mismatchTypes}}{: mismatch type plot}
#'   \item{\emph{fragDistribution}}{: fragment size distribution plot}
#' }
#'
#' @references
#' FastQC quality control tool at
#' \url{http://www.bioinformatics.bbsrc.ac.uk/projects/fastqc/}
#'
#' @author Anita Lerch, Dimos Gaidatzis and Michael Stadler
#'
#' @export
#'
#' @seealso
#' \code{\linkS4class{qProject}}, \code{\link{qAlign}},
#' \code{\link[ShortRead:ShortReadBase-package]{ShortRead}} package
#'
#' @keywords methods
#'
#' @param input A vector of files or a \code{qProject} object as returned by
#'   \code{qAlign}.
#' @param pdfFilename The path and name of a pdf file to store the report.
#'   If \code{NULL}, the quality control plots will be generated in separate
#'   plotting windows on the standard graphical device.
#' @param chunkSize The number of sequences, sequence pairs (for paired-end
#'   data) or alignments that will be sampled from each data file to collect
#'   quality statistics.
#' @param useSampleNames If TRUE, the plots will be labelled using the sample
#'   names instead of the file names. Sample names are obtained from the
#'   \code{qProject} object, or from \code{names(input)} if \code{input} is a
#'   named vector of file names. Please not that if there are multiple files
#'   for the same sample, the sample names will not be unique.
#' @param clObj A cluster object to be used for parallel processing of multiple
#'   input files.
#' @param a4layout A logical scalar. If TRUE, the output of mapping rate and
#'   uniqueness plots will be adjusted for a4 format devices.
#' @param \dots Additional arguments that will be passed to the functions
#' generating the individual quality control plots, see \sQuote{Details}.
#'
#' @name qQCReport
#' @aliases qQCReport
#'
#' @importFrom grDevices dev.new pdf dev.cur dev.off
#' @importFrom BiocParallel bplapply bpmapply bpworkers
#' @importFrom Rsamtools scanFaIndex FaFile BamFile
#' @importFrom methods is
#' @importFrom graphics par
#' @importFrom Seqinfo seqlengths
#'
#' @examples
#' # copy example data to current working directory
#' file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)
#'
#' # create alignments
#' sampleFile <- "extdata/samples_chip_single.txt"
#' genomeFile <- "extdata/hg19sub.fa"
#'
#' proj <- qAlign(sampleFile, genomeFile)
#'
#' # create quality control report
#' qQCReport(proj, pdfFilename="qc_report.pdf")
#'
qQCReport <- function(input, pdfFilename = NULL, chunkSize = 1e6L,
                      useSampleNames = FALSE, clObj = NULL, a4layout = TRUE, ...) {
    if (grDevices::dev.cur() != 1L) { # only query current par if a device is open
        gpars <- graphics::par(no.readonly = TRUE)
        on.exit(graphics::par(gpars))
    }
    # 'proj' is correct type?
    if (inherits(input, "qProject", which = FALSE)) {
        filetype <- input@samplesFormat
        if (input@paired == "no") {
            readFilename <- if (filetype == "bam") input@alignments$FileName else input@reads$FileName
            if (useSampleNames) {
                label <- sprintf("%i. %s", seq_along(readFilename),
                                 input@alignments$SampleName)
            } else {
                label <- sprintf("%i. %s", seq_along(readFilename),
                                 basename(readFilename))
            }
            mapLabel <- label
        } else {
            if (filetype == "bam") {
                readFilename <- rep(input@alignments$FileName, each = 2)
                if (useSampleNames) {
                    label <- sprintf("%i(R%i). %s",
                                     rep(seq_len(nrow(input@alignments)),
                                         each = 2),
                                     seq_len(2),
                                     rep(input@alignments$SampleName, each = 2))
                    mapLabel <- sprintf("%i. %s", seq_len(nrow(input@alignments)),
                                        input@alignments$SampleName)
                } else {
                    label <- sprintf("%i(R%i). %s",
                                     rep(seq_len(nrow(input@alignments)),
                                         each = 2),
                                     seq_len(2), basename(readFilename))
                    mapLabel <- sprintf("%i. %s", seq_len(nrow(input@alignments)),
                                        basename(input@alignments$FileName))
                }
            } else {
                readFilename <- as.vector(rbind(input@reads$FileName1,
                                                input@reads$FileName2))
                if (useSampleNames) {
                    label <- sprintf("%i(R%i). %s",
                                     rep(seq_len(nrow(input@reads)), each = 2),
                                     seq_len(2),
                                     rep(input@reads$SampleName, each = 2))
                    mapLabel <- sprintf("%i. %s", seq_len(nrow(input@reads)),
                                        input@reads$SampleName)
                } else {
                    label <- sprintf("%i(R%i). %s",
                                     rep(seq_len(nrow(input@reads)), each = 2),
                                     seq_len(2),
                                     basename(readFilename))
                    mapLabel <- sprintf("%i. %s", seq_len(nrow(input@reads)),
                                        basename(input@reads$FileName1))
                }
            }
        }
        alnFilename <- input@alignments$FileName
        if (input@genomeFormat == "BSgenome") {
            require(input@genome, character.only = TRUE, quietly = TRUE)
            genome <- get(input@genome)
        } else {
            genome <- input@genome
        }
    } else if (is.character(input)) {
        filetype <- unique(consolidateFileExtensions(input, compressed = TRUE))
        if (length(filetype) > 1L)
            stop("parameter 'input' must consist of unique filetype")
        if (useSampleNames && !is.null(names(input))) {
            label <- sprintf("%i. %s", seq_along(input), names(input))
        } else {
            label <- sprintf("%i. %s", seq_along(input), basename(input))
        }
        mapLabel <- label
        if (all(file.exists(input))) {
            if (filetype != "bam") {
                readFilename <- input
                alnFilename <- NULL
                genome <- NULL
            } else {
                readFilename <- input
                alnFilename <- input
                genome <- NULL
            }
        } else {
            stop("could not find the files '", paste(input[!file.exists(input)],
                                                     collapse = " "), "'")
        }
    } else {
        stop("'input' must be an object of type 'qProject' (returned by 'qAlign') or filenames")
    }

    # digest clObj
    clparam <- getListOfBiocParallelParam(clObj)
    nworkers <- unlist(lapply(clparam, BiocParallel::bpworkers))
    clsel <- which.max(nworkers) # will use only one layer of parallelization, select best
    if (!inherits(clparam[[clsel]], c("BatchJobsParam","SerialParam"))) { # don't test loading of QuasR on current or BatchJobs cluster nodes
        message("preparing to run on ", min(length(readFilename),nworkers[clsel]),
                " ", class(clparam[[clsel]]), " nodes...", appendLF = FALSE)
        ret <- BiocParallel::bplapply(seq.int(nworkers[clsel]),
                                      function(i) library(QuasR), BPPARAM = clparam[[clsel]])
        if (!all(vapply(ret, function(x) "QuasR" %in% x, TRUE)))
            stop("'QuasR' package could not be loaded on all nodes")
        message("done")
    }

    message("collecting quality control data")
    # FASTQ/A quality control
    if (!inherits(clparam[[clsel]], "SerialParam"))
        nthreads <- .Call(ShortRead:::.set_omp_threads, 1L) # avoid nested parallelization
    qc1L <- BiocParallel::bpmapply(
        calcQaInformation, readFilename, label,
        MoreArgs = list(filetype = filetype, chunkSize = chunkSize),
        BPPARAM = clparam[[clsel]]
    )
    if (!inherits(clparam[[clsel]], "SerialParam"))
        .Call(ShortRead:::.set_omp_threads, nthreads)
    qa <- do.call(ShortRead::rbind, qc1L)

    # BAM quality control, mismatch distribution
    if (!is.null(alnFilename) && !is.null(genome)) {

        # get bamfile index statistics for all bam files
        seqLen_bam_compatL <- lapply(alnFilename, function(x)
            Seqinfo::seqlengths(Rsamtools::BamFile(x)))

        # get sequence length of the genome
        if (methods::is(genome, "BSgenome")) {
            # BSgenome
            seqlen_genome_compat <- Seqinfo::seqlengths(genome)
        } else {
            # Fasta File
            seqlen_genome_compat <-
                Seqinfo::seqlengths(Rsamtools::scanFaIndex(Rsamtools::FaFile(genome)))
        }

        # test if all sequence lengths in all bam files as well as the
        # genome are identical
        # ... add the sequences lengths of the genome to the sequence
        # lengths of all bam files
        seqlen_all_compatL <- c(list(seqlen_genome_compat), seqLen_bam_compatL)

        # ... sort by sequence name in case there is a difference in the order
        seqlen_all_compat_sort_L <- lapply(seqlen_all_compatL, function(x) x[order(names(x))])

        # ... check if sequence lengths are identical
        dupStatus <- !duplicated(seqlen_all_compat_sort_L)[-1]
        if (sum(dupStatus) != 0){
            stop("The chromosome names/lengths in the specified genome do not match the ones in the provided bam files")
        }

        distL <- BiocParallel::bplapply(
            alnFilename, calcMmInformation, genome = genome,
            chunkSize = chunkSize, BPPARAM = clparam[[clsel]]
        )

        if (input@paired == "no") {
            unique <- lapply(distL,"[[", 4)
            frag <- NULL
            mm <- lapply(distL,"[[", 1)
        } else {
            unique <- lapply(distL,"[[", 4)
            frag <- lapply(distL,"[[", 3)
            names(frag) <- mapLabel
            mm <- do.call(c, lapply(distL,"[", c(1,2)))
        }
        names(unique) <- mapLabel
        names(mm) <- label
    } else {
        unique <- NULL
        mm <- NULL
        frag <- NULL
    }

    # open/close pdf stream
    if (!is.null(pdfFilename)) {
        grDevices::pdf(pdfFilename, paper = "default", onefile = TRUE,
                       width = 0, height = 0)
        on.exit(grDevices::dev.off())
    }

    # Plot
    message("creating QC plots")
    plotdata <- list(raw = list(qa = qa, mm = mm, frag = frag,
                                unique = unique, mapdata = NULL))
    if (!is.null(qa)) {
        if (filetype == "fastq" || filetype == "bam") {
            if (is.null(pdfFilename))
                grDevices::dev.new()
            plotdata[['qualByCycle']] <- plotQualByCycle(qa, ...)
        }

        if (is.null(pdfFilename))
            grDevices::dev.new()
        plotdata[['nuclByCycle']] <- plotNuclByCycle(qa, ...)

        if (is.null(pdfFilename))
            grDevices::dev.new()
        plotdata[['duplicated']] <- plotDuplicated(qa, ...)

    } else if (!is.null(mm)) {
        if (is.null(pdfFilename))
            grDevices::dev.new()
        plotdata[['nuclByCycle']] <- plotNuclByCycle(mm, ...)
    }

    if (!is.null(alnFilename)) {
        # get bamfile index statistics
        mapdata <- lapply(alnFilename, function(file) {
            .get_alnstats_for_bam(file)[c("mapped", "unmapped")]
        })
        mapdata <- as.data.frame(do.call(rbind, mapdata))
        rownames(mapdata) <- mapLabel
        plotdata[['raw']][['mapdata']] <- mapdata
        if (is.null(pdfFilename))
            grDevices::dev.new()
        plotdata[['mappings']] <- plotMappings(mapdata, a4layout = a4layout, ...)
    }

    if (!is.null(unique)) {
        if (is.null(pdfFilename))
            grDevices::dev.new()
        plotdata[['uniqueness']] <- plotUniqueness(unique, a4layout = a4layout, ...)
    }

    if (!is.null(mm)) {
        if (is.null(pdfFilename))
            grDevices::dev.new()
        plotdata[['errorsByCycle']] <- plotErrorsByCycle(mm, ...)

        if (is.null(pdfFilename))
            grDevices::dev.new()
        plotdata[['mismatchTypes']] <- plotMismatchTypes(mm, ...)
    }

    if (!is.null(frag)) {
        if (is.null(pdfFilename))
            grDevices::dev.new()
        plotdata[['fragDistribution']] <- plotFragmentDistribution(frag, ...)
    }

    invisible(plotdata)
}

#' @keywords internal
#' @importFrom graphics strwidth
truncStringToPlotWidth <- function(s, plotwidth) {
    sw <- graphics::strwidth(s)
    if (any(sw > plotwidth)) {
        w <- 10 # number of character to replace with ".."
        l <- nchar(s)
        news <- s
        i <- sw > plotwidth
        while (any(w < l) && any(i)) {
            news <- ifelse(i, paste(substr(s, 1, ceiling((l - w)/2) + 5),
                                    substr(s, floor((l + w)/2) + 5, l),
                                    sep = "..."), news)
            sw <- graphics::strwidth(news)
            i <- sw > plotwidth
            w <- w + 2
        }
        return(news)
    } else {
        return(s)
    }
}

#' @keywords internal
#' @importFrom S4Vectors Rle
#' @importFrom graphics layout par box text rect plot
#' @importFrom stats quantile
#' @importFrom BiocGenerics which
plotQualByCycle <- function(qcdata,
                            lmat = matrix(1:12, nrow = 6, byrow = TRUE)) {
    data <- qcdata[['perCycle']][['quality']]
    qtiles <- by(list(data$Score, data$Count), list(data$lane, data$Cycle), function(x) {
        coef <- 1.5
        scoreRle <- S4Vectors::Rle(x[[1]], x[[2]])
        n <- length(scoreRle)
        nna <- !is.na(scoreRle)
        stats <- c(min(scoreRle), stats::quantile(scoreRle, c(0.25, 0.5, 0.75)),
                   max(scoreRle))
        iqr <- diff(stats[c(2, 4)])
        out <- if (!is.na(iqr)) {
            scoreRle < (stats[2L] - coef * iqr) | scoreRle > (stats[4L] + coef * iqr)
        } else !is.finite(scoreRle)
        if (any(out[nna], na.rm = TRUE))
            stats[c(1, 5)] <- range(scoreRle[!out], na.rm = TRUE)
        conf <- stats[3L] + c(-1.58, 1.58) * iqr/sqrt(n)
        list(stats = stats, n = n, conf = conf, out = BiocGenerics::which(out))
    }, simplify = FALSE)
    ns <- nrow(qtiles)

    qtilesL <- lapply(seq_len(ns), function(i) {
        tmpconf <- do.call(cbind, lapply(qtiles[i, ], "[[", 'conf'))
        tmpxn <- ncol(tmpconf)
        list(stats = do.call(cbind, lapply(qtiles[i, ][seq_len(tmpxn)],
                                           "[[", 'stats')),
             n = sapply(qtiles[i, ][seq_len(tmpxn)], "[[", 'n'),
             conf = tmpconf,
             out = numeric(0),
             group = numeric(0),
             names = colnames(tmpconf))
    })
    names(qtilesL) <- rownames(qtiles)

    graphics::layout(lmat)
    for (i in seq_len(ns)) {
        xn <- length(qtilesL[[i]]$names)
        ym <- max(35, max(qtilesL[[i]]$stats))
        graphics::par(mar = c(5 - 1, 4 - 1, 4 - 4, 2 - 1) + .1,
                      mgp = c(3 - 1, 1 - 0.25, 0))
        graphics::plot(0:1, 0:1, type = "n", xlab = "Position in read (bp)",
                       ylab = "Quality score", xlim = c(0, xn) + 0.5,
                       xaxs = "i", ylim = c(0, ym))
        graphics::rect(xleft = seq.int(xn) - 0.5, ybottom = -10,
                       xright = seq.int(xn) + 0.5,
                       ytop = 20, col = c("#e6afaf", "#e6c3c3"), border = NA)
        graphics::rect(xleft = seq.int(xn) - 0.5, ybottom = 20,
                       xright = seq.int(xn) + 0.5,
                       ytop = 28, col = c("#e6d7af", "#e6dcc3"), border = NA)
        graphics::rect(xleft = seq.int(xn) - 0.5, ybottom = 28,
                       xright = seq.int(xn) + 0.5,
                       ytop = ym + 10, col = c("#afe6af", "#c3e6c3"), border = NA)
        do.call("bxp", c(list(qtilesL[[i]], notch = FALSE, width = NULL,
                              varwidth = FALSE, log = "",
                              border = graphics::par('fg'),
                              pars = list(boxwex = 0.8, staplewex = 0.5,
                                          outwex = 0.5,
                                          boxfill = "#99999944"),
                              outline = FALSE, horizontal = FALSE, add = TRUE,
                              at = seq_len(xn), axes = FALSE)))
        cxy <- graphics::par('cxy')
        graphics::text(x = graphics::par('usr')[1] + cxy[1] / 4,
                       y = graphics::par('usr')[3] + cxy[2] / 4, adj = c(0, 0),
                       labels = truncStringToPlotWidth(
                           rownames(qtiles)[i],
                           diff(graphics::par("usr")[c(1, 2)]) - cxy[1] / 2))
        graphics::box()
    }

    invisible(qtilesL)
}

#' @keywords internal
#' @importFrom graphics layout par abline strwidth text matplot
plotNuclByCycle <- function(qcdata,
                            lmat = matrix(1:12, nrow = 6, byrow = TRUE)) {
    if (!is.null(qcdata[['perCycle']])) {
        data <- qcdata[['perCycle']][['baseCall']]
        nfreq <- by(list(data$Base, data$Count), list(data$lane, data$Cycle), function(x) {
            y <- x[[2]] / sum(x[[2]]) * 100
            names(y) <- x[[1]]
            y
        }, simplify = TRUE)
        ns <- nrow(nfreq)

        nfreqL <- lapply(seq_len(ns), function(i) {
            tmp <- do.call(cbind, lapply(nfreq[i, ],
                                         function(x) x[c('A', 'C', 'G', 'T', 'N')]))
            tmp[is.na(tmp)] <- 0
            rownames(tmp) <- c('A', 'C', 'G', 'T', 'N')
            tmp
        })
        names(nfreqL) <- rownames(nfreq)
    } else {
        nfreqL <- lapply(qcdata, function(x){
            nfreq <- do.call(rbind, lapply(seq_len(dim(x)[3]), function(j) {
                c(A = sum(x[, "A", j]),
                  C = sum(x[, "C", j]),
                  G = sum(x[, "G", j]),
                  T = sum(x[, "T", j]),
                  N = sum(x[, "N", j]))
            }))
            rownames(nfreq) <- seq_len(dim(x)[3])
            t(nfreq / rowSums(nfreq) * 100)
        })
        ns <- length(nfreqL)
        #         names(nfreqL) <- names(qcdata)
    }
    nfreqL[is.na.data.frame(nfreqL)] <- 0

    mycols <- c("#5050ff", "#e00000", "#00c000", "#e6e600", "darkgray")
    graphics::layout(lmat)
    for (i in seq_len(ns)) {
        xn <- ncol(nfreqL[[i]])
        ym <- max(50, ceiling(max(nfreqL[[i]], na.rm = TRUE) / 5) * 5 + 5)
        graphics::par(mar = c(5 - 1, 4 - 1, 4 - 4, 2 - 1) + .1,
                      mgp = c(3 - 1, 1 - 0.25, 0))
        graphics::matplot(seq_len(xn), t(nfreqL[[i]]), type = "o",
                          xlab = "Position in read (bp)",
                          ylab = "Nucleotide frequency (%)",
                          xlim = c(0, xn) + 0.5, xaxs = "i", ylim = c(0, ym),
                          lwd = 2, lty = 1, pch = 20, cex = 0.6, col = mycols)
        graphics::abline(h = 0, lty = 2, col = "gray")
        cxy <- graphics::par('cxy')
        graphics::text(x = graphics::par('usr')[1] + cxy[1]/4,
                       y = graphics::par('usr')[4] - cxy[2]/4, adj = c(0, 1),
                       labels = truncStringToPlotWidth(
                           names(nfreqL)[i],
                           diff(graphics::par('usr')[c(1, 2)]) - 1.5 * cxy[1] -
                               graphics::strwidth(paste(rownames(nfreqL[[i]]),
                                                        collapse = " "))))
        graphics::text(x = graphics::par('usr')[2] - cxy[1] / 4 -
                           seq(4, 0) * cxy[1] * 0.8,
                       y = graphics::par('usr')[4] - cxy[2] / 4,
                       adj = c(1, 1), col = mycols,
                       labels = rownames(nfreqL[[i]]))
    }

    invisible(nfreqL)
}

#' @keywords internal
#' @importFrom S4Vectors Rle runValue runLength
#' @importFrom graphics layout par abline axis box strwidth strheight text plot
plotDuplicated <- function(qcdata,
                           breaks = 1:10,
                           lmat = matrix(1:6, nrow = 3, byrow = TRUE)) {
    if (breaks[length(breaks)] < Inf)
        breaks <- c(breaks, breaks[length(breaks)] + 1, Inf)
    breakNames <- c(as.character(breaks[seq_len(length(breaks) - 2)]),
                    paste(">", breaks[length(breaks) - 2], sep = ""))
    data <- qcdata[['sequenceDistribution']]
    nocc <- by(list(data$nOccurrences, data$nReads), list(data$lane),
               function(x) S4Vectors::Rle(values = x[[1]], lengths = x[[2]]),
               simplify = FALSE)
    ns <- nrow(nocc)

    nbin <- length(breaks) - 1
    bocc <- do.call(rbind, lapply(seq_len(ns), function(i) {
        bin <- findInterval(S4Vectors::runValue(nocc[[i]]), breaks)
        tmp <- tapply(S4Vectors::runLength(nocc[[i]]), bin, sum)/length(nocc[[i]]) * 100
        tmp2 <- numeric(nbin)
        tmp2[as.integer(names(tmp))] <- tmp
        tmp2
    }))
    dimnames(bocc) <- list(sampleName = rownames(nocc), duplicationLevel = breakNames)

    graphics::layout(lmat)
    for (i in seq_len(ns)) {
        nm <- rownames(nocc)[i]
        fs <- qcdata[['frequentSequences']]
        fs <- fs[fs$lane == nm, ]
        xn <- length(breaks) - 1
        ym <- max(50,ceiling(max(bocc[i, ]) / 5) * 5)
        graphics::par(mar = c(5 - 1, 4 - 1, 4 - 4, 2 - 1) + .1,
                      mgp = c(3 - 1, 1 - 0.25, 0))
        graphics::plot(seq_len(xn), bocc[i, ], type = "o",
                       xlab = "Sequence duplication level",
                       ylab = "Percent of unique sequences",
                       xlim = c(0, xn) + 0.5, xaxs = "i",
                       ylim = c(0, ym), lwd = 2,
                       lty = 1, pch = 20, cex = 0.6, axes = FALSE,
                       panel.first = graphics::abline(h = 0, lty = 2, col = "gray"))
        graphics::axis(1, at = seq_len(xn), labels = breakNames)
        graphics::axis(2)
        graphics::box()
        frqseqcex <- 0.8
        frqseqS <- sprintf("%-*s", max(nchar(as.character(fs[, 'sequence']))),
                           fs[, 'sequence'])
        frqseqF <- sprintf("(%6.0f)", fs[, 'count']/sum(S4Vectors::runValue(nocc[[i]])*as.numeric(S4Vectors::runLength(nocc[[i]])))*1e6)
        frqseqJ <- " "
        frqseqW <- max(nchar(as.character(fs[, 'sequence'])))
        xleft <- graphics::par('usr')[2] -
            max(graphics::strwidth(paste(frqseqS, " ", frqseqF, sep = ""),
                                   cex = frqseqcex, family = "mono"))
        while (xleft < 1 && frqseqW > 7) {
            frqseqJ <- ".. "
            frqseqW <- frqseqW - 2
            frqseqS <- strtrim(frqseqS,frqseqW)
            xleft <- graphics::par('usr')[2] -
                max(graphics::strwidth(paste(frqseqS, frqseqJ, frqseqF, sep = ""),
                                       cex = frqseqcex, family = "mono"))
        }
        if (xleft >= 1 && frqseqW > 5) {
            cxy <- graphics::par('cxy')
            ytop <- graphics::par('usr')[4] - 2.0*cxy[2]
            yoff <- ytop - 1.8*cumsum(graphics::strheight(frqseqS, cex = frqseqcex,
                                                          family = "mono"))
            ii <- yoff +
                diff(yoff[c(1, 2)]) > max(bocc[i, seq_len(xn) > floor(xleft)])
            if (any(ii)) {
                graphics::text(x = xleft, y = ytop, adj = c(0, 0),
                               labels = paste(truncStringToPlotWidth(
                                   nm, graphics::par("usr")[2] -
                                       xleft - cxy[1]/2),
                                   "frequent sequences (per Mio.):", sep = "\n"))
                graphics::text(x = xleft, y = yoff[ii], adj = c(0, 1),
                               labels = paste(frqseqS, frqseqJ, frqseqF, sep = "")[ii],
                               family = "mono", cex = frqseqcex)
            } else {
                graphics::text(x = xleft, y = ytop, adj = c(0, 0),
                               labels = truncStringToPlotWidth(
                                   nm, graphics::par("usr")[2] - xleft - cxy[1]/2))
            }
        }
    }

    invisible(bocc)
}

#' @keywords internal
#' @importFrom graphics layout par text legend barplot plot
plotMappings <- function(mapdata,
                         cols = c("#006D2C", "#E41A1C"),
                         a4layout = TRUE) {
    nr <- nrow(mapdata)

    # set page layout
    if (a4layout)
        graphics::layout(rbind(c(0, 1), c(0, 2), c(0, 0)), widths = c(2, 3),
                         heights = c(2, nr + 2, max(25 - nr, 0.5)))
    else
        graphics::layout(rbind(c(0, 1), c(0, 2)), widths = c(2, 3),
                         heights = c(2, nr + 2))

    lapply(seq(1, nr, by = 29), function(i) {
        mapdataChunk <- mapdata[min(nr, i + 29 - 1):i, , drop = FALSE]

        if (a4layout && nr > 29 && nrow(mapdataChunk) < 29)
            mapdataChunk <- rbind(mapdataChunk,
                                  matrix(NA, ncol = 2,
                                         nrow = 29 - nrow(mapdataChunk),
                                         dimnames = list(NULL, colnames(mapdataChunk))))

        # draw legend
        graphics::par(mar = c(0, 1, 0, 3) + .1)
        graphics::plot(0:1, 0:1, type = "n", xlab = "", ylab = "", axes = FALSE)
        graphics::legend(x = "center", xjust = .5, yjust = .5, bty = 'n',
                         x.intersp = 0.25,
                         fill = cols, ncol = length(cols),
                         legend = colnames(mapdataChunk), xpd = NA)

        # draw bars
        graphics::par(mar = c(5, 1, 0, 3) + .1)
        ymax <- nrow(mapdataChunk)*1.25
        mp <- graphics::barplot(t(mapdataChunk/rowSums(mapdataChunk))*100, horiz = TRUE,
                                beside = FALSE, col = cols, border = NA,
                                ylim = c(0, ymax),
                                names.arg = rep("", nrow(mapdataChunk)),
                                main = '', xlab = 'Percent of sequences',
                                ylab = '', xpd = NA)

        # draw bar annotation
        cxy <- graphics::par('cxy')
        graphics::text(x = rep(graphics::par('usr')[1] + cxy[1]/3,
                               nrow(mapdataChunk)), y = mp,
                       col = "white", adj = c(0, 0.5),
                       labels = sprintf("%.1f%%", mapdataChunk[, 'mapped']/rowSums(mapdataChunk)*100),
                       xpd = NA)
        graphics::text(x = rep(mean(graphics::par('usr')[c(1, 2)]), nrow(mapdataChunk)),
                       y = mp, col = "white", adj = c(0.5, 0.5),
                       labels = sprintf("total=%.3g",mapdataChunk[, 'mapped'] +
                                            mapdataChunk[, 'unmapped']), xpd = NA)
        graphics::text(x = rep(graphics::par('usr')[2] - cxy[1]/5, nrow(mapdataChunk)),
                       y = mp, col = "white", adj = c(1, 0.5),
                       labels = sprintf("%.1f%%", mapdataChunk[, 'unmapped']/rowSums(mapdataChunk)*100),
                       xpd = NA)

        # draw sample names
        graphics::text(x = graphics::par('usr')[1] - 1.0*cxy[1],
                       y = mp, col = "black", adj = c(1, 0.5),
                       labels = truncStringToPlotWidth(
                           rownames(mapdataChunk),
                           ((diff(graphics::par("usr")[c(1, 2)]) +
                                 4 * graphics::par("cxy")[1]) / 3 * 2) -
                               3 * par("cxy")[1]),
                       xpd = NA)
    })

    invisible(mapdata)
}

#' @keywords internal
#' @importFrom graphics layout par text legend barplot plot
plotUniqueness <- function(data,
                           cols = c("#ff8c00", "#4682b4"),
                           a4layout = TRUE) {
    data <- do.call(rbind, data)
    nr <- nrow(data)

    data[, 2] <- data[, 2] - data[, 1]
    colnames(data) <- c("unique", "non-unique")

    # set page layout
    if (a4layout)
        graphics::layout(rbind(c(0, 1), c(0, 2), c(0, 0)), widths = c(2, 3),
                         heights = c(2, nr + 2, max(25 - nr, 0.5)))
    else
        graphics::layout(rbind(c(0, 1), c(0, 2)), widths = c(2,3),
                         heights = c(2, nr + 2))

    lapply(seq(1, nr, by = 29), function(i) {
        dataChunk <- data[min(nr, i + 29 - 1):i, , drop = FALSE]

        if (a4layout && nr > 29 && nrow(dataChunk) < 29)
            dataChunk <- rbind(dataChunk,
                               matrix(NA, ncol = 2,
                                      nrow = 29 - nrow(dataChunk),
                                      dimnames = list(NULL, colnames(dataChunk))))

        # draw legend
        graphics::par(mar = c(0, 1, 0, 3) + .1)
        graphics::plot(0:1, 0:1, type = "n", xlab = "", ylab = "", axes = FALSE)
        graphics::legend(x = "center", xjust = .5, yjust = .5, bty = 'n',
                         x.intersp = 0.25,
                         fill = cols, ncol = length(cols),
                         legend = colnames(dataChunk), xpd = NA)

        # draw bars
        graphics::par(mar = c(5, 1, 0, 3) + .1)
        ymax <- nrow(dataChunk)*1.25
        mp <- graphics::barplot(t(dataChunk/rowSums(dataChunk))*100, horiz = TRUE,
                                beside = FALSE, col = cols, border = NA,
                                ylim = c(0, ymax), names.arg = rep("", nrow(dataChunk)),
                                main = '',
                                xlab = 'Percent of unique alignment positions',
                                ylab = '', xpd = NA)

        # draw bar annotation
        cxy <- graphics::par('cxy')
        graphics::text(x = rep(graphics::par('usr')[1] + cxy[1] / 3,
                               nrow(dataChunk)),
                       y = mp, col = "white", adj = c(0, 0.5),
                       labels = sprintf("%.1f%%",
                                        dataChunk[, 'unique'] /
                                            rowSums(dataChunk) * 100),
                       xpd = NA)
        graphics::text(x = rep(mean(graphics::par('usr')[c(1, 2)]),
                               nrow(dataChunk)),
                       y = mp, col = "white",
                       adj = c(0.5, 0.5),
                       labels = sprintf("total=%.3g", dataChunk[, 'unique'] +
                                            dataChunk[, 'non-unique']), xpd = NA)
        graphics::text(x = rep(graphics::par('usr')[2] - cxy[1] / 5,
                               nrow(dataChunk)),
                       y = mp, col = "white", adj = c(1, 0.5),
                       labels = sprintf("%.1f%%",
                                        dataChunk[, 'non-unique'] /
                                            rowSums(dataChunk) * 100),
                       xpd = NA)

        # draw sample names
        graphics::text(x = graphics::par('usr')[1] - 1.0 * cxy[1],
                       y = mp, col = "black", adj = c(1, 0.5),
                       labels = truncStringToPlotWidth(
                           rownames(dataChunk),
                           ((diff(graphics::par("usr")[c(1, 2)]) +
                                 4*graphics::par("cxy")[1]) / 3 * 2) -
                               3*par("cxy")[1]),
                       xpd = NA)
    })

    invisible(data)
}

#' @keywords internal
#' @importFrom graphics layout par abline text plot
plotErrorsByCycle <- function(data,
                              lmat = matrix(1:12, nrow = 6, byrow = TRUE)) {

    ns <- length(data)
    graphics::layout(lmat)
    for (i in seq_len(ns)) {
        xn <- dim(data[[i]])[3]
        cumcvg <- unlist(lapply(seq_len(xn),
                                function(j){ sum(data[[i]][, , j])}))
        nErr <- cumcvg - unlist(lapply(seq_len(xn),
                                       function(j){ sum(diag(data[[i]][, , j]))}
                                       ))
        frq <- nErr / cumcvg * 100
        ym <- max(5, ceiling(max(frq)), na.rm = TRUE)
        graphics::par(mar = c(5 - 1, 4 - 1, 4 - 4, 2 - 1) + 0.1,
                      mgp = c(3 - 1, 1 - 0.25, 0))
        graphics::plot(seq_len(xn), frq, type = 'l', lwd = 2, col = "#E41A1C",
                       ylim = c(0,ym), xaxs = "i", xlim = c(0, xn) + 0.5,
                       lty = 1, pch = 20, cex = 0.6, main = "",
                       xlab = 'Position in read (bp)',
                       ylab = 'Mismatched bases (%)')
        graphics::abline(h = 0, lty = 2, col = 'gray')
        #abline(v=c(12,25), lty = 3, col = 'red')
        cxy <- graphics::par('cxy')
        graphics::text(x = graphics::par('usr')[1] + cxy[1] / 4,
                       y = graphics::par('usr')[4] - cxy[2] / 4, adj = c(0, 1),
                       labels = truncStringToPlotWidth(
                           names(data)[i],
                           diff(graphics::par("usr")[c(1, 2)]) - cxy[1]/2))
        if (all(is.na(data[[i]])))
            graphics::text(x = mean(graphics::par('usr')[c(1, 2)]),
                           y = mean(graphics::par('usr')[3:4]),
                           adj = c(0.5, 0.5), labels = "no data")
    }

    invisible(data)
}

#' @keywords internal
#' @importFrom graphics layout par box strwidth text barplot
plotMismatchTypes <- function(data,
                              lmat = matrix(1:12, nrow = 6, byrow = TRUE)) {
    ns <- length(data)
    graphics::layout(lmat)
    mycols <- c("#5050ff", "#e00000", "#00c000", "#e6e600", "darkgray")
    for (i in seq_len(ns)) {
        mtypes <- apply(data[[i]], 1, rowSums)
        pmtypes <- mtypes * 100 / sum(mtypes)
        diag(pmtypes) <- 0 # don't plot matches
        pmtypes <- pmtypes[, colnames(pmtypes) != "N"] # don't plot genomic N

        graphics::barplot(pmtypes, ylab = "% of aligned bases",
                          xlab = "Genome", col = mycols,
                          ylim = c(0, max(colSums(pmtypes), 0.1,
                                          na.rm = TRUE) * 1.16))
        if (all(is.na(mtypes)))
            graphics::text(x = mean(graphics::par('usr')[c(1, 2)]),
                           y = mean(graphics::par('usr')[c(3, 4)]),
                           adj = c(0.5, 0.5), labels = "no data")
        graphics::box()
        cxy <- graphics::par("cxy")
        graphics::text(x = graphics::par('usr')[2] - cxy[1] / 4 -
                           seq(4, 0) * cxy[1] * 0.8,
                       y = graphics::par('usr')[4] - cxy[2] / 4,
                       adj = c(1,1), col = mycols, labels = rownames(pmtypes))
        graphics::text(x = graphics::par('usr')[2] - cxy[1] / 4 -
                           5 * cxy[1] * 0.8,
                       y = graphics::par('usr')[4] - cxy[2] / 4,
                       col = "black", labels = "Read:", adj = c(1, 1))
        graphics::text(x = graphics::par('usr')[1] + cxy[1] / 4,
                       y = graphics::par('usr')[4] - cxy[2] / 4,
                       adj = c(0, 1), col = "black",
                       labels = truncStringToPlotWidth(
                           names(data)[i],
                           graphics::par('usr')[2] - cxy[1] / 4 -
                               5 * cxy[1] * 0.8 -
                               graphics::strwidth("Read:") - cxy[1] * 1.0))
    }

    invisible(data)
}

#' @keywords internal
#' @importFrom graphics layout par abline axis text rect plot
#' @importFrom stats median
plotFragmentDistribution <- function(data, lmat = matrix(1:12, nrow = 6, byrow = TRUE)) {
    ns <- length(data)
    frag <- do.call(cbind, data)
    xn <- dim(frag)[1]
    # trim vector
    if (sum(frag[xn, ], na.rm = TRUE) == 0L) {
        xn <- max(as.integer(rownames(frag)[rowSums(frag, na.rm = TRUE) > 0]), 100)
        frag <- frag[seq_len(xn), , drop = FALSE]
    }

    graphics::layout(lmat)
    for (i in seq_len(ns)) {
        dens <- frag[, i]/sum(frag[, i])
        ym <- max(dens, 0.01, na.rm = TRUE)
        graphics::par(mar = c(5 - 1, 4 - 1, 4 - 4, 2 - 1) + .1,
                      mgp = c(3 - 1, 1 - 0.25, 0))

        #plot(dens, type='l', lwd=2, col="#377EB8", ylim=c(0,ym), xaxs="i", xlim=c(0,xn)+.5, lty=1, pch=20, cex=0.6,
        #     main="", xlab='Fragment size (nt)', ylab='Density')
        graphics::plot(dens, type = 'n', ylim = c(0, ym), xaxs = "i",
                       xlim = c(0, xn) + .5,
                       lty = 1, pch = 20, cex = 0.6,
                       main = "", xlab = 'Fragment size (nt)',
                       ylab = 'Density', xpd = NA)
        graphics::rect(xleft = seq_len(xn) - .5, ybottom = 0,
                       xright = seq_len(xn) + .5, ytop = dens,
                       col = "#377EB8", border = NA)
        graphics::abline(h = 0, lty = 2, col = 'gray')
        if (any(ii <- grepl("^>", names(dens))))
            graphics::axis(side = 1, at = xn, labels = names(dens)[xn])
        cxy <- graphics::par('cxy')
        graphics::text(x = graphics::par('usr')[1] + cxy[1] / 4,
                       y = graphics::par('usr')[4] - cxy[2] / 4, adj = c(0, 1),
                       labels = truncStringToPlotWidth(
                           names(data)[i],
                           diff(graphics::par("usr")[c(1, 2)]) - cxy[1] / 2))
        medlen <- stats::median(S4Vectors::Rle(values = seq_len(xn),
                                               lengths = frag[, i]))
        graphics::text(x = graphics::par('usr')[1] + cxy[1] / 4,
                       y = graphics::par('usr')[4] - 5 * cxy[2] / 4,
                       adj = c(0,1), col = "#377EB8", labels = sprintf("median = %1.f", medlen))
        graphics::abline(v = as.vector(medlen), lty = 3, col = "black")
        if (all(is.na(data[[i]])))
            graphics::text(x = mean(graphics::par('usr')[c(1, 2)]),
                           y = mean(graphics::par('usr')[c(3, 4)]),
                           adj = c(0.5, 0.5), labels = "no data")
    }

    invisible(frag)
}

#' @keywords internal
#' @importFrom Biostrings alphabetFrequency
#' @importFrom ShortRead sread tables alphabetByCycle
.qa_ShortRead <- function(dirPath, lane, ..., verbose = FALSE) {
    if (missing(lane))
        stop("Parameter 'lane' is missing.")
    obj <- dirPath
    alf <- Biostrings::alphabetFrequency(ShortRead::sread(obj),
                                         baseOnly = TRUE, collapse = TRUE)
    #     bqtbl <- alphabetFrequency(quality(obj), collapse=TRUE)
    #     rqs <- .qa_qdensity(quality(obj))
    freqtbl <- ShortRead::tables(ShortRead::sread(obj))
    abc <- ShortRead::alphabetByCycle(obj)
    names(dimnames(abc)) <- c("base", "cycle")
    dimnames(abc)$cycle <- as.character(seq_len(dim(abc)[2]))
    ac <- ShortRead:::.qa_adapterContamination(obj, lane, ...)
    perCycleBaseCall <- data.frame(Cycle = as.integer(colnames(abc)[col(abc)]),
                                   Base = factor(rownames(abc)[row(abc)]),
                                   Count = as.vector(abc),
                                   lane = lane, row.names = NULL)
    perCycleBaseCall <- perCycleBaseCall[perCycleBaseCall$Count != 0, ]
    #     perCycleBaseCall <- ShortRead:::.qa_perCycleBaseCall(abc, lane)
    #     perCycleQuality <- .qa_perCycleQuality(abc, quality(obj), lane)
    lst <- list(readCounts = data.frame(
        read = length(obj), filter = NA, aligned = NA,
        row.names = lane),
        baseCalls = data.frame(
            A = alf[["A"]], C = alf[["C"]], G = alf[["G"]], T = alf[["T"]],
            N = alf[["other"]], row.names = lane),
        readQualityScore = data.frame(
            quality = NULL, #rqs$x,
            density = NULL, #rqs$y,
            lane = NULL, #lane,
            type = NULL #"read"
        ),
        baseQuality = data.frame(
            score = NULL, #names(bqtbl),
            count = NULL, #as.vector(bqtbl),
            lane = NULL #lane
        ),
        alignQuality = data.frame(
            score = as.numeric(NA),
            count = as.numeric(NA),
            lane = lane, row.names = NULL),
        frequentSequences = data.frame(
            sequence = names(freqtbl$top),
            count = as.integer(freqtbl$top),
            type = "read",
            lane = lane),
        sequenceDistribution = cbind(
            freqtbl$distribution,
            type = "read",
            lane = lane),
        perCycle = list(
            baseCall = perCycleBaseCall,
            quality = NULL #perCycleQuality
        ),
        perTile = list(
            readCounts = data.frame(
                count = integer(0), type = character(0),
                tile = integer(0), lane = character(0)),
            medianReadQualityScore = data.frame(
                score = integer(), type = character(), tile = integer(),
                lane = integer(), row.names = NULL)),
        adapterContamination = ac
    )

    ShortRead:::.ShortReadQQA(lst)
}

#' @importFrom ShortRead qa
setMethod(qa, "ShortRead", .qa_ShortRead)

context("qQCReport")

test_that("qQCReport works as expected", {
  # arguments
  expect_error(qQCReport("error"))
  expect_error(qQCReport(c("f1.bam", "f2.fastq")))
  
  # results
  tmppdf <- tempfile(fileext = rep(".pdf", 6), tmpdir = "extdata")

  resqc  <- qQCReport(pChipSingle, pdfFilename = tmppdf[1])
  resqc2 <- qQCReport(pChipSingle, pdfFilename = tmppdf[2], clObj = clObj)
  resqc3 <- qQCReport(pRnaPaired,  pdfFilename = tmppdf[3], useSampleNames = FALSE)
  resqc4 <- qQCReport(alignments(pChipSingle)$genome$FileName[1],
                      pdfFilename = tmppdf[4])
  resqc5 <- qQCReport(pChipSingle@reads$FileName[1],
                      pdfFilename = tmppdf[5])
  resqc6 <- qQCReport(pChipSingleLongFname, pdfFilename = tmppdf[6])

  expect_identical(resqc, resqc2)
  expect_is(resqc, "list")
  expect_length(resqc,  8L)
  expect_length(resqc3, 9L)
  expect_length(resqc4, 5L)
  expect_length(resqc5, 4L)
  expect_is(resqc3$fragDistribution, "matrix")
  expect_is(resqc$nuclByCycle, "list")
  expect_is(resqc$nuclByCycle[[1]], "matrix")
  expect_is(resqc$nuclByCycle[[2]], "matrix")
  expect_identical(dim(resqc$nuclByCycle[[1]]), c(5L, 36L))
  expect_identical(dim(resqc$nuclByCycle[[2]]), c(5L, 36L))

  unlink(tmppdf)
})

test_that("qQCReport helper functions work as expected", {
  requireNamespace("Rsamtools")
  
  samempty <- tempfile(fileext = ".sam", tmpdir = "extdata")
  writeLines(c("@HD\tVN:1.0\tSO:coordinate","@SQ\tSN:chrV\tLN:99"), con = samempty)
  bamempty <- Rsamtools::asBam(samempty)
  
  bamf1 <- pChipSingle@alignments$FileName[1]
  
  tmppdf <- tempfile(fileext = ".pdf", tmpdir = "extdata")

  # calcQaInformation
  expect_warning(r <- QuasR:::calcQaInformation("err.fa.gz", "err", "fasta", 1e6))
  expect_null(r)
  
  # calcMmInformation
  l <- QuasR:::calcMmInformation(bamempty, genomeFile, 1e6)
  expect_is(l, "list")
  expect_length(l, 4L)
  expect_true(all(is.na(l[[3]])))

  l <- QuasR:::calcMmInformation(bamf1, genomeFile, 10)
  expect_length(l, 4L)

  # truncStringToPlotWidth
  s <- c("012345",
         "01234567890",
         "01234567890012345")
  pdf(tmppdf, height = 5, width = 5)
  plot(0:1, 0:1)
  expect_identical(QuasR:::truncStringToPlotWidth(s[1], 0.1), s[1])
  expect_identical(QuasR:::truncStringToPlotWidth(s[2], 0.1), "012345...")
  expect_identical(QuasR:::truncStringToPlotWidth(s[3], 0.1), "012345...")
  dev.off()
  unlink(tmppdf)
})

# copy sample data
file.copy(system.file("extdata", package = "QuasR"), ".", recursive = TRUE)

# temporary R library
rlibdir     <- tempfile(pattern = "Rlib", tmpdir = "extdata")
dir.create(rlibdir)
# ... add rlibdir to R_LIBS for "R CMD INSTALL" and cluster nodes to find it 
# ... add rlibdir to R_LIBS for "R CMD INSTALL" and cluster nodes to find it 
oldRlibs <- Sys.getenv("R_LIBS")
Sys.setenv(R_LIBS = paste(tools::file_path_as_absolute(rlibdir), oldRlibs,
                          sep = .Platform$path.sep))

# create cluster object
clObj <- parallel::makeCluster(2L)

# load QuasR on cluster nodes
parallel::clusterEvalQ(cl = clObj, expr = library(QuasR))

# install BSgenome.HSapiens.QuasR.hg19sub into temporary library
bsgPkg <- system.file("extdata", "BSgenome.HSapiens.QuasR.hg19sub_0.1.0.tar.gz",
                      package = "QuasR")
utils::install.packages(pkgs = bsgPkg, lib = rlibdir, repos = NULL,
                        type = "source", INSTALL_opts = "--no-test-load")

# copy one of the ChIP fastq files and give it a long name, to test the 
# truncation rules
# also generate a corresponding sample file
file.copy(from = file.path("extdata", "chip_1_1.fq.bz2"), 
          to = file.path("extdata", 
                         "chip_1_1_with_long_file_name_that_will_be_truncated.fq.bz2"))
tmp <- read.delim(file.path("extdata", "samples_chip_single.txt"))
tmp$FileName <- sub("chip_1_1", 
                    "chip_1_1_with_long_file_name_that_will_be_truncated", 
                    tmp$FileName)
write.table(tmp, file = file.path("extdata", "samples_chip_single_longfname.txt"), 
            row.names = FALSE, col.names = TRUE, quote = FALSE, sep = "\t")
sChipSingleLongFname <- file.path("extdata", "samples_chip_single_longfname.txt")

# create qProject instances
# ... for hg19sub
genomePkg     <- "BSgenome.HSapiens.QuasR.hg19sub"
genomeFile    <- file.path("extdata", "hg19sub.fa")
snpFile       <- file.path("extdata", "hg19sub_snp.txt")
auxGenomeFile <- file.path("extdata", "NC_001422.1.fa")
auxFile       <- file.path("extdata", "auxiliaries.txt")
gtfFile       <- file.path("extdata", "hg19sub_annotation.gtf")
txdbFile      <- file.path("extdata", "hg19sub_annotation.sqlite")
txdb <- txdbmaker::makeTxDbFromGFF(gtfFile, format = "gtf")
AnnotationDbi::saveDb(txdb, file = txdbFile)

sChipSingle   <- file.path("extdata", "samples_chip_single.txt")
sRnaSingle    <- file.path("extdata", "samples_rna_single.txt")
sRnaPaired    <- file.path("extdata", "samples_rna_paired.txt")
sBisSingle    <- file.path("extdata", "samples_bis_single.txt")
#sMirnaSingle  <- file.path("extdata", "samples_mirna.txt")

# ... ... as a BSgenome
pChipSingle       <- qAlign(sChipSingle,  genomePkg,  clObj = clObj, lib.loc = rlibdir, cacheDir = tempdir())
pChipSingleLongFname <- qAlign(sChipSingleLongFname,  genomePkg,  clObj = clObj, lib.loc = rlibdir, cacheDir = tempdir())
pBis              <- qAlign(sBisSingle,   genomePkg,  bisulfite = "dir", clObj = clObj, lib.loc = rlibdir)

# ... ... as a fasta genome
pChipSingleAux    <- qAlign(sChipSingle,  genomeFile, auxiliaryFile = auxFile, clObj = clObj)
pChipSingleSnps   <- qAlign(sChipSingle,  genomeFile, snpFile = snpFile, clObj = clObj)
pRnaPaired        <- qAlign(sRnaPaired,   genomeFile, clObj = clObj)
pRnaSingleSpliced <- qAlign(sRnaSingle,   genomeFile, splicedAlignment = TRUE, aligner = "Rbowtie", clObj = clObj)
pRnaPairedSpliced <- qAlign(sRnaPaired,   genomeFile, splicedAlignment = TRUE, aligner = "Rbowtie", clObj = clObj)

pRnaSingleSplicedHisat2 <- qAlign(sRnaSingle, genomeFile, alignmentsDir = "extdata", 
                                  splicedAlignment = TRUE, aligner = "Rhisat2", clObj = clObj)
pRnaPairedUnsplicedHisat2 <- qAlign(sRnaPaired, genomeFile, splicedAlignment = FALSE, 
                                    aligner = "Rhisat2", clObj = clObj)
pRnaPairedSplicedHisat2Gtf <- qAlign(sRnaPaired, genomeFile, splicedAlignment = TRUE,
                                     aligner = "Rhisat2", clObj = clObj, geneAnnotation = gtfFile)
pRnaPairedSplicedHisat2TxDb <- qAlign(sRnaPaired, genomeFile, splicedAlignment = TRUE, 
                                      aligner = "Rhisat2", clObj = clObj, geneAnnotation = txdbFile)

pBis              <- qAlign(sBisSingle,   genomeFile, bisulfite = "dir", clObj = clObj)

pBisUndir         <- qAlign(sBisSingle,   genomeFile, bisulfite = "undir", clObj = clObj)
pBisSnps          <- qAlign(sBisSingle,   genomeFile, bisulfite = "dir", snpFile = snpFile, clObj = clObj)
pPhiX             <- qAlign(file.path("extdata", "phiX_paired_withSecondary_sampleFile.txt"),
                            file.path("extdata", "NC_001422.1.fa"), paired = "fr")

# ... for synthetic genome with chrV
pSingle        <- createProjectSingle(allelic = FALSE)
pSingleAllelic <- createProjectSingle(allelic = TRUE)
pPaired        <- createProjectPaired()

# create annotation and GRanges
# ... for hg19sub
gtfGr <- createGtfGr()
txdb  <- createTxDb()
auxGr <- Rsamtools::scanFaIndex(auxGenomeFile)

# ... for synthetic genome with chrV
qGenome <- GenomicRanges::GRanges("chrV", IRanges(start = 1, width = 800), strand = "+")
q01.20  <- GenomicRanges::GRanges("chrV", IRanges(start = seq.int(20), width = 1))
q01.99  <- GenomicRanges::GRanges("chrV", IRanges(start = seq.int(99), width = 1))
q21.40  <- GenomicRanges::GRanges("chrV", IRanges(start = seq.int(20) + 20, width = 1))
q41.60  <- GenomicRanges::GRanges("chrV", IRanges(start = seq.int(20) + 40, width = 1))
q61.80  <- GenomicRanges::GRanges("chrV", IRanges(start = seq.int(20) + 60, width = 1))
q81.99  <- GenomicRanges::GRanges("chrV", IRanges(start = seq.int(19) + 80, width = 1))
qTiles  <- createTiles()

#' Update qProject
#'
#' Check if a qProject is compatible with the current class definition, and
#' update it if necessary.
#'
#' @param proj a \code{\link[=qProject-class]{qProject}} object.
#' @param quiet logical, whether to suppress update messages.
#'
#' @return A \code{\link[=qProject-class]{qProject}} object.
#'
#' @author Charlotte Soneson
#'
#' @seealso \code{\link[=qProject-class]{qProject}}
#'
#' @keywords utilities misc
#'
#' @name qProjectUpdate
#' @aliases qProjectUpdate
#'
#' @export
#'
#' @importFrom methods .hasSlot
#'
qProjectUpdate <- function(proj, quiet = TRUE) {
    mod <- FALSE
    if (!(methods::.hasSlot(proj, "geneAnnotation"))) {
        proj@geneAnnotation <- NA_character_
        if (!quiet) message("Adding geneAnnotation slot")
        mod <- TRUE
    }
    if (!(methods::.hasSlot(proj, "geneAnnotationFormat"))) {
        proj@geneAnnotationFormat <- NA_character_
        if (!quiet) message("Adding geneAnnotationFormat slot")
        mod <- TRUE
    }
    if (!mod) {
        if (!quiet) message("qProject is up to date")
    }
    proj
}

### qProject class definition
#' qProject objects
#'
#' The qProject class is a container for the meta-data (e.g. sample
#' names, paths and names of sequence and alignment files) associated
#' with a high-throughput sequencing experiment analyzed with \code{QuasR}.
#'
#' The qProject class is returned by \link{qAlign} and stores all
#' information on a high-throughput sequencing experiment analyzed with
#' \code{QuasR}. qProject objects can be conveniently passed to
#' \sQuote{q}-functions (function name starting with the letter
#' \sQuote{q}). The information is stored in the following slots:
#' \describe{
#'   \item{\code{reads}}{a 'data.frame' with sequence read files.}
#'   \item{\code{reads_md5subsum}}{a 'data.frame' with fingerprints for
#'   sequence read files.}
#'   \item{\code{alignments}}{a 'data.frame' with alignment files.}
#'   \item{\code{samplesFormat}}{a 'character(1)' specifying the format
#'   of input files.}
#'   \item{\code{genome}}{a 'character(1)' specifying the reference genome.}
#'   \item{\code{genomeFormat}}{a 'character(1)' specifying the format of
#'   the reference genome.}
#'   \item{\code{aux}}{a 'data.frame' with auxiliary reference sequence files.}
#'   \item{\code{auxAlignments}}{a 'data.frame' with alignment files for
#'   auxiliary reference sequence files.}
#'   \item{\code{aligner}}{a 'character(1)' specifying the aligner.}
#'   \item{\code{maxHits}}{a 'numeric(1)' specifying the maximum number
#'   of alignments per sequence.}
#'   \item{\code{paired}}{a 'character(1)' specifying the paired-type;
#'   one of "no", "fr", "rf", "ff".}
#'   \item{\code{splicedAlignment}}{a 'logical(1)'; \code{TRUE} when
#'   performing spliced-alignments.}
#'   \item{\code{snpFile}}{a 'character(1)' with a file name containing
#'   SNP information.}
#'   \item{\code{bisulfite}}{a 'character(1)' defining the bisulfite
#'   type; one of "no", "dir", "undir".}
#'   \item{\code{alignmentParameter}}{a 'character(1)' with aligner
#'   command line parameters.}
#'   \item{\code{projectName}}{a 'character(1)' with the project name.}
#'   \item{\code{alignmentsDir}}{a 'character(1)' with the directory to
#'   be used to store alignment files.}
#'   \item{\code{lib.loc}}{a 'character(1)' with the library directory to
#'   use for installing of alignment index packages.}
#'   \item{\code{cacheDir}}{a 'character(1)' with a directory to use for
#'   temporary files.}
#'   \item{\code{alnModeID}}{a 'character(1)' used internally to indicate
#'   the alignment mode.}
#' }
#'
#' @section Accessors:
#' In the following code snippets, \code{x} is a qProject object.
#' \describe{
#'   \item{\code{length(x)}}{: Gets the number of input files.}
#'   \item{\code{genome(x)}}{: Gets the reference genome as a 'character(1)'.
#'   The type of genome is stored as an attribute in
#'   \code{attr(genome(x),"genomeFormat")}: "BSgenome" indicates that
#'   \code{genome(x)} refers to the name of a BSgenome package, "file"
#'   indicates that it contains the path and filename of a genome in
#'   FASTA format.}
#'   \item{\code{auxiliaries(x)}}{: Gets a \code{data.frame} with auxiliary
#'   target sequences, with one row per auxiliary target, and columns
#'   "FileName" and "AuxName".}
#'   \item{\code{alignments(x)}}{: Gets a list with two elements "genome" and
#'   "aux". \code{alignments(x)$genome} contains a \code{data.frame}
#'   with \code{length(x)} rows and the columns "FileName" (containing
#'   the path to bam files with genomic alignments) and
#'   "SampleName". \code{alignments(x)$aux} contains a
#'   \code{data.frame} with one row per auxiliary target sequence (with
#'   auxiliary names as row names), and \code{length(x)} columns.}
#' }
#'
#' @section Subsetting:
#' In the following code snippets, \code{x} is a qProject object.
#' \describe{
#'   \item{\code{x[i]}}{: Get \code{qProject} object instance with \code{i}
#'   input files, where \code{i} can be an NA-free logical, numeric, or
#'   character vector.}
#' }
#'
#' @author Anita Lerch, Dimos Gaidatzis and Michael Stadler
#'
#' @aliases show,qProject-method [,qProject,ANY,missing,missing-method
#'   alignments,qProject-method alignments auxiliaries,qProject-method auxiliaries
#'   genome,qProject-method length,qProject-method qProject qProject-class
#'   class:qProject
#'
#' @name qProject-class
#' @docType class
#'
#' @seealso \link{qAlign}
#'
#' @export
#'
#' @examples
#' # copy example data to current working directory
#' file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)
#'
#' # create alignments
#' sampleFile <- "extdata/samples_chip_single.txt"
#' genomeFile <- "extdata/hg19sub.fa"
#' auxFile <- "extdata/auxiliaries.txt"
#'
#' proj <- qAlign(sampleFile, genomeFile, auxiliaryFile=auxFile)
#' proj
#'
#' # alignment statistics using a qProject
#' alignmentStats(proj)
#'
#' # alignment statistics using bam files
#' alignmentStats(alignments(proj)$genome$FileName)
#' alignmentStats(unlist(alignments(proj)$aux))
#'
setClass("qProject",
         slots = c(reads = "data.frame",
                   reads_md5subsum = "data.frame",
                   alignments = "data.frame",
                   samplesFormat = "character",
                   genome = "character",
                   genomeFormat = "character",
                   aux = "data.frame",
                   auxAlignments = "data.frame",
                   aligner = "character",
                   maxHits = "numeric",
                   paired = "character",
                   splicedAlignment = "logical",
                   snpFile = "character",
                   bisulfite = "character",
                   alignmentParameter = "character",
                   projectName = "character",
                   alignmentsDir = "character",
                   lib.loc = "character",
                   cacheDir = "character",
                   alnModeID = "character",
                   geneAnnotation = "character",
                   geneAnnotationFormat = "character")
)

### Methods
#' @export
setMethod("length", "qProject", function(x) nrow(x@reads))

#setGeneric("sampleNames", function(x) names(x))
#setMethod("sampleNames", "qProject", function(x) x@reads$SampleName)

#setGeneric("sampleNames<-", function(x, value) names(x) <- value)
#setReplaceMethod("sampleNames", "qProject", function(x, value) {
#    if(is.factor(value))
#        values <- as.character(value)
#    if(!is.character(value))
#        stop("sample names must be of type 'character' or 'factor'")
#    if(length(value) != nrow(x@reads))
#        stop(sprintf("length of sample names (%d) must be equal to the number of samples in qProject object (%d)",length(value),nrow(x@reads)))
#    x@reads$SampleName <- x@alignments$SampleName <- value
#    x
#})

#' @importFrom Seqinfo genome
#' @export
setMethod("genome", signature(x = "qProject"), function(x) {
    y <- x@genome
    attr(y, "genomeFormat") <- x@genomeFormat
    return(y)
})

setGeneric("auxiliaries", function(x) return(NULL))
#' @export
setMethod("auxiliaries", signature(x = "qProject"), function(x) return(x@aux))

setGeneric("alignments", function(x) return(NULL))
#' @export
setMethod("alignments", signature(x = "qProject"), function(x) {
    return(list(genome = x@alignments, aux = x@auxAlignments))
})

#' @export
setMethod("[", signature(x = "qProject", i = "ANY", j = "missing",
                         drop = "missing"),
          function(x, i) {
              y <- x
              if (is.character(i)) {
                  if (all(i %in% x@reads$SampleName)) {
                      if (any(inu <- vapply(unique(i),
                                            function(ii) {
                                                sum(x@reads$SampleName == ii)
                                            }, 1) > 1))
                          warning("will only select first of multiple files ",
                                  "with identical sample name: ",
                                  paste(unique(i)[inu], collapse = ", "))
                      i <- match(i, x@reads$SampleName)
                  } else {
                      stop("undefined samples selected")
                  }
              } else if (is.logical(i) &&
                         length(i) != length(x@reads$SampleName)) {
                  stop("logical subsetting vector of length ", length(i),
                       " does not match the number of sequence files (",
                       length(x@reads$SampleName), ")")
              } else if (is.numeric(i)) {
                  if (any(!is.finite(i)) ||
                      max(i) > length(x@reads$SampleName) ||
                      min(i) < 1)
                      stop("undefined samples selected")
              }
              y@reads <- y@reads[i, , drop = FALSE]
              y@reads_md5subsum <- y@reads_md5subsum[i, , drop = FALSE]
              y@alignments <- y@alignments[i, , drop = FALSE]
              if (ncol(y@auxAlignments))
                  y@auxAlignments <- y@auxAlignments[, i, drop = FALSE]
              return(y)
          })

#setGeneric("niceprint", function(x) print(x))
#setMethod("niceprint", "qProject", function(object) {
#' @importFrom methods show
#' @importFrom utils packageVersion
#' @export
setMethod("show", "qProject", function(object) {
    # project and global options
    cat("Project: " , object@projectName, "\n", sep = "")
    cat(" Options   : maxHits         : ", object@maxHits,
        "\n             paired          : ", object@paired,
        "\n             splicedAlignment: ", object@splicedAlignment,
        "\n             bisulfite       : ", object@bisulfite,
        "\n             snpFile         : ", if (length(object@snpFile) == 0 || is.na(object@snpFile)) "none" else truncPath(object@snpFile, getOption("width") - 32),
        "\n             geneAnnotation  : ", if (length(object@geneAnnotation) == 0 || is.null(object@geneAnnotation) || is.na(object@geneAnnotation)) "none" else paste0(truncPath(object@geneAnnotation, getOption("width") - 39), " (", object@geneAnnotationFormat, ")"), "\n", sep = "")
    if (length(object@aligner) == 0 || is.na(object@aligner))
        cat(" Aligner   : unknown\n")
    else
        cat(" Aligner   : ", object@aligner, " v",
            as.character(utils::packageVersion(object@aligner)),
            " (parameters: ", object@alignmentParameter, ")\n", sep = "")
    cat(" Genome    : ", truncPath(object@genome, getOption("width") - 16 -
                                       nchar(object@genomeFormat)),
        " (", object@genomeFormat, ")\n", sep = "")
    # reads
    nf <- nrow(object@reads)
    nfs <- if(nf > 1) "s" else ""
    ns <- length(unique(object@reads$SampleName))
    nss <- if(ns > 1) "s" else ""
    cat("\n")
    if (length(object@samplesFormat) == 0) {
        cat(" Reads     : none\n")
    } else if(object@samplesFormat == "bam") {
        cat(" Reads     : none (bam file project)\n")
    } else {
        cat(" Reads     : ", nf, if (object@paired != "no") paste(" pair", nfs,
                                                                  " of files, ", sep = "")
            else paste(" file", nfs, ", ", sep = ""),
            ns, " sample", nss, " (", object@samplesFormat, " format):\n", sep = "")
        qual <- if(object@samplesFormat == "fastq") paste(" (phred",object@reads$phred, ")",
                                                          sep = "") else ""
        fw <- max(nchar(basename(unlist(object@reads[, grep("FileName",colnames(object@reads))]))))
        sw <- max(nchar(object@reads$SampleName))
        if (object@paired != "no") {
            fw <- min(fw, floor((getOption("width") - 10 - sw - max(nchar(qual))) / 2))
            cat(sprintf(" %3d. %-*s  %-*s  %-*s%s\n", seq_len(nf),
                        fw, truncString(basename(object@reads$FileName1), fw),
                        fw, truncString(basename(object@reads$FileName2), fw),
                        sw, object@reads$SampleName, qual), sep = "")
        } else {
            fw <- min(fw, getOption("width") - 8 - sw - max(nchar(qual)))
            cat(sprintf(" %3d. %-*s  %-*s%s\n", seq_len(nf), fw,
                        truncString(basename(object@reads$FileName),fw),
                        sw, object@reads$SampleName, qual), sep = "")
        }
    }
    # alignments
    cat("\n")
    cat(" Genome alignments: directory: ", if (length(object@alignmentsDir) == 0) "" else if (is.na(object@alignmentsDir)) { if(object@samplesFormat == "bam") "not applicable (bam file project)" else "same as reads" } else truncPath(object@alignmentsDir,getOption("width") - 31), "\n", sep = "")
    #fw <- min(getOption("width") -8 -sw, max(nchar(basename(object@alignments[,"FileName"]))))
    #cat(sprintf(" %3d. %-*s  %-*s\n", 1:nf, fw, truncString(basename(object@alignments[,"FileName"]), fw), sw, object@reads$SampleName), sep="")
    if (length(object@alignments) > 0) {
      tmpmax <- suppressWarnings(max(nchar(basename(object@alignments[, "FileName"])), na.rm = TRUE))
      if (!is.finite(tmpmax)) tmpmax <- Inf
      fw <- min(getOption("width") - 6, tmpmax)
      cat(sprintf(" %3d. %-*s\n", seq_len(nf), fw,
                  truncString(basename(object@alignments[, "FileName"]), fw)), sep = "")
      cat("\n")
    }
    # auxiliaries
    cat(" Aux. alignments: ", if(nrow(object@aux) == 0) "none" else paste(nrow(object@aux), " file", if (nrow(object@aux) > 1) "s" else "", ", directory: ", if (is.na(object@alignmentsDir)) "same as reads" else truncPath(object@alignmentsDir, getOption("width") - 38), sep = ""),
        "\n", sep = "")
    if (length(object@aux)>0) {
        for (i in seq.int(nrow(object@aux))) {
            fw <- getOption("width") - 8 - nchar(object@aux[i, 'AuxName'])
            cat(sprintf(" %3s. %-*s  %-s\n", letters[i], fw,
                        truncPath(object@aux[i, 'FileName'], fw), object@aux[i, 'AuxName']))
            #fw <- min(getOption("width") -10 -sw, max(nchar(basename(unlist(object@auxAlignments[i,])))))
            #cat(sprintf("   %3d. %-*s  %-*s\n", 1:nf, fw, truncString(basename(unlist(object@auxAlignments[i,])), fw), sw, object@reads$SampleName), sep="")
            fw <- min(getOption("width") - 8,
                      max(nchar(basename(unlist(object@auxAlignments[i, ])))))
            cat(sprintf("   %3d. %-*s\n", seq_len(nf), fw,
                        truncString(basename(unlist(object@auxAlignments[i,])), fw)), sep = "")
        }
    }
    cat("\n")
    return(invisible(NULL))
})

context("qProject")

# create qProject instance
genomeFile     <- file.path("extdata", "hg19sub.fa")
sChipSingle    <- file.path("extdata", "samples_chip_single.txt")
auxFile        <- file.path("extdata", "auxiliaries.txt")
pChipSingle    <- qAlign(sChipSingle,  genomeFile, projectName = "genome")
pChipSingleAux <- qAlign(sChipSingle,  genomeFile, auxiliaryFile = auxFile,
                         projectName = "genome-aux")

test_that("qProject length works as expected", {
  expect_identical(length(pChipSingle), 2L)
  expect_identical(length(pChipSingleAux), 2L)
})

test_that("qProject has a working genome method", {
  expect_identical(normalizePath(genomeFile), normalizePath(genome(pChipSingle)))
  expect_identical(normalizePath(genomeFile), normalizePath(genome(pChipSingleAux)))
})

test_that("qProject has a working auxiliaries method", {
  expect_true(0 == nrow(auxiliaries(pChipSingle)))
  expect_true(1 == nrow(auxiliaries(pChipSingleAux)))
})

test_that("qProject has a working alignments method", {
  aln <- alignments(pChipSingle)
  expect_true(2 == nrow(aln$genome))
  expect_true(0 == nrow(aln$aux))
  
  aln <- alignments(pChipSingleAux)
  expect_true(2 == nrow(aln$genome))
  expect_true(2 == ncol(aln$aux))
})

test_that("qProject has a working show method", {
  expect_output(show(pChipSingle), "Project: genome")
  expect_output(show(pChipSingleAux), "Project: genome-aux")
})

test_that("qProject can be subset", {
  expect_is(pChipSingle[1:2], "qProject")
  expect_identical(length(pChipSingle[1]), 1L)
  expect_error(pChipSingle["Sample3"])
  expect_identical(pChipSingle[1], suppressWarnings(pChipSingle["Sample1"]))
  expect_identical(pChipSingle[2], suppressWarnings(pChipSingle["Sample2"]))
  expect_length(pChipSingleAux[2], 1L)
})

test_that("qProjectUpdate works", {
  expect_identical(pChipSingle, qProjectUpdate(pChipSingle))
})

# bowtie alignments: --best --strata -m 1 (return one alignment, but only if it is a unique mapper)
# plus -q/-f [--phred33/64-quals] [-C] -S --quiet
# paired:
# valid values are NULL, "no", "fr", "rf", "ff"
# in case of NULL, QuasR determines the paired status automatically from the given sampleFile (2 columns:unpaired, 3 columns:paired).
# The orientation for paired end is set to "fr" by default. In case of bam input files, the user needs to specify manually the
# status ("no","fr","rf","ff")
# snpFile need four columns (chrom, pos, ref, alt) with no header
# geneAnnotation should be the path to either a gtf file or a TxDb sqlite file

#' Align reads
#'
#' Create read alignments against reference genome and optional auxiliary
#' targets if not yet existing. If necessary, also build target indices for
#' the aligner.
#'
#' Before generating new alignments, \code{qAlign} looks for previously
#' generated alignments as well as for an aligner index. If no aligner
#' index exists, it will be automatically created and stored in the same
#' directory as the provided fasta file, or as an R package in the case
#' of a BSgenome reference. The name of this R package will be the same
#' as the BSgenome package name, with an additional suffix from the
#' aligner (e.g. \code{BSgenome.Hsapiens.UCSC.hg19.Rbowtie}). The
#' generated bam files contain both aligned und unaligned reads. For
#' paired-end samples, by default no alignments will be reported for
#' read pairs where only one of the reads could be aligned.
#'
#' \code{sampleFile} is a tab-delimited text file listing all the input
#' sequences to be included in a given analysis. The file has either two
#' (single-end) or three columns (paired-end). The first row contains the
#' column names, and additional rows contain relative or absolute path
#' and name of input sequence file(s), as well as the according sample
#' name. Three input file formats are supported (fastq, fasta and bam).
#' All input files in one \code{sampleFile} need to be in the same
#' format, and are recognized by their extension (.fq, .fastq, .fa,
#' .fasta, .fna, .bam), in raw or compressed form (e.g. .fastq.gz). If
#' bam files are provided, then no alignments are generated by
#' \code{qAlign}, and the alignments contained in the bam files will be
#' used instead.
#'
#' The column names in \code{sampleFile} have to match to the ones in the
#' examples below, for a single-read experiment:
#' \tabular{ll}{
#'   FileName        \tab SampleName \cr
#'   chip_1_1.fq.bz2 \tab Sample1    \cr
#'   chip_2_1.fq.bz2 \tab Sample2
#' }
#' and for a paired-end experiment:
#' \tabular{lll}{
#'   FileName1      \tab FileName2      \tab SampleName \cr
#'   rna_1_1.fq.bz2 \tab rna_1_2.fq.bz2 \tab Sample1    \cr
#'   rna_2_1.fq.bz2 \tab rna_2_2.fq.bz2 \tab Sample2
#' }
#'
#' The \dQuote{SampleName} column is the human-readable name for each
#' sample that will be used as sample labels. Multiple sequence files may
#' be associated to the same sample name, which instructs \code{QuasR} to
#' combine those files.
#'
#' \code{auxiliaryFile} is a tab-delimited text file listing one or
#' several additional target sequence files in fasta format. Reads that
#' do not map against the reference genome will be aligned against each
#' of these target sequence files. The first row contains the column
#' names which have to match to the ones in the example below:
#' \tabular{ll}{
#'   FileName       \tab AuxName \cr
#'   NC_001422.1.fa \tab phiX174
#' }
#'
#' \code{snpFile} is a tab-delimited text file without a header and
#' contains four columns with chromosome name, position, reference allele
#' and alternative allele, as in the example below:
#' \tabular{llll}{
#'   chr1 \tab  8596 \tab G \tab A \cr
#'   chr1 \tab 18443 \tab G \tab A \cr
#'   chr1 \tab 18981 \tab C \tab T \cr
#'   chr1 \tab 19341 \tab G \tab A
#' }
#'
#' The reference and alternative alleles will be injected into the
#' reference genome, resulting in two separate genomes. All reads will be
#' aligned separately to both of these genomes, and the alignments will
#' be combined, only retaining the best alignment for each read. In the
#' final alignment, each read will be marked with a tag that classifies
#' it into reference (\code{R}), alternative (\code{A}) or unknown
#' (\code{U}), if the reads maps equally well to both genomes.
#'
#' If \code{bisulfite} is set to \dQuote{dir} or \dQuote{undir}, reads
#' will be C-to-T converted and aligned to a similarly converted genome.
#'
#' If \code{alignmentParameter} is \code{NULL} (recommended),
#' \code{qAlign} will select default parameters that are suitable for the
#' experiment type. Please note that for bisulfite or allele-specific
#' experiments, each read is aligned multiple times, and resulting
#' alignments need to be combined. This requires special settings for the
#' alignment parameters that are not recommended to be changed. For
#' \sQuote{simple} experiments (neither bisulfite, allele-specific, nor
#' spliced), alignments are generated using the parameters \code{-m
#' maxHits --best --strata}. This will align reads with up to
#' \dQuote{maxHits} best hits in the genome and selects one of them randomly.
#'
#' @param  sampleFile The name of a text file listing input sequence files
#'   and sample names (see \sQuote{Details}).
#' @param genome The reference genome for primary alignments, one of:
#' \itemize{
#'   \item a string referring to a \dQuote{BSgenome} package
#'   (e.g. \dQuote{"BSgenome.Hsapiens.UCSC.hg19"}), which will be
#'   downloaded automatically from Bioconductor if not present
#'   \item the name of a fasta sequence file containing one or
#'   several sequences (chromosomes) to be used as a reference. The aligner
#'   index will be created when necessary and stored in a default
#'   location (see \sQuote{Details}).
#' }
#' @param auxiliaryFile The name of a text file listing sequences to be
#'   used as additional targets for alignment of reads not mapping to the
#'   reference genome (see \sQuote{Details}).
#' @param aligner selects the aligner program to be used for aligning the
#'   reads. Currently, only \dQuote{Rbowtie} and \dQuote{Rhisat2} are supported,
#'   which are R wrapper packages for \sQuote{bowtie} / \sQuote{SpliceMap} and
#'   \sQuote{hisat2}, respectively (see \code{\link[Rbowtie]{Rbowtie-package}} and
#'   \code{\link[Rhisat2]{Rhisat2-package}} packages).
#' @param maxHits sets the maximal number of allowed mapping positions
#'   per read (default: 1). If a read produces more than \code{maxHits}
#'   alignments, no alignments will be reported for it. In case of a
#'   multi-mapping read, a single alignment is randomly selected.
#' @param paired defines the type of paired-end library and can be set to
#'   one of \code{no} (single read experiment, default), \code{fr} (fw/rev),
#'   \code{ff} (fw/fw) or \code{rf} (rev/fw).
#' @param splicedAlignment If \code{TRUE}, reads will be aligned using a
#'   spliced aligner, depending on the value of \code{aligner} described above:
#'   \describe{
#'     \item{\code{aligner="Rhisat2"}}{: This is the recommended setting
#'     for spliced alignments and will use hisat2 from the
#'     \code{\link[Rhisat2]{Rhisat2-package}}. See also the \code{geneAnnotation}
#'     argument below for providing known exon-exon junctions.}
#'     \item{\code{aligner="Rbowtie"}}{: This is not recommended and only
#'     available for legacy reasons. It will use SpliceMap to produce spliced
#'     alignments (without using a database of known exon-exon junctions).
#'     Compared to the alternative alignment modes (non-spliced or spliced using
#'     \code{Rhisat2} as aligner), this alignment mode is about ten-fold slower
#'     and also less sensitive. Furthermore, SpliceMap can only be used for
#'     reads with a minimal length of 50nt; SpliceMap ignores reads that are
#'     shorter, and these reads will not be contained in the BAM file,
#'     neither as mapped or unmapped reads.}
#'   }
#' @param snpFile The name of a text file listing single nucleotide
#'   polymorphisms to be used for allele-specific alignment and
#'   quantification (see \sQuote{Details}).
#' @param bisulfite For bisulfite-converted samples (Bis-seq), the type
#'   of bisulfite library (\dQuote{dir} for directional libraries,
#'   \dQuote{undir} for undirectional libraries).
#' @param alignmentParameter An optional string containing command line
#'   parameters to be used for the aligner, to overrule the default
#'   alignment parameters used by \code{QuasR}. Please use with caution;
#'   some alignment parameters may break assumptions made by
#'   \code{QuasR}. Default parameters are listed in \sQuote{Details}.
#' @param projectName An optional name for the alignment project.
#' @param alignmentsDir The directory to be used for storing alignments
#'   (bam files). If set to \code{NULL} (default), bam files will be
#'   generated at the location of the input sequence files.
#' @param lib.loc can be used to change the default library path of
#'   R. The library path is used by \code{QuasR} to store aligner index
#'   packages created from \code{BSgenome} reference genomes.
#' @param cacheDir specifies the location to store (potentially huge)
#'   temporary files. If set to \code{NULL} (default), the temporary
#'   directory of the current R session as returned by \code{tempdir()}
#'   will be used.
#' @param clObj A cluster object, created by the package \pkg{parallel}, to
#'   enable parallel processing and speed up the alignment process.
#' @param checkOnly If \code{TRUE}, prevents the automatic creation of
#'   alignments or aligner indices. This allows to quickly check for missing
#'   alignment files without starting the potentially long process of
#'   their creation. In the case of missing alignments or indices, an
#'   exception is thrown.
#' @param geneAnnotation Only used if \code{aligner} is \code{"Rhisat2"}.
#'   The path to either a gtf file or a sqlite database generated by exporting
#'   a \code{TxDb} object. This file is used to generate a splice site file
#'   for \code{Rhisat2}, that will be used to guide the spliced alignment.
#'   Please note that if using an sqlite database file, do not use the one
#'   contained in the installed package folder of a \code{TxDb} package.
#'   \code{QuasR} (through \code{Rhisat2}) creates additional files in the
#'   folder which would interfere with the loading of the TxDb package.
#'
#' @export
#'
#' @return A \code{\link[=qProject-class]{qProject}} object.
#'
#' @author Anita Lerch, Dimos Gaidatzis, Charlotte Soneson and Michael Stadler
#' @keywords utilities misc
#'
#' @seealso
#' \code{\link[=qProject-class]{qProject}},
#' \code{\link[parallel]{makeCluster}} from package \pkg{parallel},
#' \code{\link[Rbowtie]{Rbowtie-package}} package,
#' \code{\link[Rhisat2]{Rhisat2-package}} package
#'
#' @name qAlign
#' @aliases qAlign
#'
#' @examples
#' \dontrun{
#' # see qCount, qMeth and qProfile manual pages for examples
#' example(qCount)
#' example(qMeth)
#' example(qProfile)
#' }
#'
qAlign <- function(sampleFile, genome, auxiliaryFile = NULL, aligner = "Rbowtie",
                   maxHits = 1, paired = NULL, splicedAlignment = FALSE,
                   snpFile = NULL, bisulfite = "no", alignmentParameter = NULL,
                   projectName = "qProject", alignmentsDir = NULL, lib.loc = NULL,
                   cacheDir = NULL, clObj = NULL, checkOnly = FALSE,
                   geneAnnotation = NULL) {

    # check if the user provided a samplefile and a genome
    if (missing(sampleFile)) {
        stop("Missing 'sampleFile' parameter.")
    }
    if (missing(genome)) {
        stop("Missing 'genome' parameter.")
    }

    # create a qProject, perform various tests, check for installed
    # BSgenome and load aligner packages
    # create fasta indices (.fai) files for all the reference sequences
    # (genome & aux) as well as all md5 sum files
    proj <- createQProject(sampleFile, genome, auxiliaryFile, aligner,
                           maxHits, paired, splicedAlignment, snpFile,
                           bisulfite, alignmentParameter, projectName,
                           alignmentsDir, lib.loc, cacheDir, geneAnnotation)

    # display the status of the project. in case of checkOnly=TRUE,
    # throw an exception if there are alignment files missing
    missingFilesMessage(proj, checkOnly)

    # check if there are any genomic alignment files missing. if so,
    # create index and align
    if (any(is.na(proj@alignments$FileName))) {
        # build genome index
        if (is.na(proj@snpFile)) {
            if (proj@genomeFormat == "file") {
                buildIndex(proj@genome, paste(proj@genome, proj@alnModeID, sep = "."),
                           proj@alnModeID, resolveCacheDir(proj@cacheDir))
            } else if (proj@genomeFormat == "BSgenome") {
                buildIndexPackage(proj@genome, proj@aligner, proj@alnModeID,
                                  resolveCacheDir(proj@cacheDir), proj@lib.loc)
            } else {
                stop("Fatal error 45906")
            }
        } else {
            # create indices for the two secondary genomes specified by snps
            buildIndexSNP(proj@snpFile, paste(proj@snpFile, proj@alnModeID, sep = "."),
                          proj@genome, proj@genomeFormat, proj@alnModeID,
                          resolveCacheDir(proj@cacheDir))
        }

        # Rhisat2, generate splice site file
        if (proj@aligner == "Rhisat2" && !is.na(proj@geneAnnotation)) {
            buildSpliceSiteFile(proj@geneAnnotation, proj@geneAnnotationFormat)
        }

        # align to the genome (qProject gets updated with the alignment file names)
        proj <- createGenomicAlignments(proj, clObj)

    }

    # create indices for the auxiliary files if necessary
    # (if there are any alignment files missing)
    if (any(is.na(proj@auxAlignments))) {
        for (i in seq_len(nrow(proj@aux))) {
            buildIndex(proj@aux$FileName[i],
                       paste(proj@aux$FileName[i], proj@alnModeID, sep = "."),
                       proj@alnModeID, resolveCacheDir(proj@cacheDir),
                       checkMD5 = TRUE)
        }

        proj <- createAuxAlignments(proj, clObj)
    }
    return(proj)
}


# inspect the qProject and give an overview of all the files that need to be computed
#' @keywords internal
#' @importFrom Seqinfo seqlengths
#' @importFrom Rsamtools scanBamHeader
#' @importFrom utils flush.console installed.packages
#' @importFrom stats na.omit
missingFilesMessage <- function(proj, checkOnly) {

    genomeIndexNeedsToBeCreated <- FALSE
    spliceSiteFileNeedsToBeCreated <- FALSE
    genomicAlignmentsNeedToBeCreated <- sum(is.na(proj@alignments$FileName))
    auxAlignmentsNeedToBeCreated <- sum(is.na(proj@auxAlignments))

    if (any(is.na(proj@alignments$FileName))) {
        if (is.na(proj@snpFile)) {
            if (proj@genomeFormat == "file") {
                indexPath <- paste(proj@genome, proj@alnModeID, sep = ".")
                if (file.exists(indexPath)) {
                    if (!("ref_md5Sum.txt" %in% dir(indexPath))) {
                        genomeIndexNeedsToBeCreated <- TRUE
                    }
                } else {
                    genomeIndexNeedsToBeCreated <- TRUE
                }
            } else if (proj@genomeFormat == "BSgenome") {
                indexPackageName <- paste(proj@genome, proj@alnModeID, sep = ".")
                if (!(indexPackageName %in% utils::installed.packages()[, 'Package'])) {
                    genomeIndexNeedsToBeCreated <- TRUE
                }
            } else {
                stop("'genomeFormat' must be 'file' or 'BSgenome'")
            }
        } else {
            indexPathR <- paste(proj@snpFile, basename(proj@genome),
                                "R", "fa", proj@alnModeID, sep = ".")
            indexPathA <- paste(proj@snpFile, basename(proj@genome),
                                "A", "fa", proj@alnModeID, sep = ".")

            if (file.exists(indexPathR) & file.exists(indexPathA)) {
                if (!("ref_md5Sum.txt" %in% dir(indexPathR)) |
                    !("ref_md5Sum.txt" %in% dir(indexPathA))) {
                    genomeIndexNeedsToBeCreated <- TRUE
                }
            } else {
                genomeIndexNeedsToBeCreated <- TRUE
            }
        }

        ## Splice site file
        if (!is.null(proj@geneAnnotation) && !is.na(proj@geneAnnotation)) {
            if (!file.exists(paste0(proj@geneAnnotation, ".SpliceSites.txt"))) {
                spliceSiteFileNeedsToBeCreated <- TRUE
            }
        }
    }

    ## for non-bam projects, check if sequence names and lengths in pre-existing
    ## bam files are consistent with BSgenome reference
    if (proj@samplesFormat != "bam" && any(!is.na(proj@alignments$FileName)) &&
        proj@genomeFormat == "BSgenome") {
        refchrs <- Seqinfo::seqlengths(get(proj@genome))
        refchrs <- refchrs[order(names(refchrs))]
        bamchrsL <- lapply(Rsamtools::scanBamHeader(
            stats::na.omit(proj@alignments$FileName)),
            function(bh) {
                x <- bh$targets
                x[order(names(x))]
            })
        ok <- unlist(lapply(bamchrsL, function(x) identical(x, refchrs)))
        if (!all(ok)) {
            warnfiles <- stats::na.omit(proj@alignments$FileName)[!ok]
            warning("The genome in ", proj@genome,
                    " has changed since some bam files\n",
                    "in this project were generated.\n",
                    "The following pre-existing bam files were generated for a\n",
                    "genome that is inconsistent with the current verion of ",
                    proj@genome, ":\n  ",
                    paste(warnfiles, collapse = "\n  "))
        }
    }

    if (!genomeIndexNeedsToBeCreated & !spliceSiteFileNeedsToBeCreated &
        genomicAlignmentsNeedToBeCreated == 0 & auxAlignmentsNeedToBeCreated == 0) {
        message("all necessary alignment files found")
    } else {
        message("alignment files missing - need to:")
        if (genomeIndexNeedsToBeCreated) {
            message("    create alignment index for the genome")
        }
        if (spliceSiteFileNeedsToBeCreated) {
            message("    create splice site file for gene annotation")
        }
        if (genomicAlignmentsNeedToBeCreated > 0) {
            message("    create ", genomicAlignmentsNeedToBeCreated,
                    " genomic alignment(s)")
        }
        if (auxAlignmentsNeedToBeCreated > 0) {
            message("    create ", auxAlignmentsNeedToBeCreated,
                    " auxiliary alignment(s)")
        }

        if (checkOnly) {
            stop("alignment or index files are missing and checkOnly=TRUE. ",
                 "Aborting execution", call. = FALSE)
        }

        if (interactive()) {
            message("will start in ", appendLF = FALSE); utils::flush.console()
            for (i in 9:1) {
                message("..", i, "s", appendLF = FALSE); utils::flush.console()
                Sys.sleep(1)
            }
            message("")
        }
    }
}


# read all the input information, perform various checks and compile the data into a qProject object
#' @keywords internal
#' @importFrom tools file_path_as_absolute file_ext file_path_sans_ext
#' @importFrom BSgenome available.genomes
#' @importFrom ShortRead FastqStreamer yield
#' @importFrom Biostrings quality
#' @importFrom Biobase testBioCConnection
#' @importFrom methods new is
#' @importFrom utils installed.packages read.delim
createQProject <- function(sampleFile, genome, auxiliaryFile, aligner,
                           maxHits, paired, splicedAlignment,
                           snpFile, bisulfite, alignmentParameter,
                           projectName, alignmentsDir,
                           lib.loc, cacheDir, geneAnnotation) {

    # instantiate a qProject
    proj <- methods::new("qProject")

    # -----------DETERMINE THE FORMAT OF THE GENOME AND DOWNLOAD FROM BIOCONDUCTOR IF NEEDED -------------

    if (length(genome) != 1) {
        stop("The genome parameter should contain only a single entry", call. = FALSE)
    }

    # if there exists a / or \\ at the end of the genome string, remove it.
    # this is required for the consistent behavior of file.exists on windows
    # systems. file.exists("dir/") != file.exists("dir").
    genome <- sub("(\\\\|/)$", "", genome)

    if (file.exists(genome)) {
        # genome is a directory or a file
        if (!(file.info(genome)$isdir)) {
            # genome is a file, check if it is a fasta file
            if (consolidateFileExtensions(genome) == "fasta") {
                proj@genome <- tools::file_path_as_absolute(genome)
                proj@genomeFormat <- "file"
            } else {
                stop("The specified genome ", genome,
                     " does not have the extension of a fasta file (fa,fasta,fna)",
                     call. = FALSE)
            }
        } else {
            # genome is a directory
            stop("The specified genome has to be a file and not a directory: ",
                 genome, call. = FALSE)
        }
    } else {
        # check if the genome is a BSgenome.
        if (genome %in% utils::installed.packages(lib.loc = lib.loc)[, 'Package']) {
            # BSgenome is already installed, load it
            if (!require(genome, character.only = TRUE, quietly = TRUE,
                         lib.loc = c(lib.loc, .libPaths()))) {
                stop("The BSgenome ", genome,
                     " is installed but cannot be loaded. ",
                     "The version of the BSgenome might be outdated ",
                     "(verify using BiocManager::valid()).",
                     call. = FALSE)
            }

            proj@genome <- genome
            proj@genomeFormat <- "BSgenome"
        } else {
            message("The specified genome is not a fasta file or an installed BSgenome.")
            message("Connecting to Bioconductor to check for available genomes ",
                    "(internet connection required)...", appendLF = FALSE)

            if (Biobase::testBioCConnection()) {
                # Connection to Bioconductor OK
                message("OK")
                if (genome %in% BSgenome::available.genomes()) {
                    # The genome is available in Bioconductor,
                    # request installation
                    message(genome, " is available from Bioconductor.")
                    stop("Please install ", genome, " using:\n",
                         "   BiocManager::install(\"", genome, "\")\n",
                         "before calling qAlign.", call. = FALSE)

                } else {
                    # The genome is not available in Bioconductor
                    stop(genome,
                         " is not available from Bioconductor. ",
                         "Use BSgenome::available.genomes() for a complete list.",
                         call. = FALSE)
                }
            } else {
                # No connection to Bioconductor
                stop("Could not check if ", genome,
                     " is available from Bioconductor.\n",
                     "Use BSgenome::available.genomes() for a complete list,\n",
                     "and install ", genome, " using:\n",
                     "   BiocManager::install(\"", genome, "\")\n",
                     "before calling qAlign.", call. = FALSE)

            }
        }
    }

    # --------------------------------- PROCESS THE GENOME ANNOTATION ---------------------------------
    if (!is.null(geneAnnotation)) {
        if (methods::is(geneAnnotation, "character") && length(geneAnnotation) == 1 &&
            file.exists(geneAnnotation) &&
            tools::file_ext(geneAnnotation) %in% c("gtf", "gff", "gff3", "sqlite")) {
            if (tools::file_ext(geneAnnotation) == "sqlite") {
                proj@geneAnnotationFormat <- "TxDb"
            } else {
                proj@geneAnnotationFormat <- "gtf"
            }
        } else {
            stop("'geneAnnotation' must be a path to an existing sqlite, gtf or gff file.")
        }
        proj@geneAnnotation <- tools::file_path_as_absolute(geneAnnotation)
    } else {
        proj@geneAnnotation <- NA_character_
        proj@geneAnnotationFormat <- NA_character_
    }

    # ---------------------------------------- PARSE THE PAIRED PARAMETER ---------------------------------
    if (!is.null(paired)) {
        if (!(paired %in% c("no", "fr", "rf", "ff"))) {
            stop("The parameter paired supports only NULL, 'no', 'fr', 'rf' and 'ff'",
                 call. = FALSE)
        }
    }

    # ---------------------------------------- PARSE THE SAMPLE FILE -------------------------------------
    if (!file.exists(sampleFile)) {
        stop("Cannot open ", sampleFile, call. = FALSE)
    }
    samples <- utils::read.delim(sampleFile, header = TRUE, colClasses = "character")

    if (nrow(samples) == 0) {
        stop(sampleFile," is either empty or there is a header missing", call. = FALSE)
    }

    # get absolute path of the sample.txt file
    sampleFileAbsolutePath <- dirname(tools::file_path_as_absolute(sampleFile))

    # Check if the reads are single end
    if (ncol(samples) == 2) {
        if (all(colnames(samples) == c("FileName", "SampleName"))) {
            # this is a valid single end samples file. check if listed files exist
            for (i in seq_len(nrow(samples))) {
                pathRet <- pathAsAbsoluteRedirected(samples$FileName[i],
                                                    sampleFileAbsolutePath)
                if (!is.null(pathRet)) {
                    if (samples$SampleName[i] == "") {
                        stop(samples$FileName[i], " listed in ", sampleFile,
                             " has no sample name", call. = FALSE)
                    }
                    samples$FileName[i] <- pathRet
                } else {
                    stop(samples$FileName[i], " listed in ", sampleFile,
                         " does not exist", call. = FALSE)
                }
            }
            # determine format of the files (fa,fasta,fna)
            proj@samplesFormat <- determineSamplesFormat(samples$FileName)

            if (proj@samplesFormat == "bam") {
                # samples are provided as bam files
                if (is.null(paired)) {
                    stop("Paired status of the provided bam files cannot be ",
                         "determined automatically, please set the paired parameter",
                         call. = FALSE)
                }

                if (length(unique(samples$FileName)) != nrow(samples)) {
                    stop("There are duplicate files in sampleFile. ",
                         "This is not allowed.", call. = FALSE)
                }

                if (paired == "no") {
                    proj@reads <- samples
                    proj@reads$FileName <- NA_character_
                } else {
                    proj@reads <- data.frame(FileName1 = NA_character_,
                                             FileName2 = NA_character_,
                                             SampleName = samples$SampleName,
                                             stringsAsFactors = FALSE)
                }

                proj@paired <- paired
                proj@alignments <- samples
            } else {
                # samples are provided as reads
                if (!is.null(paired)) {
                    if (paired != "no") {
                        stop(sampleFile,
                             " contains 2 columns which represents unpaired end data.",
                             " Please reset the paired parameter",
                             call. = FALSE)
                    }
                }
                if (length(unique(samples$FileName)) != nrow(samples)) {
                    stop("There are duplicate files in sampleFile. ",
                         "This is not allowed as it would result in ",
                         "non-unique alignment file names",
                         call. = FALSE)
                }

                proj@paired <- "no"
                proj@reads <- samples
                proj@alignments <- samples
                proj@alignments$FileName <- NA_character_
            }
        } else {
            # incorrect format
            stop(sampleFile,
                 " should contain column names FileName,SampleName (single end data)",
                 call. = FALSE)
        }
        # Check if the reads are paired data
    } else if (ncol(samples) == 3) {
        if (all(colnames(samples) == c("FileName1", "FileName2", "SampleName"))) {
            # this is a valid paired end samples file. check if listed files exist
            for (i in seq_len(nrow(samples))) {
                pathRet <- pathAsAbsoluteRedirected(samples$FileName1[i],
                                                    sampleFileAbsolutePath)
                if (!is.null(pathRet)) {
                    if (samples$SampleName[i] == "") {
                        stop(samples$FileName1[i], " listed in ",
                             sampleFile, " has no sample name", call. = FALSE)
                    }
                    samples$FileName1[i] <- pathRet
                } else {
                    stop(samples$FileName1[i], " listed in ", sampleFile,
                         " does not exist", call. = FALSE)
                }
            }
            for (i in seq_len(nrow(samples))) {
                pathRet <- pathAsAbsoluteRedirected(samples$FileName2[i],
                                                    sampleFileAbsolutePath)
                if (!is.null(pathRet)) {
                    if (samples$SampleName[i] == "") {
                        stop(samples$FileName2[i], " listed in ",
                             sampleFile, " has no sample name", call. = FALSE)
                    }

                    samples$FileName2[i] <- pathRet
                } else {
                    stop(samples$FileName2[i], " listed in ",
                         sampleFile, " does not exist", call. = FALSE)
                }
            }
            # determine format of the files (fa,fasta,fna)
            proj@samplesFormat <- determineSamplesFormat(c(samples$FileName1,
                                                           samples$FileName2))

            if (proj@samplesFormat == "bam") {
                stop("Bam files need to be listed in a two column file: ",
                     sampleFile, call. = FALSE)
            }
            if (!is.null(paired)) {
                if (paired == "no") {
                    stop(sampleFile,
                         " contains 3 columns which represents paired end data. ",
                         "Please reset the paired parameter",
                         call. = FALSE)
                }
            }
            if (length(unique(c(samples$FileName1, samples$FileName2))) !=
                (2 * nrow(samples))) {
                stop("There are duplicate files in sampleFile. ",
                     "This is not allowed as it would result in ",
                     "non-unique alignment file names",
                     call. = FALSE)
            }

            if (is.null(paired)) {
                proj@paired <- "fr"
            } else {
                proj@paired <- paired
            }

            proj@reads <- samples
            proj@alignments <- data.frame(FileName = NA_character_,
                                          SampleName = samples$SampleName,
                                          stringsAsFactors = FALSE)

        } else {
            # incorrect format
            stop(sampleFile,
                 " should contain the column names FileName1,FileName2,SampleName (paired end data)",
                 call. = FALSE)
        }
        # The format of the file is not supported
    } else {
        stop(sampleFile,
             " should be a tab delimited file with either 2 or 3 columns",
             call. = FALSE)
    }


    # --------------- FOR FASTQ FILES, READ A SMALL CHUNK TO GUESS THE QUALITY FORMAT (phred33 or phred64) -------
    if (proj@samplesFormat == "fastq") {
        # add an additional quality column to the reads table
        proj@reads <- data.frame(proj@reads, phred = NA_character_,
                                 stringsAsFactors = FALSE)
        # switch off omp parallelization in ShortRead::FastqStreamer
        nthreads <- .Call(ShortRead:::.set_omp_threads, 1L)
        for (i in seq_len(nrow(proj@reads))) {
            # take only first column even for paired end data
            fastq_fs <- ShortRead::FastqStreamer(proj@reads[i, 1], n = 2000,
                                                 readerBlockSize = 5e5)

            tryCatch({
                fastq_sq <- ShortRead::yield(fastq_fs)
            }, error = function(ex) {
                close(fastq_fs)
                stop("Incorrect format for the fastq file: ",
                     proj@reads[i, 1], call. = FALSE)
            })
            close(fastq_fs)
            # determine the format of the quality values
            if (inherits(Biostrings::quality(fastq_sq), "FastqQuality")) {
                proj@reads$phred[i] <- "33"
            } else if (inherits(Biostrings::quality(fastq_sq), "SFastqQuality")) {
                proj@reads$phred[i] <- "64"
            } else {
                stop("The quality values of the provided sequences files are not interpretable: ",
                     proj@reads[i, 1], call. = FALSE)
            }
        }
        # switch back on omp parallelization in ShortRead::FastqStreamer
        .Call(ShortRead:::.set_omp_threads, nthreads)
    }


    # -------------------- CALCULATE MD5 SUB SUMS FOR ALL READ FILES ----------------------------------------
    if (proj@samplesFormat != "bam") {
        if (proj@paired == "no") {
            proj@reads_md5subsum <- data.frame(
                md5subsum = md5subsum(proj@reads$FileName),
                stringsAsFactors = FALSE
            )
        } else {
            proj@reads_md5subsum <- data.frame(
                md5subsum1 = md5subsum(proj@reads$FileName1),
                md5subsum2 = md5subsum(proj@reads$FileName2),
                stringsAsFactors = FALSE)
        }
    } else {
        if (proj@paired == "no") {
            proj@reads_md5subsum <- as.data.frame(
                matrix(NA_character_, nrow = nrow(proj@reads), ncol = 1),
                stringsAsFactors = FALSE
            )
            colnames(proj@reads_md5subsum) <- "md5subsum"
        } else {
            proj@reads_md5subsum <- as.data.frame(
                matrix(NA_character_, nrow = nrow(proj@reads), ncol = 2),
                stringsAsFactors = FALSE
            )
            colnames(proj@reads_md5subsum) <- c("md5subsum1", "md5subsum2")
        }
    }

    # ----------------------------------- PARSE THE SNP FILE ------------------------------------

    if (!is.null(snpFile)) {
        if (!file.exists(snpFile)) {
            stop("Cannot open ", snpFile, call. = FALSE)
        }
        proj@snpFile <- tools::file_path_as_absolute(snpFile)
    } else {
        proj@snpFile <- NA_character_
    }


    # ---------------------------------------- PARSE THE AUXILIARY FILE -------------------------------------
    if (!is.null(auxiliaryFile)) {
        if (proj@samplesFormat == "bam") {
            stop("The option 'auxiliaryFile' is not supported for bam input files",
                 call. = FALSE)
        }
        if (!is.na(proj@snpFile)) {
            stop("The option 'auxiliaryFile' is not supported in allelic mode",
                 call. = FALSE)
        }
        if (!file.exists(auxiliaryFile)) {
            stop("Cannot open ", auxiliaryFile, call. = FALSE)
        }
        auxiliaries <- utils::read.delim(auxiliaryFile, header = TRUE,
                                         colClasses = "character")

        if (nrow(auxiliaries) == 0) {
            stop(auxiliaryFile, " is either empty or there is a header missing",
                 call. = FALSE)
        }

        # get absolute path of the auxiliary.txt file
        auxFileAbsolutePath <- dirname(tools::file_path_as_absolute(auxiliaryFile))

        if (ncol(auxiliaries) == 2) {
            if (all(colnames(auxiliaries) == c("FileName", "AuxName"))) {
                # this is a valid auxiliaries file. check if listed files exist
                for (i in seq_len(nrow(auxiliaries))) {
                    pathRet <- pathAsAbsoluteRedirected(auxiliaries$FileName[i],
                                                        auxFileAbsolutePath)
                    if (!is.null(pathRet)) {
                        if (auxiliaries$AuxName[i] == "") {
                            stop(auxiliaries$FileName[i], " listed in ",
                                 auxiliaryFile, " has no name", call. = FALSE)
                        }
                        auxiliaries$FileName[i] <- pathRet
                    } else {
                        stop(auxiliaries$FileName[i], " listed in ",
                             auxiliaryFile, " does not exist", call. = FALSE)
                    }
                }
                # test the file extensions
                allAuxFileExts <- unique(consolidateFileExtensions(auxiliaries$FileName))
                if (!all(consolidateFileExtensions(auxiliaries$FileName) == "fasta")) {
                    stop("All auxiliary files need to have a fasta extension (fa,fasta,fna)", call. = FALSE)
                }

                if (length(unique(auxiliaries$AuxName)) != nrow(auxiliaries)) {
                    stop("All auxiliary files need to have a unique AuxName",
                         call. = FALSE)
                }

                # store the auxiliary files
                proj@aux <- auxiliaries
            } else {
                # incorrect format
                stop(auxiliaryFile,
                     " should contain column names FileName,AuxName",
                     call. = FALSE)
            }
        } else {
            stop(auxiliaryFile,
                 " should be a tab delimited file with 2 columns", call. = FALSE)
        }

        # Fill data into auxAlignments
        auxAlignments <- data.frame(
            matrix(NA_character_, nrow = nrow(auxiliaries), ncol = nrow(proj@reads)),
            stringsAsFactors = FALSE
        )
        rownames(auxAlignments) <- auxiliaries$AuxName
        colnames(auxAlignments) <- proj@reads$SampleName
        proj@auxAlignments <- auxAlignments

    }


    # ----------------------------------- PARSE BISULFITE PARAMETER -----------------------------------

    if (bisulfite %in% c("no", "dir", "undir")) {
        proj@bisulfite <- bisulfite
        if (bisulfite != "no" && !(proj@paired %in% c("no", "fr"))) {
            stop("Bisulfite paired-end mode only supports pair orientation 'fr'",
                 call. = FALSE)
        }
    } else {
        stop("Bisulfite mode only supports 'no', 'dir' and 'undir'", call. = FALSE)
    }

    # ----------------------------------- PARSE MAXHITS PARAMETER --------------------------------------
    proj@maxHits <- maxHits

    #------------------------------------ PARSE THE PROJECT NAME ----------------------------------
    if (is.null(projectName)) {
        proj@projectName <- NA_character_
    } else {
        if (length(projectName) == 1) {
            proj@projectName <- projectName
        } else {
            stop("The projectName should contain only a single entry",
                 call. = FALSE)
        }
    }

    # ---------------------------------- PARSE THE BAMFILE DIRECTORY --------------------------
    if (is.null(alignmentsDir)) {
        proj@alignmentsDir <- NA_character_
    } else {
        alignmentsDir <- sub("(\\\\|/)$", "", alignmentsDir)  # for windows systems
        if (file.exists(alignmentsDir)) {
            # it's a directory or a file
            if (file.info(alignmentsDir)$isdir) {
                proj@alignmentsDir <- tools::file_path_as_absolute(alignmentsDir)
            } else {
                stop("alignmentsDir ", alignmentsDir,
                     " is not a directory", call. = FALSE)
            }
        } else {
            stop("alignmentsDir ", alignmentsDir, " does not exist", call. = FALSE)
        }
    }

    # ---------------------------------- PARSE THE LIB.LOC DIRECTORY --------------------------
    if (is.null(lib.loc)) {
        proj@lib.loc <- NA_character_
    } else {
        lib.loc <- sub("(\\\\|/)$", "", lib.loc)  # for windows systems
        if (file.exists(lib.loc)) {
            # it's a directory or a file
            if (file.info(lib.loc)$isdir) {
                proj@lib.loc <- tools::file_path_as_absolute(lib.loc)
            } else {
                stop("lib.loc ", lib.loc, " is not a directory", call. = FALSE)
            }
        } else {
            stop("lib.loc ", lib.loc, " does not exist", call. = FALSE)
        }
    }

    # ---------------------------------- PARSE THE CACHE DIRECTORY --------------------------

    if (is.null(cacheDir)) {
        proj@cacheDir <- NA_character_
    } else {
        cacheDir <- sub("(\\\\|/)$", "", cacheDir)  # for windows systems
        if (file.exists(cacheDir)) {
            # it's a directory or a file
            if (file.info(cacheDir)$isdir) {
                # if not already present, create a subdirectory in the cacheDir,
                # this prevent collisions
                # when the the same cacheDir is being used by multiple users
                proj@cacheDir <- file.path(tools::file_path_as_absolute(cacheDir),
                                           basename(tempdir()))

                if (!file.exists(proj@cacheDir)) {
                    if (!dir.create(path = proj@cacheDir, showWarnings = FALSE)) {
                        stop("No permissions to write in the cacheDir: ",
                             proj@cacheDir, call. = FALSE)
                    }
                }
            } else {
                stop("cacheDir ", cacheDir, " is not a directory", call. = FALSE)
            }
        } else {
            stop("cacheDir ", cacheDir, " does not exist", call. = FALSE)
        }
    }


    # --------------- SET THE ALIGNERMODE ID AND LOAD THE ALIGNER PACKAGE IF REQUIRED --------------------

    supportedAligners <- c("Rbowtie", "Rhisat2")
    if (aligner %in% supportedAligners) {
        proj@aligner <- aligner
    } else {
        stop("The specified aligner is unknown, please select one of the following: ",
             paste(supportedAligners, collapse = ","), call. = FALSE)
    }

    if ((proj@samplesFormat %in% c("fasta", "fastq")) & (proj@bisulfite == "no")) {
        alnModeID <- proj@aligner
    } else if ((proj@samplesFormat %in% c("fasta", "fastq")) &
               (proj@bisulfite != "no")) {
        if (aligner == "Rhisat2") {
            stop("Bisulfite alignment mode is not available for Rhisat2")
        }
        alnModeID <- paste(proj@aligner, "CtoT", sep = "")
    } else if ((proj@samplesFormat %in% c("csfasta", "csfastq")) &
               proj@bisulfite == "no") {
        if (aligner == "Rhisat2") {
            stop("Color space alignment mode is not available for Rhisat2")
        }
        alnModeID <- paste(proj@aligner, "Cs", sep = "")
    } else if ((proj@samplesFormat %in% c("csfasta","csfastq")) &
               proj@bisulfite != "no") {
        stop("Bisulfite alignment mode is not available for color space reads")
    } else if (proj@samplesFormat == "bam") {
        alnModeID <- NA_character_
        proj@aligner <- NA_character_
    } else {
        stop("Fatal error 2340923")
    }

    proj@alnModeID <- alnModeID

    # load the aligner package in the case where there are missing
    # alignments (genomic or aux)
    if (any(is.na(proj@alignments$FileName)) | any(is.na(proj@auxAlignments))) {

        pkgname <- aligner

        if (!requireNamespace(pkgname, quietly = TRUE)) {
            stop("The ", pkgname, " package is required for alignments, but not ",
                 "installed.\nInstall it using BiocManager::install(\"", pkgname, "\")",
                 call. = FALSE)
        }
        # these test are not needed while Rbowtie is in "Depends"
        #if(!(pkgname %in% installed.packages()[,"Package"])){stop(pkgname, " package is required for the alignments but not installed on this system",call.=FALSE)}
        #if(!require(pkgname, character.only=TRUE, quietly=TRUE)){stop("Fatal error 340954")}
        #pkg_version <- as.character(packageVersion(pkgname))
        #QuasR_suggests <- unlist(strsplit(installed.packages()['QuasR','Suggests'], ","))
        #QuasR_suggests_pkg <- grep(pkgname, QuasR_suggests, value=T)
    }

    #------------------------------------ PARSE SPLICED ALIGNMENT PARAMETER ---------------------------
    proj@splicedAlignment <- splicedAlignment
    if (proj@splicedAlignment & (proj@bisulfite != "no")) {
        stop("The spliced alignment mode is not supported for bisulfite samples")
    }
    if (!is.na(proj@aligner) && proj@aligner == "Rbowtie" && proj@splicedAlignment &&
        !(proj@paired %in% c("no", "fr"))) {
        stop("The spliced alignment mode with Rbowtie only supports the pair orientation 'fr'")
    }

    #------------------------------------ PARSE THE ALIGNMENT PARAMETERS ----------------------------------
    if (is.na(proj@aligner)) {
        proj@alignmentParameter <- ""
    } else {
        if (is.null(alignmentParameter)) {
            if (!proj@splicedAlignment) {
                if (proj@aligner == "Rbowtie") {  # bowtie
                    # Test for the case where no merge reorder is going to be
                    # executed later on. In that case maxhits needs to
                    # to be reinforced by bowtie.
                    if ((proj@bisulfite == "no") && (is.na(proj@snpFile))) {
                        proj@alignmentParameter <-
                            paste("-m", proj@maxHits, "--best --strata")
                    } else {
                        proj@alignmentParameter <-
                            paste("-k", proj@maxHits + 1, "--best --strata")
                    }
                    # For the allelic case, ignore qualities. Anyways the
                    # assignment to the R or A genome is based on sequence.
                    if ((proj@samplesFormat == "fasta") || !is.null(snpFile)) {
                        proj@alignmentParameter <-
                            paste(proj@alignmentParameter, "-v 2")
                    }
                    if (proj@paired != "no") {
                        proj@alignmentParameter <-
                            paste(proj@alignmentParameter, "--maxins 500")
                    }
                } else {  # hisat2
                    if (is.na(proj@snpFile)) {
                        proj@alignmentParameter <-
                            paste("-k", proj@maxHits + 1)
                    } else {
                        # XV tag is not added to singly aligned reads and
                        # will make qCount fail
                        proj@alignmentParameter <-
                            paste("-k", proj@maxHits + 1, "--no-mixed --no-discordant")
                    }
                }
            } else {
                if (proj@aligner == "Rbowtie") {  # spliced, bowtie
                    if (is.na(proj@snpFile)) {
                        proj@alignmentParameter <-
                            "-max_intron 400000 -min_intron 20000 -max_multi_hit 10 -selectSingleHit TRUE -seed_mismatch 1 -read_mismatch 2 -try_hard yes"
                    } else {
                        proj@alignmentParameter <-
                            "-max_intron 400000 -min_intron 20000 -max_multi_hit 10 -selectSingleHit FALSE -seed_mismatch 1 -read_mismatch 2 -try_hard yes"
                    }
                } else {  # spliced, hisat2
                    if (!is.na(proj@geneAnnotation)) {
                        proj@alignmentParameter <-
                            paste("-k", proj@maxHits + 1,
                                  "--known-splicesite-infile",
                                  paste0(proj@geneAnnotation, ".SpliceSites.txt"))
                    } else {
                        proj@alignmentParameter <-
                            paste("-k", proj@maxHits + 1)
                    }
                    if (!is.na(proj@snpFile)) {
                        # XV tag is not added to singly aligned reads and
                        # will make qCount fail
                        proj@alignmentParameter <-
                            paste(proj@alignmentParameter, "--no-mixed --no-discordant")
                    }
                }
            }
        } else {
            if (length(alignmentParameter) == 1) {
                proj@alignmentParameter <- alignmentParameter
            } else {
                stop("The alignmentParameter should contain only a ",
                     "single character string",
                     call. = FALSE)
            }
        }
    }

    # ---------------------------------- CREATE .fai AND .md5 FILES --------------------------

    # create fasta indices (.fai) files for all the reference sequences (genome & aux)
    # create all the .md5 files necessary to identify preexisting bam files
    createReferenceSequenceIndices(proj)


    # --------------------- SEARCH FOR BAM FILES THAT HAVE BEEN CREATED PREVIOUSLY ----------------------

    # search for genomic alignments
    for (i in seq_len(nrow(proj@reads))) {
        if (is.na(proj@alignments$FileName[i])) {
            projBamInfo <- bamInfoOnlyBaseName(qProjectBamInfo(proj, i))

            if (is.na(proj@alignmentsDir)) {
                bamDir <- dirname(proj@reads[i, 1])
            } else {
                bamDir <- proj@alignmentsDir
            }
            samplePrefix <- basename(tools::file_path_sans_ext(proj@reads[i, 1],
                                                               compression = TRUE))
            filesInBamDir <- list.files(bamDir, pattern = ".bam$")
            bamFilesToInspect <- filesInBamDir[sub("\\_[^\\_]+.bam$", "",
                                                   filesInBamDir) == samplePrefix]
            bamTxtFilesToInspect <- paste(file.path(bamDir, bamFilesToInspect),
                                          "txt", sep = ".")
            bamTxtFilesToInspectExist <-
                bamTxtFilesToInspect[file.exists(bamTxtFilesToInspect)]
            bamFilesToInspectWithTxt <-
                file.path(bamDir, bamFilesToInspect[file.exists(bamTxtFilesToInspect)])

            compatibleBamFileInd <- NULL
            if (length(bamTxtFilesToInspectExist) > 0) {
                for (m in seq_len(length(bamTxtFilesToInspectExist))) {
                    bamInfoT_DF <- utils::read.delim(bamTxtFilesToInspectExist[m],
                                                     header = FALSE, row.names = 1,
                                                     stringsAsFactors = FALSE)
                    bamInfoT <- bamInfoT_DF[, 1]
                    names(bamInfoT) <- rownames(bamInfoT_DF)
                    bamInfoT <- bamInfoOnlyBaseName(bamInfoT)

                    # compare the actual parameters to the one from the bam file on disk
                    ## Exclude slots related to the geneAnnotation if the aligner is Rbowtie
                    if (proj@aligner == "Rbowtie") {
                        projBamInfo <-
                            projBamInfo[!(names(projBamInfo) %in%
                                              c("geneAnnotation",
                                                "geneAnnotationFormat",
                                                "geneAnnotation.md5"))]
                        bamInfoT <-
                            bamInfoT[!(names(bamInfoT) %in%
                                           c("geneAnnotation",
                                             "geneAnnotationFormat",
                                             "geneAnnotation.md5"))]
                    }
                    if (identical(projBamInfo, bamInfoT)) {
                        compatibleBamFileInd[length(compatibleBamFileInd) + 1] <- m
                    }
                }
                if (length(compatibleBamFileInd) > 1) {
                    for (k in seq_len(length(compatibleBamFileInd))) {
                        message(bamFilesToInspectWithTxt[k])
                    }
                    stop("Multiple bam files exist with same alignment parameters (see above list). QuasR is unable to decide which one to use. Please delete manually the respective bam files", call. = FALSE)
                }
                if (length(compatibleBamFileInd) == 1) {
                    proj@alignments$FileName[i] <-
                        bamFilesToInspectWithTxt[compatibleBamFileInd]
                }
            }
        }
    }

    # search for aux alignments
    if (nrow(proj@auxAlignments) > 0) {
        for (i in seq_len(ncol(proj@auxAlignments))) {
            for (j in seq_len(nrow(proj@auxAlignments))) {
                projBamInfo <- bamInfoOnlyBaseName(qProjectBamInfo(proj, i, j))

                if (is.na(proj@auxAlignments[j, i])) {
                    if (is.na(proj@alignmentsDir)) {
                        bamDir <- dirname(proj@reads[i, 1])
                    } else {
                        bamDir <- proj@alignmentsDir
                    }
                    samplePrefix <- basename(
                        tools::file_path_sans_ext(proj@reads[i, 1], compression = TRUE))
                    filesInBamDir <- list.files(bamDir, pattern = ".bam$")
                    bamFilesToInspect <- filesInBamDir[sub("\\_[^\\_]+.bam$", "",
                                                           filesInBamDir) == samplePrefix]
                    bamTxtFilesToInspect <- paste(file.path(bamDir, bamFilesToInspect),
                                                  "txt", sep = ".")
                    bamTxtFilesToInspectExist <-
                        bamTxtFilesToInspect[file.exists(bamTxtFilesToInspect)]
                    bamFilesToInspectWithTxt <-
                        file.path(bamDir,
                                  bamFilesToInspect[file.exists(bamTxtFilesToInspect)])

                    compatibleBamFileInd <- NULL
                    if (length(bamTxtFilesToInspectExist) > 0) {
                        for (m in seq_len(length(bamTxtFilesToInspectExist))) {
                            bamInfoT_DF <- utils::read.delim(bamTxtFilesToInspectExist[m],
                                                             header = FALSE, row.names = 1,
                                                             stringsAsFactors = FALSE)
                            bamInfoT <- bamInfoT_DF[, 1]
                            names(bamInfoT) <- rownames(bamInfoT_DF)
                            bamInfoT <- bamInfoOnlyBaseName(bamInfoT)

                            # compare the actual parameters to the one from the bam file on disk
                            if (proj@aligner == "Rbowtie") {
                                projBamInfo <-
                                    projBamInfo[!(names(projBamInfo) %in%
                                                      c("geneAnnotation",
                                                        "geneAnnotationFormat",
                                                        "geneAnnotation.md5"))]
                                bamInfoT <-
                                    bamInfoT[!(names(bamInfoT) %in%
                                                   c("geneAnnotation",
                                                     "geneAnnotationFormat",
                                                     "geneAnnotation.md5"))]
                            }
                            if (identical(projBamInfo, bamInfoT)) {
                                compatibleBamFileInd[length(compatibleBamFileInd) + 1] <- m
                            }
                        }
                        if (length(compatibleBamFileInd) > 1) {
                            for (k in seq_len(length(compatibleBamFileInd))) {
                                message(bamFilesToInspectWithTxt[k])
                            }
                            stop("Multiple bam files exist with same alignment parameters (see above list). QuasR is unable to decide which one to use. Please delete manually the respective bam files", call. = FALSE)
                        }
                        if (length(compatibleBamFileInd) == 1) {
                            proj@auxAlignments[j, i] <-
                                bamFilesToInspectWithTxt[compatibleBamFileInd]
                        }
                    }
                }
            }
        }
    }

    return(proj)
}



# create search index (.fai) files for all the reference sequences that are
# going to be used for the alignments (genome & aux)
# do nothing if the fai files exist already
# create an .md5 file that contains the md5sum of the referece sequences
# if snp file exists, calculate md5 and store it in a (.md5) file
#' @keywords internal
#' @importFrom Biostrings fasta.seqlengths
#' @importFrom Rsamtools indexFa scanFaIndex
#' @importFrom Seqinfo seqnames
#' @importFrom tools md5sum
#' @importFrom utils write.table
createReferenceSequenceIndices <- function(proj) {
    # create fasta index for the genome if it is not a BSgenome and if the .fai file is not present
    if (proj@genomeFormat == "file") {
        if (!file.exists(paste(proj@genome, "fai", sep = "."))) {
            # test if the sequence file is a valid fasta file using the
            # fasta.seqlengths() function from Biostrings
            # this is necessary because indexFa() from Rsamtools would
            # crash R if it is passed an invalid fasta file
            message(paste("Creating .fai file for:", proj@genome))
            result <- try(Biostrings::fasta.seqlengths(proj@genome))
            if (is(result, "try-error")) {
                stop("The fasta file ", proj@genome,
                     " is not a valid fasta file", call. = FALSE)
            }
            # remove everything after the white space after the id
            # (not done by fasta.seqlengths)
            faInfoNames <- sub("\\s+.+", "", names(result), perl = TRUE)
            if (length(unique(faInfoNames)) != length(faInfoNames)) {
                stop("Sequence names in the file: ", proj@genome,
                     " are not unique", call. = FALSE)
            }
            if (is(try(Rsamtools::indexFa(proj@genome)), "try-error")) {
                stop("Cannot write into the directory where ", proj@genome,
                     " is located. Make sure you have the right permissions",
                     call. = FALSE)
            }
        } else {
            faiSeqNames <- as.character(Seqinfo::seqnames(
                Rsamtools::scanFaIndex(proj@genome)))
            if (length(unique(faiSeqNames)) != length(faiSeqNames)) {
                stop("Sequence names in the file: ", proj@genome,
                     " are not unique (information extracted from the .fai file",
                     call. = FALSE)
            }
        }
        # create md5 sum file
        if (!file.exists(paste(proj@genome, "md5", sep = "."))) {
            utils::write.table(tools::md5sum(proj@genome),
                               paste(proj@genome, "md5", sep = "."),
                               sep = "\t", quote = FALSE, col.names = FALSE,
                               row.names = FALSE)
        }
    }
    # create fasta index for the auxilliaries if not present already
    if (nrow(proj@aux) > 0) {
        for (i in seq_len(nrow(proj@aux))) {
            if (!file.exists(paste(proj@aux$FileName[i], "fai", sep = "."))) {
                # test if the sequence file is a valid fasta file using the
                # fasta.seqlengths() function from Biostrings
                # this is necessary because indexFa() from Rsamtools would
                # crash R if it is passed an invalid fasta file (R version 2.14.1)
                result <- try(Biostrings::fasta.seqlengths(proj@aux$FileName[i]))
                if (is(result, "try-error")) {
                    stop("The fasta file ", proj@aux$FileName[i],
                         " is not a valid fasta file", call. = FALSE)
                }
                # remove everything after the white space after the id
                # (not done by fasta.seqlengths)
                faInfoNames <- sub("\\s+.+", "", names(result), perl = TRUE)
                if (length(unique(faInfoNames)) != length(faInfoNames)) {
                    stop("Sequence names in the file: ", proj@aux$FileName[i],
                         " are not unique", call. = FALSE)
                }
                if (is(try(Rsamtools::indexFa(proj@aux$FileName[i])),
                       "try-error")) {
                    stop("Cannot write into the directory where ",
                         proj@aux$FileName[i],
                         " is located. Make sure you have the right permissions",
                         call. = FALSE)
                }
            }

            if (!file.exists(paste(proj@aux$FileName[i], "md5", sep = "."))) {
                # create md5 sum file
                utils::write.table(tools::md5sum(proj@aux$FileName[i]),
                                   paste(proj@aux$FileName[i], "md5", sep = "."),
                                   sep = "\t", quote = FALSE,
                                   col.names = FALSE, row.names = FALSE)
            }
        }
    }

    #create md5 sum file for the snp file
    if (!is.na(proj@snpFile)) {
        if (!file.exists(paste(proj@snpFile, "md5", sep = "."))) {
            utils::write.table(tools::md5sum(proj@snpFile),
                               paste(proj@snpFile, "md5", sep = "."),
                               sep = "\t", quote = FALSE,
                               col.names = FALSE, row.names = FALSE)
        }
    }

    # create md5 sum file for the geneAnnotation
    if (!is.na(proj@geneAnnotation)) {
        if (!file.exists(paste0(proj@geneAnnotation, ".md5"))) {
            utils::write.table(tools::md5sum(proj@geneAnnotation),
                               paste0(proj@geneAnnotation, ".md5"),
                               sep = "\t", quote = FALSE,
                               col.names = FALSE, row.names = FALSE)
        }
    }
}


# returns information for one bam file in qProject
# sampleNr specifies the sample for which the information is compiled
# if auxNr is not NULL, it returns information about aux bam file
#' @keywords internal
#' @importFrom utils packageVersion read.delim
qProjectBamInfo <- function(proj, sampleNr, auxNr = NULL) {

    if (sampleNr > nrow(proj@reads)) {
        stop("project has no sample ", sampleNr)
    }
    if (!is.null(auxNr)) {
        if (auxNr > nrow(proj@aux)) {
            stop("project has no aux ",auxNr)
        }
    }

    alnInfo <- NULL
    if (proj@paired == "no") {
        alnInfo["reads.FileName1"] <- proj@reads$FileName[sampleNr]
        alnInfo["reads.FileName2"] <- NA
        alnInfo["reads.md5subsum1"] <- proj@reads_md5subsum$md5subsum[sampleNr]
        alnInfo["reads.md5subsum2"] <- NA
    } else {
        alnInfo["reads.FileName1"] <- proj@reads$FileName1[sampleNr]
        alnInfo["reads.FileName2"] <- proj@reads$FileName2[sampleNr]
        alnInfo["reads.md5subsum1"] <- proj@reads_md5subsum$md5subsum1[sampleNr]
        alnInfo["reads.md5subsum2"] <- proj@reads_md5subsum$md5subsum2[sampleNr]
    }

    alnInfo["samplesFormat"] <- proj@samplesFormat
    alnInfo["genome"] <- proj@genome
    if (proj@genomeFormat == "file") {
        alnInfo["genome.md5"] <- as.character(
            utils::read.delim(paste(proj@genome, "md5",
                                    sep = "."),
                              header = FALSE,
                              colClasses = "character")[1, 1])
    } else {
        alnInfo["genome.md5"] <- NA
    }
    alnInfo["genomeFormat"] <- proj@genomeFormat
    alnInfo["aux"] <- NA
    alnInfo["aux.md5"] <- NA
    alnInfo["aligner"] <- proj@aligner
    if (!is.na(proj@aligner)) {
        alnInfo["aligner.version"] <- as.character(utils::packageVersion(proj@aligner))
    } else {
        alnInfo["aligner.version"] <- NA
    }
    alnInfo["maxHits"] <- proj@maxHits
    alnInfo["paired"] <- proj@paired
    alnInfo["splicedAlignment"] <- proj@splicedAlignment
    alnInfo["snpFile"] <- proj@snpFile
    alnInfo["snpFile.md5"] <- NA
    alnInfo["bisulfite"] <- proj@bisulfite
    alnInfo["alignmentParameter"] <- proj@alignmentParameter
    alnInfo["geneAnnotation"] <- proj@geneAnnotation
    alnInfo["geneAnnotationFormat"] <- proj@geneAnnotationFormat
    alnInfo["geneAnnotation.md5"] <- NA
    alnInfo["QuasR.version"] <- as.character(utils::packageVersion('QuasR'))

    if (!is.null(auxNr)) {
        alnInfo["aux"] <- proj@aux$FileName[auxNr]
        alnInfo["aux.md5"] <- as.character(
            utils::read.delim(paste(proj@aux$FileName[auxNr], "md5", sep = "."),
                              header = FALSE, colClasses = "character")[1, 1])
    }

    if (!is.na(proj@snpFile)) {
        alnInfo["snpFile.md5"] <- as.character(
            utils::read.delim(paste(proj@snpFile, "md5", sep = "."),
                              header = FALSE, colClasses = "character")[1, 1])
    }
    if (!is.na(proj@geneAnnotation)) {
        alnInfo["geneAnnotation.md5"] <- as.character(
            utils::read.delim(paste0(proj@geneAnnotation, ".md5"),
                              header = FALSE, colClasses = "character")[1, 1])
    }

    return(alnInfo)
}


# replace full file paths in bamInfo by base name
# remove the aligner and QuasR version. this allows using bam files generated with an older QuasR version
#' @keywords internal
bamInfoOnlyBaseName <- function(bamInfo) {
    bamInfo["reads.FileName1"] <- basename(bamInfo["reads.FileName1"])
    bamInfo["reads.FileName2"] <- basename(bamInfo["reads.FileName2"])
    bamInfo["genome"] <- basename(bamInfo["genome"])
    bamInfo["aux"] <- basename(bamInfo["aux"])
    bamInfo["snpFile"] <- basename(bamInfo["snpFile"])
    bamInfo["geneAnnotation"] <- basename(bamInfo["geneAnnotation"])

    if ("aligner.version" %in% names(bamInfo)) {
        bamInfo <- bamInfo[!(names(bamInfo) %in% "aligner.version")]
    }

    if ("QuasR.version" %in% names(bamInfo)) {
        bamInfo <- bamInfo[!(names(bamInfo) %in% "QuasR.version")]
    }

    return(bamInfo)
}

# helper function that converts filepaths to absolute filepaths in the case where the working
# directory needs to be temporarily redirected. This is needed if e.g. the samples.txt file
# is not located in the working directory.
# returns the absolute path if the file exists
# returns NULL if the file does not exist
#' @keywords internal
#' @importFrom tools file_path_as_absolute
pathAsAbsoluteRedirected <- function(fileName, redirectPath) {
    curwd <- getwd() # store the original working directory required to jump back
    on.exit(setwd(curwd)) # make sure that it will jump back in a case of error or not

    setwd(redirectPath) # jump to the redirected position
    if (file.exists(fileName)) {
        return(tools::file_path_as_absolute(fileName))
    } else {
        return(NULL)
    }
}

# helper function that returns the temporary directory given the cacheDir (from qProject)
# if the user specified cacheDir, then it returns it. but if the user did not specify a cacheDir
# it returns the R temporary directory (which can be different for different machines)
#' @keywords internal
resolveCacheDir <- function(cacheDir) {
    if (is.na(cacheDir))
        return(tempdir())
    else
        return(cacheDir)
}


# given a vector of filenames, the function determines the final format
# taking into account all the different types of extensions for
# sequence files. Throughs an error if one ore more samples do not contain
# a valid file extension
#' @keywords internal
determineSamplesFormat <- function(filename) {
    fileExtension <- consolidateFileExtensions(filename, compressed = TRUE)

    validExtsSel <- fileExtension %in%
        c("fasta", "fastq", "bam", "csfasta", "csfastq")

    if (all(validExtsSel)) {
        if (length(unique(fileExtension)) == 1) {
            return(unique(fileExtension))
        } else {
            stop("Mixed sample file formats are not allowed: ",
                 paste(unique(fileExtension), collapse = ","),
                 call. = FALSE)
        }
    } else {
        stop(filename[!validExtsSel][1],
             " does not have a valid file extension ",
             "(fa,fna,fasta,fq,fastq,bam,csfasta,csfastq)",
             call. = FALSE)
    }
}

context("alignmentStats")

test_that("alignmentStats correctly digests its arguments", {
  expect_error(alignmentStats(1L))
  expect_error(alignmentStats("nonexistent.bam"))
})

test_that("alignmentStats works as expected", {
  resSoll <- matrix(c(95000,95000,
                      2339,3609,
                      258,505), nrow = 2, ncol = 3)
  res <- alignmentStats(pChipSingle)
  expect_identical(resSoll, unname(res))
  res <- alignmentStats(alignments(pChipSingle)$genome$FileName)
  expect_identical(resSoll, unname(res))

  resSoll <- matrix(c(95000,95000,5386,5386,
                      2339,3609,251,493,
                      258,505,7,12), nrow = 4, ncol = 3)
  res <- alignmentStats(pChipSingleAux)
  expect_identical(resSoll, unname(res))
})


context("qAlign")

test_that("qAlign digests arguments correctly", {
  # test redundant sample files
  tmpf1 <- tempfile(fileext = ".txt")
  tmpf2 <- tempfile(fileext = ".txt")
  tab1 <- pChipSingle@reads
  tab2 <- pChipSingle@alignments
  write.table(tab1[c(1,1), ], tmpf1, sep = "\t", row.names = FALSE)
  write.table(tab2[c(1,1), ], tmpf2, sep = "\t", row.names = FALSE)
  expect_error(qAlign(tmpf1, genomeFile))
  expect_error(qAlign(tmpf2, genomeFile))

  # other arguments
  expect_error(qAlign("nonexistent_file"))
  expect_error(qAlign(genome = genomeFile))
  expect_error(qAlign(sChipSingle, genome = genomeFile[c(1,1)]))
  expect_error(qAlign(sampleFile = sChipSingle))
  expect_error(qAlign(sChipSingle, genomeFile, splicedAlignment = TRUE, checkOnly = TRUE))
  expect_error(qAlign(sChipSingle, genomeFile, aligner = "unsupportedAligner"))
  expect_error(qAlign(sChipSingle, genomeFile, lib.loc = "notADirectory"))
  expect_error(qAlign(sChipSingle, genomeFile, alignmentsDir = "notADirectory"))
  expect_error(qAlign(sChipSingle, genomeFile, aligner = "Rhisat2", bisulfite = "dir"))
  expect_error(qAlign(sChipSingle, genomeFile, aligner = "Rbowtie", splicedAlignment = TRUE, bisulfite = "dir"))
  expect_error(qAlign(sRnaPaired, genomeFile, aligner = "Rbowtie", splicedAlignment = TRUE, paired = "rf"))
  expect_error(qAlign(sBisSingle, genomeFile, bisulfite = "invalid"))
  expect_error(qAlign(sRnaPaired, genomeFile, bisulfite = "dir", paired = "rf"))
  expect_error(qAlign(sRnaPaired, genomeFile, auxiliaryFile = "nonExisting"))
  expect_error(qAlign(sRnaPaired, genomeFile, aligner = "Rhisat2", geneAnnotation = "nonExisting"))
  expect_error(qAlign(sRnaPaired, genomeFile, paired = "invalid"))
  expect_error(qAlign(sampleFile = "nonExisting", genomeFile))
  expect_error(qAlign(sChipSingle, genomeFile, paired = "fr"))

  # inconsistent bam header and BSgenome reference
  # ... create bam file with inconsistent header
  pBad <- pChipSingle
  goodbamfile <- pChipSingle@alignments$FileName[1]
  goodsamfile <- Rsamtools::asSam(goodbamfile, tempfile())
  goodsamlines <- readLines(goodsamfile)
  badsamlines <- c(goodsamlines[1:4], "@SQ\tSN:chr4\tLN:9999", goodsamlines[5:length(goodsamlines)])
  badsamfile <- tempfile(fileext = ".sam")
  writeLines(badsamlines, badsamfile)
  badbamfile <- Rsamtools::asBam(badsamfile, file.path(dirname(goodbamfile), paste0("bad_", sub(".bam$", "", basename(goodbamfile)))))
  # ... incorporate it into a sample file
  goodfnames <- c(pChipSingle@reads$FileName[1], paste0(pChipSingle@alignments$FileName[1], ".txt"))
  badfnames <- file.path(dirname(goodfnames), paste0("bad_", basename(goodfnames)))
  file.copy(goodfnames, badfnames)
  txtlines <- readLines(badfnames[2])
  txtlines[1] <- sub("chip_1_1", "bad_chip_1_1", txtlines[1])
  writeLines(txtlines, badfnames[2])
  badsamplefile <- tempfile(tmpdir = dirname(goodfnames[1]), fileext = ".txt")
  samplelines <- readLines(sChipSingle)
  samplelines[2] <- paste0("bad_", samplelines[2])
  writeLines(samplelines, badsamplefile)
  expect_warning(qAlign(badsamplefile, genomePkg, clObj = clObj, lib.loc = rlibdir, cacheDir = tempdir()))
})

test_that("qAlign correctly works for single reads", {
  aln <- GenomicAlignments::readGAlignments(pChipSingle@alignments$FileName[1], use.names = TRUE)
  expect_length(runValue(strand(aln)), 1073L)
  expect_identical(seqnames(aln), Rle(factor(rep(paste0("chr",1:3), c(590, 708, 1041)))))
  expect_identical(sum(as.numeric(start(aln))), 36493854)
  expect_identical(sum(as.numeric(end(aln))), 36575719)
})

test_that("qAlign correctly works for single reads with auxiliaries", {
  aln <- GenomicAlignments::readGAlignments(pChipSingleAux@alignments$FileName[1], use.names = TRUE)
  expect_length(runValue(strand(aln)), 1073L)
  expect_identical(seqnames(aln), Rle(factor(rep(paste0("chr",1:3), c(590, 708, 1041)))))
  expect_identical(sum(as.numeric(start(aln))), 36493854)
  expect_identical(sum(as.numeric(end(aln))), 36575719)

  aln <- GenomicAlignments::readGAlignments(pChipSingleAux@auxAlignments["phiX174","Sample2"], use.names = TRUE)
  expect_length(runValue(strand(aln)), 238L)
  expect_identical(seqnames(aln), Rle(factor(rep("phiX174", 493))))
  expect_identical(sum(as.numeric(start(aln))), 1339781)
  expect_identical(sum(as.numeric(end(aln))), 1357036)
})

test_that("qAlign correctly works for paired-end reads", {
  aln <- GenomicAlignments::readGAlignments(pRnaPaired@alignments$FileName[2], use.names = TRUE)
  expect_length(runValue(strand(aln)), 394L)
  expect_identical(seqnames(aln), Rle(factor(rep(paste0("chr",1:3), c(898, 64, 1690)))))
  expect_identical(sum(as.numeric(start(aln))), 54091733)
  expect_identical(sum(as.numeric(end(aln))), 54221681)
})

test_that("qAlign correctly works for single reads (spliced, Rbowtie)", {
  aln <- GenomicAlignments::readGAlignments(pRnaSingleSpliced@alignments$FileName[3], use.names = TRUE)
  expect_length(runValue(strand(aln)), 435L)
  expect_identical(seqnames(aln), Rle(factor(rep(paste0("chr",1:3), c(732, 1112, 1156)))))
  expect_identical(sum(as.numeric(start(aln))), 42121859)
  expect_identical(sum(as.numeric(end(aln))), 43006110)
})

test_that("qAlign correctly works for paired-end reads (spliced, Rbowtie)", {
  aln <- GenomicAlignments::readGAlignments(pRnaPairedSpliced@alignments$FileName[1], use.names = TRUE)
  expect_length(runValue(strand(aln)), 1620L)
  expect_identical(seqnames(aln), Rle(factor(rep(paste0("chr",1:3), c(850, 2924, 2228)))))
  expect_identical(sum(as.numeric(start(aln))), 69243139)
  expect_identical(sum(as.numeric(end(aln))), 71021433)
})

test_that("qAlign correctly works for single reads (spliced, without splice site file, Rhisat2)", {
  aln <- GenomicAlignments::readGAlignments(pRnaSingleSplicedHisat2@alignments$FileName[1], use.names = TRUE)
  expect_length(runValue(strand(aln)), 601L)
  expect_identical(seqnames(aln), Rle(factor(rep(paste0("chr",1:3), c(420, 1457, 1104)))))
  expect_identical(sum(as.numeric(start(aln))), 34122867)
  expect_identical(sum(as.numeric(end(aln))), 35028898)
})

test_that("qAlign correctly works for paired reads (unspliced, without splice site file, Rhisat2)", {
  aln <- GenomicAlignments::readGAlignments(pRnaPairedUnsplicedHisat2@alignments$FileName[1], use.names = TRUE)
  expect_length(runValue(strand(aln)), 868L)
  expect_identical(seqnames(aln), Rle(factor(rep(paste0("chr",1:3), c(766, 2055, 2090)))))
  expect_identical(sum(as.numeric(start(aln))), 62133906)
  expect_identical(sum(as.numeric(end(aln))), 62374333)
})

test_that("qAlign correctly works for paired reads (spliced, with splice site file from gtf, Rhisat2)", {
  aln <- GenomicAlignments::readGAlignments(pRnaPairedSplicedHisat2Gtf@alignments$FileName[1], use.names = TRUE)
  expect_length(runValue(strand(aln)), 1000L)
  expect_identical(seqnames(aln), Rle(factor(rep(paste0("chr",1:3), c(839, 2889, 2207)))))
  expect_identical(sum(as.numeric(start(aln))), 68200619)
  expect_identical(sum(as.numeric(end(aln))), 70203383)
})

test_that("qAlign correctly works for paired reads (spliced, with splice site file from TxDb, Rhisat2)", {
  aln <- GenomicAlignments::readGAlignments(pRnaPairedSplicedHisat2TxDb@alignments$FileName[1], use.names = TRUE)
  expect_length(runValue(strand(aln)), 1000L)
  expect_identical(seqnames(aln), Rle(factor(rep(paste0("chr",1:3), c(839, 2889, 2207)))))
  expect_identical(sum(as.numeric(start(aln))), 68200619)
  expect_identical(sum(as.numeric(end(aln))), 70203383)
})

test_that("qAlign correctly works in allelic mode", {
  aln <- GenomicAlignments::readGAlignments(pChipSingleSnps@alignments$FileName[1], use.names = TRUE,
                                            param = Rsamtools::ScanBamParam(tag = "XV"))
  expect_length(runValue(strand(aln)), 931L)
  expect_identical(seqnames(aln), Rle(factor(rep(paste0("chr",1:3), c(503, 634, 905)))))
  expect_identical(sum(as.numeric(start(aln))), 31658312)
  expect_identical(sum(as.numeric(end(aln))), 31729782)
  expect_equal(as.vector(table(mcols(aln)$XV)[c("A","R","U")]), c(13, 192, 1837))
})

test_that("qAlign correctly works in directional bisulfite mode", {
  aln <- GenomicAlignments::readGAlignments(pBis@alignments$FileName[1], use.names = TRUE)
  expect_length(runValue(strand(aln)), 8154L)
  expect_identical(seqnames(aln), Rle(factor(rep(paste0("chr",1:3), c(5973, 3997, 15528)))))
  expect_identical(sum(as.numeric(start(aln))), 494072411)
  expect_identical(sum(as.numeric(end(aln))), 495957570)
})

test_that("qAlign correctly works in undirectional bisulfite mode", {
  aln <- GenomicAlignments::readGAlignments(pBisUndir@alignments$FileName[1], use.names = TRUE)
  expect_length(runValue(strand(aln)), 8160L)
  expect_identical(seqnames(aln), Rle(factor(rep(paste0("chr",1:3), c(5973, 3997, 15526)))))
  expect_identical(sum(as.numeric(start(aln))), 493991845)
  expect_identical(sum(as.numeric(end(aln))), 495876924)
})


context("qAlign helper functions")

test_that("pathAsAbsoluteRedirected works as expected", {
    expect_null(QuasR:::pathAsAbsoluteRedirected("test.txt", "../"))
})

test_that("resolveCacheDir works as expected", {
    expect_identical("extdata", QuasR:::resolveCacheDir("extdata"))
    expect_identical(tempdir(), QuasR:::resolveCacheDir(NA))
})

test_that("determineSamplesFormat correctly digests its arguments", {
    expect_error(QuasR:::determineSamplesFormat(c("file1.notSupported")))
    expect_error(QuasR:::determineSamplesFormat(c("file1.fasta", "file2.fastq")))
})

# build an index based on a given BSgenome, create a package with the files and install it on the system
#' @keywords internal
#' @importFrom Biobase createPackage
#' @importFrom utils installed.packages install.packages
buildIndexPackage <- function(genome, aligner, alnModeID, cacheDir, lib.loc) {
    indexPackageName <- paste(genome, alnModeID, sep = ".")
    
    lib.locTemp <- lib.loc
    if (is.na(lib.loc)){
        lib.locTemp <- NULL
    } # this is a way to convert NA to NULL needed for install.packages
    
    # Create the index and install it if it is not yet installed on the system
    if (!(indexPackageName %in% utils::installed.packages(lib.loc = lib.locTemp)[, 'Package'])) {
        genomeObj <- get(genome) # access the BSgenome
        # flush the BSgenome to disk
        fastaFilepath <- BSgenomeSeqToFasta(genomeObj, tempfile(tmpdir = cacheDir, 
                                                                fileext = ".fa"))  
        on.exit(unlink(fastaFilepath))

        # create the package (without installing it yet). if it is already in 
        # the temp dir, keep it. It might contain an index
        # calculated in a previous round where the installation was not successful 
        # (due to permissions)
        if (!file.exists(file.path(cacheDir, indexPackageName))) {
            seedList <- createSeedList(genomeObj, aligner, indexPackageName)
            templatePath <- system.file("AlignerIndexPkg-template", package = "QuasR")
            Biobase::createPackage(indexPackageName, cacheDir, templatePath, 
                                   seedList, quiet = TRUE)
        }
        # create the index files
        buildIndex(fastaFilepath,file.path(cacheDir, indexPackageName, "inst", 
                                           "alignmentIndex"), alnModeID, cacheDir)
        
        # install the package
        utils::install.packages(
            file.path(cacheDir, indexPackageName), repos = NULL, 
            dependencies = FALSE, type = "source", lib = lib.locTemp
        )
        
        if (indexPackageName %in% utils::installed.packages(lib.loc = lib.locTemp)[, 'Package']) {
            # package installation was successful, clean up
            unlink(file.path(cacheDir, indexPackageName), recursive = TRUE)
        } else {
            stop("Failed to install the index package '", indexPackageName, "'")
        }
    }
}

#' @keywords internal
#' @importFrom utils read.table
#' @importFrom Rsamtools scanFaIndex scanFa indexFa
#' @importFrom Seqinfo seqnames
#' @importFrom Biostrings masks injectHardMask replaceLetterAt DNAStringSet
#'   writeXStringSet
buildIndexSNP <- function(snpFile, indexPath, genome, genomeFormat, 
                          alnModeID, cacheDir, checkMD5 = FALSE) {

    fastaOutFileR <- paste(snpFile, basename(genome), "R", "fa", sep = ".")
    fastaOutFileA <- paste(snpFile, basename(genome), "A", "fa", sep = ".")
    
    if (!file.exists(fastaOutFileR) | !file.exists(fastaOutFileA)) {
        # read in the SNPs
        message(paste("Reading and processing the SNP file:", snpFile))
        snps <- utils::read.table(snpFile, colClasses = c("factor", "numeric", 
                                                          "character", "character"))
        colnames(snps) <- c("chrom", "pos", "ref", "alt")
 
        # convert ref nucleotides to upper case if not already the case
        snps[, 3] <- toupper(snps[, 3]) 
        # convert alt nucleotides to upper case if not already the case
        snps[, 4] <- toupper(snps[, 4]) 
        
        # check if there are only regular nucleotides (ACGT) in the snp file
        if (!all(unique(c(snps[, 3], snps[, 4])) %in% c("A", "C", "G", "T"))) {
            stop("There are non-regular nucleoides in snpFile. Only ACGT are allowed.",
                 call. = FALSE)
        }
        
        snpsL <- split(snps, snps[, 1]) # split SNPs accoring to chromosome (first column)
        
        # check for duplicate snp entries (not allowed)
        if (sum(vapply(snpsL, function(x) sum(duplicated(x[, 2])), 1)) > 0) {
            stop("There are duplicate SNP positions in snpFile.", call. = FALSE)
        }
        
        if (genomeFormat == "file") {
            idx <- Rsamtools::scanFaIndex(genome)
            allChrs <- as.character(Seqinfo::seqnames(idx))
        } else {
            genomeObj <- get(genome) # access the BSgenome
            allChrs <- Seqinfo::seqnames(genomeObj)
        }
        if (!all(names(snpsL) %in% allChrs)) {
            stop("The snpFile contains chromosomes that are not present in the genome",
                 call. = FALSE)
        }
    }

    for (j in seq_len(2)) {
        fastaOutFile <- c(fastaOutFileR, fastaOutFileA)[j]
        
        if (!file.exists(fastaOutFile)) {
            append <- FALSE
            message(paste("Creating the genome fasta file containing the SNPs:",
                          fastaOutFile))
            for (i in seq_len(length(allChrs))) {
                if (genomeFormat == "file") {
                    seq <- Rsamtools::scanFa(genome, idx[i])[[1]]
                } else {
                    if (is.null(Biostrings::masks(genomeObj[[allChrs[i]]]))) {
                        seq <- genomeObj[[allChrs[i]]]
                    } else {
                        seq <- Biostrings::injectHardMask(genomeObj[[allChrs[i]]],
                                                          letter = "N")
                    }
                }
                snpsLC <- snpsL[[allChrs[i]]]
                # check if the ref nucleotide in snpFile matches the genome
                if (!is.null(snpsLC)) {
                    # inject the SNPs
                    seqSNP <- Biostrings::replaceLetterAt(seq, snpsLC[, 2], 
                                                          snpsLC[, 2 + j])
                    seqSNP_SS <- Biostrings::DNAStringSet(seqSNP)
                } else {
                    seqSNP_SS <- Biostrings::DNAStringSet(seq)
                }
                names(seqSNP_SS) <- allChrs[i]
                
                Biostrings::writeXStringSet(seqSNP_SS, filepath = fastaOutFile, 
                                            format = "fasta", append = append)
                append <- TRUE
            }
        }
    }
    
    # create .fai file for the snp genome
    for (fastaOutFile in c(fastaOutFileR, fastaOutFileA)) {
        if (!file.exists(paste(fastaOutFile, "fai", sep = "."))) {
            message(paste("Creating a .fai file for the snp genome:", fastaOutFile))
            if (is(try(Rsamtools::indexFa(fastaOutFile)), "try-error")) {
                stop("Cannot write into the directory where ", fastaOutFile, 
                     " is located. Make sure you have the right permissions",
                     call. = FALSE)
            }
        }
    }

    # create The two indices
    buildIndex(fastaOutFileR, paste(snpFile, basename(genome), "R", "fa",
                                    alnModeID, sep = "."), alnModeID, cacheDir)
    buildIndex(fastaOutFileA, paste(snpFile, basename(genome), "A", "fa",
                                    alnModeID, sep = "."), alnModeID, cacheDir)
}



# build an index based on a given fasta file with one or more sequences.
#' @keywords internal
#' @importFrom utils read.delim write.table
#' @importFrom tools md5sum
buildIndex <- function(seqFile, indexPath, alnModeID, cacheDir, checkMD5 = FALSE) {
    
    # check if the directory exists but contains no ref_md5Sum.txt file. This means that a last index builder call did not
    # finish properly. Delete the directory containing the partial index
    if (file.exists(indexPath)) {
        if (!("ref_md5Sum.txt" %in% dir(indexPath))) {
            message(paste("Deleting an incomplete index at:", indexPath))
            file.remove(dir(indexPath, full.names = TRUE))
            unlink(indexPath, recursive = TRUE)
        } else {
            # if checkMD5==TRUE, check consistency between the sequences and the index
            # delete index in the case of inconsistency
            if (checkMD5) {
                MD5_fromIndexTab <- utils::read.delim(
                    file.path(indexPath, "ref_md5Sum.txt"), 
                    header = FALSE, colClasses = "character"
                )
                if (!all(dim(MD5_fromIndexTab) == c(1, 1))){
                    stop("The md5sum file does not have the right format: ",
                         file.path(indexPath, "ref_md5Sum.txt"), call. = FALSE)
                }
                MD5_fromIndex <- MD5_fromIndexTab[1, 1]
                MD5_fromSeq <- tools::md5sum(seqFile)
                if (MD5_fromIndex != MD5_fromSeq) {
                    message(paste("The sequence file", seqFile,
                                  "was changed. Updating the index: ", indexPath)) 
                    file.remove(dir(indexPath, full.names = TRUE))
                    unlink(indexPath, recursive = TRUE)
                }
            }
        }
    }
    if (!file.exists(indexPath)) {
        # create the directory for the index
        if (!dir.create(indexPath)){
            stop("Cannot create the directory: ", indexPath, call. = FALSE)
        }
        
        # Create all the various indices
        message(paste("Creating an", alnModeID, "index for", seqFile))

        if (alnModeID == "Rbowtie") {
            ret <- buildIndex_Rbowtie(seqFile, indexPath)
        } else if (alnModeID == "RbowtieCtoT") {
            ret <- buildIndex_RbowtieCtoT(seqFile, indexPath, cacheDir)
        } else if (alnModeID == "RbowtieCs") {
            ret <- buildIndex_RbowtieCs(seqFile, indexPath)
        } else if (alnModeID == "Rhisat2") {
            ret <- buildIndex_Rhisat2(seqFile, indexPath)
        } else {
            stop("Fatal error 2374027")
        }
        
        if (ret == 0) {
            indexMD5 <- tools::md5sum(seqFile)
            utils::write.table(indexMD5, file = file.path(indexPath, "ref_md5Sum.txt"),
                               row.names = FALSE, col.names = FALSE, 
                               sep = "\t", quote = FALSE)
            message("Finished creating index")
        } else {
            # the execution of index-build failed, delete the directory.
            file.remove(dir(indexPath, full.names = TRUE))
            unlink(indexPath, recursive = TRUE)
            stop("The execution of the index builder failed. No index was created", 
                 call. = FALSE)
        }
    }
}

# build index for Rhisat2, base space, non-bisulfite converted
#' @keywords internal
buildIndex_Rhisat2 <- function(seqFile,indexPath) {
    indexFullPath <- file.path(indexPath, "hisat2Index")
    
    ret <- system2(file.path(system.file(package = "Rhisat2"), "hisat2-build"),
                   c(shQuote(seqFile), shQuote(indexFullPath)), 
                   stdout = TRUE, stderr = TRUE)
    if (!(grepl("^Total time for call to driver", ret[length(ret)]))) {
        ret <- 1
    } else {
        ret <- 0
    }
    return(ret)
}

# generate splice site file
#' @keywords internal
#' @importFrom txdbmaker makeTxDbFromGFF
#' @importFrom AnnotationDbi loadDb
#' @importFrom tools md5sum
#' @importFrom utils read.delim write.table
buildSpliceSiteFile <- function(geneAnnotation, geneAnnotationFormat) {
    if (file.exists(paste0(geneAnnotation, ".SpliceSites.txt"))) {
        # if the SpliceSites.txt file exists, but not the md5sum file, remove the former
        if (!file.exists(paste0(geneAnnotation, ".SpliceSites.txt.md5"))) {
            message("Deleting an incomplete SpliceSites.txt file at: ",
                    paste0(geneAnnotation, ".SpliceSites.txt"))
            unlink(paste0(geneAnnotation, ".SpliceSites.txt"))
        } else {
            # both SpliceSites.txt and md5 file exist
            md5FromFile <- utils::read.delim(
                paste0(geneAnnotation, ".SpliceSites.txt.md5"),
                header = FALSE, colClasses = "character"
            )
            if (!all(dim(md5FromFile) == c(1, 1))) {
                stop("The md5sum file does not have the right format: ",
                     paste0(geneAnnotation, ".SpliceSites.txt.md5"), call. = FALSE)
            }
            md5FromFile <- md5FromFile[1, 1]
            md5FromObj <- tools::md5sum(geneAnnotation)
            if (md5FromFile != md5FromObj) {
                message("The annotation file ", geneAnnotation,
                        " was changed. Recreating the SpliceSites file.")
                unlink(paste0(geneAnnotation, ".SpliceSites.txt"))
            }
        }
    }
    if (!file.exists(paste0(geneAnnotation, ".SpliceSites.txt"))) {
        if (geneAnnotationFormat == "TxDb") {
            txdb <- AnnotationDbi::loadDb(geneAnnotation)
        } else if (geneAnnotationFormat == "gtf") {
            txdb <- suppressWarnings(
                txdbmaker::makeTxDbFromGFF(geneAnnotation, format = "auto")
            )
        } else {
            stop("Fatal error 81956293")
        }
        Rhisat2::extract_splice_sites(txdb, paste0(geneAnnotation, ".SpliceSites.txt"), 
                                      min_length = 5)
        md5FromObj <- tools::md5sum(geneAnnotation)
        utils::write.table(
            md5FromObj, file = paste0(geneAnnotation, ".SpliceSites.txt.md5"),
            row.names = FALSE, col.names = FALSE, sep = "\t", quote = FALSE
        )
    }
}

# build index for Rbowtie, base space, non-bisulfite converted
#' @keywords internal
#' @import Rbowtie
buildIndex_Rbowtie <- function(seqFile, indexPath) {
    indexFullPath <- file.path(indexPath, "bowtieIndex")
    
    ret <- system2(file.path(system.file(package = "Rbowtie"), "bowtie-build"),
                   c(shQuote(seqFile), shQuote(indexFullPath)), stdout = TRUE, stderr = TRUE)
    if (!(grepl("^Total time for backward call to driver", ret[length(ret)]))) {
        ret <- 1
    } else {
        ret <- 0
    }
    
    return(ret)
}

# build index for Rbowtie, base space, bisulfite converted
#' @keywords internal
#' @importFrom Rsamtools scanFaIndex scanFa
#' @importFrom Biostrings writeXStringSet chartr
buildIndex_RbowtieCtoT <- function(seqFile, indexPath, cacheDir) {
    indexFullPath <- file.path(indexPath, "bowtieIndex")
    
    # read the reference sequences
    idx <- Rsamtools::scanFaIndex(seqFile)
    
    # create two temporary sequences files, C->T the plus strand and G->A for the minus strand
    outFilePlus <- tempfile(tmpdir = cacheDir, fileext = ".fa")
    outFileMinus <- tempfile(tmpdir = cacheDir, fileext = ".fa")
    
    on.exit(unlink(c(outFilePlus, outFileMinus)))
    
    # read one chromosome after the other, convert and write to disk
    append <- FALSE
    for (i in seq_len(length(idx))) {
        seq <- Rsamtools::scanFa(seqFile, idx[i])
        plus_strand <- Biostrings::chartr("C", "T", seq)
        minus_strand <- Biostrings::chartr("G", "A", seq)
        Biostrings::writeXStringSet(plus_strand, filepath = outFilePlus, 
                                    format = "fasta", append = append)
        Biostrings::writeXStringSet(minus_strand, filepath = outFileMinus, 
                                    format = "fasta", append = append)
        append <- TRUE
    }

    # execute bowtie twice to create the two indices
    ret1 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie-build"),
                    c(shQuote(outFilePlus), 
                      shQuote(file.path(indexPath, "bowtieIndexCtoT"))), 
                    stdout = TRUE, stderr = TRUE)
    if (!(grepl("^Total time for backward call to driver", ret1[length(ret1)]))) {
        ret1 <- 1
    } else {
        ret1 <- 0
    }
    
    ret2 <- system2(file.path(system.file(package = "Rbowtie"), "bowtie-build"),
                    c(shQuote(outFileMinus), 
                      shQuote(file.path(indexPath, "bowtieIndexGtoA"))), 
                    stdout = TRUE, stderr = TRUE)
    if (!(grepl("^Total time for backward call to driver", ret2[length(ret2)]))) {
        ret2 <- 1
    } else {
        ret2 <- 0
    }
 
    if ((ret1 == 0) & (ret2 == 0)) {
        return(0)
    } else {
        return(1)
    }
}

# build index for Rbowtie, color space, non-bisulfite converted
#' @keywords internal
#' @import Rbowtie
buildIndex_RbowtieCs <- function(seqFile, indexPath) {
    indexFullPath <- file.path(indexPath, "bowtieIndexCs")

    ret <- system2(file.path(system.file(package = "Rbowtie"), "bowtie-build"),
                   c(shQuote(seqFile), shQuote(indexFullPath), "-C"), 
                   stdout = TRUE, stderr = TRUE)
    if (!(grepl("^Total time for backward call to driver", ret[length(ret)]))) {
        ret <- 1
    } else {
        ret <- 0
    }
    
    return(ret)
}


# flush all chromosomes of a BSgenome into a file
#' @keywords internal
#' @importFrom methods is
#' @importFrom Biostrings masks DNAStringSet writeXStringSet injectHardMask
#' @importFrom Seqinfo seqnames
BSgenomeSeqToFasta <- function(bsgenome, outFile) {
    if (!methods::is(bsgenome, "BSgenome")) {
        stop("The variable 'bsgenome' is not a BSgenome")
    }
    append <- FALSE
    for (chrT in Seqinfo::seqnames(bsgenome)) {
        if (is.null(Biostrings::masks(bsgenome[[chrT]])))
            chrSeq <- Biostrings::DNAStringSet(bsgenome[[chrT]])
        else
            chrSeq <- Biostrings::DNAStringSet(
                Biostrings::injectHardMask(bsgenome[[chrT]], 
                                           letter = "N"))
        names(chrSeq) <- chrT
        Biostrings::writeXStringSet(chrSeq, filepath = outFile, 
                                    format = "fasta", append = append)
        append <- TRUE
    }
    return(outFile)
}

#' @keywords internal
#' @importFrom S4Vectors metadata
#' @importFrom utils packageVersion
#' @importFrom Seqinfo bsgenomeName provider releaseDate organism 
#'   commonName
createSeedList <- function(genome, aligner, indexPackageName) {
    pv <- S4Vectors::metadata(genome)$genome
    seed <- list(##package seeds
        PKGTITLE = paste(aligner, "Index of", Seqinfo::bsgenomeName(genome)),
        PKGDESCRIPTION = paste(aligner, "Index of", Seqinfo::bsgenomeName(genome)),
        PKGVERSION = "1.0",
        DATE = format(Sys.time(), "%Y-%M-%d"),
        AUTHOR = "QuasR",
        MAINTAINER = "This package was automatically created <yourfault@somewhere.net>",
        LIC = paste("see", Seqinfo::bsgenomeName(genome)),
        PKGDETAILS = "Storing genome index for BSgenome which is needed for alignments.",
        PKGEXAMPLES = "No examples",
        
        ##genome seeds
        GENOMENAME = Seqinfo::bsgenomeName(genome),
        PROVIDER = Seqinfo::provider(genome),
        PROVIDERVERSION = ifelse(!is.null(pv) && is.character(pv) && 
                                     length(pv) == 1L, pv, "not_available"),
        RELEASEDATE = Seqinfo::releaseDate(genome),
        RELEASENAME = "not_available",
        ORGANISM = Seqinfo::organism(genome),
        SPECIES = Seqinfo::commonName(genome),
        SRCDATAFILES = Seqinfo::bsgenomeName(genome),
        ORGANISMBIOCVIEW = gsub(" ", "_", Seqinfo::organism(genome)),
        
        #aligner seeds
        ALIGNER = aligner,
        ALIGNERVERSION = as.character(utils::packageVersion(aligner))
    )
    
    return(seed)
}

## query : GRanges : value is list of matrices:
##                   one list element per sample with matrix:
##                            one(normal) or three(allelic) rows per unique query name and max(width(query)) columns
##                   e.g.   res[['Sample1']]['HCP_TSS','-100']

#' Quantify alignments by relative position
#'
#' Quantify alignments from sequencing data, relative to their position in
#' query regions.
#'
#' \code{qProfile} is used to count alignments in each sample from a
#' \code{qProject} object, relative to their position in query regions.
#'
#' Most arguments are identical to the ones of \code{\link[QuasR]{qCount}}.
#'
#' The \code{query} argument is a \code{\link[GenomicRanges:GRanges-class]{GRanges}}
#' object that defines the regions for the profile. All regions in
#' \code{query} will be aligned to one another at their anchor position,
#' which corresponds to their biological start position (\code{start(query)}
#' for regions on strand \dQuote{+} or \dQuote{*}, \code{end(query)} for
#' regions on strand \dQuote{-}).
#'
#' This anchor position will be extended (with regard to strand) by
#' the number of bases specified by \code{upstream} and \code{downstream}.
#' In the return value, the anchor position will be at position zero.
#'
#' If \code{binSize} is greater than one, \code{upstream} and \code{downstream}
#' will be slightly increased in order to include the complete first and last
#' bins of \code{binSize} bases.
#'
#' Regions with identical names in \code{names{query}} will be summed, and
#' profiles will be padded with zeros to accomodate the length of all profiles.
#'
#' @param proj A \code{\linkS4class{qProject}} object representing a
#'   sequencing experiment as returned by \code{\link[QuasR]{qAlign}}
#' @param query An object of type \code{\link[GenomicRanges:GRanges-class]{GRanges}}
#'   with the regions to be profiled. All regions in \code{query} will be
#'   anchored at their biological start position (\code{start(query)} for
#'   regions on strand \dQuote{+} or \dQuote{*}, \code{end(query)} for
#'   regions on strand \dQuote{-}). This position will become position zero
#'   in the return value.
#' @param upstream An \dQuote{integer} vector of length one or the same
#'   length as \code{query} indicating the number of bases upstream of the
#'   anchor position to include in the profile.
#' @param downstream An \dQuote{integer} vector of length one or the same
#'   length as \code{query} indicating the number of bases downstream of the
#'   anchor position to include in the profile.
#' @param selectReadPosition defines the part of the alignment that has to be
#'   contained within a query region to produce an overlap (see Details), and
#'   that is used to calculate the relative position within the query region.
#'   Possible values are:
#'   \describe{
#'     \item{\code{start} (default)}{: start of the alignment}
#'     \item{\code{end}}{: end of the alignment}
#'   }
#' @param shift controls the shifting alignments towards their 3'-end before
#'   quantification. \code{shift} can be one of:
#'   \itemize{
#'     \item an \dQuote{integer} vector of the same length as the
#'     number of alignment files
#'     \item a single \dQuote{integer} value
#'     \item the character string \code{"halfInsert"} (only available for
#'     paired-end experiments)
#'   }
#'   The default of \code{0} will not shift any alignments.
#' @param orientation sets the required orientation of the alignments relative
#'   to the query region in order to be counted, one of:
#'   \describe{
#'     \item{\code{any} (default)}{: count alignment on the same and opposite strand}
#'     \item{\code{same}}{: count only alignment on the same strand}
#'     \item{\code{opposite}}{: count only alignment on the opposite strand}
#'   }
#' @param useRead For paired-end experiments, selects the read mate whose
#'   alignments should be counted, one of:
#'   \describe{
#'     \item{\code{any} (default)}{: count all alignments}
#'     \item{\code{first}}{: count only alignments from the first read}
#'     \item{\code{last}}{: count only alignments from the last read}
#'   }
#' @param auxiliaryName Which bam files to use in an experiments with
#'   auxiliary alignments (see Details).
#' @param mask If not \code{NULL}, a \code{\link[GenomicRanges:GRanges-class]{GRanges}}
#'   object with reference regions to be masked, i.e. excluded from the
#'   quantification, such as unmappable or highly repetitive regions (see
#'   Details).
#' @param collapseBySample If \code{TRUE} (the default), sum alignment
#'   counts from bam files with the same sample name.
#' @param includeSpliced If \code{TRUE} (the default), include spliced
#'   alignments when counting. A spliced alignment is defined as an
#'   alignment with a gap in the read of at least 60 bases.
#' @param includeSecondary If \code{TRUE} (the default), include alignments
#'   with the secondary bit (0x0100) set in the \code{FLAG} when counting.
#' @param mapqMin Minimal mapping quality of alignments to be included when
#'   counting (mapping quality must be greater than or equal to \code{mapqMin}).
#'   Valid values are between 0 and 255. The default (0) will include all
#'   alignments.
#' @param mapqMax Maximal mapping quality of alignments to be included when
#'   counting (mapping quality must be less than or equal to \code{mapqMax}).
#'   Valid values are between 0 and 255. The default (255) will include all
#'   alignments.
#' @param absIsizeMin For paired-end experiments, minimal absolute insert
#'   size (TLEN field in SAM Spec v1.4) of alignments to be included when
#'   counting. Valid values are greater than 0 or \code{NULL} (default),
#'   which will not apply any minimum insert size filtering.
#' @param absIsizeMax For paired-end experiments, maximal absolute insert
#'   size (TLEN field in SAM Spec v1.4) of alignments to be included when
#'   counting. Valid values are greater than 0 or \code{NULL} (default),
#'   which will not apply any maximum insert size filtering.
#' @param maxInsertSize Maximal fragment size of the paired-end experiment.
#'   This parameter is used if \code{shift="halfInsert"} and will ensure that
#'   query regions are made wide enough to emcompass all alignment pairs whose
#'   mid falls into the query region. The default value is \code{500} bases.
#' @param binSize Numeric scalar giving the size of bins (must be an odd number).
#'   The default value (\code{1}) gives back counts for single bases. Otherwise,
#'   alignments are counted in adjacent, non-overlapping windows of size
#'   \code{binSize} that tile the interval defined by \code{upstream} and
#'   \code{downstream}.
#' @param clObj A cluster object to be used for parallel processing (see
#'   \sQuote{Details}).
#'
#' @name qProfile
#' @aliases qProfile
#'
#' @return
#' A \code{list} of matrices with \code{length(unique(names(query)))} rows
#' with profile names, and \code{max(upstream)+max(downstream)+1} columns
#' indicating relative position (for \code{binsize=1}).
#'
#' For \code{binSize} values greater than 1, the number of columns corresponds to
#' the number of bins (tiles), namely
#' \code{ceiling(max(upstream)/binSize)+ceiling(max(downstream)/binSize)}.
#' A middle bin of size \code{binSize} is always positioned centered at the anchor
#' of each region. Additional bins are positioned upstream and downstream, adjacent
#' to that middle bin, in order to include at least \code{upstream} and
#' \code{downstream} bases, respectively (potentially more in order to fill the
#' first and last bins).
#'
#' The relative positions are given as column names (for \code{binSize > 1}
#' they refer to the bin mid). In that case, the bins are "right-open". For
#' example, if \code{binSize = 10}, the bin with the midpoint "-50" contains
#' counts for the alignments in [-55,-45).
#'
#' The first list element is called \dQuote{coverage} and contains, for each
#' profile and relative position, the number of overlapping regions
#' that contributed to the profile.
#'
#' Subsequent list elements contain the alignment counts for individual
#' sequence files (\code{collapseBySample=FALSE}) or samples
#' (\code{collapseBySample=TRUE}) in \code{proj}.
#'
#' For projects with allele-specific quantification, i.e. if a file with
#' single nucleotide polymorphisms was supplied to the \code{snpFile}
#' argument of \code{\link[QuasR]{qAlign}}, there will be three rows
#' instead of one row with counts per unique region name, with numbers
#' of alignments for Reference, Unknown and Alternative genotypes
#' (suffixed _R, _U and _A).
#'
#' @author Anita Lerch, Dimos Gaidatzis and Michael Stadler
#'
#' @keywords utilities misc
#'
#' @export
#'
#' @seealso
#' \code{\link[QuasR]{qCount}},
#' \code{\link[QuasR]{qAlign}},
#' \code{\linkS4class{qProject}},
#' \code{\link[parallel]{makeCluster}} from package \pkg{parallel}
#'
#' @examples
#' # copy example data to current working directory
#' file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)
#'
#' # create alignments (single-end experiment)
#' genomeFile <- "extdata/hg19sub.fa"
#' sampleFile <- "extdata/samples_chip_single.txt"
#' proj <- qAlign(sampleFile, genomeFile)
#'
#' # load transcript start site coordinates
#' library(rtracklayer)
#' annotationFile <- "extdata/hg19sub_annotation.gtf"
#' tssRegions <- import.gff(annotationFile, format="gtf",
#'                          feature.type="start_codon")
#'
#' # obtain a combined TSS profile
#' pr1 <- qProfile(proj, tssRegions)
#' lapply(pr1, dim)
#' lapply(pr1, "[", , 1:5)
#'
#' prComb <- do.call("+", lapply(pr1[-1], function(x) x/pr1[[1]]))
#' barplot(prComb, xlab="Position", ylab="Mean no. of alignments")
#'
#' # obtain TSS profiles for individual regions
#' names(tssRegions) <- mcols(tssRegions)$transcript_id
#' pr2 <- qProfile(proj, tssRegions)
#' lapply(pr2, dim)
#' lapply(pr2, "[", 1:3, 1:5)
#'
#' @importFrom Rsamtools scanBamHeader
#' @importFrom GenomicRanges GRanges
#' @importFrom IRanges IRanges
#' @importFrom BiocGenerics start end strand
#' @importFrom Seqinfo seqnames seqlevels
#' @importFrom parallel clusterEvalQ clusterMap
#'
qProfile <- function(proj,
                     query,
                     upstream = 1000,
                     downstream = upstream,
                     selectReadPosition = c("start", "end"),
                     shift = 0L,
                     orientation = c("any", "same", "opposite"),
                     useRead = c("any", "first", "last"),
                     auxiliaryName = NULL,
                     mask = NULL,
                     collapseBySample = TRUE,
                     includeSpliced = TRUE,
                     includeSecondary = TRUE,
                     mapqMin = 0L,
                     mapqMax = 255L,
                     absIsizeMin = NULL,
                     absIsizeMax = NULL,
                     maxInsertSize = 500L,
                     binSize = 1L,
                     clObj = NULL) {
    ## setup variables from 'proj' ---------------------------------------------
    ## 'proj' is correct type?
    if (!inherits(proj, "qProject", which = FALSE))
        stop("'proj' must be an object of type 'qProject' (returned by 'qAlign')")

    samples <- proj@alignments$SampleName
    nsamples <- length(samples)
    bamfiles <-
        if (is.null(auxiliaryName))
            proj@alignments$FileName
    else if (!is.na(i <- match(auxiliaryName, proj@aux$AuxName)))
        unlist(proj@auxAlignments[i, ], use.names = FALSE)
    else
        stop("unknown 'auxiliaryName', should be one of: NULL, ",
             paste(sprintf("'%s'", proj@aux$AuxName), collapse = ", "))


    ## validate parameters -----------------------------------------------------
    if (!is.numeric(upstream))
        stop("'upstream' must be of type 'numeric'")
    if (!is.numeric(downstream))
        stop("'downstream' must be of type 'numeric'")
    upstream <- as.integer(upstream)
    downstream <- as.integer(downstream)
    selectReadPosition <- match.arg(selectReadPosition)
    orientation <- match.arg(orientation)
    useRead <- match.arg(useRead)
    if (!is.logical(collapseBySample) || length(collapseBySample) != 1L)
        stop("'collapseBySample' must be either TRUE or FALSE")
    if (!is.logical(includeSpliced) || length(includeSpliced) != 1L)
        stop("'includeSpliced' must be either TRUE or FALSE")
    if (!is.logical(includeSecondary) || length(includeSecondary) != 1L)
        stop("'includeSecondary' must be either TRUE or FALSE")
    if ((!is.null(absIsizeMin) || !is.null(absIsizeMax)) && proj@paired == "no")
        stop("'absIsizeMin' and 'absIsizeMax' can only be used for paired-end experiments")
    if (is.null(absIsizeMin)) # -1L -> do not apply TLEN filtering
        absIsizeMin <- -1L
    if (is.null(absIsizeMax))
        absIsizeMax <- -1L
    if (!is.numeric(maxInsertSize) || length(maxInsertSize) != 1L)
        stop("'maxInsertSize' must be a numerical scalar")
    if (!is.numeric(binSize) || length(binSize) != 1L || binSize <= 0)
        stop("'binSize' must be a single numerical value greater than zero")
    if (binSize %% 2 != 1)
        stop("'binSize' must be an odd number")

    ## check shift
    if (length(shift) == 1 && shift == "halfInsert") {
        if (proj@paired == "no") {
            stop("'shift=\"halfInsert\"' can only be used for paired-end experiments")
        } else {
            shifts <- rep(-1000000L, nsamples)
            broaden <- as.integer(ceiling(maxInsertSize/2))
        }
    } else {
        if (!is.numeric(shift) || (length(shift) > 1 && length(shift) != nsamples))
            stop(sprintf("'shift' must be 'halfInsert', a single integer or an integer vector with %d values", nsamples))
        else if (length(shift) == 1)
            shifts <- rep(as.integer(shift), nsamples)
        else
            shifts <- as.integer(shift)
        broaden <- 0L
    }

    ## all query chromosomes present in all bamfiles?
    trTab <- table(unlist(lapply(Rsamtools::scanBamHeader(bamfiles),
                                 function(bh) names(bh$targets))))
    trCommon <- names(trTab)[trTab == length(bamfiles)]
    if (any(f <- !(Seqinfo::seqlevels(query) %in% trCommon)))
        stop(sprintf("sequence levels in 'query' not found in alignment files: %s",
                     paste(Seqinfo::seqlevels(query)[f], collapse = ", ")))

    ## 'useRead' set but not a paired-end experiment?
    if (useRead != "any" && proj@paired == "no")
        warning("ignoring 'useRead' for single read experiments")


    ## preprocess query --------------------------------------------------------
    ##    --> extract 'querynames', 'refpos', 'queryWin', 'maxUp', 'maxDown', 'maxUpBin', 'maxDownBin'
    ##        split into 'queryWinL', 'refposL', 'querynamesIntL' by name
    ##    GRanges query --------------------------------------------------------
    if (inherits(query,"GRanges")) {
        # define 'querynames'
        if (!is.null(names(query)))
            querynames <- names(query)
        else
            querynames <- rep("query", length(query)) # combine all regions

        # define 'refpos' and 'queryWin'
        if (length(upstream) == 1)
            upstream <- rep(upstream, length(query))
        else if (length(upstream) != length(query))
            stop(sprintf("the length of 'upstream' (%d) must be one or the same as 'query' (%d)",
                         length(upstream), length(query)))
        if (length(downstream) == 1)
            downstream <- rep(downstream, length(query))
        else if (length(downstream) != length(query))
            stop(sprintf("the length of 'downstream' (%d) must be one or the same as 'query' (%d)",
                         length(downstream), length(query)))

        # adjust 'upstream', 'downstream' to include full bins
        upstream <- ceiling((upstream - (binSize - 1)/2) / binSize) * binSize +
            (binSize - 1)/2
        downstream <- ceiling((downstream - (binSize - 1)/2) / binSize) * binSize +
            (binSize - 1)/2

        # define 'maxUp', 'maxDown', 'maxUpBin' and 'maxDownBin'
        # (have one bin that is centered at anchor point, relative position of bin mid at zero)
        #   maxUp, maxDown: number of bases upstream/downstream of start(query) --> includes half of middle bin, but not the anchor posittion
        #                   (total number of covered bases: maxUp + maxDown + 1)
        #   maxUpBin, maxDownBin: number of bins upstream/downstream of middle bin
        #                         (total number of bins: maxUpBin + maxDownBin + 1)
        maxUpBin   = as.integer(ceiling((max(upstream)   + 1 - (binSize + 1)/2)/binSize))
        maxDownBin = as.integer(ceiling((max(downstream) + 1 - (binSize + 1)/2)/binSize))
        maxUp   = as.integer(maxUpBin   * binSize + (binSize - 1)/2)
        maxDown = as.integer(maxDownBin * binSize + (binSize - 1)/2)
        # err = (maxUp + maxDown + 1) %% binSize # has to be zero
        binNames <- as.character(seq(-maxUpBin * binSize, maxDownBin * binSize, by = binSize))
        if ((maxUpBin + maxDownBin + 1) > 20000L)
            warning(sprintf("profiling over large region (%d basepairs, %d bins) - may be slow and require a lot of memory",
                            maxUp + maxDown + 1, maxUpBin + maxDownBin))

        plusStrand <- as.character(BiocGenerics::strand(query)) != "-"
        refpos <- ifelse(plusStrand, BiocGenerics::start(query),
                         BiocGenerics::end(query))
        queryWin <- GenomicRanges::GRanges(
            Seqinfo::seqnames(query),
            IRanges::IRanges(
              start = pmax(1, ifelse(plusStrand,
                                     refpos - upstream, refpos - downstream)),
              end = ifelse(plusStrand, refpos + downstream, refpos + upstream)),
            strand = BiocGenerics::strand(query)
        )

        # split 'queryWin' --> 'queryWinL' and 'refpos' --> 'refposL' by 'querynames'
        if (!is.null(clObj) & inherits(clObj, "cluster", which = FALSE)) {
            profileChunkL <- split(seq_len(length(queryWin)),
                                   factor(querynames, levels = unique(querynames)))
            approxNumRegionsPerChunk <- length(queryWin) / (length(clObj) / length(bamfiles))
            profileChunkToTask <- round(cumsum(vapply(profileChunkL, length, 1))
                                        / approxNumRegionsPerChunk)
            taskL <- lapply(split(seq_along(profileChunkL), profileChunkToTask), function(i) do.call(c, profileChunkL[i]))
        } else {
            taskL <- list(seq_len(length(queryWin))) # single task per bam file
        }
        queryWinL <- lapply(taskL, function(i) queryWin[i])
        refposL <- lapply(taskL, function(i) refpos[i])
        querynamesInt <- as.integer(factor(querynames, levels = unique(querynames)))
        querynamesIntL <- lapply(taskL, function(i) querynamesInt[i])

        # calculate coverage
        cvgBaseL <- lapply(seq_along(queryWin), function(i)
            (maxUp - upstream[i] + 1):(maxUp + downstream[i] + 1))
        cvgBase <- do.call(
          rbind, lapply(split(seq_along(queryWin),
                              factor(querynames, levels = unique(querynames))),
                        function(i) tabulate(unlist(cvgBaseL[i]),
                                             nbins = maxUp + maxDown + 1))
        )
        cvg <- do.call(
          cbind, lapply(split(seq.int(maxUp + maxDown + 1),
                              rep(seq(-maxUpBin, maxDownBin), each = binSize)),
                        function(i) rowSums(cvgBase[, i, drop = FALSE]))
        )
        colnames(cvg) <- binNames

    } else {
        stop("'query' must be an object of type 'GRanges'")
    }
    ## from now on, only use 'queryWinL' (named list of GRanges objects) with reference positions in 'refposL'


    ## apply 'mask' to queryWinL -----------------------------------------------
    if (!is.null(mask)) {
        if (!inherits(mask, "GRanges"))
            stop("'mask' must be an object of type 'GRanges'")
        stop("'mask' is not yet supported for qProfile")
    }


    ## setup tasks for parallelization -----------------------------------------
    if (!is.null(clObj) & inherits(clObj, "cluster", which = FALSE)) {
        loadQuasR(clObj)
        myapply <- function(...) parallel::clusterMap(clObj, ..., SIMPLIFY = FALSE,
                                                      .scheduling = "dynamic")
    } else {
        myapply <- function(...) mapply(..., SIMPLIFY = FALSE)
    }

    ## count alignments --------------------------------------------------------
    message("profiling alignments...", appendLF = FALSE)
    res <- myapply(profileAlignments,
                   bamfile = rep(bamfiles, each = length(queryWinL)),
                   queryids = querynamesIntL,
                   regions = queryWinL,
                   refpos = refposL,
                   shift = rep(shifts, each = length(queryWinL)),
                   MoreArgs = list(
                       selectReadPosition = selectReadPosition,
                       orientation = orientation,
                       useRead = useRead,
                       broaden = broaden,
                       allelic = !is.na(proj@snpFile),
                       maxUp = maxUp,
                       maxDown = maxDown,
                       maxUpBin = maxUpBin,
                       maxDownBin = maxDownBin,
                       includeSpliced = includeSpliced,
                       includeSecondary = includeSecondary,
                       mapqmin = as.integer(mapqMin)[1],
                       mapqmax = as.integer(mapqMax)[1],
                       absisizemin = as.integer(absIsizeMin)[1],
                       absisizemax = as.integer(absIsizeMax)[1],
                       binsize = as.integer(binSize),
                       binNames = binNames))
    message("done")

    ## fuse by input file, rename and collapse by sample
    if (!is.na(proj@snpFile)) {
        res <- lapply(split(seq_along(res), rep(displayNames(proj), each = length(queryWinL))),
                      function(i) {
                          tmpR <- do.call(rbind, lapply(res[i], "[[", "R"))
                          tmpU <- do.call(rbind, lapply(res[i], "[[", "U"))
                          tmpA <- do.call(rbind, lapply(res[i], "[[", "A"))
                          rownames(tmpR) <- rownames(tmpU) <- rownames(tmpA) <-
                              unique(querynames)
                          list(R = tmpR, U = tmpU, A = tmpA)
                      })
        if (collapseBySample) {
            res <- lapply(split(seq_along(res), factor(samples, levels = unique(samples))),
                          function(i) list(R = Reduce("+", lapply(res[i], "[[", "R")),
                                           U = Reduce("+", lapply(res[i], "[[", "U")),
                                           A = Reduce("+", lapply(res[i], "[[", "A"))))
        }
        nms <- paste(rep(names(res), each = 3), c("R", "U", "A"), sep = "_")
        res <- do.call(c, res)
        names(res) <- nms
    } else {
        res <- lapply(split(seq_along(res), rep(displayNames(proj), each = length(queryWinL))),
                      function(i) {
                          tmp <- do.call(rbind, res[i])
                          rownames(tmp) <- unique(querynames)
                          tmp
                      })
        if (collapseBySample) {
            res <- lapply(split(seq_along(res), factor(samples, levels = unique(samples))),
                          function(i) Reduce("+", res[i]))
        }
    }

    ## add the region coverage as first elemnt
    res <- c(list(coverage = cvg), res)

    ## return results
    return(res)
}

## profile alignments (with the C-function) for single bamfile, multiple regions, single shift
## return a numeric vector with maxWidth elements corresponding to the positions within the query regions
#' @keywords internal
#' @importFrom Rsamtools scanBamHeader
#' @importFrom Seqinfo seqnames
#' @importFrom BiocGenerics start end strand match as.vector
profileAlignments <- function(bamfile, queryids, regions, refpos, shift,
                              selectReadPosition, orientation, useRead,
                              broaden, allelic, maxUp, maxDown, maxUpBin,
                              maxDownBin, includeSpliced, includeSecondary,
                              mapqmin, mapqmax, absisizemin, absisizemax,
                              binsize, binNames) {
    tryCatch({ # try catch block contains whole function

        # translate seqnames to tid and create region data.frame
        seqnamesBamHeader <- names(Rsamtools::scanBamHeader(bamfile)[[1]]$targets)

        # prepare region vectors
        tid <- BiocGenerics::as.vector(BiocGenerics::match(Seqinfo::seqnames(regions),
                                                           seqnamesBamHeader) - 1L)
        s <- BiocGenerics::start(regions) - 1L # Samtools library has 0-based inclusive start
        e <- BiocGenerics::end(regions) # Samtools library has 0-based exclusive end
        rp <- refpos - 1L # Samtools library has 0-based inclusive start

        ## swap selstrand for 'orientation="opposite"'
        regstrand <- as.character(BiocGenerics::strand(regions))
        if (orientation == "any")
            selstrand <- rep("*", length(regions))
        else if (orientation == "opposite")
            selstrand <- c("+"="-", "-"="+", "*"="*")[regstrand]
        else # orientation == "same"
            selstrand <- regstrand

        ## translate useRead parameter
        BAM_FREAD1 <- 64L
        BAM_FREAD2 <- 128L
        if (useRead == "any")
            readBitMask <- BAM_FREAD1 + BAM_FREAD2
        else if (useRead == "first")
            readBitMask <- BAM_FREAD1
        else if (useRead == "last")
            readBitMask <- BAM_FREAD2

        ## translate includeSecondary parameter
        BAM_FSECONDARY <- 256L
        if (includeSecondary)
            readBitMask <- readBitMask + BAM_FSECONDARY

        ## count alignments by position
        if (!allelic) {
            count <- t(.Call(profileAlignmentsNonAllelic, bamfile, queryids, tid,
                             s, e, rp, selstrand, regstrand,
                             selectReadPosition, readBitMask, shift, broaden,
                             maxUp, maxDown, maxUpBin, maxDownBin,
                             includeSpliced, mapqmin, mapqmax, absisizemin,
                             absisizemax, binsize, binNames))
        } else {
            count <- lapply(.Call(profileAlignmentsAllelic, bamfile, queryids, tid,
                                  s, e, rp, selstrand, regstrand,
                                  selectReadPosition, readBitMask, shift, broaden,
                                  maxUp, maxDown, maxUpBin, maxDownBin,
                                  includeSpliced, mapqmin, mapqmax, absisizemin,
                                  absisizemax, binsize, binNames), t)
        }

        return(count)

    }, error = function(ex) {
        reg <- regions[c(1, length(regions))]
        emsg <- paste("Internal error on ", Sys.info()['nodename'],
                      ", bamfile ", bamfile," with regions\n\t",
                      paste(Seqinfo::seqnames(reg), ":",
                            BiocGenerics::start(reg), "-" , BiocGenerics::end(reg),
                            ":", BiocGenerics::strand(reg), sep = "",
                            collapse = "\n\t...\n\t"),
                      "\n Error message is: ", ex$message, sep = "")
        stop(emsg)
    })
}

---
title: "An introduction to QuasR"
date: "`r format(Sys.time(), '%d %B, %Y')`"
bibliography: QuasR-refs.bib
author:
  - Michael Stadler
  - Dimos Gaidatzis
  - Charlotte Soneson
  - Anita Lerch
package: QuasR
output: 
  BiocStyle::html_document:
    toc_float: true
vignette: >
  %\VignetteIndexEntry{An introduction to QuasR}
  %\VignetteEncoding{UTF-8}  
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

<!--
\DeclareRobustCommand{\QuasRlogo}{\raisebox{-8mm}{\includegraphics[width=45mm]{QuasR-logo.pdf}}}% use \DeclareRobustCommand instead of \newcommand to avoid premature expansion of \QuasRlogo within by 'titling' package
-->

<img src="QuasR-logo.png" style="position:absolute;top:0px;right:0px;" />

<!--
```{r options, results='hide', echo=FALSE}
#options(width=65)
options('useFancyQuotes' = FALSE, continue = " ", digits = 3)
```
-->



# Introduction

The `r Biocpkg("QuasR")` package (short for <i>Qu</i>antify and <i>a</i>nnotate <i>s</i>hort reads
in <i>R</i>) integrates the functionality of several **R** packages (such as `r Biocpkg("IRanges")` [@IRanges]
and `r Biocpkg("Rsamtools")`) and external software (e.g. `bowtie`, through the 
`r Biocpkg("Rbowtie")` package, and `HISAT2`, through the `r Biocpkg("Rhisat2")` package).
The package aims to cover the whole analysis workflow of typical high throughput
sequencing experiments, starting from the raw sequence reads, over pre-processing and
alignment, up to quantification. A single **R** script can contain all steps of a complete
analysis, making it simple to document, reproduce or share the workflow containing all
relevant details.

The current `r Biocpkg("QuasR")` release supports the analysis of single read and
paired-end ChIP-seq (chromatin immuno-precipitation combined with sequencing), RNA-seq
(gene expression profiling by sequencing of RNA) and Bis-seq (measurement of DNA
methylation by sequencing of bisulfite-converted genomic DNA) experiments. It has
been successfully used with data from Illumina, 454 Life Technologies and SOLiD
sequencers, the latter by using bam files created externally of `r Biocpkg("QuasR")`.

# Preliminaries

## Citing `r Biocpkg("QuasR")`
If you use `r Biocpkg("QuasR")` [@QuasR] in your work, you can cite it as follows:
```{r cite, eval=TRUE}
citation("QuasR")
```

## Installation{#installation}
`r Biocpkg("QuasR")` is a package for the **R** computing environment and it is
assumed that you have already installed **R**. See the **R** project at (http://www.r-project.org).
To install the latest version of `r Biocpkg("QuasR")`, you will need to be using the
latest version of **R**. `r Biocpkg("QuasR")` is part of the Bioconductor project
at (http://www.bioconductor.org). To get `r Biocpkg("QuasR")` together with its
dependencies you can use
```{r install, eval=FALSE}
if (!require("BiocManager"))
    install.packages("BiocManager")
BiocManager::install("QuasR")
```

Bioconductor works on a 6-monthly official release cycle. As with other Bioconductor
packages, there are always two versions of `r Biocpkg("QuasR")`. Most users will
use the current official release version, which will be installed by `BiocManager::install`
if you are using the current release version of **R**. There is also a development version
of `r Biocpkg("QuasR")` that includes new features due for the next official release.
The development version will be installed if you are using the development version of
**Bioconductor** (see `version = "devel"` in `r Biocpkg("BiocManager")`). The official
release version always has an even second number (for example 1.20.1), whereas the
developmental version has an odd second number (for example 1.21.4).

## Loading of *QuasR* and other required packages
In order to run the code examples in this vignette, the `r Biocpkg("QuasR")` package
and a few additional packages need to be loaded:
```{r loadLibraries, eval=TRUE}
suppressPackageStartupMessages({
    library(QuasR)
    library(BSgenome)
    library(Rsamtools)
    library(rtracklayer)
    library(GenomicFeatures)
    library(txdbmaker)
    library(Gviz)
})
```

## How to get help
Most questions about `r Biocpkg("QuasR")` will hopefully be answered by the documentation
or references. If you've run into a question which isn't addressed by the documentation,
or you've found a conflict between the documentation and software, then there
is an active support community which can offer help.

The authors of the package (maintainer: `r maintainer("QuasR")`) always appreciate
receiving reports of bugs in the package functions or in the documentation. The same
goes for well-considered suggestions for improvements. 

Any other questions or problems concerning `r Biocpkg("QuasR")` should be posted
to the Bioconductor support site (https://support.bioconductor.org). Users posting
to the support site for the first time should read the helpful posting guide at
(https://support.bioconductor.org/info/faq/). Note that each function in `r Biocpkg("QuasR")`
has it's own help page, as described in the section \@ref(introToR).
Posting etiquette requires that you read the relevant help page carefully before
posting a problem to the site.


# Quick Start
## A brief introduction to **R**{#introToR}
If you already use **R** and know about its interface, just skip this
section and continue with section \@ref(sampleQuasRsession).

The structure of this vignette and in particular this section is based on the excellent
user guide of the `r Biocpkg("limma")` package, which we would like to hereby acknowledge.
**R** is a program for statistical computing. It is a command-driven language meaning
that you have to type commands into it rather than pointing and clicking using a mouse.
In this guide it will be assumed that you have successfully downloaded and installed **R**
from (http://www.r-project.org) as well as `r Biocpkg("QuasR")` (see section \@ref(installation)).
A good way to get started is to type
```{r help1, eval=FALSE}
help.start()
```

at the **R** prompt or, if you're using **R** for Windows, to follow the drop-down
menu items *Help* $\succ$ *Html help*. Following the links *Packages* $\succ$ `r Biocpkg("QuasR")`
from the html help page will lead you to the contents page of help topics for functions
in `r Biocpkg("QuasR")`.  

Before you can use any `r Biocpkg("QuasR")` commands you have to load the package
by typing
```{r loadQuasRLibrary, eval=FALSE}
library(QuasR)
```

at the **R** prompt. You can get help on any function in any loaded package by typing
`?` and the function name at the **R** prompt, for example
```{r help2, eval=FALSE}
?preprocessReads
```

or equivalently
```{r help3, eval=FALSE}
help("preprocessReads")
```

for detailed help on the `preprocessReads` function. The function help
page is especially useful to learn about its arguments and its return value.

Working with **R** usually means creating and transforming *objects*.
Objects might include data sets, variables, functions, anything at all.
For example
```{r assign, eval=FALSE}
x <- 2
```

will create a variable `x` and will assign it the value 2. At any stage of your
**R** session you can type
```{r ls, eval=FALSE}
ls()
```

to get a list of all the objects currently existing in your session. You can
display an object by typing its name on the prompt. The following displays the
object `x`:
```{r printObject, eval=FALSE}
x
```

We hope that you can use `r Biocpkg("QuasR")` without having to spend a lot of time
learning about the **R** language itself but a little knowledge in this direction
will be very helpful, especially when you want to do something not explicitly provided
for in `r Biocpkg("QuasR")` or in the other Bioconductor packages. For more details
about the **R** language see *An Introduction to R* which is available from the online
help, or one of the many great online resources, like the documentation at [r-project.org](https://www.r-project.org/),
the growing list of free books at [bioconductor.org](https://bioconductor.org/books/release/),
or the books from [rstudio.com](https://rstudio.com/resources/books/) (many of which are
also available for free). For more background on using **R** for statistical analysis see [@Dalgaard].


## Sample *QuasR* session{#sampleQuasRsession}
This is a quick overview of what an analysis could look like for users preferring
to jump right into an analysis. The example uses data that is provided with the
`r Biocpkg("QuasR")` package, which is first copied to the current working directory,
into a subfolder called `"extdata"`:
```{r SampleSession1, eval=TRUE}
file.copy(system.file(package = "QuasR", "extdata"), ".", recursive = TRUE)
```

The sequence files to be analyzed are listed in `sampleFile` (see section
\@ref(sampleFile) for details).
The sequence reads will be aligned using `bowtie` [@bowtie] (from the `r Biocpkg("Rbowtie")`
package [@Rbowtie]) to a small reference genome (consisting of three short segments
from the hg19 human genome assembly, available in full for example in the
`r Biocpkg("BSgenome.Hsapiens.UCSC.hg19")` package). Information on selecting
an appropriate reference genome is summarized in section \@ref(genome).

Make sure that you have sufficient disk space, both in your **R** temporary
directory (`tempdir()`) as well as to store the resulting alignments
(see section \@ref(qAlign)).
```{r SampleSession2, eval=TRUE}
sampleFile <- "extdata/samples_chip_single.txt"
genomeFile <- "extdata/hg19sub.fa"

proj <- qAlign(sampleFile, genomeFile)
proj
```

The `proj` object keeps track of all the information of a sequencing experiment,
for example where sequence and alignment files are stored, and what aligner and
reference genome was used to generate the alignments.

Now that the alignments have been generated, further analyses can be performed.
A quality control report is saved to the `"extdata/qc_report.pdf"` file using the
`qQCReport` function.
```{r SampleSession3, eval=TRUE}
qQCReport(proj, "extdata/qc_report.pdf")
```

The number of alignments per promoter region is quantified using `qCount`. Genomic
coordinates for promoter regions are imported from a gtf file (`annotFile`) into
the `GRanges`-object with the name `promReg`:
```{r SampleSession4, eval=TRUE}
library(rtracklayer)
library(GenomicFeatures)
annotFile <- "extdata/hg19sub_annotation.gtf"
txStart <- import.gff(annotFile, format = "gtf", feature.type = "start_codon")
promReg <- promoters(txStart, upstream = 500, downstream = 500)
names(promReg) <- mcols(promReg)$transcript_name

promCounts <- qCount(proj, query = promReg)
promCounts
```
 
# *QuasR* Overview
The following scheme shows the major components of `r Biocpkg("QuasR")` and their
relationships:
![](QuasR-scheme.png)

`r Biocpkg("QuasR")` works with data (sequences and alignments, reference genome,
etc.) that are stored as files on your storage (the gray cylinder on the lower left
of Figure above, see section \@ref(fileStorageLocations) for details on storage locations).
`r Biocpkg("QuasR")` does not need a database management system, or these files to
be named and organized according to a specific scheme.

In order to keep track of directory paths during an analysis, `r Biocpkg("QuasR")`
makes use of a `qProject` object that is returned by the `qAlign` function, which
at the minimum requires two inputs: the name of a samples text file (see section
\@ref(sampleFile) for details), and the reference genome for the alignments
(see section \@ref(genome)).

The `qProject` object is the main argument passed to subsequent functions such as
`qQCReport` and `qCount`. The `qProject` object contains all necessary information
on the current project and eliminates the need to repeatedly enter the same information.
All functions that work on `qProject` objects can be recognized by their names starting
with the letter *q*.

Read quantification (apart from quantification of methylation which has its own
function `qMeth`) is done using the `qCount` function: It counts the alignments in
regions of interest (e.g. promoters, genes, exons, etc.) and produces a count table
(regions in rows, samples in columns) for further visualization and analysis. The
count table can also be used as input to a statistical analysis using packages such
as `r Biocpkg("edgeR")` [@edgeR], `r Biocpkg("DESeq")` [@DESeq], `r Biocpkg("DESeq2")` [@DESeq2],
`r Biocpkg("TCC")` [@TCC], `r Biocpkg("DEXSeq")` [@DEXSeq] or `r Biocpkg("baySeq")` [@baySeq].

In summary, a typical `r Biocpkg("QuasR")` analysis consists of the following steps
(some of them are optional):

- `preprocessReads` (optional): Remove adapters from start or end of reads, filter
  out reads of low quality, short length or low complexity (section \@ref(preProcessing)).  
- Prepare *samples file*: List sequence files or alignments, provide sample names
  (section \@ref(sampleFile)).  
- Prepare *auxiliary file* (optional): List additional reference sequences for
  alignment of reads not matching the reference genome (section \@ref(auxiliaryFile)).  
- `qAlign`: Create `qProject` object and specify project parameters. Also download
  BSgenome package, create aligner indices and align reads if not already existing 
  (section \@ref(qAlign)).  
- `qQCReport` (optional): Create quality control report with plots on sequence qualities
  and alignment statistics (section \@ref(qQCReport)).  
- `qExportWig` (optional): Export genomic alignments as wiggle tracks for genome
  browser visualization (section \@ref(qExportWig)).  
- `qCount`: Quantify alignments in regions of interest (section \@ref(qCount)).  

Recurrent example tasks that may be part of any typical analysis are described in
section \@ref(exampleTasks). Example workflows for specific experiment types (ChIP-seq,
RNA-seq and Bis-seq) are described in section \@ref(exampleWorkflows).

## File storage locations{#fileStorageLocations}
Apart from `qExportWig` and `qQCReport`, which generate wig files and pdf reports,
`qAlign` is the only function in `r Biocpkg("QuasR")` that stores files on the disk
(see section \@ref(qAlign) for details). All files generated by `qAlign` are listed here
by type, together with their default location and how locations can be changed.  

- *Temporary files* (default: `tempdir()`): Temporary files include reference genomes
  in `fasta` format, decompressed input sequence files, and temporary alignments in
  text format, and can require a large amount of disk space. By default, these files
  will be written to the temporary directory of the **R** process (as reported by
  `tempdir()`). If using `clObj` for parallel processing, this may be the `tempdir()`
  from the cluster node(s). An alternative location can be set using the `TMPDIR`
  environment variable (see `?tempdir`).  
- *Alignment files (`bam` format)* (default: same directory as the input sequence files):
  Alignments against reference genome and auxiliary targets are stored in `bam` format
  in the same directory that also contains the input sequence file (listed in `sampleFile`).
  Please note that if the input sequence file corresponds to a symbolic link, `r Biocpkg("QuasR")`
  will follow the link and use the directory of the original file instead. An alternative
  directory can be specified with the `alignmentsDir` argument from `qAlign`, which
  will store all `bam` files in that directory even if the input sequence files are located
  in different directories.  
- *Alignment index files* (default: depends on `genome` and `snpFile` arguments):
  Many alignment tools including `bowtie` require an index of the reference sequence
  to perform alignments. If necessary, `qAlign` will build this index automatically
  and store it in a default location that depends on the `genome` argument:  
    + `BSgenome`: If `genome` is the name of a `r Biocpkg("BSgenome")` package
      (such as `"BSgenome.Hsapiens.UCSC.hg19"`), the index will be stored as a
      new **R** package in the default library path (as reported by `.libPaths()[1]`,
      see `?install.packages` for details), or alternatively in the library
      specified by the `lib.loc` argument of `qAlign`. The name of this index
      package will be the name of the original `r Biocpkg("BSgenome")` package
      with a suffix for the index type, for example `"BSgenome.Hsapiens.UCSC.hg19.Rbowtie"`.  
    + `fasta`: If `genome` refers to a reference genome file in `fasta` format,
      the index will be stored in a subdirectory at the same location. Similarly,
      the indices for files listed in `auxiliaryFile` are store at the location
      of these files. For example, the `Rbowtie` index for the genome at
      `"./genome/mm9.fa"` is stored in `"./genome/mm9.fa.Rbowtie"`.  
    + *Allele-specific analysis*: A special case is the allele-specific analysis,
      where reference and alternative alleles listed in `snpFile` (e.g. `"./mySNPs.tab"`)
      are injected into the `genome` (e.g. `"BSgenome.Mmusculus.UCSC.mm9"`)
      to create two variant genomes to be indexed. These indices are saved at the
      location of the `snpFile` in a directory named after `snpFile`, `genome`
      and the index type (e.g. `"./mySNPs.tab.BSgenome.Mmusculus.UCSC.mm9.A.fa.Rbowtie"`).



# Example tasks{#exampleTasks}
## Create a sample file{#sampleFile}
The sample file is a tab-delimited text file with two or three columns. The first
row contains the column names: For a single read experiment, these are 'FileName'
and 'SampleName'; for a paired-end experiment, these are 'FileName1', 'FileName2'
and 'SampleName'. If the first row does not contain the correctly spelled column
names, `r Biocpkg("QuasR")` will not accept the samples file. Subsequent rows contain
the input sequence files.

Here are examples of such sample files for a single read experiment:

<pre>
```{r sampleFileSingle, echo=FALSE, results="asis"}
cat(paste(readLines(system.file(package = "QuasR",
                                "extdata", "samples_chip_single.txt")),
          collapse = "\n"))
```
</pre>
<!--
------------------- | -------------
`FileName`          | `SampleName`  
`chip_1_1.fq.bz2`   | `Sample1`  
`chip_2_1.fq.bz2`   | `Sample2`  
-->

and for a paired-end experiment:

<pre>
```{r sampleFilePaired, echo=FALSE, results="asis"}
cat(paste(readLines(system.file(package = "QuasR",
                                "extdata", "samples_rna_paired.txt")),
      collapse = "\n"))
```
</pre>
<!--
`FileName1`        | `FileName2`        | `SampleName`  
`rna_1_1.fq.bz2`   | `rna_1_2.fq.bz2`   | `Sample1`  
`rna_2_1.fq.bz2`   | `rna_2_2.fq.bz2`   | `Sample2`  
-->

These example files are also contained in the `r Biocpkg("QuasR")` package and may
be used as templates. The path of the files can be determined using:  
```{r sampleFile, eval=FALSE}
sampleFile1 <- system.file(package="QuasR", "extdata",
                           "samples_chip_single.txt")
sampleFile2 <- system.file(package="QuasR", "extdata",
                           "samples_rna_paired.txt")
```

The columns *FileName* for single-read, or *FileName1* and *FileName2* for paired-end
experiments contain paths and names to files containing the sequence data. The paths
can be absolute or relative to the location of the sample file. This allows combining
files from different directories in a single analysis. For each input sequence file,
`qAlign` will create one alignment file and by default store it in the same directory
as the sequence file. Already existing alignment files with identical parameters will
not be re-created, so that it is easy to reuse the same sequence files in multiple
projects without unnecessarily copying sequence files or recreating alignments.

The *SampleName* column contains sample names for each sequence file. The same name
can be used on several lines to indicate multiple sequence files that belong to the
same sample (`qCount` can use this information to automatically combine counts for
one sample from multiple files).

Three file formats are supported for input files (but cannot be mixed within a single
sample file):  

- **fasta** files have names that end with '.fa', '.fna' or '.fasta'. They contain
  only sequences (and no base qualities) and will thus by default be aligned on the
  basis of mismatches (the best alignment is the one with fewest mismatches).  
- **fastq** files have names that end with '.fq' or '.fastq'. They contain sequences
  and corresponding base qualities and will be aligned by default using these qualities.
  The encoding scheme of base qualities is automatically detected for each individual
  fastq file.  
- **bam** files have names that end with '.bam'. They can be used if the sequence
  reads have already been aligned outside of `r Biocpkg("QuasR")`, and `r Biocpkg("QuasR")`
  will only be used for downstream analysis based on the alignments contained in the
  `bam` files. This makes it possible to use alignment tools that are not available
  within `r Biocpkg("QuasR")`, but making use of this option comes with a risk and
  should only be used by experienced users. For example, it cannot be guaranteed
  any more that certain assumptions made by `qCount` are fulfilled by the external
  aligner (see below). When using external `bam` 
  files, we recommend to use files which contain only one alignment per read. This
  may also include multi-hit reads, for which one of the alignments is randomly
  selected. This allows `r Biocpkg("QuasR")` to count the total number of reads by
  counting the total number of alignments. Furthermore, if the `bam` files also
  contain the unmapped reads, `r Biocpkg("QuasR")` will be able to calculate the
  fraction of mapped reads. For bisulfite samples we require ungapped alignments
  stored in unpaired or paired *ff* orientation (even if the input reads are *fr*).
  For allele-specific `bam` files, `r Biocpkg("QuasR")` requires an additional tag
  for each alignment called `XV` of type `A` (printable character) with the possible
  values `R` (Reference), `U` (Unknown) and `A` (Alternative).  

**fasta** and **fastq** files can be compressed with gzip, bzip2 or xz (file extensions
'.gz', '.bz2' or 'xz', respectively) and will be automatically decompressed when necessary.

### Working only with `bam` files after performing alignments
Once alignments have been created, most analyses will only require the `bam` files
and will not access the original raw sequence files anymore. However, re-creating
a `qProject` object by a later identical call to `qAlign` will still need access to
the raw sequences to verify consistency between raw data and alignments. It may be
desirable to remove this dependency, for example to archive or move away the raw
sequence files and to reclaim used disk space.

This can be achieved using the following procedure involving two sequential calls
to `qAlign`. First, `qAlign` is called with the orignial sample file (`sampleFile1`)
that lists the raw sequence files, and subsequently with a second sample file
(`sampleFile2`) that lists the `bam` files generated in the first call. Such a 
second sample file can be easily generated given the `qProject` object (`proj1`) 
returned by the first call:  
```{r <sampleFileSeqToBam, eval=FALSE}
sampleFile1 <- "samples_fastq.txt"
sampleFile2 <- "samples_bam.txt"

proj1 <- qAlign(sampleFile1, genomeFile)

write.table(alignments(proj1)$genome, sampleFile2, sep="\t", row.names=FALSE)

proj2 <- qAlign(sampleFile2, genomeFile)
```

The analysis can now be exclusively based on the `bam` files using `sampleFile2` and `proj2`.

### Consistency of samples within a project
The sample file implicitly defines the type of samples contained in the project:
*single read* or *paired-end read*, sequences *with* or *without* qualities.
This type will have a profound impact on the downstream analysis. For example,
it controls whether alignments will be performed in single or paired-end mode,
either with or without base qualities. That will also determine availability of
certain options for quality control and quantification in `qQCReport` and `qCount`.
For consistency, it is therefore required that all samples within a project have
the same type; it is not possible to mix both single and paired-end read samples,
or **fasta** and **fastq** files in a single project (sample file). If necessary,
it may be possible to analyse different types of files in separate `r Biocpkg("QuasR")`
projects and combine the derived results at the end.


## Create an auxiliary file (optional){#auxiliaryFile}
By default `r Biocpkg("QuasR")` aligns reads only to the reference genome. However,
it may be interesting to align non-matching reads to further targets, for example
to identify contamination from vectors or a different species, or in order to
quantify spike-in material not contained in the reference genome. In `r Biocpkg("QuasR")`,
such supplementary reference files are called *auxiliary* references and can be
specified to `qAlign` using the `auxiliaryFile` argument (see section \@ref(qAlign)
for details). The format of the auxiliary file is similar to the one of the sample
file described in section \@ref(sampleFile): It contains two columns with
column names 'FileName' and 'AuxName' in the first row. Additional rows contain
names and files of one or several auxiliary references in `fasta` format.

An example auxiliary file looks like this:

<pre>
```{r auxFile, echo=FALSE, results="asis"}
cat(paste(readLines(system.file(package = "QuasR",
                                "extdata", "auxiliaries.txt")),
          collapse = "\n"))
```
</pre>
<!--
`FileName`        | `AuxName`  
`NC_001422.1.fa`  | `phiX174`  
-->

and is available from your `r Biocpkg("QuasR")` installation at
```{r auxiliaryFile, eval=TRUE}
auxFile <- system.file(package = "QuasR", "extdata", "auxiliaries.txt")
```

## Select the reference genome{#genome}
Sequence reads are primarily aligned against the reference genome (see
section \@ref(redundancy) on how to choose a suitable reference assembly).
If necessary, `r Biocpkg("QuasR")` will create an aligner index for the genome.
The reference genome can be provided in one of two different formats:

- **a string**, referring to the name of a `r Biocpkg("BSgenome")` package:
```{r selectGenomeBSgenome, eval=TRUE}
available.genomes()
genomeName <- "BSgenome.Hsapiens.UCSC.hg19"
```

In this example, the BSgenome package `"BSgenome.Hsapiens.UCSC.hg19"` refers to
an unmasked genome; alignment index and alignments will be performed on the full
unmasked genome sequence (recommended). If using a masked genome (e.g. `"BSgenome.Hsapiens.UCSC.hg19.masked"`),
masked regions will be replaced with `"N"` bases, and this hard-masked version of
the genome will be used for creating the alignment index and further alignments.
Please also see section \@ref(redundancy) for potential issues with redundant
sequences contained in the reference genome, e.g. in `r Biocpkg("BSgenome.Hsapiens.UCSC.hg19")`
or `r Biocpkg("BSgenome.Hsapiens.UCSC.hg38")`.

- **a file name**, referring to a sequence file containing one or several reference
  sequences (e.g. chromosomes) in `fasta` format:
```{r selectGenomeFile, eval=FALSE}
genomeFile <- system.file(package="QuasR", "extdata", "hg19sub.fa")
```

### Choosing a suitable (non-redundant) reference genome{#redundancy}
For some organisms, several versions of the genome assembly exist. These
differ for example in whether or not they include alternative variants for
sequences that are variable within the species. This may lead to 
redundant sequences in the assembly, and thus reads mapping to
such sequences being wrongly classified as "multi-mapping", and comparing
data aligned to different assembly version may give rise to incorrect
results. A nice summary of this issue is provided in this [blog post](https://lh3.github.io/2017/11/13/which-human-reference-genome-to-use) from
Heng Li.

The `r Biocpkg("BSgenome")` packages `r Biocpkg("BSgenome.Hsapiens.UCSC.hg19")` (versions
newer than 1.4.0 from Bioconductor 3.10) and `r Biocpkg("BSgenome.Hsapiens.UCSC.hg38")`
(all versions) do contain such redundant sequences and are therefore not ideal
references for alignment of human data. Specific "analysis set" or "primary assembly"
versions of the assembly should be used instead (see the before-mentioned [blog post](https://lh3.github.io/2017/11/13/which-human-reference-genome-to-use) for
details).

When using a `r Biocpkg("BSgenome")` reference, `r Biocpkg("QuasR")` will check
in the `qAlign` function whether the chromosome names and lengths contained
in the header of any pre-existing bam files are identical to the ones provided by
the genome and warn if this is not the case.

## Sequence data pre-processing {#preProcessing}
The `preprocessReads` function can be used to prepare the input sequence files
prior to alignment. The function takes one or several sequence files (or pairs
of files for a paired-end experiment) in `fasta` or `fastq` format as input and
produces the same number of output files with the processed reads.

In the following example, we truncate the reads by removing the three bases from
the 3'-end (the right side), remove the adapter sequence `AAAAAAAAAA` from the
5'-end (the left side) and filter out reads that, after truncation and adapter
removal, are shorter than 14 bases or contain more than 2 `N` bases:
```{r preprocessReadsSingle,eval=TRUE}
td <- tempdir()
infiles <- system.file(package = "QuasR", "extdata",
                       c("rna_1_1.fq.bz2","rna_2_1.fq.bz2"))
outfiles <- file.path(td, basename(infiles))
res <- preprocessReads(filename = infiles,
                       outputFilename = outfiles,
                       truncateEndBases = 3,
                       Lpattern = "AAAAAAAAAA",
                       minLength = 14, 
                       nBases = 2)
res
unlink(outfiles)
```

`preprocessReads` returns a matrix with a summary of the pre-processing. The matrix
contains one column per (pair of) input sequence files, and contains the total
number of reads (`totalSequences`), the number of reads that matched to the five
prime or three prime adapters (`matchTo5pAdapter` and `matchTo3pAdapter`), the
number of reads that were too short (`tooShort`), contained too many non-base
characters (`tooManyN`) or were of low sequence complexity (`lowComplexity`, 
deactivated by default). Finally, the number of reads that passed the filtering
steps is reported in the last row (`totalPassed`).

In the example below we process paired-end reads, removing all pairs with one or
several `N` bases. Even if only one sequence in a pair fulfills the filtering
criteria, both reads in the pair are removed, thereby preserving the matching
order of the sequences in the two files:  
```{r preprocessReadsPaired,eval=TRUE}
td <- tempdir()
infiles1 <- system.file(package = "QuasR", "extdata", "rna_1_1.fq.bz2")
infiles2 <- system.file(package = "QuasR", "extdata", "rna_1_2.fq.bz2")
outfiles1 <- file.path(td, basename(infiles1))
outfiles2 <- file.path(td, basename(infiles2))
res <- preprocessReads(filename = infiles1,
                       filenameMate = infiles2,
                       outputFilename = outfiles1,
                       outputFilenameMate = outfiles2,
                       nBases = 0)
res
```

More details on the `preprocessReads` function can be found in the function
documentation (see `?preprocessReads`) or in the section \@ref(preprocessReads).


# Example workflows{#exampleWorkflows}

## ChIP-seq: Measuring protein-DNA binding and chromatin modifications{#ChIPseq}
Here we show an exemplary single-end ChIP-seq workflow using a small number of
reads from a histone 3 lysine 4 trimethyl (H3K4me3) ChIP-seq experiment. This
histone modification is known to locate to genomic regions with a high density
of CpG dinucleotides (so called CpG islands); about 60% of mammalian genes have
such a CpG island close to their transcript start site. All necessary files are
included in the `r Biocpkg("QuasR")` package, and we start the example workflow
by copying those files into the current working directly, into a subfolder called `"extdata"`:
```{r ChIP_copyExtdata, eval=TRUE}
file.copy(system.file(package = "QuasR", "extdata"), ".", recursive = TRUE)
```


### Align reads using the `qAlign` function
We assume that the sequence reads have already been pre-processed as described
in section \@ref(preProcessing). Also, a sample file (section \@ref(sampleFile))
that lists all sequence files to be analyzed has been prepared. A `fasta` file
with the reference genome sequence(s) is also available (section \@ref(genome)),
as well as an auxiliary file for alignment of reads that failed to match the reference
genome (section \@ref(auxiliaryFile)).

By default, newly generated `bam` files will be stored at the location of the input
sequence files, which should be writable and have sufficient capacity (an alternative
location can be specified using the `alignmentsDir` argument). Make also sure that
you have sufficient temporary disk space for intermediate files in `tempdir()`
(see section \@ref(qAlign)). We start by aligning the reads using `qAlign`:
```{r ChIP_qAlign, eval=TRUE}
sampleFile <- "extdata/samples_chip_single.txt"
auxFile <- "extdata/auxiliaries.txt"
genomeFile <- "extdata/hg19sub.fa"

proj1 <- qAlign(sampleFile, genome = genomeFile, auxiliaryFile = auxFile)
proj1
```

`qAlign` will build alignment indices if they do not yet exist (by default, if the
genome and auxiliary sequences are given in the form of `fasta` files, they will 
be stored in the same folder). The `qProject` object (`proj1`) returned by `qAlign`
now contains all information about the ChIP-seq experiment: the (optional) project name,
the project options, aligner package, reference genome, and at the bottom the sequence
and alignment files. For each input sequence file, there will be one `bam` file with
alignments against the reference genome, and one for each auxiliary target sequence
with alignments of reads without genome hits. Our `auxFile` contains a single auxiliary
target sequence, so we expect two `bam` files per input sequence file:
```{r ChIP_bamfiles1, eval=TRUE}
list.files("extdata", pattern = ".bam$")
```
The `bam` file names consist of the base name of the sequence file with an added
random string. The random suffix makes sure that newly generated alignment files
do not overwrite existing ones, for example of the same reads aligned against an 
alternative reference genome. Each alignment file is accompanied by two additional
files with suffixes `.bai` and `.txt`:
```{r ChIP_bamfiles2, eval=TRUE}
list.files("extdata", pattern = "^chip_1_1_")[1:3]
```
The `.bai` file is the `bam` index used for fast access by genomic coordinate. 
The `.txt` file contains all the parameters used to generate the corresponding `bam`
file. Before new alignments are generated, `qAlign` will look for available `.txt`
files in default locations (the directory containing the input sequence file, or
the value of `alignmentsDir`), and read their contents to determine if a compatible
`bam` file already exists. A compatible `bam` file is one with the same reads and
genome, aligned using the same aligner and identical alignment parameters. If a
compatible `bam` file is not found, or the `.txt` file is missing, `qAlign` will
generate a new `bam` file. It is therefore recommended not to delete the `.txt`
file - without it, the corresponding `bam` file will become unusable for `r Biocpkg("QuasR")`. 


### Create a quality control report
`r Biocpkg("QuasR")` can produce a quality control report in the form of a series
of diagnostic plots with details on sequences and alignments (see QuasR scheme figure above).
The plots are generated by calling the `qQCReport` function with the `qProject`
object as argument. `qQCReport` uses `r Biocpkg("ShortRead")` [@ShortRead] internally
to obtain some of the quality metrics, and some of the plots are inspired by the
FastQC quality control tool by Simon Andrews (http://www.bioinformatics.bbsrc.ac.uk/projects/fastqc/).
The plots will be stored into a multipage PDF document defined by the `pdfFilename`
argument, or else shown as individual plot windows on the current graphics device.
In order to keep the running time reasonably short, some quality metrics are obtained
from a random sub-sample of the sequences or alignments.
```{r ChIP_qcplot1, eval=TRUE, echo=FALSE}
qcdat1 <- qQCReport(proj1, pdfFilename = "extdata/qc_report.pdf")
```
```{r ChIP_qcplots2, eval=TRUE}
qQCReport(proj1, pdfFilename = "extdata/qc_report.pdf")
```

Currently available plots are described in section \@ref(qQCReport) and following.


### Alignment statistics
The `alignmentStats` gets the number of (un-)mapped reads for each sequence file
in a `qProject` object, by reading the `bam` file indices, and returns them as a
`data.frame`. The function also works for arguments of type `character` with one
or several `bam` file names (for details see section \@ref(alignmentStats)).
```{r ChIP_alignmentStats, eval=TRUE}
alignmentStats(proj1)
```


### Export genome wig file from alignments
For visualization in a genome browser, alignment coverage along the genome can be
exported to a (compressed) wig file using the `qExportWig` function. The created 
fixedStep wig file (see (http://genome.ucsc.edu/goldenPath/help/wiggle.html) for 
details on the wig format) will contain one track per sample in the `qProject` 
object. The resolution is defined using the `binsize` argument, and if `scaling` 
is set to `TRUE`, read counts per bin are scaled by the total number of aligned 
reads in each sample to improve comparability: 
```{r ChIP_qExportWig, eval=TRUE}
qExportWig(proj1, binsize = 100L, scaling = TRUE, collapseBySample = TRUE)
```


### Count alignments using `qCount`
Alignments are quantified using `qCount`, for example using a `GRanges` object as
a query. In our H3K4me3 ChIP-seq example, we expect the reads to occur around the
transcript start site of genes. We can therefore construct suitable query regions
using genomic intervals around the start sites of known genes. In the code below,
this is achieved with help from the `r Biocpkg("txdbmaker")` package to first
create a `TxDb` object from a `.gtf` file with gene annotation. With the `promoters`
function from the `r Biocpkg("GenomicFeatures")` package, we can then create the
`GRanges` object with regions to be quantified. Finally, because most genes
consist of multiple overlapping transcripts, we select the first transcript for
each gene:  
```{r ChIP_GenomicFeatures, eval=TRUE}
library(txdbmaker)
annotFile <- "extdata/hg19sub_annotation.gtf"
chrLen <- scanFaIndex(genomeFile)
chrominfo <- data.frame(chrom = as.character(seqnames(chrLen)),
                        length = width(chrLen),
                        is_circular = rep(FALSE, length(chrLen)))
txdb <- makeTxDbFromGFF(file = annotFile, format = "gtf",
                        chrominfo = chrominfo,
                        dataSource = "Ensembl",
                        organism = "Homo sapiens")
promReg <- promoters(txdb, upstream = 1000, downstream = 500,
                     columns = c("gene_id","tx_id"))
gnId <- vapply(mcols(promReg)$gene_id,
               FUN = paste, FUN.VALUE = "",
               collapse = ",")
promRegSel <- promReg[ match(unique(gnId), gnId) ]
names(promRegSel) <- unique(gnId)
promRegSel
```

Using `promRegSel` object as query, we can now count the alignment per sample in
each of the promoter windows.
```{r ChIP_qCount, eval=TRUE}
cnt <- qCount(proj1, promRegSel)
cnt
```

The counts returned by `qCount` are the raw number of alignments per sample and
region, without any normalization for the query region length, or the total number
of aligned reads in a sample. As expected, we can find H3K4me3 signal at promoters 
of a subset of the genes with CpG island promoters, which we can visualize with help
of the `r Biocpkg("Gviz")` package:
```{r ChIP_visualize, eval=TRUE, fig.width=8, fig.height=4.5}
gr1 <- import("Sample1.wig.gz")
gr2 <- import("Sample2.wig.gz")

library(Gviz)
axisTrack <- GenomeAxisTrack()
dTrack1 <- DataTrack(range = gr1, name = "Sample 1", type = "h")
dTrack2 <- DataTrack(range = gr2, name = "Sample 2", type = "h")
txTrack <- GeneRegionTrack(txdb, name = "Transcripts", showId = TRUE)
plotTracks(list(axisTrack, dTrack1, dTrack2, txTrack),
           chromosome = "chr3", extend.left = 1000)
```


### Create a genomic profile for a set of regions using `qProfile`
Given a set of anchor positions in the genome, `qProfile` calculates the number of
nearby alignments relative to the anchor position, for example to generate a average
profile. The neighborhood around anchor positions can be specified by the `upstream`
and `downstream` argument. Alignments that are upstream of an anchor position will
have a negative relative position, and downstream alignments a positive. The anchor
positions are all aligned at position zero in the return value.

Anchor positions will be provided to `qProfile` using the `query` argument, which
takes a `GRanges` object. The anchor positions correspond to `start()` for regions
on `+` or `*` strands, and to `end()` for regions on the `-` strand. As mentioned
above, we expect H3K4me3 ChIP-seq alignments to be enriched around the transcript 
start site of genes. We can therefore construct a suitable `query` object from the
start sites of known genes. In the code below, start sites (`start_codon`) are imported
from a `.gtf` file with the help of the `r Biocpkg("rtracklayer")` package. In addition,
`strand` and `gene_name` are also selected for import. Duplicated start sites, e.g. from
genes with multiple transcripts, are removed. Finally, all regions are given the name
`TSS`, because `qProfile` combines regions with identical names into a single profile. 
```{r ChIP_rtracklayer, eval=TRUE}
library(rtracklayer)
annotationFile <- "extdata/hg19sub_annotation.gtf"
tssRegions <- import.gff(annotationFile, format = "gtf",
                         feature.type = "start_codon",
                         colnames = "gene_name")
tssRegions <- tssRegions[!duplicated(tssRegions)]
names(tssRegions) <- rep("TSS", length(tssRegions))
head(tssRegions)
```

Alignments around the `tssRegions` coordinates are counted in a window defined by
the `upstream` and `downstream` arguments, which specify the number of bases to
include around each anchor position. For `query` regions on `+` or `*` strands, 
upstream refers to the left side of the anchor position (lower coordinates), 
while for regions on the `-` strand, upstream refers to the right side (higher coordinates).
The following example creates separate profiles for alignments on the *same* and
on the *opposite* strand of the regions in `query`.
```{r ChIP_qProfile, eval=TRUE}
prS <- qProfile(proj1, tssRegions, upstream = 3000, downstream = 3000, 
                orientation = "same")
prO <- qProfile(proj1, tssRegions, upstream = 3000, downstream = 3000, 
                orientation = "opposite")
lapply(prS, "[", , 1:10)
```

The counts returned by `qProfile` are the raw number of alignments per sample and
position, without any normalization for the number of query regions or the total
number of alignments in a sample per position. To obtain the average number of alignments,
we divide the alignment counts by the number of `query` regions that covered a given
relative position around the anchor sites. This coverage is available as the first
element in the return value. The shift between *same* and *opposite* strand alignments
is indicative for the average length of the sequenced ChIP fragments.
```{r ChIP_visualizeProfile, eval=TRUE, fig.width=8, fig.height=4.5}
prCombS <- do.call("+", prS[-1]) / prS[[1]]
prCombO <- do.call("+", prO[-1]) / prO[[1]]

plot(as.numeric(colnames(prCombS)), filter(prCombS[1,], rep(1/100,100)), 
     type = 'l', xlab = "Position relative to TSS",
     ylab = "Mean no. of alignments")
lines(as.numeric(colnames(prCombO)), filter(prCombO[1,], rep(1/100,100)), 
      type = 'l', col = "red")
legend(title = "strand", legend = c("same as query","opposite of query"), 
       x = "topleft", col = c("black","red"),
       lwd = 1.5, bty = "n", title.adj = 0.1)
```

### Using a `r Biocpkg("BSgenome")` package as reference genome
`r Biocpkg("QuasR")` also allows using of `r Biocpkg("BSgenome")` packages instead
of a `fasta` file as reference genome (see section \@ref(genome)).
To use a `r Biocpkg("BSgenome")`, the `genome` argument of `qAlign` is set to a
string matching the name of a `r Biocpkg("BSgenome")` package, for example 
`"BSgenome.Hsapiens.UCSC.hg19"`. If that package is not already installed, `qAlign`
will abort with an informative message describing how to install the package
using `BiocManager::install`.
The corresponding alignment index will be saved as a new package, named after the
original `r Biocpkg("BSgenome")` package and the aligner used to build the index,
for example `BSgenome.Hsapiens.UCSC.hg19.Rbowtie`.

The code example below illustrates the use of a `r Biocpkg("BSgenome")` reference
genome for the same example data as above. Running it for the first time will take
a few hours in order to build the aligner index, but subsequent uses of the
same reference genome will reuse the existing index and immediately start alignments:  
```{r ChIP_BSgenomeProject, eval=FALSE}
file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)

sampleFile <- "extdata/samples_chip_single.txt"
auxFile <- "extdata/auxiliaries.txt"

available.genomes() # list available genomes
genomeName <- "BSgenome.Hsapiens.UCSC.hg19"

proj1 <- qAlign(sampleFile, genome=genomeName, auxiliaryFile=auxFile)
proj1
```


## RNA-seq: Gene expression profiling{#RNAseq}
In `r Biocpkg("QuasR")`, an analysis workflow for an RNA-seq dataset is very similar
to the one described above for a ChIP-seq experiment. The major difference is that
here reads are aligned using `qAlign(..., splicedAlignment=TRUE, aligner="Rhisat2")`,
which will cause `qAlign` to align reads with the `HISAT2` aligner [@hisat2] (via the
`r Biocpkg("Rhisat2")` package), rather than with `bowtie` [@bowtie]. Before the
`r Biocpkg("Rhisat2")` package was available (introduced in Bioconductor 3.9),
`qAlign(... splicedAlignment=TRUE)` aligned reads using `SpliceMap` [@SpliceMap], which
is not recommended now but still possible in order to reproduce old results.
Spliced paired-end alignments are also supported; the `splicedAlignment`
argument can be freely combined with the `paired` argument. In addition, HISAT2
also allows the specification of known splice sites, which can help in the read
alignment. This is done by specifying the argument `geneAnnotation` in `qAlign()`,
to either a `.gtf` file or a `sqlite` database generated by exporting a `TxDb` object.  

### Spliced alignment of RNA-seq reads
We start the example workflow by copying the example data files into the current
working directly, into a subfolder called `"extdata"`, and then create spliced
alignments using `qAlign`:
```{r RNA_qAlign, eval=TRUE}
file.copy(system.file(package = "QuasR", "extdata"), ".", recursive = TRUE)

sampleFile <- "extdata/samples_rna_paired.txt"
genomeFile <- "extdata/hg19sub.fa"

proj2 <- qAlign(sampleFile, genome = genomeFile,
                splicedAlignment = TRUE, aligner = "Rhisat2")
proj2
```

Aligning the reads with `splicedAlignment=TRUE` will allow to also align reads 
that cross exon junctions, and thus have a large deletion (the intron) 
relative to the reference genome. 
```{r RNA_alignmentStats, eval=TRUE}
proj2unspl <- qAlign(sampleFile, genome = genomeFile,
                     splicedAlignment = FALSE)

alignmentStats(proj2)
alignmentStats(proj2unspl)
```

### Quantification of gene and exon expression
As with ChIP-seq experiments, `qCount` is used to quantify alignments. For
quantification of gene or exon expression levels, `qCount` can be called with a
query of type `TxDb`, such as the one we constructed in the ChIP-seq workflow above
from a `.gtf` file. The argument `reportLevel` can be used to control if annotated
exonic regions should be quantified independently (`reportLevel="exon"`) or
non-redundantly combined per gene (`reportLevel="gene"`): 
```{r RNA_qCount, eval=TRUE}
geneLevels <- qCount(proj2, txdb, reportLevel = "gene")
exonLevels <- qCount(proj2, txdb, reportLevel = "exon")

head(geneLevels)
head(exonLevels)
```


### Calculation of RPKM expression values
The values returned by `qCount` are the number of alignments. Sometimes it is
required to normalize for the length of query regions, or the size of the libraries.
For example, gene expression levels in the form of *RPKM* values (reads per kilobase
of transcript and million mapped reads) can be obtained as follows:
```{r RNA_RPMK, eval=TRUE}
geneRPKM <- t(t(geneLevels[,-1] / geneLevels[,1] * 1000)
              / colSums(geneLevels[,-1]) * 1e6)
geneRPKM
```
Please note the RPKM values in our example are higher than what you would usually
get for a real RNA-seq dataset. The values here are artificially scaled up because
our example data contains reads only for a small number of genes.


### Analysis of alternative splicing: Quantification of exon-exon junctions
Exon-exon junctions can be quantified by setting `reportLevel="junction"`. In this
case, `qCount` will ignore the `query` argument and scan all alignments for any
detected splices, which are returned as a `GRanges` object: The region start and
end coordinates correspond to the first and last bases of the intron, and the
counts are returned in the `mcols()` of the `GRanges` object. Alignments that 
are identically spliced but reside on opposite strands will be quantified separately.
In an unstranded RNA-seq experiment, this may give rise to two separate counts 
for the same intron, one each for the supporting alignments on plus and minus 
strands.
```{r RNA_junction, eval=TRUE}
exonJunctions <- qCount(proj2, NULL, reportLevel = "junction")
exonJunctions
```

About half of the exon-exon junctions detected in this sample dataset correspond 
to known introns; they tend to be the ones with higher coverage:
```{r RNA_junction2, eval=TRUE}
knownIntrons <- unlist(intronsByTranscript(txdb))
isKnown <- overlapsAny(exonJunctions, knownIntrons, type = "equal")
table(isKnown)

tapply(rowSums(as.matrix(mcols(exonJunctions))),
       isKnown, summary)
```

When quantifying exon junctions, only spliced alignments will be included in the
quantification. It is also possible to only include unspliced alignments in the
quantification, for example when counting exon body alignments that complement the
exon junction alignments. This can be done using the `includeSpliced` argument
from `qCount`:
```{r RNA_includeSpliced, eval=TRUE}
exonBodyLevels <- qCount(proj2, txdb, reportLevel = "exon",
                         includeSpliced = FALSE)
summary(exonLevels - exonBodyLevels)
```

```{r RNA_qcplot1, eval=TRUE, echo=FALSE}
qcdat2 <- qQCReport(proj2unspl, pdfFilename = "qc_report.pdf")
```




## smRNA-seq: small RNA and miRNA expression profiling
Expression profiling of miRNAs differs only slightly from the profiling of mRNAs.
There are a few details that need special care, which are outlined in this section.

### Preprocessing of small RNA (miRNA) reads
Again, we start the example workflow by copying the example data files into the 
current working directly, into a subfolder called `"extdata"`.
```{r miRNA_extdata, eval=TRUE}
file.copy(system.file(package = "QuasR", "extdata"), ".", recursive = TRUE)
```

As a next step, we need to remove library adapter sequences from short RNA reads.
Most sequencing experiments generate reads that are longer than the average length
of a miRNA (22nt). Therefore, the read sequence will run through the miRNA into the
library adapter sequence and would not match when aligned in full to the reference
genome.

We can remove those adapter sequences using `preprocessReads` (see section
\@ref(preprocessReads) for more details), which for each input sequence file will
generate an output sequence file containing appropriately truncated sequences.
In the example below, we get the input sequence filenames from `sampleFile`, and 
also prepare an updated `sampleFile2` that refers to newly generated processed
sequence files: 
```{r miRNA_preprocessReads, eval=TRUE}
# prepare sample file with processed reads filenames
sampleFile <- file.path("extdata", "samples_mirna.txt")
sampleFile
sampleFile2 <- sub(".txt", "_processed.txt", sampleFile)
sampleFile2

tab <- read.delim(sampleFile, header = TRUE, as.is = TRUE)
tab

tab2 <- tab
tab2$FileName <- sub(".fa", "_processed.fa", tab$FileName)
write.table(tab2, sampleFile2, sep = "\t", quote = FALSE, row.names = FALSE)
tab2

# remove adapters
oldwd <- setwd(dirname(sampleFile))
res <- preprocessReads(tab$FileName,
                       tab2$FileName,
                       Rpattern = "TGGAATTCTCGGGTGCCAAGG")
res
setwd(oldwd)
```

The miRNA reads in `mirna_1.fa` are by the way synthetic sequences and do not
correspond to any existing miRNAs. As you can see above from the return value of
`preprocessReads`, all reads matched to the 3'-adapter and were therefore truncated,
reducing their length to roughly the expected 22nt:
```{r miRNA_lengthes, eval=TRUE, fig.width=6, fig.height=4.5}
# get read lengths
library(Biostrings)
oldwd <- setwd(dirname(sampleFile))
lens <- fasta.seqlengths(tab$FileName, nrec = 1e5)
lens2 <- fasta.seqlengths(tab2$FileName, nrec = 1e5)
setwd(oldwd)
# plot length distribution
lensTab <- rbind(raw = tabulate(lens, 50),
                 processed = tabulate(lens2, 50))
colnames(lensTab) <- 1:50
barplot(lensTab/rowSums(lensTab)*100,
        xlab = "Read length (nt)", ylab = "Percent of reads")
legend(x = "topleft", bty = "n", fill = gray.colors(2),
       legend = rownames(lensTab))
```

### Alignment of small RNA (miRNA) reads
Next, we create alignments using `qAlign`. In contrast to the general RNA-seq workflow
(section \@ref(RNAseq)), alignment time can be reduced by
using the default unspliced alignment (`splicedAlignment=FALSE`). Importantly, we
need to set `maxHits=50` or similar to also align reads that perfectly match the
genome multiple times. This is required because of the miRNAs that are encoded by
multiple genes. Reads from such miRNAs would not be aligned and thus their expression
would be underestimated if using the default `maxHits=1`. An example of such a
multiply-encoded miRNA is mmu-miR-669a-5p, which has twelve exact copies in the
mm10 genome assembly according to mirBase19.
```{r miRNA_qAlign, eval=TRUE}
proj3 <- qAlign(sampleFile2, genomeFile, maxHits = 50)
alignmentStats(proj3)
```

A more detailed picture of the experiments' quality can be obtained using
`qQCReport(proj3, "qcreport.pdf")` or similar (see also section \@ref(qQCReport)).

### Quantification of small RNA (miRNA) reads
As with other experiment types, miRNAs are quantified using `qCount`. For this
purpose, we first construct a query `GRanges` object with the genomic locations
of mature miRNAs. The locations can be obtained from the `r Biocpkg("mirbase.db")`
package, or directly from the species-specific gff files provided by the mirBase
database (e.g. (ftp://mirbase.org/pub/mirbase/19/genomes/mmu.gff3)). For the purpose
of this example, the `r Biocpkg("QuasR")` package provides a small gff file
(`"mirbaseXX_qsr.gff3"`) that is formatted as the ones available from mirBase.
The gff file contains both the locations of pre-miRNAs (hairpin precursors), as
well as mature miRNAs. The two can be discriminated by their `"type"`:
```{r miRNA_prepareQuery, eval=TRUE}
mirs <- import("extdata/mirbaseXX_qsr.gff3")
names(mirs) <- mirs$Name
preMirs <- mirs[ mirs$type == "miRNA_primary_transcript" ]
matureMirs <- mirs[ mirs$type == "miRNA" ]
```

Please note that the name attribute of the `GRanges` object must be set appropriately,
so that `qCount` can identify a single mature miRNA sequence that is encoded by
multiple loci (see below) by their identical names. In this example, there are no
multiply-encoded mature miRNAs, but in a real sample, you can detect them for 
example with `table(names(mirs))`.

The `preMirs` and `matureMirs` could now be used as `query` in `qCount`. In 
practise however, miRNA seem to not always be processed with high accuracy. 
Many miRNA reads that start one or two bases earlier or later can be observed 
in real data, and also their length may vary for a few bases. This is the case
for the synthetic miRNAs used in this example, whose lengthes and start positions
have been sampled from a read data set:
```{r miRNA_coverage, eval=TRUE, fig.width=6, fig.height=4.5}
library(Rsamtools)
alns <- scanBam(alignments(proj3)$genome$FileName,
                param = ScanBamParam(what = scanBamWhat(),
                                     which = preMirs[1]))[[1]]
alnsIR <- IRanges(start = alns$pos - start(preMirs), width = alns$qwidth)
mp <- barplot(as.vector(coverage(alnsIR)), names.arg = seq_len(max(end(alnsIR))),
              xlab = "Relative position in pre-miRNA",
              ylab = "Alignment coverage")
rect(xleft = mp[start(matureMirs) - start(preMirs) + 1,1],
     ybottom = -par('cxy')[2],
     xright = mp[end(matureMirs) - start(preMirs) + 1,1],
     ytop = 0, col = "#CCAA0088", border = NA, xpd = NA)
```

By default, `qCount` will count alignments that have their 5'-end within the query
region (see `selectReadPosition` argument). The 5'-end correspond to the lower 
(left) coordinate for alignments on the plus strand, and to the higher (right) 
coordinate for alignments on the minus strand. In order not to miss miRNAs that 
have a couple of extra or missing bases, we therefore construct a query window 
around the 5'-end of each mature miRNA, by adding three bases up- and downstream:
```{r miRNA_extendQuery, eval=TRUE}
matureMirsExtended <- resize(matureMirs, width = 1L, fix = "start") + 3L
```

The resulting extended query is then used to quantify mature miRNAs. Multiple-encoded
miRNAs will be represented by multiple ranges in `matureMirs` and `matureMirsExtended`,
which have identical names. `qCount` will automatically sum all alignments from 
any of those regions and return a single number per sample and unique miRNA name.
```{r miRNA_quantify, eval=TRUE}
# quantify mature miRNAs
cnt <- qCount(proj3, matureMirsExtended, orientation = "same")
cnt

# quantify pre-miRNAs
cnt <- qCount(proj3, preMirs, orientation = "same")
cnt
```


## Bis-seq: Measuring DNA methylation
Sequencing of bisulfite-converted genomic DNA allows detection of methylated 
cytosines, which in mammalian genomes typically occur in the context of CpG 
dinucleotides. The treatment of DNA with bisulfite induces deamination of 
non-methylated cytosines, converting them to uracils. Sequencing and aligning
of such bisulfite-converted DNA results in C-to-T mismatches. Both alignment of
converted reads, as well as the interpretation of the alignments for calculation
of methylation levels require specific approaches and are supported in 
`r Biocpkg("QuasR")` by `qAlign` (`bisulfite` argument, section \@ref(qAlign)) and 
`qMeth` (section \@ref(qMeth)), respectively.

We start the analysis by copying the example data files into the current working 
directly, into a subfolder called `"extdata"`. Then, bisulfite-specific alignment
is selected in `qAlign` by setting `bisulfite` to `"dir"` for a directional 
experiment, or to `"undir"` for an undirectional Bis-seq experiment:
```{r Bis_qAlign, eval=TRUE}
file.copy(system.file(package = "QuasR", "extdata"), ".", recursive = TRUE)

sampleFile <- "extdata/samples_bis_single.txt"
genomeFile <- "extdata/hg19sub.fa"

proj4 <- qAlign(sampleFile, genomeFile, bisulfite = "dir")
proj4
```

The resulting alignments are not different from those of non-Bis-seq experiments,
apart from the fact that they may contain many C-to-T (or A-to-G) mismatches that
are not counted as mismatches when aligning the reads. The number of alignments 
in specific genomic regions could be quantified using `qCount` as with ChIP-seq 
or RNA-seq experiments. For quantification of methylation the `qMeth` function 
is used: 
```{r Bis_qMeth1, eval=TRUE}
meth <- qMeth(proj4, mode = "CpGcomb", collapseBySample = TRUE)
meth
```

By default, `qMeth` quantifies methylation for all cytosines in CpG contexts,
combining the data from plus and minus strands (`mode="CpGcomb"`). The results
are returned as a `GRanges` object with coordinates of each CpG, and two metadata
columns for each input sequence file in the `qProject` object. These two columns 
contain the total number of aligned reads that overlap a given CpG (C-to-C matches
or C-to-T mismatches, suffix `_T` in the column name), and the number of read 
alignments that had a C-to-C match at that position (methylated events, suffix `_M`).

Independent of the number of alignments, the returned object will list all CpGs
in the target genome including the ones that have zero coverage, unless you set
`keepZero=FALSE`:
```{r Bis_qMeth2, eval=TRUE}
chrs <- readDNAStringSet(genomeFile)
sum(vcountPattern("CG",chrs))
length(qMeth(proj4))
length(qMeth(proj4, keepZero = FALSE))
```

The fraction methylation can easily be obtained as the ratio between `_M` and 
`_T` columns:
```{r Bis_visualize, eval=TRUE, fig.height=4.5, fig.width=8}
percMeth <- mcols(meth)[,2] * 100 / mcols(meth)[,1]
summary(percMeth)

axisTrack <- GenomeAxisTrack()
dTrack1 <- DataTrack(range = gr1, name = "H3K4me3", type = "h")
dTrack2 <- DataTrack(range = meth, data = percMeth,
                     name = "Methylation", type = "p")
txTrack <- GeneRegionTrack(txdb, name = "Transcripts", showId = TRUE)
plotTracks(list(axisTrack, dTrack1, dTrack2, txTrack),
           chromosome = "chr3", extend.left = 1000)
```

If `qMeth` is called without a `query` argument, it will by default return 
methylation states for each C or CpG in the genome. Using a `query` argument it
is possible to restrict the analysis to specific genomic regions, and if using 
in addition `collapseByQueryRegion=TRUE`, the single base methylation states will
further be combined for all C's that are contained in the same query region:
```{r Bis_query, eval=TRUE}
qMeth(proj4, query = GRanges("chr1",IRanges(start = 31633, width = 2)),
      collapseBySample = TRUE)
qMeth(proj4, query = promRegSel, collapseByQueryRegion = TRUE,
      collapseBySample = TRUE)
```

Finally, `qMeth` allows the retrieval of methylation states for individual molecules
(per alignment). This is done by using a `query` containing a single genomic region
(typically small, such as a PCR amplicon) and setting `reportLevel="alignment"`. 
In that case, the return value of `qMeth` will be a list (over samples) of lists
(with four elements giving the identities of alignment, C nucleotide, strand and 
the methylation state). See the documentation of `qMeth` for more details.


## Allele-specific analysis{#alleleSpecificAnalysis}
All experiment types supported by `r Biocpkg("QuasR")` (ChIP-seq, RNA-seq and 
Bis-seq; only alignments to the genome, but not to auxiliaries) can also be analyzed
in an allele-specific manner. For this, a file containing genomic location and 
the two alleles of known sequence polymorphisms has to be provided to the `snpFile`
argument of `qAlign`. The file is in tab-delimited text format without a header
and contains four columns with chromosome name, position, reference allele and 
alternative allele. 

Below is an example of a SNP file, also available from `system.file(package="QuasR", "extdata", "hg19sub_snp.txt")`:

<pre>
```{r snpFile, echo=FALSE, results="asis"}
cat(paste(c(readLines(system.file(package = "QuasR",
                                  "extdata", "hg19sub_snp.txt"))[1:4], "..."),
          collapse = "\n"))
```
</pre>
<!--
`chr1` |  `8596` | `G` | `A`  
`chr1` | `18443` | `G` | `A`  
`chr1` | `18981` | `C` | `T`  
`chr1` | `19341` | `G` | `A`  
`...`  |         |     |  
-->

For a given locus, either reference or alternative allele may but does not have 
to be identical to the sequence of the reference genome (`genomeFile` in this case).
To avoid an alignment bias, all reads are aligned separately to each of the two
new genomes, which `r Biocpkg("QuasR")` generates by *injecting* the SNPs listed
in `snpFile` into the reference genome. Finally, the two alignment files are combined,
only retaining the best alignment for each read. While this procedure takes more
than twice as long as aligning against a single genome, it has the advantage to 
correctly align reads even in regions of high SNP density and has been shown to 
produce more accurate results.

While combining alignments, each read is classified into one of three groups (stored
in the `bam` files under the `XV` tag):

  - **R**: the read aligned better to the **reference** genome  
  - **U**: the read aligned equally well to both genomes (**unknown** origin)  
  - **A**: the read aligned better to the **alternative** genome  

Using these alignment classifications, the `qCount` and `qMeth` functions will
produce three counts instead of a single count; one for each class. The column
names will be suffixed by `_R`, `_U` and `_A`.

The examples below use data provided with the `r Biocpkg("QuasR")` package, which
is first copied to the current working directory, into a subfolder called `"extdata"`:
```{r Alelle_Extdata, eval=TRUE}
file.copy(system.file(package = "QuasR", "extdata"), ".", recursive = TRUE)
```


The example below aligns the same reads that were also used in the ChIP-seq workflow
(section \@ref(ChIPseq)), but this time using a `snpFile`:
```{r Allele_qAlign, eval=TRUE}
sampleFile <- "extdata/samples_chip_single.txt"
genomeFile <- "extdata/hg19sub.fa"
snpFile <- "extdata/hg19sub_snp.txt"
proj1SNP <- qAlign(sampleFile, genome = genomeFile, snpFile = snpFile)
proj1SNP
```

Instead of one count per promoter region and sample, `qCount` now returns three 
(`promRegSel` was generated in the ChIP-seq example workflow):
```{r Allele_qCount, eval=TRUE}
head(qCount(proj1, promRegSel))
head(qCount(proj1SNP, promRegSel))
```

The example below illustrates use of a `snpFile` for Bis-seq experiments. Similarly
as for `qCount`, the count types are labeled by `R`, `U` and `A`. These labels are
added to the total and methylated column suffixes `_T` and `_M`, resulting in
a total of six instead of two counts per feature and sample:
```{r Allele_Bis, eval=TRUE}
sampleFile <- "extdata/samples_bis_single.txt"
genomeFile <- "extdata/hg19sub.fa"
proj4SNP <- qAlign(sampleFile, genomeFile,
                   snpFile = snpFile, bisulfite = "dir")
head(qMeth(proj4SNP, mode = "CpGcomb", collapseBySample = TRUE))
```


# Description of Individual *QuasR* Functions
Please refer to the `r Biocpkg("QuasR")` reference manual or the function 
documentation (e.g. using `?qAlign`) for a complete description of `r Biocpkg("QuasR")`
functions. The descriptions provided below are meant to give an overview over all
functions and summarize the purpose of each one.

## `preprocessReads` {#preprocessReads}
The `preprocessReads` function can be used to prepare the input sequences before
alignment to the reference genome, for example to filter out low quality reads 
unlikely to produce informative alignments. When working with paired-end experiments,
the paired reads are expected to be contained in identical order in two separate 
files. For this reason, both reads of a pair are filtered out if any of the two
reads fulfills the filtering criteria. The following types of filtering tasks 
can be performed (in the order as listed):

  1. **Truncate reads**: remove nucleotides from the start and/or end of each read.  
  2. **Trim adapters**: remove nucleotides at the beginning and/or end of each read
     that match to a defined (adapter) sequence. The adapter trimming is done by
     calling `trimLRPatterns` from the `r Biocpkg("Biostrings")` package [@Biostrings].  
  3. **Filter out low quality reads**: Filter out reads that fulfill any of the filtering
     criteria (contain more than `nBases` `N` bases, are shorter than `minLength` or
     have a dinucleotide complexity of less than `complexity`-times the average
     complexity of the human genome sequence).  

The dinucleotide complexity is calculated in bits as Shannon entropy using the following
formula $-\sum_i f_i \cdot \log_2 f_i$, where $f_i$ is the frequency of dinucleotide
$i$ ($i=1, 2, ..., 16$).


## `qAlign` {#qAlign}
`qAlign` is the function that generates alignment files in `bam` format, for all
input sequence files listed in `sampleFile` (see section \@ref(sampleFile)),
against the reference genome (`genome` argument), and for reads that do not match
to the reference genome, against one or several auxiliary target sequences 
(`auxiliaryFile`, see section \@ref(auxiliaryFile)).

The reference genome can be provided either as a `fasta` sequence file or as a
`BSgenome` package name (see section \@ref(genome)). If a `BSgenome`
package is not found in the installed packages, `qAlign` will abort with a
description how the missing package can be installed from Bioconductor.

The alignment program is set by `aligner`, and parameters by `maxHits`, `paired`,
`splicedAlignment` and `alignmentParameter`. Currently, `aligner` can only be set
to `"Rbowtie"`, which is a wrapper for *bowtie* [@bowtie] and *SpliceMap* [@SpliceMap],
or `"Rhisat2"`, which is a wrapper for *HISAT2* [@hisat2].
When `aligner="Rbowtie"`, *SpliceMap* will be used if `splicedAlignment=TRUE`
(not recommended anymore except for reproducing older analyses). However, it is
recommended to create spliced alignment using `splicedAlignment=TRUE, aligner="Rhisat2"`,
which will use the *HISAT2* aligner and typically leads to more sensistive
alignments and shorter alignment times compared to *SpliceMap*. The alignment strategy
is furthermore affected by the parameters `snpFile` (alignments to variant genomes containing
sequence polymorphisms) and `bisulfite` (alignment of bisulfite-converted reads).
Finally, `clObj` can be used to enable parallelized alignment, sorting and 
conversion to `bam` format.

For each input sequence file listed in `sampleFile`, one `bam` file with alignments
to the reference genome will be generated, and an additional one for each auxiliary
sequence file listed in `auxiliaryFile`. By default, these `bam` files are stored
at the same location as the sequence files, unless a different location is specified
under `alignmentsDir`. If compatible alignment files are found at this location,
they will not be regenerated, which allows re-use of the same sequencing samples 
in multiple analysis projects by listing them in several project-specific `sampleFile`s.

The alignment process produces temporary files, such as decompressed input sequence 
files or raw alignment files before conversion to `bam` format, which can be several 
times the size of the input sequence files. These temporary files are stored in the
directory specified by `cacheDir`, which defaults to the **R** process temporary 
directory returned by `tempdir()`. The location of `tempdir()` can be set using 
environment variables (see `?tempdir`).

`qAlign` returns a `qProject` object that contains all file names and paths, as 
well as all alignment parameters necessary for further analysis (see section 
\@ref(qProject) for methods to access the information contained in a `qProject`
object).



## `qProject` class {#qProject}
The `qProject` objects are returned by `qAlign` and contain all information about
a sequencing experiment needed for further analysis. It is the main argument passed
to the functions that start with a *q* letter, such as `qCount`, `qQCReport` and
`qExportWig`. Some information inside of a `qProject` object can be accessed by
specific methods (in the examples below, `x` is a `qProject` object):

  - `length(x)` gets the number of input files.  
  - `genome(x)` gets the reference genome as a `character(1)`. The type of genome
    is stored as an attribute in `attr(genome(x),"genomeFormat")`: `"BSgenome"` 
    indicates that `genome(x)` refers to the name of a *BSgenome* package, 
    `"file"` indicates that it contains the path and file name of a genome in
    `fasta` format.  
  - `auxiliaries(x)` gets a `data.frame` with auxiliary target sequences. The 
    `data.frame` has one row per auxiliary target file, and two columns "FileName" 
    and "AuxName".  
  - `alignments(x)` gets a list with two elements `"genome"` and `"aux"`. 
    `"genome"` contains a `data.frame` with `length(x)` rows and two columns 
    `"FileName"` (containing the path to bam files with genomic alignments) and 
    `"SampleName"`. `"aux"` contains a `data.frame` with one row per auxiliary 
    target file (with auxiliary names as row names), and `length(x)` columns 
    (one per input sequence file).  
  - `x[i]` returns a `qProject` object instance with `i` input files, where `i`
    can be an `NA`-free logical, numeric, or character vector.


## `qQCReport` {#qQCReport}
The `qQCReport` function samples a random subset of sequences and alignments from
each sample or input file and generates a series of diagnostic plots for estimating
data quality. The available plots vary depending on the types of available input 
(fasta, fastq, bam files or `qProject` object; paired-end or single-end). The plots
below show the currently available plots as produced by the ChIP-seq example in 
section \@ref(ChIPseq) (except for the fragment size distributions which are based 
on an unspliced alignment of paired-end RNA seq reads):

- **Quality score boxplot** shows the distribution of base quality values as a box
  plot for each position in the input sequence. The background color (green, orange
  or red) indicates ranges of high, intermediate and low qualities. 
```{r qcplotsFig1, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8}
QuasR:::plotQualByCycle(qcdat1$raw$qa, lmat = rbind(1:2))
```

- **Nucleotide frequency** plot shows the frequency of A, C, G, T and N bases by
  position in the read. 
```{r qcplotsFig2, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8}
QuasR:::plotNuclByCycle(qcdat1$raw$qa, lmat = rbind(1:2))
```

- **Duplication level** plot shows for each sample the fraction of reads observed
  at different duplication levels (e.g. once, two-times, three-times, etc.). In
  addition, the most frequent sequences are listed. 
```{r qcplotsFig3, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8}
QuasR:::plotDuplicated(qcdat1$raw$qa, lmat = rbind(1:2))
```

- **Mapping statistics** shows fractions of reads that were (un)mappable to the
  reference genome. 
```{r qcplotsFig4, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8}
QuasR:::plotMappings(qcdat1$raw$mapdata, a4layout = FALSE)
```

- **Library complexity** shows fractions of unique read(-pair) alignment positions. 
  Please note that this measure is not independent from the total number of reads 
  in a library, and is best compared between libraries of similar sizes. 
```{r qcplotsFig5, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8}
QuasR:::plotUniqueness(qcdat1$raw$unique, a4layout = FALSE)
```

- **Mismatch frequency** shows the frequency and position (relative to the read
  sequence) of mismatches in the alignments against the reference genome. 
```{r qcplotsFig6, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8}
QuasR:::plotErrorsByCycle(qcdat1$raw$mm, lmat = rbind(1:2))
```

- **Mismatch types** shows the frequency of read bases that caused mismatches in
  the alignments to the reference genome, separately for each genome base. 
```{r qcplotsFig7, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8}
QuasR:::plotMismatchTypes(qcdat1$raw$mm, lmat = rbind(1:2))
```

- **Fragment size** shows the distribution of fragment sizes inferred from aligned
  read pairs.  
```{r qcplotsFig8, eval=TRUE, echo=FALSE, fig.height=4, fig.width=8}
QuasR:::plotFragmentDistribution(qcdat2$raw$frag, lmat = rbind(1:2))
```



## `alignmentStats` {#alignmentStats}
`alignmentStats` is comparable to the `idxstats` function from Samtools; it returns
the size of the target sequence, as well as the number of mapped and unmapped reads
that are contained in an indexed `bam` file. The function works for arguments of type
`qProject`, as well as on a string with one or several `bam` file names. There is 
however a small difference in the two that is illustrated in the following example,
which uses the `qProject` object from the ChIP-seq workflow:
```{r alignmentStats, eval=TRUE}
# using bam files
alignmentStats(alignments(proj1)$genome$FileName)
alignmentStats(unlist(alignments(proj1)$aux))

# using a qProject object
alignmentStats(proj1)
```

If calling `alignmentStats` on the bam files directly as in the first two expressions
of the above example, the returned numbers correspond exactly to what you would obtain
by the `idxstats` function from Samtools, only that the latter would report them
separately for each target sequence, while `alignmentStats` sums them for each
`bam` file. These numbers correctly state that there are zero unmapped reads in
the auxiliary `bam` files. However, if calling `alignmentStats` on a `qProject`
object, it will report 7 and 12 unmapped reads in the auxiliary `bam` files. This
is because `alignmentStats` is aware that unmapped reads are removed from auxiliary
`bam` files by `r Biocpkg("QuasR")`, but can be calculated from the total number
of reads to be aligned to the auxiliary target, which equals the number of unmapped
reads in the corresponding genomic `bam` file.


## `qExportWig` {#qExportWig}
`qExportWig` creates fixed-step wig files (see (http://genome.ucsc.edu/goldenPath/help/wiggle.html)
for format definition) from the genomic alignments contained in a `qProject` object. 
The `combine` argument controls if several input files are combined into a single 
multi-track wig file, or if they are exported as individual wig files. Alignments
of single read experiments can be shifted towards there 3'-end using `shift`; 
paired-end alignments are automatically shifted by half the insert size. The
resolution of the created wig file is defines by the `binsize` argument, and 
if `scaling=TRUE`, multiple alignment files in the `qProject` object are scaled by their total number of aligned reads per sample.


## `qCount` {#qCount}
`qCount` is the workhorse for counting alignments that overlap query regions. 
Usage and details on parameters can be obtained from the `qCount` function
documentation. Two aspects that are of special importance are also discussed here:

### Determination of overlap
How an alignment overlap with a query region is defined can be controlled by the
following arguments of `qCount`:

  - `selectReadPosition` specifies the read base that serves as a reference for
    overlaps with query regions. The alignment position of that base, eventually
    after shifting (see below), needs to be contained in the query region for an
    overlap. `selectReadPosition` can be set to `"start"` (the default) or `"end"`
    , which refer to  the biological start (5'-end) and end (3'-end) of the read.
    For example, the `"start"` of a read aligned to the plus strand is the leftmost
    base in the alignment (the one with the lowest coordinate), and the `"end"` 
    of a read aligned to the minus strand is also its leftmost base in the alignment.  
  - `shift` allows shifting of alignments towards their 3'-end prior to overlap
    determination and counting. This can be helpful to increase resolution of ChIP-seq
    experiments by moving alignments by half the immuno-precipitated fragment size 
    towards the middle of fragments. `shift` can either contain `"integer"` values 
    that specify the shift size, or for paired-end experiments, it can be set to 
    the keyword `"halfInsert"`, which will estimate the true fragment size from 
    the distance between aligned read pairs and shift the alignments accordingly.  
  - `orientation` controls the interpretation of alignment strand relative to the
    strand of the query region. The default value `"any"` will count all overlapping 
    alignments, irrespective of the strand. This setting is for example used in an
    unstranded RNA-seq experiment where both sense and antisense reads are generated
    from an mRNA. A value of `"same"` will only count the alignments on the same 
    strand as the query region (e.g. in a stranded RNA-seq experiment), and 
    `"opposite"` will only count the alignments on the opposite strand from the
    query region (e.g. to quantify anti-sense transcription in a stranded RNA-seq
    experiment).  
  - `useRead` only applies to paired-end experiments and allows to quantify either
    all alignments (`useRead="any"`), or only the first (`useRead="first"`) or last
    (`useRead="last"`) read from each read pair or read group. Note that for 
    `useRead="any"` (the default), an alignment pair that is fully contained within
    a query region will contribute two counts to the value of that region.  
  - `includeSpliced`: When set to `FALSE`, spliced alignments will be excluded from
    the quantification. This could be useful for example to avoid redundant counting 
    of reads when the spliced alignments are quantified separately using
    `reportLevel="junction"`.     


### Running modes of `qCount`
The features to be quantified are specified by the `query` argument. At the same
time, the type of `query` selects the mode of quantification. `qCount` supports
three different types of `query` arguments and implements three corresponding
quantification types, which primarily differ in the way they deal with redundancy,
such as query bases that are contained in more than one query region. A fourth
quantification mode allows counting of alignments supporting exon-exon juctions:  

  - `GRanges` query: Overlapping alignments are counted separately for each coordinate
    region in the query object. If multiple regions have identical names, their counts
    will be summed, counting each alignment only once even if it overlaps more than
    one of these regions. Alignments may however be counted more than once if they
    overlap multiple regions with different names. This mode is for example used to
    quantify ChIP-seq alignments in promoter regions (see section \@ref(ChIPseq)), or
    gene expression levels in an RNA-seq experiment (using a 'query' with exon regions
    named by gene).  
  - `GRangesList` query: Alignments are counted and summed for each list element in
    the query object if they overlap with any of the regions contained in the list
    element. The order of the list elements defines a hierarchy for quantification:
    Alignment will only be counted for the first element (the one with the lowest 
    index in the query) that they overlap, but not for any potential further list 
    elements containing overlapping regions. This mode can be used to hierarchically
    and uniquely count (assign) each alignment to a one of several groups of regions
    (the elements in the query), for example to estimate the fractions of different
    classes of RNA in an RNA-seq experiment (rRNA, tRNA, snRNA, snoRNA, mRNA, etc.)  
  - `TxDb` query: Used to extract regions from annotation and report alignment counts
    depending on the value of the `reportLevel` argument. If `reportLevel="exon"`,
    alignments overlapping each exon in the query are counted. If `reportLevel="gene"`,
    alignment counts for all exons of a gene will be summed, counting each alignment
    only once even if it overlaps multiple annotated exons of a gene. These are 
    useful to calculate exon or gene expression levels in RNA-seq experiments 
    based on the annotation in a `TxDb` object. If `reportLevel="promoter"`, the
    `promoters` function from package `r Biocpkg("GenomicFeatures")` is used 
    with default arguments to extract promoter regions around transcript start 
    sites, e.g. to quantify alignments inf a ChIP-seq experiment.  
  - any of the above or `NULL` for `reportLevel="junction"`: The `query` argument 
    is ignored if `reportLevel` is set to `"junction"`, and `qCount` will count 
    the number of alignments supporting each exon-exon junction detected in any
    of the samples in `proj`. The arguments `selectReadPosition`, `shift`, `orientation`,
    `useRead` and `mask` will have no effect in this quantification mode.  



## `qProfile` {#qProfile}
The `qProfile` function differs from `qCount` in that it returns alignments counts
relative to their position in the query region. Except for `upstream` and `downstream`,
the arguments of `qProfile` and `qCount` are the same. This section will describe 
these two additional arguments; more details on the other arguments are available
in section \@ref(qCount) and from the `qProfile` function documentation.

The regions to be profiled are anchored by the biological start position, which 
are aligned at position zero in the return value. The biological start position 
is defined as `start(query)` for regions on the plus strand and `end(query)` for
regions on the minus strand. The anchor positions are extended to the left and 
right sides by the number of bases indicated in the `upstream` and `downstream` 
arguments. 

  - `upstream` indicates the number of bases upstream of the anchor position, 
    which is on the left side of the anchor point for regions on the plus strand 
    and on the right side for regions on the minus strand.  
  - `downstream` indicates the number of bases downstream of the anchor position,
    which is on the left side of the anchor point for regions on the plus strand 
    and on the left side for regions on the minus strand.  

Be aware that query regions with a `*` strand are handled the same way as regions
on the plus strand.


## `qMeth` {#qMeth}
`qMeth` is used exclusively for Bis-seq experiments. In contrast to `qCount`,
which counts the number of read alignments per query region, `qMeth` quantifies
the number of C and T bases per cytosine in query regions, in order to determine
methylation status.

`qMeth` can be run in one of four modes, controlled by the `mode` argument:

  - `CpGcomb`: Only C's in CpG context are considered. It is assumed that methylation
    status of the CpG base-pair on both strands is identical. Therefore, the total
    and methylated counts obtained for the C at position $i$ and the C on the opposite
    strand at position $i+1$ are summed.  
  - `CpG`: As with `CpGcomb`, only C's in CpG context are quantified. However, counts
    from opposite strand are not summed, resulting in separate output values for C's
    on both strands.  
  - `allC`: All C's contained in query regions are quantified, keeping C's from 
    either strand separate. While this mode allows quantification of non-CpG 
    methylation, it should be used with care, as the large result could use up
    available memory. In that case, a possible work-around is to divide the 
    region of interest (e.g. the genome) into several regions (e.g. chromosomes)
    and call `qMeth` separately for each region.  
  - `var`: In this mode, only alignments on the opposite strand from C's are analysed
    in order to collect evidence for sequence polymorphisms. Methylated C's are 
    hot-spots for C-to-T transitions, which in a Bis-seq experiment cannot be 
    discriminated from completely unmethylated C's. The information is however 
    contained in alignments to the G from the opposite strand: Reads containing 
    a G are consistent with a non-mutated C, and reads with an A support the 
    presence of a sequence polymorphism. `qMeth(..., mode="var")` returns counts
    for total and matching bases for all C's on both strands. A low fraction of 
    matching bases is an indication of a mutation and can be used as a basis to 
    identify mutated positions in the studied genome relative to the reference 
    genome. Such positions should not be included in the quantification of methylation.  


When using `qMeth` in a allele-specific quantification (see also section 
\@ref(alleleSpecificAnalysis), cytosines (or CpGs) that overlap a sequence 
polymorphism will not be quantified.


# Session information
The output in this vignette was produced under:
```{r sessionInfo, echo=FALSE}
sessionInfo()
```

```{r cleanUp, eval=TRUE, echo=FALSE}
unlink("extdata", recursive = TRUE, force = TRUE)
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/QuasR-package.R
\docType{package}
\name{QuasR-package}
\alias{QuasR-package}
\alias{QuasR}
\title{Quantify and Annotate Short Reads in R}
\description{
This package provides a pipeline for the quantification and analysis of 
short reads.
}
\details{
See packageDescription('QuasR') for package details.
}
\examples{
\dontrun{
# see qCount, qMeth and qProfile manual pages for examples
example(qCount)
example(qMeth)
example(qProfile)
}
}
\seealso{
\code{\link{qAlign}}, \code{\link{qCount}}, \code{\link{qProfile}}, 
  \code{\link{qMeth}}, \code{\link{qQCReport}}
}
\author{
Anita Lerch, Charlotte Soneson, Dimos Gaidatzis and Michael Stadler
}
\keyword{internal}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qMeth.R
\name{qMeth}
\alias{qMeth}
\title{Quantify DNA methylation}
\usage{
qMeth(
  proj,
  query = NULL,
  reportLevel = c("C", "alignment"),
  mode = c("CpGcomb", "CpG", "allC", "var"),
  collapseBySample = TRUE,
  collapseByQueryRegion = FALSE,
  asGRanges = TRUE,
  mask = NULL,
  reference = "genome",
  keepZero = TRUE,
  mapqMin = 0L,
  mapqMax = 255L,
  clObj = NULL
)
}
\arguments{
\item{proj}{A \code{qProject} object from a bisulfite sequencing experiment}

\item{query}{A \code{GRanges} object with the regions to be
quantified. If \code{NULL}, all available target sequences (e.g. the
whole genome) will be analyzed. Available target sequences are
extracted from the header of the first bam file.}

\item{reportLevel}{Report results combined for C's
(\code{reportLevel}=\dQuote{C}), the default) or individually for single
alignments (\code{reportLevel}=\dQuote{alignment}). The latter imposes
further restrictions on some arguments (see \sQuote{Details}).}

\item{mode}{Cytosine quantification mode, one of:
\describe{
  \item{\code{CpGcomb}}{: only C's in CpG context (strands combined)}
  \item{\code{CpG}}{: only C's in CpG context (strands separate)}
  \item{\code{allC}}{: all C's (strands separate)}
  \item{\code{var}}{: variant detection (all C's, strands separate)}
}
\code{CpGcomb} is the default.}

\item{collapseBySample}{If \code{TRUE}, combine (sum) counts from
bamfiles with the same sample name.}

\item{collapseByQueryRegion}{If \code{TRUE}, combine (sum) counts for
all cytosines contained in the same query region.}

\item{asGRanges}{If \code{TRUE}, return results as a \code{GRanges} object;
if \code{FALSE}, the results are returned as a \code{data.frame}.}

\item{mask}{An optional \code{GRanges} object with genomic regions to
be masked, i.e. excluded from the analysis (e.g. unmappable regions).}

\item{reference}{Source of bam files; can be either \dQuote{genome}
(then the alignments against the genome are used) or the name of an
auxiliary target sequence (then alignments against this target
sequence will be used). The auxiliary name must correspond to the
name contained in the auxiliary file refered by the
\code{auxiliaryFile} argument of \code{\link[QuasR]{qAlign}}.}

\item{keepZero}{If \code{FALSE}, only cytosines covered by at least
one alignment will be returned; \code{keepZero} must be \code{TRUE}
if multiple samples have the same sample name and
\code{collapseBySample} is \code{TRUE}.}

\item{mapqMin}{Minimal mapping quality of alignments to be included when
counting (mapping quality must be greater than or equal to
\code{mapqMin}). Valid values are between 0 and 255. The default (0)
will include all alignments.}

\item{mapqMax}{Maximal mapping quality of alignments to be included when
counting (mapping quality must be less than or equal to \code{mapqMax}).
Valid values are between 0 and 255. The default (255) will include
all alignments.}

\item{clObj}{A cluster object to be used for parallel processing of
multiple files (see \sQuote{Details}).}
}
\value{
For \code{reportLevel}=\dQuote{C}, a \code{GRanges} object if
\code{asGRanges}=\code{TRUE}, otherwise a \code{data.frame}.

Each row contains the coordinates of individual cytosines for
\code{collapseByQueryRegion}=\code{FALSE} or query regions
for \code{collapseByQueryRegion}=\code{TRUE}.

In addition to the coordinates columns (or \code{seqnames},
\code{ranges} and \code{strand} slots for \code{GRanges} objects),
each row contains per bam file:

Two values (total and methylated events, with suffixes _T and _M), or
if the \code{qProject} object was created including a SNP table,
six values (total and methylated events for Reference, Unknown and
Alternative genotypes, with suffixed _TR, _TU, _TA, _MR, _MU and _MA).
In the latter case, C's or CpG's that overlap with SNPs in the table
are removed.

If \code{collapseBySample}=\code{TRUE}, groups of bam files with
identical sample name are combined (summed) and will be represented by
a single set of total and methylated count columns.

If \code{mode}=\dQuote{var}, the _T and _M columns correspond to total
and matching alignments overlapping the guanine paired to the cytosine.

For \code{reportLevel}=\dQuote{alignment}, a \code{list} with one
element per bam file or sample (depending on \code{collapseBySample}).
Each list element is another list with the elements:
\describe{
  \item{\code{aid}}{: character vector with unique alignment identifiers}
  \item{\code{Cid}}{: integer vector with genomic coordinate of C base}
  \item{\code{strand}}{: character vector with the strand of the C base}
  \item{\code{meth}}{: integer vector with methylation state for
  alignment and C defined by \code{aid} and \code{Cid}. The values are
  1 for methylated or 0 for unmethylated states.}
}
}
\description{
Quantify methylation of cytosines from bisulfite sequencing data.
}
\details{
\code{qMeth} can be used on a \code{qProject} object from a bisulfite
sequencing experiment (sequencing of bisulfite-converted DNA), such as
the one returned by \code{\link[QuasR]{qAlign}} when its parameter
\code{bisulfite} is set to a different value than \dQuote{no}.

\code{qMeth} quantifies DNA methylation by counting total and
methylated events for individual cytosines, using the alignments that
have been generated in converted (three-letter) sequence space for
example by \code{\link[QuasR]{qAlign}}. A methylated event corresponds
to a C/C match in the alignment, an unmethylated event to a T/C mismatch
(or G/G matches and A/G mismatches on the opposite strand). For paired-end
samples, the part of the left fragment alignment that overlaps
with the right fragment alignment is ignored, preventing the
use of redundant information coming from the same molecule.

Both directed (\code{bisulfite}=\dQuote{dir}) and undirected
(\code{bisulfite}=\dQuote{undir}) experimental protocols are supported
by \code{\link[QuasR]{qAlign}} and \code{qMeth}.

By default, results are returned per C nucleotide. If
\code{reportLevel}=\dQuote{alignment}, results are reported separately
for individual alignments. In that case, \code{query} has to be a
\code{GRanges} object with exactly one region, \code{mode} has to be
either \dQuote{CpG} or \dQuote{allC}, the arguments
\code{collapseByQueryRegion}, \code{asGRanges}, \code{mask} and
\code{keepZero} have no effect and allele-specific projects are
treated in the same way as normal (non-allele specific) projects.

Using the parameter \code{mode}, quantification can be limited to
cytosines in CpG context, and counts obtained for the two cytosines on
opposite strands within a single CpG can be combined (summed).

The quantification of methylation for all cytosines in the query region(s)
(\code{mode}=\dQuote{allC}) should be done with care, especially for
large query regions, as the return value may require a large amount of
memory.

If \code{mode} is set to \dQuote{var}, \code{qMeth} only counts reads
from the strand opposite of the cytosine and reports total and
matching alignments. For a position identical to the reference
sequence, only matches (and very few sequencing errors) are
expected, independent on the methylation state of the cytosine. A
reduced fraction of alignments matching the reference are indicative
of sequence variations in the sequenced sample.

\code{mapqMin} and \code{mapqMax} allow to select alignments
based on their mapping qualities. \code{mapqMin} and \code{mapqMax} can
take integer values between 0 and 255 and equal to
\eqn{-10 log_{10} Pr(\textnormal{mapping position is wrong})}{-10
log10 Pr(mapping position is wrong)}, rounded to the nearest
integer. A value 255 indicates that the mapping quality is not available.

If an object that inherits from class \code{cluster} is provided to
the \code{clObj} argument, for example an object returned by
\code{\link[parallel]{makeCluster}} from package \pkg{parallel},
the quantification task is split into multiple chunks and processed in
parallel using \code{\link[parallel:clusterApply]{clusterApplyLB}} from package
\pkg{parallel}. Not all tasks will be efficiently parallelized: For
example, a single query region and a single (group of) bam files will
not be split into multiple chunks.
}
\examples{
# copy example data to current working directory
file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)

# create alignments
sampleFile <- "extdata/samples_bis_single.txt"
genomeFile <- "extdata/hg19sub.fa"
proj <- qAlign(sampleFile, genomeFile, bisulfite="dir")
proj

# calculate methylation states
meth <- qMeth(proj, mode="CpGcomb")
meth

}
\seealso{
\code{\link[QuasR]{qAlign}},
\code{\link[parallel]{makeCluster}} from package \pkg{parallel}
}
\author{
Anita Lerch, Dimos Gaidatzis and Michael Stadler
}
\keyword{misc}
\keyword{utilities}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qExportWig.R
\name{qExportWig}
\alias{qExportWig}
\title{QuasR wig file export}
\usage{
qExportWig(
  proj,
  file = NULL,
  collapseBySample = TRUE,
  binsize = 100L,
  shift = 0L,
  strand = c("*", "+", "-"),
  scaling = TRUE,
  tracknames = NULL,
  log2p1 = FALSE,
  colors = c("#1B9E77", "#D95F02", "#7570B3", "#E7298A", "#66A61E", "#E6AB02", "#A6761D",
    "#666666"),
  includeSecondary = TRUE,
  mapqMin = 0L,
  mapqMax = 255L,
  absIsizeMin = NULL,
  absIsizeMax = NULL,
  createBigWig = FALSE,
  useRead = c("any", "first", "last"),
  pairedAsSingle = FALSE,
  clObj = NULL
)
}
\arguments{
\item{proj}{A \code{qProject} object as returned by \code{qAlign}.}

\item{file}{A character vector with the name(s) for the wig or bigWig
file(s) to be generated. Either \code{NULL} or a vector of the same
length as the number of bam files (for \code{collapseBySample=FALSE})
or the number of unique sample names (for \code{collapseBySample=TRUE})
in \code{proj}. If \code{NULL}, the wig or bigWig file names are generated
from the names of the genomic bam files or unique sample names with an
added \dQuote{.wig.gz} or \dQuote{.bw} extension.}

\item{collapseBySample}{If \code{TRUE}, genomic bam files with identical
sample name will be combined (summed) into a single track.}

\item{binsize}{A numerical value defining the bin and step size for the
wig or bigWig file(s). \code{binsize} will be coerced to \code{integer()}.}

\item{shift}{Either a vector or a scalar value defining the read shift (e.g.
half of fragment length, see \sQuote{Details}). If \code{length(shift)>1},
the length must match the number of bam files in \sQuote{proj}, and
the i-th sample will be converted to wig or bigWig using the value in
\code{shift[i]}. \code{shift} will be coerced to \code{integer()}. For
paired-end alignments, \code{shift} will be ignored, and a warning
will be issued if it is set to a non-zero value (see \sQuote{Details}).}

\item{strand}{Only count alignments of \code{strand}. The default
(\dQuote{*}) will count all alignments.}

\item{scaling}{If TRUE or a numerical value, the output values in the wig
or bigWig file(s) will be linearly scaled by the total number of aligned
reads per sample to improve comparability (see \sQuote{Details}).}

\item{tracknames}{A character vector with the names of the tracks to appear
in the track header. If \code{NULL}, the sample names in \code{proj}
will be used.}

\item{log2p1}{If \code{TRUE}, the number of alignments \code{x} per bin will
be transformed using the formula \code{log2(x+1)}.}

\item{colors}{A character vector with R color names to be used for the tracks.}

\item{includeSecondary}{If \code{TRUE} (the default), include alignments
with the secondary bit (0x0100) set in the \code{FLAG}.}

\item{mapqMin}{Minimal mapping quality of alignments to be included
(mapping quality must be greater than or equal to \code{mapqMin}).
Valid values are between 0 and 255. The default (0) will include all
alignments.}

\item{mapqMax}{Maximal mapping quality of alignments to be included
(mapping quality must be less than or equal to \code{mapqMax}).
Valid values are between 0 and 255. The default (255) will include all
alignments.}

\item{absIsizeMin}{For paired-end experiments, minimal absolute insert
size (TLEN field in SAM Spec v1.4) of alignments to be included. Valid
values are greater than 0 or \code{NULL} (default), which will not
apply any minimum insert size filtering.}

\item{absIsizeMax}{For paired-end experiments, maximal absolute insert
size (TLEN field in SAM Spec v1.4) of alignments to be included. Valid
values are greater than 0 or \code{NULL} (default), which will not apply
any maximum insert size filtering.}

\item{createBigWig}{If \code{TRUE}, first a temporary wig file will be
created and then converted to BigWig format (file extension \dQuote{.bw})
using the \code{\link[rtracklayer]{wigToBigWig}} function from
package \pkg{rtracklayer}.}

\item{useRead}{For paired-end experiments, selects the read mate whose
alignments should be counted, one of:
\describe{
  \item{\code{any} (default)}{: count all alignments}
  \item{\code{first}}{: count only alignments from the first read}
  \item{\code{last}}{: count only alignments from the last read}
}
For single-read alignments, this argument will be ignored. For
paired-end alignments, setting this argument to a value different
from the default (\code{any}) will cause \code{qExportWig} not to
automatically use the mid of fragments, but to treat the selected
read as if it would come from a single-read experiment (see
\sQuote{Details}).}

\item{pairedAsSingle}{If \code{TRUE}, treat paired-end data single read
data, which means that instead of calculating fragment mid-points for
each read pair, the 5-prime ends of the reads is used. This is for example
useful when analyzing paired-end DNAse-seq or ATAC-seq data, in which
the read starts are informative for chromatin accessibility.}

\item{clObj}{A cluster object to be used for parallel processing of multiple
samples.}
}
\value{
(invisible) The file name of the generated wig or bigWig file(s).
}
\description{
Create a fixed-step wig file from the alignments in the genomic bam files
of the \sQuote{QuasR} project.
}
\details{
\code{qExportWig()} uses the genome bam files in \code{proj} as input
to create wig or bigWig files with the number of alignments (pairs)
per window of \code{binsize} nucleotides. By default
(\code{collapseBySample=TRUE}), one file per unique sample will be
created. If \code{collapseBySample=FALSE}, one file per genomic bam
file will be created. See \url{http://genome.ucsc.edu/goldenPath/help/wiggle.html}
for the definition of the wig format, and
\url{http://genome.ucsc.edu/goldenPath/help/bigWig.html} for the definition
of the bigWig format.

The genome is tiled with sequential windows of length \code{binsize},
and alignments in the bam file are assigned to these windows: Single
read alignments are assigned according to their 5'-end coordinate
shifted by \code{shift} towards the 3'-end (assuming that the 5'-end
is the leftmost coordinate for plus-strand alignments, and the rightmost
coordinate for minus-strand alignments). Paired-end alignments are
assigned according to the base in the middle between the leftmost and
rightmost coordinates of the aligned pair of reads, unless
\code{pairedAsSingle = TRUE} is used. Each pair of reads
is only counted once, and not properly paired alignments are
ignored. If \code{useRead} is set to select only the first or last
read in a paired-end experiment, the selected read will be treated as
reads from a single read experiment. Secondary alignments can be
excluded by setting \code{includeSecondary=FALSE}. In paired-end
experiments, \code{absIsizeMin} and \code{absIsizeMax} can be used to select
alignments based on their insert size (TLEN field in SAM Spec v1.4).

For \code{scaling=TRUE}, the number of alignments per bin \eqn{n}
for the sample \eqn{i} are linearly scaled to the mean total
number of alignments over all samples in \code{proj} according to:
\eqn{n_s = n /N[i] *mean(N)} where \eqn{n_s} is the scaled number
of alignments in the bin and \eqn{N} is a vector with the total
number of alignments for each sample. Alternatively, if scaling is set
to a positive numerical value \eqn{s}, this value is used instead of
\eqn{\textnormal{mean}(N)}{mean(N)}, and values are scaled according
to: \eqn{n_s = n /N[i] *s}.

\code{mapqMin} and \code{mapqMax} allow to select alignments
based on their mapping qualities. \code{mapqMin} and \code{mapqMax} can
take integer values between 0 and 255 and equal to
\eqn{-10 log_{10} Pr(\textnormal{mapping position is wrong})}{-10
log10 Pr(mapping position is wrong)}, rounded to the nearest
integer. A value 255 indicates that the mapping quality is not available.

If \code{createBigWig=FALSE} and \code{file} ends with \sQuote{.gz},
the resulting wig file will be compressed using gzip and is suitable
for uploading as a custom track to your favorite genome browser
(e.g. UCSC or Ensembl).
}
\examples{
# copy example data to current working directory
file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)

# create alignments
sampleFile <- "extdata/samples_chip_single.txt"
genomeFile <- "extdata/hg19sub.fa"
proj <- qAlign(sampleFile, genomeFile)

# export wiggle file
qExportWig(proj, binsize=100L, shift=0L, scaling=TRUE)

}
\seealso{
\code{\linkS4class{qProject}}, \code{\link{qAlign}},
\code{\link[rtracklayer]{wigToBigWig}}
}
\author{
Anita Lerch, Dimos Gaidatzis and Michael Stadler
}
\keyword{utilities}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qProject-class.R
\docType{class}
\name{qProject-class}
\alias{qProject-class}
\alias{show,qProject-method}
\alias{[,qProject,ANY,missing,missing-method}
\alias{alignments,qProject-method}
\alias{alignments}
\alias{auxiliaries,qProject-method}
\alias{auxiliaries}
\alias{genome,qProject-method}
\alias{length,qProject-method}
\alias{qProject}
\alias{class:qProject}
\title{qProject objects}
\description{
The qProject class is a container for the meta-data (e.g. sample
names, paths and names of sequence and alignment files) associated
with a high-throughput sequencing experiment analyzed with \code{QuasR}.
}
\details{
The qProject class is returned by \link{qAlign} and stores all
information on a high-throughput sequencing experiment analyzed with
\code{QuasR}. qProject objects can be conveniently passed to
\sQuote{q}-functions (function name starting with the letter
\sQuote{q}). The information is stored in the following slots:
\describe{
  \item{\code{reads}}{a 'data.frame' with sequence read files.}
  \item{\code{reads_md5subsum}}{a 'data.frame' with fingerprints for
  sequence read files.}
  \item{\code{alignments}}{a 'data.frame' with alignment files.}
  \item{\code{samplesFormat}}{a 'character(1)' specifying the format
  of input files.}
  \item{\code{genome}}{a 'character(1)' specifying the reference genome.}
  \item{\code{genomeFormat}}{a 'character(1)' specifying the format of
  the reference genome.}
  \item{\code{aux}}{a 'data.frame' with auxiliary reference sequence files.}
  \item{\code{auxAlignments}}{a 'data.frame' with alignment files for
  auxiliary reference sequence files.}
  \item{\code{aligner}}{a 'character(1)' specifying the aligner.}
  \item{\code{maxHits}}{a 'numeric(1)' specifying the maximum number
  of alignments per sequence.}
  \item{\code{paired}}{a 'character(1)' specifying the paired-type;
  one of "no", "fr", "rf", "ff".}
  \item{\code{splicedAlignment}}{a 'logical(1)'; \code{TRUE} when
  performing spliced-alignments.}
  \item{\code{snpFile}}{a 'character(1)' with a file name containing
  SNP information.}
  \item{\code{bisulfite}}{a 'character(1)' defining the bisulfite
  type; one of "no", "dir", "undir".}
  \item{\code{alignmentParameter}}{a 'character(1)' with aligner
  command line parameters.}
  \item{\code{projectName}}{a 'character(1)' with the project name.}
  \item{\code{alignmentsDir}}{a 'character(1)' with the directory to
  be used to store alignment files.}
  \item{\code{lib.loc}}{a 'character(1)' with the library directory to
  use for installing of alignment index packages.}
  \item{\code{cacheDir}}{a 'character(1)' with a directory to use for
  temporary files.}
  \item{\code{alnModeID}}{a 'character(1)' used internally to indicate
  the alignment mode.}
}
}
\section{Accessors}{

In the following code snippets, \code{x} is a qProject object.
\describe{
  \item{\code{length(x)}}{: Gets the number of input files.}
  \item{\code{genome(x)}}{: Gets the reference genome as a 'character(1)'.
  The type of genome is stored as an attribute in
  \code{attr(genome(x),"genomeFormat")}: "BSgenome" indicates that
  \code{genome(x)} refers to the name of a BSgenome package, "file"
  indicates that it contains the path and filename of a genome in
  FASTA format.}
  \item{\code{auxiliaries(x)}}{: Gets a \code{data.frame} with auxiliary
  target sequences, with one row per auxiliary target, and columns
  "FileName" and "AuxName".}
  \item{\code{alignments(x)}}{: Gets a list with two elements "genome" and
  "aux". \code{alignments(x)$genome} contains a \code{data.frame}
  with \code{length(x)} rows and the columns "FileName" (containing
  the path to bam files with genomic alignments) and
  "SampleName". \code{alignments(x)$aux} contains a
  \code{data.frame} with one row per auxiliary target sequence (with
  auxiliary names as row names), and \code{length(x)} columns.}
}
}

\section{Subsetting}{

In the following code snippets, \code{x} is a qProject object.
\describe{
  \item{\code{x[i]}}{: Get \code{qProject} object instance with \code{i}
  input files, where \code{i} can be an NA-free logical, numeric, or
  character vector.}
}
}

\examples{
# copy example data to current working directory
file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)

# create alignments
sampleFile <- "extdata/samples_chip_single.txt"
genomeFile <- "extdata/hg19sub.fa"
auxFile <- "extdata/auxiliaries.txt"

proj <- qAlign(sampleFile, genomeFile, auxiliaryFile=auxFile)
proj

# alignment statistics using a qProject
alignmentStats(proj)

# alignment statistics using bam files
alignmentStats(alignments(proj)$genome$FileName)
alignmentStats(unlist(alignments(proj)$aux))

}
\seealso{
\link{qAlign}
}
\author{
Anita Lerch, Dimos Gaidatzis and Michael Stadler
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessReads.R
\name{preprocessReads}
\alias{preprocessReads}
\title{Preprocess Short Reads}
\usage{
preprocessReads(
  filename,
  outputFilename = NULL,
  filenameMate = NULL,
  outputFilenameMate = NULL,
  truncateStartBases = NULL,
  truncateEndBases = NULL,
  Lpattern = "",
  Rpattern = "",
  max.Lmismatch = rep(0:2, c(6, 3, 100)),
  max.Rmismatch = rep(0:2, c(6, 3, 100)),
  with.Lindels = FALSE,
  with.Rindels = FALSE,
  minLength = 14L,
  nBases = 2L,
  complexity = NULL,
  nrec = 1000000L,
  clObj = NULL
)
}
\arguments{
\item{filename}{the name(s) of the input sequence file(s).}

\item{outputFilename}{the name(s) of the output sequence file(s).}

\item{filenameMate}{for paired-end experiments, the name(s) of the
input sequence file(s) containing the second read (mate) of each pair.}

\item{outputFilenameMate}{for paired-end experiments, the name(s) of the
output sequence file(s) containing the second read (mate) of each pair.}

\item{truncateStartBases}{integer(1): the number of bases to be truncated
(removed) from the beginning of each sequence.}

\item{truncateEndBases}{integer(1): the number of bases to be truncated
(removed) from the end of each sequence.}

\item{Lpattern}{character(1): the left (5'-end) adapter sequence.}

\item{Rpattern}{character(1): the right (3'-end) adapter sequence.}

\item{max.Lmismatch}{mismatch tolerance when searching for matches of
\code{Lpattern} (see \sQuote{Details}).}

\item{max.Rmismatch}{mismatch tolerance when searching for matches of
\code{Rpattern} (see \sQuote{Details}).}

\item{with.Lindels}{if \code{TRUE}, indels are allowed in the alignments of
the suffixes of \code{Lpattern} with the subject, at its beginning
(see \sQuote{Details}).}

\item{with.Rindels}{same as \code{with.Lindels} but for alignments of the
prefixes of \code{Rpattern} with the subject, at its end (see
\sQuote{Details}).}

\item{minLength}{integer(1): the minimal allowed sequence length.}

\item{nBases}{integer(1): the maximal number of Ns allowed per sequence.}

\item{complexity}{\code{NULL} (default) or numeric(1): If not \code{NULL},
the minimal sequence complexity, as a fraction of the average complexity
in the human genome (~3.9bits). For example, \code{complexity = 0.5} will
filter out sequences that do not have at least half the complexity of the
human genome. See \sQuote{Details} on how the complexity is calculated.}

\item{nrec}{integer(1): the number of sequence records to read at a time.}

\item{clObj}{a cluster object to be used for parallel processing of multiple
files (see \sQuote{Details}).}
}
\value{
A matrix with summary statistics on the processed sequences, containing:
\itemize{
  \item One column per input file (or pair of input files for paired-end
                                   experiments).
  \item The number of sequences or sequence pairs in rows:
  \describe{
    \item{\code{totalSequences}}{ - the total number in the input}
    \item{\code{matchTo5pAdaptor}}{ - matching to \code{Lpattern}}
    \item{\code{matchTo3pAdaptor}}{ - matching to \code{Rpattern}}
    \item{\code{tooShort}}{ - shorter than \code{minLength}}
    \item{\code{tooManyN}}{ - more than \code{nBases} Ns}
    \item{\code{lowComplexity}}{ - relative complexity below \code{complexity}}
    \item{\code{totalPassed}}{ - the number of sequences/sequence pairs
      that pass all filtering criteria and were written to the output file(s).}
  }
}
}
\description{
Truncate sequences, remove parts matching to adapters and filter out low
quality or low complexity sequences from (compressed) 'fasta' or 'fastq' files.
}
\details{
Sequence files can be in fasta or fastq format, and can be compressed by
either gzip, bzip2 or xz (extensions .gz, .bz2 or .xz). Multiple files
can be processed by a single call to \code{preprocessReads}; in that
case all sequence file vectors must have identical lengths.

\code{nrec} can be used to limit the memory usage when processing
large input files. \code{preprocessReads} iteratively loads chunks of
\code{nrec} sequences from the input until all data been processed.

Sequence pairs from paired-end experiments can be processed by
specifying pairs of input and output files (\code{filenameMate} and
\code{outputFilenameMate} arguments). In that case, it is assumed that
pairs appear in the same order in the two input files, and only pairs
in which both reads pass all filtering criteria are written to the
output files, maintaining the consistent ordering.

If output files are compressed, the processed sequences are first
written to temporary files (created in the same directory as the final
output file), and the output files are generated at the end by compressing
the temporary files.

For the trimming of left and/or right flanking sequences (adapters) from
sequence reads, the \code{\link[Biostrings]{trimLRPatterns}} function
from package \pkg{Biostrings} is used, and the arguments \code{Lpattern},
\code{Rpattern}, \code{max.Lmismatch}, \code{max.Rmismatch},
\code{with.Lindels} and \code{with.Rindels} are used in the call to
\code{trimLRPatterns}. \code{Lfixed} and \code{Rfixed} arguments
of \code{trimLRPatterns} are set to \code{TRUE}, thus only fixed
patterns (without IUPAC codes for ambigous bases) can be
used. Currently, trimming of adapters is only supported for single read
experiments.

Sequence complexity (\eqn{H}) is calculated based on the dinucleotide
composition using the formula (Shannon entropy): \deqn{H = -\sum_i {f_i \log_2 f_i},}
where \eqn{f_i} is the fraction of dinucleotide \eqn{i} from all
dinucleotides in the sequence. Sequence reads that fulfill the condition
\eqn{H/H_r \ge c} are retained (not filtered out), where \eqn{H_r =
3.908} is the reference complexity in bits obtained from the human
genome, and \eqn{c} is the value given to the argument \code{complexity}.

If an object that inherits from class \code{cluster} is provided to
the \code{clObj} argument, for example an object returned by
\code{\link[parallel]{makeCluster}} from package \pkg{parallel},
multiple files will be processed in parallel using
\code{\link[parallel:clusterApply]{clusterMap}} from package \pkg{parallel}.
}
\examples{
# sample files
infiles <- system.file(package="QuasR", "extdata",
                       c("rna_1_1.fq.bz2","rna_1_2.fq.bz2"))
outfiles <- paste(tempfile(pattern=c("output_1_","output_2_")),".fastq",sep="")
# single read example
preprocessReads(infiles, outfiles, nBases=0, complexity=0.6)
unlink(outfiles)
# paired-end example
preprocessReads(filename=infiles[1],
                outputFilename=outfiles[1],
                filenameMate=infiles[2],
                outputFilenameMate=outfiles[2],
                nBases=0, complexity=0.6)
unlink(outfiles)

}
\seealso{
\code{\link[Biostrings]{trimLRPatterns}} from package \pkg{Biostrings},
\code{\link[parallel]{makeCluster}} from package \pkg{parallel}
}
\author{
Anita Lerch, Dimos Gaidatzis and Michael Stadler
}
\keyword{misc}
\keyword{utilities}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qProfile.R
\name{qProfile}
\alias{qProfile}
\title{Quantify alignments by relative position}
\usage{
qProfile(
  proj,
  query,
  upstream = 1000,
  downstream = upstream,
  selectReadPosition = c("start", "end"),
  shift = 0L,
  orientation = c("any", "same", "opposite"),
  useRead = c("any", "first", "last"),
  auxiliaryName = NULL,
  mask = NULL,
  collapseBySample = TRUE,
  includeSpliced = TRUE,
  includeSecondary = TRUE,
  mapqMin = 0L,
  mapqMax = 255L,
  absIsizeMin = NULL,
  absIsizeMax = NULL,
  maxInsertSize = 500L,
  binSize = 1L,
  clObj = NULL
)
}
\arguments{
\item{proj}{A \code{\linkS4class{qProject}} object representing a
sequencing experiment as returned by \code{\link[QuasR]{qAlign}}}

\item{query}{An object of type \code{\link[GenomicRanges:GRanges-class]{GRanges}}
with the regions to be profiled. All regions in \code{query} will be
anchored at their biological start position (\code{start(query)} for
regions on strand \dQuote{+} or \dQuote{*}, \code{end(query)} for
regions on strand \dQuote{-}). This position will become position zero
in the return value.}

\item{upstream}{An \dQuote{integer} vector of length one or the same
length as \code{query} indicating the number of bases upstream of the
anchor position to include in the profile.}

\item{downstream}{An \dQuote{integer} vector of length one or the same
length as \code{query} indicating the number of bases downstream of the
anchor position to include in the profile.}

\item{selectReadPosition}{defines the part of the alignment that has to be
contained within a query region to produce an overlap (see Details), and
that is used to calculate the relative position within the query region.
Possible values are:
\describe{
  \item{\code{start} (default)}{: start of the alignment}
  \item{\code{end}}{: end of the alignment}
}}

\item{shift}{controls the shifting alignments towards their 3'-end before
quantification. \code{shift} can be one of:
\itemize{
  \item an \dQuote{integer} vector of the same length as the
  number of alignment files
  \item a single \dQuote{integer} value
  \item the character string \code{"halfInsert"} (only available for
  paired-end experiments)
}
The default of \code{0} will not shift any alignments.}

\item{orientation}{sets the required orientation of the alignments relative
to the query region in order to be counted, one of:
\describe{
  \item{\code{any} (default)}{: count alignment on the same and opposite strand}
  \item{\code{same}}{: count only alignment on the same strand}
  \item{\code{opposite}}{: count only alignment on the opposite strand}
}}

\item{useRead}{For paired-end experiments, selects the read mate whose
alignments should be counted, one of:
\describe{
  \item{\code{any} (default)}{: count all alignments}
  \item{\code{first}}{: count only alignments from the first read}
  \item{\code{last}}{: count only alignments from the last read}
}}

\item{auxiliaryName}{Which bam files to use in an experiments with
auxiliary alignments (see Details).}

\item{mask}{If not \code{NULL}, a \code{\link[GenomicRanges:GRanges-class]{GRanges}}
object with reference regions to be masked, i.e. excluded from the
quantification, such as unmappable or highly repetitive regions (see
Details).}

\item{collapseBySample}{If \code{TRUE} (the default), sum alignment
counts from bam files with the same sample name.}

\item{includeSpliced}{If \code{TRUE} (the default), include spliced
alignments when counting. A spliced alignment is defined as an
alignment with a gap in the read of at least 60 bases.}

\item{includeSecondary}{If \code{TRUE} (the default), include alignments
with the secondary bit (0x0100) set in the \code{FLAG} when counting.}

\item{mapqMin}{Minimal mapping quality of alignments to be included when
counting (mapping quality must be greater than or equal to \code{mapqMin}).
Valid values are between 0 and 255. The default (0) will include all
alignments.}

\item{mapqMax}{Maximal mapping quality of alignments to be included when
counting (mapping quality must be less than or equal to \code{mapqMax}).
Valid values are between 0 and 255. The default (255) will include all
alignments.}

\item{absIsizeMin}{For paired-end experiments, minimal absolute insert
size (TLEN field in SAM Spec v1.4) of alignments to be included when
counting. Valid values are greater than 0 or \code{NULL} (default),
which will not apply any minimum insert size filtering.}

\item{absIsizeMax}{For paired-end experiments, maximal absolute insert
size (TLEN field in SAM Spec v1.4) of alignments to be included when
counting. Valid values are greater than 0 or \code{NULL} (default),
which will not apply any maximum insert size filtering.}

\item{maxInsertSize}{Maximal fragment size of the paired-end experiment.
This parameter is used if \code{shift="halfInsert"} and will ensure that
query regions are made wide enough to emcompass all alignment pairs whose
mid falls into the query region. The default value is \code{500} bases.}

\item{binSize}{Numeric scalar giving the size of bins (must be an odd number).
The default value (\code{1}) gives back counts for single bases. Otherwise,
alignments are counted in adjacent, non-overlapping windows of size
\code{binSize} that tile the interval defined by \code{upstream} and
\code{downstream}.}

\item{clObj}{A cluster object to be used for parallel processing (see
\sQuote{Details}).}
}
\value{
A \code{list} of matrices with \code{length(unique(names(query)))} rows
with profile names, and \code{max(upstream)+max(downstream)+1} columns
indicating relative position (for \code{binsize=1}).

For \code{binSize} values greater than 1, the number of columns corresponds to
the number of bins (tiles), namely
\code{ceiling(max(upstream)/binSize)+ceiling(max(downstream)/binSize)}.
A middle bin of size \code{binSize} is always positioned centered at the anchor
of each region. Additional bins are positioned upstream and downstream, adjacent
to that middle bin, in order to include at least \code{upstream} and
\code{downstream} bases, respectively (potentially more in order to fill the
first and last bins).

The relative positions are given as column names (for \code{binSize > 1}
they refer to the bin mid). In that case, the bins are "right-open". For
example, if \code{binSize = 10}, the bin with the midpoint "-50" contains
counts for the alignments in [-55,-45).

The first list element is called \dQuote{coverage} and contains, for each
profile and relative position, the number of overlapping regions
that contributed to the profile.

Subsequent list elements contain the alignment counts for individual
sequence files (\code{collapseBySample=FALSE}) or samples
(\code{collapseBySample=TRUE}) in \code{proj}.

For projects with allele-specific quantification, i.e. if a file with
single nucleotide polymorphisms was supplied to the \code{snpFile}
argument of \code{\link[QuasR]{qAlign}}, there will be three rows
instead of one row with counts per unique region name, with numbers
of alignments for Reference, Unknown and Alternative genotypes
(suffixed _R, _U and _A).
}
\description{
Quantify alignments from sequencing data, relative to their position in
query regions.
}
\details{
\code{qProfile} is used to count alignments in each sample from a
\code{qProject} object, relative to their position in query regions.

Most arguments are identical to the ones of \code{\link[QuasR]{qCount}}.

The \code{query} argument is a \code{\link[GenomicRanges:GRanges-class]{GRanges}}
object that defines the regions for the profile. All regions in
\code{query} will be aligned to one another at their anchor position,
which corresponds to their biological start position (\code{start(query)}
for regions on strand \dQuote{+} or \dQuote{*}, \code{end(query)} for
regions on strand \dQuote{-}).

This anchor position will be extended (with regard to strand) by
the number of bases specified by \code{upstream} and \code{downstream}.
In the return value, the anchor position will be at position zero.

If \code{binSize} is greater than one, \code{upstream} and \code{downstream}
will be slightly increased in order to include the complete first and last
bins of \code{binSize} bases.

Regions with identical names in \code{names{query}} will be summed, and
profiles will be padded with zeros to accomodate the length of all profiles.
}
\examples{
# copy example data to current working directory
file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)

# create alignments (single-end experiment)
genomeFile <- "extdata/hg19sub.fa"
sampleFile <- "extdata/samples_chip_single.txt"
proj <- qAlign(sampleFile, genomeFile)

# load transcript start site coordinates
library(rtracklayer)
annotationFile <- "extdata/hg19sub_annotation.gtf"
tssRegions <- import.gff(annotationFile, format="gtf",
                         feature.type="start_codon")

# obtain a combined TSS profile
pr1 <- qProfile(proj, tssRegions)
lapply(pr1, dim)
lapply(pr1, "[", , 1:5)

prComb <- do.call("+", lapply(pr1[-1], function(x) x/pr1[[1]]))
barplot(prComb, xlab="Position", ylab="Mean no. of alignments")

# obtain TSS profiles for individual regions
names(tssRegions) <- mcols(tssRegions)$transcript_id
pr2 <- qProfile(proj, tssRegions)
lapply(pr2, dim)
lapply(pr2, "[", 1:3, 1:5)

}
\seealso{
\code{\link[QuasR]{qCount}},
\code{\link[QuasR]{qAlign}},
\code{\linkS4class{qProject}},
\code{\link[parallel]{makeCluster}} from package \pkg{parallel}
}
\author{
Anita Lerch, Dimos Gaidatzis and Michael Stadler
}
\keyword{misc}
\keyword{utilities}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qAlign.R
\name{qAlign}
\alias{qAlign}
\title{Align reads}
\usage{
qAlign(
  sampleFile,
  genome,
  auxiliaryFile = NULL,
  aligner = "Rbowtie",
  maxHits = 1,
  paired = NULL,
  splicedAlignment = FALSE,
  snpFile = NULL,
  bisulfite = "no",
  alignmentParameter = NULL,
  projectName = "qProject",
  alignmentsDir = NULL,
  lib.loc = NULL,
  cacheDir = NULL,
  clObj = NULL,
  checkOnly = FALSE,
  geneAnnotation = NULL
)
}
\arguments{
\item{sampleFile}{The name of a text file listing input sequence files
and sample names (see \sQuote{Details}).}

\item{genome}{The reference genome for primary alignments, one of:
\itemize{
  \item a string referring to a \dQuote{BSgenome} package
  (e.g. \dQuote{"BSgenome.Hsapiens.UCSC.hg19"}), which will be
  downloaded automatically from Bioconductor if not present
  \item the name of a fasta sequence file containing one or
  several sequences (chromosomes) to be used as a reference. The aligner
  index will be created when necessary and stored in a default
  location (see \sQuote{Details}).
}}

\item{auxiliaryFile}{The name of a text file listing sequences to be
used as additional targets for alignment of reads not mapping to the
reference genome (see \sQuote{Details}).}

\item{aligner}{selects the aligner program to be used for aligning the
reads. Currently, only \dQuote{Rbowtie} and \dQuote{Rhisat2} are supported,
which are R wrapper packages for \sQuote{bowtie} / \sQuote{SpliceMap} and
\sQuote{hisat2}, respectively (see \code{\link[Rbowtie]{Rbowtie-package}} and
\code{\link[Rhisat2]{Rhisat2-package}} packages).}

\item{maxHits}{sets the maximal number of allowed mapping positions
per read (default: 1). If a read produces more than \code{maxHits}
alignments, no alignments will be reported for it. In case of a
multi-mapping read, a single alignment is randomly selected.}

\item{paired}{defines the type of paired-end library and can be set to
one of \code{no} (single read experiment, default), \code{fr} (fw/rev),
\code{ff} (fw/fw) or \code{rf} (rev/fw).}

\item{splicedAlignment}{If \code{TRUE}, reads will be aligned using a
spliced aligner, depending on the value of \code{aligner} described above:
\describe{
  \item{\code{aligner="Rhisat2"}}{: This is the recommended setting
  for spliced alignments and will use hisat2 from the
  \code{\link[Rhisat2]{Rhisat2-package}}. See also the \code{geneAnnotation}
  argument below for providing known exon-exon junctions.}
  \item{\code{aligner="Rbowtie"}}{: This is not recommended and only
  available for legacy reasons. It will use SpliceMap to produce spliced
  alignments (without using a database of known exon-exon junctions).
  Compared to the alternative alignment modes (non-spliced or spliced using
  \code{Rhisat2} as aligner), this alignment mode is about ten-fold slower
  and also less sensitive. Furthermore, SpliceMap can only be used for
  reads with a minimal length of 50nt; SpliceMap ignores reads that are
  shorter, and these reads will not be contained in the BAM file,
  neither as mapped or unmapped reads.}
}}

\item{snpFile}{The name of a text file listing single nucleotide
polymorphisms to be used for allele-specific alignment and
quantification (see \sQuote{Details}).}

\item{bisulfite}{For bisulfite-converted samples (Bis-seq), the type
of bisulfite library (\dQuote{dir} for directional libraries,
\dQuote{undir} for undirectional libraries).}

\item{alignmentParameter}{An optional string containing command line
parameters to be used for the aligner, to overrule the default
alignment parameters used by \code{QuasR}. Please use with caution;
some alignment parameters may break assumptions made by
\code{QuasR}. Default parameters are listed in \sQuote{Details}.}

\item{projectName}{An optional name for the alignment project.}

\item{alignmentsDir}{The directory to be used for storing alignments
(bam files). If set to \code{NULL} (default), bam files will be
generated at the location of the input sequence files.}

\item{lib.loc}{can be used to change the default library path of
R. The library path is used by \code{QuasR} to store aligner index
packages created from \code{BSgenome} reference genomes.}

\item{cacheDir}{specifies the location to store (potentially huge)
temporary files. If set to \code{NULL} (default), the temporary
directory of the current R session as returned by \code{tempdir()}
will be used.}

\item{clObj}{A cluster object, created by the package \pkg{parallel}, to
enable parallel processing and speed up the alignment process.}

\item{checkOnly}{If \code{TRUE}, prevents the automatic creation of
alignments or aligner indices. This allows to quickly check for missing
alignment files without starting the potentially long process of
their creation. In the case of missing alignments or indices, an
exception is thrown.}

\item{geneAnnotation}{Only used if \code{aligner} is \code{"Rhisat2"}.
The path to either a gtf file or a sqlite database generated by exporting
a \code{TxDb} object. This file is used to generate a splice site file
for \code{Rhisat2}, that will be used to guide the spliced alignment.
Please note that if using an sqlite database file, do not use the one
contained in the installed package folder of a \code{TxDb} package.
\code{QuasR} (through \code{Rhisat2}) creates additional files in the
folder which would interfere with the loading of the TxDb package.}
}
\value{
A \code{\link[=qProject-class]{qProject}} object.
}
\description{
Create read alignments against reference genome and optional auxiliary
targets if not yet existing. If necessary, also build target indices for
the aligner.
}
\details{
Before generating new alignments, \code{qAlign} looks for previously
generated alignments as well as for an aligner index. If no aligner
index exists, it will be automatically created and stored in the same
directory as the provided fasta file, or as an R package in the case
of a BSgenome reference. The name of this R package will be the same
as the BSgenome package name, with an additional suffix from the
aligner (e.g. \code{BSgenome.Hsapiens.UCSC.hg19.Rbowtie}). The
generated bam files contain both aligned und unaligned reads. For
paired-end samples, by default no alignments will be reported for
read pairs where only one of the reads could be aligned.

\code{sampleFile} is a tab-delimited text file listing all the input
sequences to be included in a given analysis. The file has either two
(single-end) or three columns (paired-end). The first row contains the
column names, and additional rows contain relative or absolute path
and name of input sequence file(s), as well as the according sample
name. Three input file formats are supported (fastq, fasta and bam).
All input files in one \code{sampleFile} need to be in the same
format, and are recognized by their extension (.fq, .fastq, .fa,
.fasta, .fna, .bam), in raw or compressed form (e.g. .fastq.gz). If
bam files are provided, then no alignments are generated by
\code{qAlign}, and the alignments contained in the bam files will be
used instead.

The column names in \code{sampleFile} have to match to the ones in the
examples below, for a single-read experiment:
\tabular{ll}{
  FileName        \tab SampleName \cr
  chip_1_1.fq.bz2 \tab Sample1    \cr
  chip_2_1.fq.bz2 \tab Sample2
}
and for a paired-end experiment:
\tabular{lll}{
  FileName1      \tab FileName2      \tab SampleName \cr
  rna_1_1.fq.bz2 \tab rna_1_2.fq.bz2 \tab Sample1    \cr
  rna_2_1.fq.bz2 \tab rna_2_2.fq.bz2 \tab Sample2
}

The \dQuote{SampleName} column is the human-readable name for each
sample that will be used as sample labels. Multiple sequence files may
be associated to the same sample name, which instructs \code{QuasR} to
combine those files.

\code{auxiliaryFile} is a tab-delimited text file listing one or
several additional target sequence files in fasta format. Reads that
do not map against the reference genome will be aligned against each
of these target sequence files. The first row contains the column
names which have to match to the ones in the example below:
\tabular{ll}{
  FileName       \tab AuxName \cr
  NC_001422.1.fa \tab phiX174
}

\code{snpFile} is a tab-delimited text file without a header and
contains four columns with chromosome name, position, reference allele
and alternative allele, as in the example below:
\tabular{llll}{
  chr1 \tab  8596 \tab G \tab A \cr
  chr1 \tab 18443 \tab G \tab A \cr
  chr1 \tab 18981 \tab C \tab T \cr
  chr1 \tab 19341 \tab G \tab A
}

The reference and alternative alleles will be injected into the
reference genome, resulting in two separate genomes. All reads will be
aligned separately to both of these genomes, and the alignments will
be combined, only retaining the best alignment for each read. In the
final alignment, each read will be marked with a tag that classifies
it into reference (\code{R}), alternative (\code{A}) or unknown
(\code{U}), if the reads maps equally well to both genomes.

If \code{bisulfite} is set to \dQuote{dir} or \dQuote{undir}, reads
will be C-to-T converted and aligned to a similarly converted genome.

If \code{alignmentParameter} is \code{NULL} (recommended),
\code{qAlign} will select default parameters that are suitable for the
experiment type. Please note that for bisulfite or allele-specific
experiments, each read is aligned multiple times, and resulting
alignments need to be combined. This requires special settings for the
alignment parameters that are not recommended to be changed. For
\sQuote{simple} experiments (neither bisulfite, allele-specific, nor
spliced), alignments are generated using the parameters \code{-m
maxHits --best --strata}. This will align reads with up to
\dQuote{maxHits} best hits in the genome and selects one of them randomly.
}
\examples{
\dontrun{
# see qCount, qMeth and qProfile manual pages for examples
example(qCount)
example(qMeth)
example(qProfile)
}

}
\seealso{
\code{\link[=qProject-class]{qProject}},
\code{\link[parallel]{makeCluster}} from package \pkg{parallel},
\code{\link[Rbowtie]{Rbowtie-package}} package,
\code{\link[Rhisat2]{Rhisat2-package}} package
}
\author{
Anita Lerch, Dimos Gaidatzis, Charlotte Soneson and Michael Stadler
}
\keyword{misc}
\keyword{utilities}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qCount.R
\name{qCount}
\alias{qCount}
\title{Quantify alignments}
\usage{
qCount(
  proj,
  query,
  reportLevel = c(NULL, "gene", "exon", "promoter", "junction"),
  selectReadPosition = c("start", "end"),
  shift = 0L,
  orientation = c("any", "same", "opposite"),
  useRead = c("any", "first", "last"),
  auxiliaryName = NULL,
  mask = NULL,
  collapseBySample = TRUE,
  includeSpliced = TRUE,
  includeSecondary = TRUE,
  mapqMin = 0L,
  mapqMax = 255L,
  absIsizeMin = NULL,
  absIsizeMax = NULL,
  maxInsertSize = 500L,
  clObj = NULL
)
}
\arguments{
\item{proj}{A \code{\linkS4class{qProject}} object representing a
sequencing experiment as returned by \code{\link[QuasR]{qAlign}}}

\item{query}{An object of type \code{\link[GenomicRanges:GRanges-class]{GRanges}},
\code{\link[GenomicRanges:GRangesList-class]{GRangesList}} or
\code{\link[GenomicFeatures:TxDb-class]{TxDb}} with the regions to be
quantified. The type of \code{query} will determine the mode of
quantification (see \sQuote{Details}). For
\code{reportLevel="junction"}, \code{query} is ignored and can also
be \code{NULL}.}

\item{reportLevel}{Level of quantification (\code{query} of type
\code{TxDb} or \code{NULL}), one of
\describe{
  \item{\code{gene} (default)}{: one value per gene}
  \item{\code{exon}}{: one value per exon}
  \item{\code{promoter}}{: one value per promoter}
  \item{\code{junction}}{: one count per detected exon-exon junction
      (\code{query} will be ignored in this case) }
}}

\item{selectReadPosition}{defines the part of the alignment that has
to be contained within a query region to produce an overlap (see
\sQuote{Details}). Possible values are:
\describe{
  \item{\code{start} (default)}{: start of the alignment}
  \item{\code{end}}{: end of the alignment}
}}

\item{shift}{controls the shifting alignments towards their 3'-end before
quantification. \code{shift} can be one of:
\itemize{
  \item an \dQuote{integer} vector of the same length as the
  number of alignment files
  \item a single \dQuote{integer} value
  \item the character string \code{"halfInsert"} (only available for
  paired-end experiments)
}
The default of \code{0} will not shift any alignments.}

\item{orientation}{sets the required orientation of the alignments relative
to the query region in order to be counted, one of:
\describe{
  \item{\code{any} (default)}{: count alignment on the same and opposite strand}
  \item{\code{same}}{: count only alignment on the same strand}
  \item{\code{opposite}}{: count only alignment on the opposite strand}
}}

\item{useRead}{For paired-end experiments, selects the read mate whose
alignments should be counted, one of:
\describe{
  \item{\code{any} (default)}{: count all alignments}
  \item{\code{first}}{: count only alignments from the first read}
  \item{\code{last}}{: count only alignments from the last read}
}}

\item{auxiliaryName}{Which bam files to use in an experiments with
auxiliary alignments (see \sQuote{Details}).}

\item{mask}{If not \code{NULL}, a \code{\link[GenomicRanges:GRanges-class]{GRanges}}
object with reference regions to be masked, i.e. excluded from the
quantification, such as unmappable or highly repetitive regions (see
\sQuote{Details}).}

\item{collapseBySample}{If \code{TRUE} (the default), sum alignment
counts from bam files with the same sample name.}

\item{includeSpliced}{If \code{TRUE} (the default), include spliced
alignments when counting. A spliced alignment is defined as an
alignment with a gap in the read of at least 60 bases.}

\item{includeSecondary}{If \code{TRUE} (the default), include alignments
with the secondary bit (0x0100) set in the \code{FLAG} when counting.}

\item{mapqMin}{Minimal mapping quality of alignments to be included when
counting (mapping quality must be greater than or equal to
\code{mapqMin}). Valid values are between 0 and 255. The default (0)
will include all alignments.}

\item{mapqMax}{Maximal mapping quality of alignments to be included when
counting (mapping quality must be less than or equal to \code{mapqMax}).
Valid values are between 0 and 255. The default (255) will include
all alignments.}

\item{absIsizeMin}{For paired-end experiments, minimal absolute insert
size (TLEN field in SAM Spec v1.4) of alignments to be included when
counting. Valid values are greater than 0 or \code{NULL} (default),
which will not apply any minimum insert size filtering.}

\item{absIsizeMax}{For paired-end experiments, maximal absolute insert
size (TLEN field in SAM Spec v1.4) of alignments to be included when
counting. Valid values are greater than 0 or \code{NULL} (default),
which will not apply any maximum insert size filtering.}

\item{maxInsertSize}{Maximal fragment size of the paired-end experiment.
This parameter is used if \code{shift="halfInsert"} and will
ensure that query regions are made wide enough to emcompass all
alignment pairs whose mid falls into the query region. The default
value is \code{500} bases.}

\item{clObj}{A cluster object to be used for parallel processing (see
\sQuote{Details}).}
}
\value{
A \code{matrix} with effective query regions width in the first
column, and alignment counts in subsequent columns, or a
\code{GRanges} object if \code{reportLevel="junction"}.

The effective query region width returned as first column in the
matrix is calculated by the number of unique, non-masked bases in the
reference sequence that contributed to the count of this query
name (irrespective if the bases were covered by alignments or not).
An effective width of zero indicates that the region was fully
masked and will have zero counts in all samples.

The alignment counts in the matrix are contained from column two
onwards. For projects with allele-specific quantification, i.e. if a
file with single nucleotide polymorphisms was supplied to the
\code{snpFile} argument of \code{\link[QuasR]{qAlign}}, there will be
three columns per bam file (number of alignments for Reference,
Unknown and Alternative genotypes, with suffixed _R, _U and
_A). Otherwise there is a single columns per bam file.

If \code{collapseBySample}=\code{TRUE}, groups of bam files with identical
sample name are combined by summing their alignment counts.

For \code{reportLevel="junction"}, the return value is a
\code{GRanges} object. The start and end coordinates correspond to the
first and last base in each detected intron. Plus- and minus-strand
alignments are quantified separately, so that in an unstranded RNA-seq
experiment, the same intron may be represented twice; once for each
strand. The counts for each sample are contained in the \code{mcols}
of the \code{GRanges} object.
}
\description{
Quantify alignments from sequencing data.
}
\details{
\code{qCount} is used to count alignments in each sample from a
\code{qProject} object. The features to be quantified, together with
the mode of quantification, are specified by the \code{query}
argument, which is one of:
\describe{
  \item{\code{\link[GenomicRanges:GRanges-class]{GRanges}}}{: Overlapping alignments
  are counted separately for each coordinate region. If multiple
  regions have identical names, their counts will be summed, counting
  each alignment only once even if it overlaps more than one of these
  regions. Alignments may be counted more than once if they overlap
  multiple regions that have different names.
  This mode is for example used to quantify ChIP-seq alignments in
  promoter regions, or gene expression levels in an RNA-seq experiment
  (using a \code{query} with exon regions named by gene).}
  \item{\code{\link[GenomicRanges:GRangesList-class]{GRangesList}}}{: Alignments are
  counted and summed for each list element in \code{query} if they
  overlap with any of the regions contained in the list element. The
  order of the list elements defines a hierarchy for quantification:
  Alignment will only be counted for the first element (the one with
  the lowest index in \code{query}) that they overlap, but not for any
  potential further list elements containing overlapping regions.
  This mode can be used to hierarchically and uniquely count (assign)
  each alignment to a one of several groups of regions (the elements
  in \code{query}), for example to estimate the fractions of different
  classes of RNA in an RNA-seq experiment (rRNA, tRNA, snRNA, snoRNA,
  mRNA, etc.)}
  \item{\code{\link[GenomicFeatures:TxDb-class]{TxDb}}}{: Used to extract
  regions from annotation and report alignment counts depending on the
  value of \code{reportLevel}. If \code{reportLevel="exon"},
  alignments overlapping each exon in \code{query} are counted.
  If \code{reportLevel="gene"}, alignment counts for all exons of a
  gene will be summed, counting each alignment only once even if it
  overlaps multiple annotated exons of a gene. These are useful to
  calculate exon or gene expression levels in RNA-seq experiments
  based on the annotation in a \code{TxDb} object. If
  \code{reportLevel="promoter"}, the \code{promoters} function from package
  \pkg{GenomicFeatures} is used with default arguments to extract
  promoter regions around transcript start sites, e.g. to quantify
  alignments inf a ChIP-seq experiment.}
  \item{any of the above or \code{NULL} for
  \code{reportLevel="junction"}}{: The \code{query} argument is ignored
  if \code{reportLevel} is set to \code{"junction"}, and \code{qCount}
  will count the number of alignments supporting each exon-exon
  junction detected in any of the samples in \code{proj}. The
  arguments \code{selectReadPosition}, \code{shift},
  \code{orientation}, \code{useRead} and \code{mask} will have no
  effect in this quantification mode.}
}

The additional arguments allow to fine-tune the quantification:

\code{selectReadPosition} defines the part of the alignment that has
to be contained within a query region for an overlap. The values
\code{start} (default) and \code{end} refer to the biological start
(5'-end) and end (3'-end) of the alignment. For example, the
\code{start} of an alignment on the plus strand is its leftmost
(lowest) base, and the \code{end} of an alignment on the minus strand
is also the leftmost base.

\code{shift} allows on-the-fly shifting of alignments towards their
3'-end prior to overlap determination and counting. This can be
helpful to increase resolution of ChIP-seq experiments by moving
alignments by half the immuno-precipitated fragment size towards the
middle of fragments. \code{shift} is either an \dQuote{integer} vector
with one value per alignment file in \code{proj}, or a single
\dQuote{integer} value, in which case all alignment files will be
shifted by the same value. For paired-end experiments, it can be
alternatively set to "halfInsert", which will estimate the true
fragment size from the distance between aligned read pairs and shift
the alignments accordingly.

\code{orientation} controls the interpretation of alignment strand
when counting, relative to the strand of the query region. \code{any}
will count all overlapping alignments, irrespective of the alignment
strand (e.g. used in an unstranded RNA-seq experiment). \code{same}
will only count the alignments on the same strand as the query region
(e.g. in a stranded RNA-seq experiment that generates reads from the
sense strand), and \code{opposite} will only
count the alignments on the opposite strand from the query region
(e.g. to quantify anti-sense transcription in a stranded RNA-seq
experiment).

\code{includeSpliced} and \code{includeSecondary} can be used to
include or exclude spliced or secondary alignments,
respectively. \code{mapqMin} and \code{mapqMax} allow to select alignments
based on their mapping qualities. \code{mapqMin} and \code{mapqMax} can
take integer values between 0 and 255 and equal to
\eqn{-10 log_{10} Pr(\textnormal{mapping position is wrong})}{-10
log10 Pr(mapping position is wrong)}, rounded to the nearest
integer. A value 255 indicates that the mapping quality is not available.

In paired-end experiments, \code{useRead} allows to quantify either
all alignments (\code{useRead="any"}), or only the first
(\code{useRead="first"}) or last (\code{useRead="last"}) read from a
read pair or read group. Note that for \code{useRead="any"} (the
default), an alignment pair that is fully contained within a query
region will contribute two counts to the value of that
region. \code{absIsizeMin} and \code{absIsizeMax} can be used to
select alignments based on their insert size (TLEN field in SAM Spec
v1.4).

\code{auxiliaryName} selects the reference sequence for which
alignments should be quantified. \code{NULL} (the default) will
select alignments against the genome. If set to a character string
that matches one of the auxiliary target names (as specified in
the \code{auxiliaryFile} argument of \code{\link[QuasR]{qAlign}}), the
corresponding alignments will be counted.

\code{mask} can be used to specify a
\code{\link[GenomicRanges:GRanges-class]{GRanges}} object with regions in the
reference sequence to be excluded from quantification. The regions
will be considered unstranded (\code{strand="*"}). Alignments that
overlap with a region in \code{mask} will not be counted. Masking may
reduce the effective width of query regions reported by \code{qCount},
even down to zero for regions that are fully contained in \code{mask}.

If \code{clObj} is set to an object that inherits from class
\code{cluster}, for example an object returned by
\code{\link[parallel]{makeCluster}} from package \pkg{parallel}, the
quantification task is split into multiple chunks and processed in
parallel using \code{\link[parallel:clusterApply]{clusterMap}}. Currently, not all
tasks will be efficiently parallelized: For example, a single query
region and a single (group of) bam files will not be split into
multiple chunks.
}
\examples{
library(GenomicRanges)
library(Biostrings)
library(Rsamtools)

# copy example data to current working directory
file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)

# load genome sequence
genomeFile <- "extdata/hg19sub.fa"
gseq <- readDNAStringSet(genomeFile)
chrRegions <- GRanges(names(gseq), IRanges(start=1,width=width(gseq),names=names(gseq)))

# create alignments (paired-end experiment)
sampleFile <- "extdata/samples_rna_paired.txt"
proj <- qAlign(sampleFile, genomeFile, splicedAlignment=TRUE)

# count reads using a "GRanges" query
qCount(proj, query=chrRegions)
qCount(proj, query=chrRegions, useRead="first")

# hierarchical counting using a "GRangesList" query
library(rtracklayer)
annotationFile <- "extdata/hg19sub_annotation.gtf"
gtfRegions <- import.gff(annotationFile, format="gtf", feature.type="exon")
names(gtfRegions) <- mcols(gtfRegions)$source
gtfRegionList <- split(gtfRegions, names(gtfRegions))
names(gtfRegionList)

res3 <- qCount(proj, gtfRegionList)
res3

# gene expression levels using a "TxDb" query
library("txdbmaker")
genomeRegion <- scanFaIndex(genomeFile)
chrominfo <- data.frame(chrom=as.character(seqnames(genomeRegion)),
                        length=end(genomeRegion),
                        is_circular=rep(FALSE, length(genomeRegion)))
txdb <- makeTxDbFromGFF(annotationFile,
                        format="gtf",
                        chrominfo=chrominfo,
                        dataSource="Ensembl modified",
                        organism="Homo sapiens")

res4 <- qCount(proj, txdb, reportLevel="gene")
res4

# exon-exon junctions
res5 <- qCount(proj, NULL, reportLevel="junction")
res5

}
\seealso{
\code{\link[QuasR]{qAlign}},
\code{\linkS4class{qProject}},
\code{\link[parallel]{makeCluster}} from package \pkg{parallel}
}
\author{
Anita Lerch, Dimos Gaidatzis and Michael Stadler
}
\keyword{misc}
\keyword{utilities}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qProject-class.R
\name{qProjectUpdate}
\alias{qProjectUpdate}
\title{Update qProject}
\usage{
qProjectUpdate(proj, quiet = TRUE)
}
\arguments{
\item{proj}{a \code{\link[=qProject-class]{qProject}} object.}

\item{quiet}{logical, whether to suppress update messages.}
}
\value{
A \code{\link[=qProject-class]{qProject}} object.
}
\description{
Check if a qProject is compatible with the current class definition, and
update it if necessary.
}
\seealso{
\code{\link[=qProject-class]{qProject}}
}
\author{
Charlotte Soneson
}
\keyword{misc}
\keyword{utilities}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{worker_message}
\alias{worker_message}
\title{Build a formatted message for outputting to log files}
\usage{
worker_message(..., sep = "", appendLF = TRUE)
}
\description{
Build a formatted message for outputting to log files
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/qQCReport.R
\name{qQCReport}
\alias{qQCReport}
\title{QuasR Quality Control Report}
\usage{
qQCReport(
  input,
  pdfFilename = NULL,
  chunkSize = 1000000L,
  useSampleNames = FALSE,
  clObj = NULL,
  a4layout = TRUE,
  ...
)
}
\arguments{
\item{input}{A vector of files or a \code{qProject} object as returned by
\code{qAlign}.}

\item{pdfFilename}{The path and name of a pdf file to store the report.
If \code{NULL}, the quality control plots will be generated in separate
plotting windows on the standard graphical device.}

\item{chunkSize}{The number of sequences, sequence pairs (for paired-end
data) or alignments that will be sampled from each data file to collect
quality statistics.}

\item{useSampleNames}{If TRUE, the plots will be labelled using the sample
names instead of the file names. Sample names are obtained from the
\code{qProject} object, or from \code{names(input)} if \code{input} is a
named vector of file names. Please not that if there are multiple files
for the same sample, the sample names will not be unique.}

\item{clObj}{A cluster object to be used for parallel processing of multiple
input files.}

\item{a4layout}{A logical scalar. If TRUE, the output of mapping rate and
uniqueness plots will be adjusted for a4 format devices.}

\item{\dots}{Additional arguments that will be passed to the functions
generating the individual quality control plots, see \sQuote{Details}.}
}
\value{
The function is called for its side effect of generating quality
control plots. It invisibly returns a list with components that contain the
data used to generate each of the QC plots. Available components are
(depending on input data, see \sQuote{Details}):
\describe{
  \item{\emph{qualByCycle}}{: quality score boxplot}
  \item{\emph{nuclByCycle}}{: nucleotide frequency plot}
  \item{\emph{duplicated}}{: duplication level plot}
  \item{\emph{mappings}}{: mapping statistics barplot}
  \item{\emph{uniqueness}}{: library complexity barplot}
  \item{\emph{errorsByCycle}}{: mismatch frequency plot}
  \item{\emph{mismatchTypes}}{: mismatch type plot}
  \item{\emph{fragDistribution}}{: fragment size distribution plot}
}
}
\description{
Generate quality control plots for a \code{qProject} object or a vector of
fasta/fastq/bam files. The available plots vary depending on the types of
available input (fasta, fastq, bam files or \code{qProject} object;
paired-end or single-end).
}
\details{
This function generates quality control plots for all input files or the
sequence and alignment files contained in a \code{qProject} object,
allowing assessment of the quality of a sequencing experiment.
\code{qQCReport} uses functionality from the \pkg{ShortRead} package to
collect quality data, and visualizes the results similarly as the
\sQuote{FastQC} quality control tool from Simon Andrews (see
\sQuote{References} below). It is recommended to create PDF reports
(\code{pdfFilename} argument), for which the plot layouts have been optimised.

Some plots will only be generated if the necessary information is available
(e.g. base qualities in fastq sequence files).

The currently available plot types are:
\describe{
  \item{\emph{Quality score boxplot}}{shows the distribution of
        base quality values as a box plot for each position in the input
        sequence. The background color (green, orange or red)
        indicates ranges of high, intermediate and low qualities.}
  \item{\emph{Nucleotide frequency}}{plot shows the frequency of A, C,
        G, T and N bases by position in the read.}
  \item{\emph{Duplication level}}{plot shows for each sample the
        fraction of reads observed at different duplication levels
        (e.g. once, two-times, three-times, etc.). In addition, the most
        frequent sequences are listed.}
  \item{\emph{Mapping statistics}}{shows fractions of reads that were
        (un)mappable to the reference genome.}
  \item{\emph{Library complexity}}{shows fractions of unique
        read(-pair) alignment positions, as a measure of the complexity in
        the sequencing library. Please note that this measure is not
        independent from the total number of reads in a library, and is best
        compared between libraries of similar sizes.}
  \item{\emph{Mismatch frequency}}{shows the frequency and position
        (relative to the read sequence) of mismatches in the alignments
        against the reference genome.}
  \item{\emph{Mismatch types}}{shows the frequency of
        read bases that caused mismatches in the alignments to the
        reference genome, separately for each genome base.}
  \item{\emph{Fragment size}}{shows the distribution of fragment sizes
        inferred from aligned read pairs.}
}

One approach to assess the quality of a sample is to compare its
control plots to the ones from other samples and search for relative
differences. Special quality measures are expected for certain types
of experiments: A genomic re-sequencing sample with an
overrepresentation of T bases may be suspicious, while such a
nucleotide bias is normal for a directed bisulfite-sequencing sample.

Additional arguments can be passed to the internal functions that
generate the individual quality control plots using \code{\dots{}}:
\describe{
  \item{\code{lmat}:}{a matrix (e.g. \code{matrix(1:12, ncol=2)}) used
        by an internal call to the \code{layout} function to specify the
        positioning of multiple plot panels on a device page. Individual panels
        correspond to different samples.}
  \item{\code{breaks}:}{a numerical vector
        (e.g. \code{c(1:10)}) defining the bins used by
        the \sQuote{Duplication level} plot.}
}
}
\examples{
# copy example data to current working directory
file.copy(system.file(package="QuasR", "extdata"), ".", recursive=TRUE)

# create alignments
sampleFile <- "extdata/samples_chip_single.txt"
genomeFile <- "extdata/hg19sub.fa"

proj <- qAlign(sampleFile, genomeFile)

# create quality control report
qQCReport(proj, pdfFilename="qc_report.pdf")

}
\references{
FastQC quality control tool at
\url{http://www.bioinformatics.bbsrc.ac.uk/projects/fastqc/}
}
\seealso{
\code{\linkS4class{qProject}}, \code{\link{qAlign}},
\code{\link[ShortRead:ShortReadBase-package]{ShortRead}} package
}
\author{
Anita Lerch, Dimos Gaidatzis and Michael Stadler
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{alignmentStats}
\alias{alignmentStats}
\title{Get statistics on alignments}
\usage{
alignmentStats(x, collapseBySample = TRUE)
}
\arguments{
\item{x}{the source of alignment bam files, one of:
\itemize{
  \item a \code{character} vector with bam files
  \item a \code{qProject} object
}}

\item{collapseBySample}{If \code{TRUE} and \code{x} is a \code{qProject}
object, sum counts for bam files with identical sample names.}
}
\value{
A \code{matrix} with one row per bam file and three columns
("seqlength", "mapped" and "unmapped").
}
\description{
Get statistics on alignments from bam file or \code{qProject} object.
}
\details{
Internally, \code{alignmentStats} queries the bam index files similar
to 'idxstats' from samtools. Please note that this does not discriminate
for example between primary and secondary alignments. If you need more
statistics, see for example \code{\link[Rsamtools]{quickBamFlagSummary}}
from package \pkg{Rsamtools}.

If \code{x} is a \code{qProject} object, the auxiliary bam files will not
contain any unmapped reads, and the corresponding unmapped counts are
calculated by subtracting auxiliary mapped counts from the total reads.
The latter correspond to the unmapped counts from the corresponding genome
bam files.
}
\examples{
\dontrun{
# see qProject manual page for an example
example(qProject)
}

}
\seealso{
\code{\link[=qProject-class]{qProject}},
\code{\link[Rsamtools]{quickBamFlagSummary}} from package \pkg{Rsamtools}
}
\author{
Anita Lerch, Dimos Gaidatzis and Michael Stadler
}
\keyword{misc}
\keyword{utilities}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{.get_alnstats_for_bam}
\alias{.get_alnstats_for_bam}
\title{Internal function to get seqlengths, mapped and unmapped counts for a bam file}
\usage{
.get_alnstats_for_bam(bf)
}
\arguments{
\item{bf}{Character scalar with the path and filename to a bam file (index
is assumed to be already existing)}
}
\value{
a named numeric vector with elements 'seqlength', 'mapped' and 'unmapped'
}
\description{
Internal function to get seqlengths, mapped and unmapped counts for a bam file
}
\keyword{internal}

\name{@PKGNAME@}
\docType{package}

\alias{@PKGNAME@-package}
\alias{@PKGNAME@}


\title{@PKGTITLE@}

\description{
  @PKGDESCRIPTION@
}

\details{
\tabular{ll}{
Package: \tab @PKGNAME@ \cr
Type: \tab Package\cr
Version: \tab @PKGVERSION@ \cr
Date: \tab @DATE@ \cr
License: \tab @LIC@ \cr
LazyLoad: \tab yes\cr
}
  @PKGDETAILS@
}

\note{
  This @ALIGNER@ ver. @ALIGNERVERSION@ index package was made from the following source data files:
  \preformatted{
@SRCDATAFILES@
  }
}

\author{@AUTHOR@}

\seealso{
}

\examples{
@PKGEXAMPLES@
}

\keyword{package}
\keyword{data}
